import { OnDestroy, OnInit, ElementRef, ViewContainerRef } from '@angular/core';
import { Clipboard } from '@angular/cdk/clipboard';
import { OverlayService } from '../core';
export declare class MatCopyDirective implements OnDestroy, OnInit {
    private _viewContainerRef;
    private _copy;
    protected _elementRef: ElementRef;
    private _overlay;
    constructor(_viewContainerRef: ViewContainerRef, _copy: Clipboard, _elementRef: ElementRef, _overlay: OverlayService);
    /** keyUp subject */
    private _keyUp$;
    /** Where the elemet is locked */
    private _disabled;
    set disabled(value: boolean);
    get disabled(): boolean;
    getSelection(): void;
    open(connectedTo: {
        x: number;
        y: number;
    } & {
        width?: number;
        height?: number;
    }, selectText: string): void;
    /** Close the overlay. */
    close(): void;
    copy(text: string): void;
    onKeyup(): void;
    registerKeyUpEvent(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
