import { OnDestroy, NgZone } from '@angular/core';
import { ScrollDispatcher } from '@angular/cdk/scrolling';
import { Overlay, OverlayRef, ScrollStrategy, FlexibleConnectedPositionStrategyOrigin } from '@angular/cdk/overlay';
import { MatPosition } from '../position/position';
import { Observable } from 'rxjs';
export interface CreateConfig {
    withTransformOriginOn?: string;
    withFlexibleDimensions?: boolean;
    withViewportMargin?: number;
    panelClass?: string;
    backdropClass?: string;
    hasBackdrop?: boolean;
    disposeOnNavigation?: boolean;
    scrollStrategy?: ScrollStrategy;
    position?: MatPosition;
    offsetX?: number;
    offsetY?: number;
}
export declare class OverlayService implements OnDestroy {
    _overlay: Overlay;
    private _ngZone;
    private _scrollDispatcher;
    constructor(_overlay: Overlay, _ngZone: NgZone, _scrollDispatcher: ScrollDispatcher);
    _overlayRef: OverlayRef | null;
    _overlayInstance: any;
    private readonly _destroyed;
    private readonly _onClose;
    private _connectedTo;
    private createOverlay;
    updatePosition(positionStr: MatPosition, offsetX?: number, offsetY?: number): void;
    updateOverlayPosition(): void;
    open(connectedTo: FlexibleConnectedPositionStrategyOrigin, portal: any, config?: CreateConfig): any;
    hasOverlay(): boolean;
    afterClose(): Observable<void>;
    close(): void;
    ngOnDestroy(): void;
}
