import { Observable } from 'rxjs';
export interface StorageItem {
    _createAt: number;
    _updateAt?: number;
    _expiresAt?: number;
    value: any;
}
export declare class MatStorage {
    constructor();
    private _storage;
    private readonly _onChange;
    /** utf8 to base64 */
    private _UToB;
    /** base64 to utf8 */
    private _BToU;
    /** where is expires */
    private _isExpires;
    /** format data to  StorageItem. */
    private _getStringValue;
    /** register event listener on storage change. */
    private _registerEventListener;
    /** get value by key. */
    get(key: string, fullProperty?: boolean): any;
    /**
     * @param expires Set the period of validity, unit seconds.
     * @description Add or update data.
     */
    set(key: string, value: any, expires?: number | string): void;
    /** remove item by key */
    remove(key: string): any;
    /** clear all of the storage */
    clear(): void;
    /** the count that storage has stored. */
    length(): number;
    /** get all keys array. */
    keys(): string[];
    /** where the key is existed. */
    includes(key: string): boolean;
    /** return a Observable to watch change by key */
    observable(key: string): Observable<any>;
}
