/**
 * TODO:Create Content Component For focusActiveCell;
 */
import { ChangeDetectorRef, OnDestroy, OnInit, ElementRef, EventEmitter, TemplateRef, ViewContainerRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { OverlayService } from '../core';
import { Moment } from 'moment';
import { MatCalendarCellCssClasses, MatCalendar } from '@angular/material/datepicker';
export declare type MatDateType = 'day' | 'month' | 'year';
export declare const LocalFormats: {
    parse: {
        dateInput: string;
    };
    display: {
        dateInput: string;
        monthYearLabel: string;
        dateA11yLabel: string;
        monthYearA11yLabel: string;
    };
};
export declare const MAT_DATE_VALUE_ACCESSOR: any;
export declare class MatDate implements OnDestroy, OnInit, ControlValueAccessor {
    private _cd;
    private _ele;
    private _viewContainerRef;
    private _overlay;
    constructor(_cd: ChangeDetectorRef, _ele: ElementRef, _viewContainerRef: ViewContainerRef, _overlay: OverlayService);
    datepickerContent: TemplateRef<any>;
    calendar: MatCalendar<any>;
    readonly matOpened: EventEmitter<boolean>;
    readonly yearSelected: EventEmitter<any>;
    readonly monthSelected: EventEmitter<any>;
    readonly daySelected: EventEmitter<any>;
    placeholder: string;
    tabIndex: number;
    format: string;
    get formatDefault(): string;
    _maxDate: any;
    set maxDate(value: any);
    /** Whether the value is required. */
    private _required;
    get required(): boolean;
    set required(value: boolean);
    _minDate: any;
    set minDate(value: any);
    /** The date to open the calendar to initially. */
    get startAt(): any;
    set startAt(value: any);
    private _startAt;
    set dateFilter(value: (date: any) => boolean);
    get dateFilter(): (date: any) => boolean;
    _dateFilter: (date: any) => boolean;
    /** Classes to be passed to the date picker panel. Supports the same syntax as `ngClass`. */
    panelClass: string | string[];
    /** Function that can be used to add custom CSS classes to dates. */
    dateClass: (date: any) => MatCalendarCellCssClasses;
    private _type;
    set type(value: MatDateType);
    get type(): MatDateType;
    get startView(): "month" | "year" | "multi-year";
    get touchUi(): boolean;
    set touchUi(value: boolean);
    private _touchUi;
    get showTime(): boolean;
    set showTime(value: boolean);
    private _showTime;
    /** Whether the option is disabled. */
    private _disabled;
    get disabled(): any;
    set disabled(value: any);
    /** Whether the calendar is open. */
    get opened(): boolean;
    set opened(value: boolean);
    private _opened;
    /** The currently selected date. */
    _validSelected: Moment;
    private _selected;
    get selected(): any | null;
    set selected(value: any | null);
    _timeSelected: string;
    _timeOpened: boolean;
    _minTime: string;
    _maxTime: string;
    /** Get default time value. */
    getTimeDefault(): string;
    toggleTime(): void;
    /** Open the calendar. */
    open(): void;
    setMaxAndMinTime(): void;
    /** Close the calendar. */
    close(): void;
    /** Where is show now button */
    isNow(): boolean;
    /** Observable on overlay close */
    private onOverlayClose;
    /** Open the calendar as a popup. */
    private _openAsPopup;
    _selectYear(date: Moment): void;
    _selectMonth(date: Moment): void;
    _selectDay(date: Moment): void;
    clearValue(): void;
    setNowValue(): void;
    setValue(): void;
    _userSelection(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
    _onTouched: () => any;
    /** The method to be called in order to update ngModel. */
    _controlValueAccessorChangeFn: (value: any) => void;
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value: any): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn: (value: any) => void): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn: any): void;
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled: boolean): void;
}
