/**
 * TODO:接管键盘事件， 最大最小值限制
 */
import { ChangeDetectorRef, OnDestroy, OnInit, ElementRef, EventEmitter, TemplateRef, ViewContainerRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { OverlayService } from '../core';
export declare const MAT_TIME_VALUE_ACCESSOR: any;
export declare class MatTime implements OnDestroy, OnInit, ControlValueAccessor {
    private _cd;
    private _ele;
    private _viewContainerRef;
    private _overlay;
    constructor(_cd: ChangeDetectorRef, _ele: ElementRef, _viewContainerRef: ViewContainerRef, _overlay: OverlayService);
    timeContent: TemplateRef<any>;
    readonly matOpened: EventEmitter<boolean>;
    readonly matChange: EventEmitter<any>;
    readonly matOptionClick: EventEmitter<any>;
    tabIndex: number;
    placeholder: string;
    header: string;
    for: string;
    split: string;
    showFooter: boolean;
    _minTime: any;
    set minTime(value: any);
    _maxTime: any;
    set maxTime(value: any);
    /** Whether the option is disabled. */
    private _disabled;
    get disabled(): any;
    set disabled(value: any);
    /** Whether the option is disabled. */
    private _required;
    get required(): boolean;
    set required(value: boolean);
    /** Whether the calendar is open. */
    get opened(): boolean;
    set opened(value: boolean);
    private _opened;
    /** The currently selected date. */
    set selected(value: any | null);
    get selected(): any | null;
    private _validSelected;
    readonly _hourOptions: string[];
    readonly _minuteAndSecondOptions: string[];
    displayValue: any;
    getDefaultValue(): {
        hour: string;
        minute: string;
        second: string;
    };
    /** Open the calendar. */
    open(): void;
    /** Where the item is disabled. */
    isDisabledItem(value: number, type: 'hour' | 'minute' | 'second'): boolean;
    /** Where the now button is show. */
    isNow(): boolean;
    /** Close the calendar. */
    close(): void;
    /** Observable on overlay close */
    private onOverlayClose;
    /** Open the calendar as a popup. */
    private _openAsPopup;
    /** Get options by number */
    getTimePickerOptions(count: number): string[];
    setDisplayNow(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    /** Set time display by value */
    setDisplayBySelected(): void;
    /** Set value equal to now time */
    setNowValue(): void;
    /** Clear time value */
    clearValue(): void;
    /** Set value with display and close the overlay. */
    setValue(): void;
    /** Time option click */
    optionClick(item: any, type: any): void;
    /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
    _onTouched: () => any;
    /** The method to be called in order to update ngModel. */
    _controlValueAccessorChangeFn: (value: any) => void;
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value: any): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn: (value: any) => void): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn: any): void;
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled: boolean): void;
}
