/**
 * TODO: 接管键盘事件， 因为搜索占位部分失效。
 */
import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit, AfterViewInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { MatSelect } from '@angular/material/select';
export declare function getMatDropdownNonFunctionValueError(key: string): Error;
export declare const MAT_DROPDOWN_DEFAULT_VIEW_FIELD = "label";
export declare const MAT_DROPDOWN_DEFAULT_CHILDREN_FIELD = "children";
export declare const MAT_DROPDOWN_DEFAULT_DISABLED_FIELD = "disabled";
export interface MatDropdownOption {
    value: any;
    view: any;
    data: any;
    disabled: boolean;
    hidden?: boolean;
    children?: any[];
}
export declare const MAT_DROPDOWN_VALUE_ACCESSOR: any;
export declare class MatDropdown implements OnDestroy, OnInit, ControlValueAccessor, AfterViewInit {
    private _cd;
    constructor(_cd: ChangeDetectorRef);
    readonly matChange: EventEmitter<any>;
    readonly matFilter: EventEmitter<any>;
    readonly matOpened: EventEmitter<any>;
    readonly valueChange: EventEmitter<any>;
    selectInstance: MatSelect;
    tabIndex: number;
    /** Field name of disabled when datasource as objecet array. */
    disabledField: string;
    /** Field name of view when datasource as objecet array. */
    viewField: string;
    /** Field name of view when datasource as objecet array. */
    disableOptionCentering: boolean;
    /** Field name of view when datasource as objecet array. */
    disableRipple: boolean;
    /** Where show search input. */
    showFilter: boolean;
    /** Field name of view when datasource as objecet array. */
    placeholder: string;
    /** Field name of view when datasource as objecet array. */
    searcPlaceholder: string;
    /** Field name of children when datasource as objecet array. */
    childrenField: string;
    /** Field name of value when datasource as objecet array. */
    valueField: string;
    /** `name` attribute for the underlying `input` element. */
    name: string;
    /** Whether the dropdown is required. */
    private _required;
    get required(): boolean;
    set required(value: boolean);
    /** Whether the dropdown options display with group. */
    private _group;
    get group(): boolean;
    set group(value: boolean);
    /** Whether the dropdown options display with group. */
    private _reset;
    get reset(): boolean;
    set reset(value: boolean);
    /** Whether multiple options can be selected. */
    private _multiple;
    set multiple(value: boolean);
    get multiple(): boolean;
    /** Whether the option is disabled. */
    private _disabled;
    get disabled(): any;
    set disabled(value: any);
    /** Comparison function to specify which option is checked. Defaults to object equality. */
    private _compareWith;
    get compareWith(): (o1: any, o2: any) => boolean;
    set compareWith(fn: (o1: any, o2: any) => boolean);
    /** Comparison function to specify which option is checked. Defaults to object equality. */
    private _filterWith;
    get filterWith(): (option: MatDropdownOption, key: string) => boolean;
    set filterWith(fn: (option: MatDropdownOption, key: string) => boolean);
    /** Value of the checkbox list. */
    private _value;
    get value(): any;
    set value(newValue: any);
    private _direction;
    get direction(): 'vertical' | 'horizontal';
    set direction(newValue: 'vertical' | 'horizontal');
    formatOption(item: any): MatDropdownOption;
    /** Option of the checkbox. */
    private _dataSource;
    set dataSource(dataValue: MatDropdownOption[]);
    get dataSource(): MatDropdownOption[];
    /** Filter option by search text. */
    filterOption(): void;
    /** Reset value on button click */
    resetValue(): void;
    /** Whether data source is empty. */
    isDataSourceEmpty(): boolean;
    /** Whether empty on search */
    isEmpty(): boolean;
    /** Event on value change */
    onValueChange(event: any): void;
    /** Event on open state change */
    _panelIsOpend: boolean;
    onOpenedChange(event: any): void;
    searchText: string;
    search(event: KeyboardEvent): void;
    ngOnInit(): void;
    private _panelPosition;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
    _onTouched: () => any;
    /** The method to be called in order to update ngModel. */
    _controlValueAccessorChangeFn: (value: any) => void;
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value: any): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn: (value: any) => void): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn: any): void;
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled: boolean): void;
}
