import { ChangeDetectorRef, AfterViewInit, AfterContentInit, OnDestroy, ElementRef, EventEmitter } from '@angular/core';
import { NgForm, NgControl } from '@angular/forms';
import { MatReactiveFormErrorMessageStrategy, MatReactiveFormMessageConfig } from '../reactive-form';
export declare class MatFieldLabel {
}
export declare class MatFieldWapper {
    private _ele;
    private ngForm;
    _defaultErrorMessageStrategy: MatReactiveFormErrorMessageStrategy;
    onSubmitted: EventEmitter<any>;
    constructor(_ele: ElementRef, ngForm: NgForm, _defaultErrorMessageStrategy: MatReactiveFormErrorMessageStrategy);
    private _messageStrategy;
    get messageStrategy(): string;
    set messageStrategy(value: string);
    get submitted(): boolean;
    onKeyDown(event: KeyboardEvent): boolean;
    submit(): void;
    onSubmit(e: any): void;
    /******** Where the form is invalid. ********/
    invalid(): boolean;
    /******** Go to error element on submitted. ********/
    goToError(): void;
    reset(value?: any): void;
}
export declare class MatField implements AfterViewInit, AfterContentInit, OnDestroy {
    private _cd;
    private _parentForm;
    _defaultErrorMessageStrategy: MatReactiveFormErrorMessageStrategy;
    _defaultMessageConfig: MatReactiveFormMessageConfig;
    constructor(_cd: ChangeDetectorRef, _parentForm: NgForm, _defaultErrorMessageStrategy: MatReactiveFormErrorMessageStrategy, _defaultMessageConfig: MatReactiveFormMessageConfig);
    ngControl: NgControl;
    labelEle: MatFieldLabel;
    isRequired(): boolean;
    get label(): string;
    set label(value: string);
    private _label;
    get describe(): string;
    set describe(value: string);
    private _describe;
    get hideLabel(): boolean;
    set hideLabel(value: boolean);
    private _hideLabel;
    get errorMessage(): string;
    isSubmit(): boolean;
    private _checkErrorMessageStrategy;
    ngAfterViewInit(): void;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
}
