import { ChangeDetectorRef, ElementRef, InjectionToken, AfterViewInit, EventEmitter } from '@angular/core';
import { DomSanitizer, SafeUrl } from '@angular/platform-browser';
import { HttpClient } from '@angular/common/http';
import { ControlValueAccessor, Validator, ValidationErrors, AbstractControl } from '@angular/forms';
import { MatLightBoxService } from '../lightbox';
import { MatToast } from '../toast';
export declare class MatImageUploadTrigger {
}
export declare const MAT_IMAGE_UPLOAD_DEFAULT_REQUEST: InjectionToken<any>;
export declare function MAT_IMAGE_UPLOAD_DEFAULT_REQUEST_FACTORY(): any;
export declare const MAT_IMAGE_UPLOAD_VALUE_ACCESSOR: any;
export declare const MAT_IMAGE_UPLOAD_VALIDATORS_ACCESSOR: any;
export declare const MAT_UPLOAD_DEFAULT_THUMB_FIELD = "thumb";
export declare class MtaImageUpload implements AfterViewInit, ControlValueAccessor, Validator {
    domSanitizer: DomSanitizer;
    private cd;
    private lightBoxService;
    private toast;
    private _defaultRequest;
    private http;
    /** User-supplied override of the trigger element. */
    customTrigger: MatImageUploadTrigger;
    file: ElementRef;
    matError: EventEmitter<any>;
    handleError: boolean;
    /** Whether the upload is disabled. */
    private _disabled;
    get disabled(): boolean;
    set disabled(value: boolean);
    /** Whether upload can be multiple selected. */
    private _multiple;
    set multiple(value: boolean);
    get multiple(): boolean;
    /** Whether upload is readonly. */
    private _readonly;
    set readonly(value: boolean);
    get readonly(): boolean;
    private _srcField;
    set srcField(value: string);
    get srcField(): string;
    private _nameField;
    set nameField(value: string);
    get nameField(): string;
    private _thumbField;
    set thumbField(value: string);
    get thumbField(): string;
    get triggerText(): string;
    set triggerText(value: string);
    private _triggerText;
    color: string;
    limit: number;
    limitText: string;
    imageModel: string;
    url: string;
    name: string;
    formData: {
        [key: string]: any;
    };
    maxSize: number;
    maxSizeText: string;
    handleResponse: any;
    accept: any;
    acceptText: any;
    set required(value: boolean);
    get required(): boolean;
    _required: boolean;
    _fileList: any;
    _vaule: any[];
    _pending: boolean;
    set pending(value: boolean);
    get pending(): boolean;
    constructor(domSanitizer: DomSanitizer, cd: ChangeDetectorRef, lightBoxService: MatLightBoxService, toast: MatToast, _defaultRequest: any, http: HttpClient);
    ngAfterViewInit(): void;
    /** Trigger Element Click Function. */
    triggerClick(event: MouseEvent): void;
    /** File Select Event */
    fileEleChange(event: Event): void;
    /** Get unique id */
    getUid(): string;
    /** Format file size. */
    formatSize(size: number): string;
    /** Format url by (window.URL.createObjectURL) or filereader  */
    formatUrl(file: File): SafeUrl;
    /** Format file name */
    formatFile(file: File): any;
    isFileValid(file: File, index: number, existSize: number): boolean;
    viewImage(activeIndex: number): void;
    /** Remove item by index. */
    removeImage(index: number): void;
    /** Where show the trigger element. */
    showFileTrigger(): boolean;
    getFromData(): FormData;
    hasFileToUpload(): boolean;
    /** File upload fail */
    fileUploadFail(file: any, reason?: string): void;
    postFile(file: any): Promise<void>;
    private requiredValidator;
    private pendingValidator;
    private onChange;
    private onTouched;
    private validatorOnChange;
    private validator;
    /** @docs-private */
    registerOnValidatorChange(fn: () => void): void;
    validate(c: AbstractControl): ValidationErrors | null;
    changeValue(): void;
    /** Implemented as part of ControlValueAccessor. */
    writeValue(value: any): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn: any): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn: any): void;
    /** Implemented as a part of ControlValueAccessor. */
    setDisabledState(isDisabled: boolean): void;
}
