import { ElementRef, OnDestroy, OnInit, Renderer2, ViewContainerRef } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { OverlayService } from '../core';
export declare const MAT_IMAGE_ZOOM_SCALE = 2.5;
export declare class MatImageZoomDirective implements OnDestroy, OnInit {
    _sanitizer: DomSanitizer;
    private _el;
    private _renderer;
    private _overlay;
    private _viewContainerRef;
    constructor(_sanitizer: DomSanitizer, _el: ElementRef, _renderer: Renderer2, _overlay: OverlayService, _viewContainerRef: ViewContainerRef);
    /** The element of magnifying glass moves with the mouse. */
    private _blockElement;
    /** The element of larger image wapper. */
    private _zoomImageElement;
    /** Where the image is loaded. */
    private _isLoaded;
    /** The host element. */
    private _ele;
    /** The window width when image is scaled. */
    zoomWindowWidth: number;
    /** The window height when image is scaled. */
    zoomWindowHeight: number;
    /** The number of scale. */
    set scale(value: number);
    get scale(): number;
    private _scale;
    set largeSrc(value: string);
    get largeSrc(): string;
    private _largeSrc;
    /** Add event listener on mousemove */
    _onMouseMove(event: MouseEvent): void;
    /** Add event listener on mouseover. */
    _onMouseOver(event: MouseEvent): void;
    /** Add event listener on mouseout. */
    _onMouseOut(event: Event): void;
    /** Add event listener on image load. */
    _onLoad(event: Event): void;
    private _addMoveBlock;
    private _addZoomImage;
    private _resetScale;
    private _setHostStyle;
    private _openZoomImage;
    private _hideZoomImage;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
