import { ElementRef, InjectionToken, ChangeDetectorRef } from '@angular/core';
export declare type MatImagePosition = 'LT' | 'LC' | 'LB' | 'RT' | 'RC' | 'RB' | 'TC' | 'BC' | 'C' | 'CC' | string;
export declare type MatImageMode = 'contain' | 'cover' | 'fill' | 'none' | 'scale-down';
export declare class MatImageConfig {
    model: MatImageMode;
    position?: MatImagePosition;
    width?: number;
    height?: number;
    radius?: number;
    color?: string;
    alt?: string;
    outline?: boolean;
    shadow?: boolean;
    title?: string;
    src?: string;
}
export declare function MAT_NOTIFICATION_DEFAULT_OPTIONS_FACTORY(): MatImageConfig;
export declare const MAT_IMAGE_DEFAULT_CONFIG: InjectionToken<MatImageConfig>;
export declare class MatImageBase {
    _ele: ElementRef;
    _cd: ChangeDetectorRef;
    _defaultConfig: MatImageConfig;
    constructor(_ele: ElementRef, _cd: ChangeDetectorRef, _defaultConfig: MatImageConfig);
    /** Style object of img */
    _imgStyle: any;
    /** Width of img element */
    private _width;
    set width(value: number);
    get width(): number;
    /** Height of img element */
    private _height;
    set height(value: number);
    get height(): number;
    /** Radius of img element */
    private _radius;
    set radius(value: number);
    get radius(): number;
    /** Background color of img element */
    private _color;
    set color(value: string);
    get color(): string;
    /** Style of object-fit value */
    private _model;
    set model(mode: MatImageMode);
    /** Style of object-position value */
    private _position;
    set position(position: MatImagePosition);
    /** Where show shadow  */
    private _shadow;
    set shadow(value: boolean);
    get shadow(): boolean;
    /** Where show border line  */
    private _outline;
    set outline(value: boolean);
    get outline(): boolean;
    /** Set style when prams change */
    _setStyle(): void;
    private _getPosition;
}
