import { ElementRef, OnInit, ChangeDetectorRef, EventEmitter } from '@angular/core';
import { MatImageBase, MatImageConfig } from './image-base';
export declare class MatImage extends MatImageBase implements OnInit {
    _ele: ElementRef;
    _cd: ChangeDetectorRef;
    _defaultConfig: MatImageConfig;
    constructor(_ele: ElementRef, _cd: ChangeDetectorRef, _defaultConfig: MatImageConfig);
    /** Event emitted when the image has been loaded. */
    matLoad: EventEmitter<any>;
    /** Event emitted when the image has been load error. */
    matError: EventEmitter<any>;
    /** Title of img element */
    title: string;
    /** Alt of img element */
    alt: string;
    /** src of img element */
    src: string;
    /** Mat image params with obje  */
    set config(value: MatImageConfig);
    /** Event on img load error */
    _imageError(event: any): void;
    /** Event on img load */
    _imageLoad(event: any): void;
    ngOnInit(): void;
}
