import { TemplateRef, OnDestroy } from '@angular/core';
import { MatDialog, MatDialogRef, MatDialogConfig } from '@angular/material/dialog';
import { ComponentType } from '@angular/cdk/portal';
import { Observable } from 'rxjs';
export declare class MatConfirmData {
    title?: string;
    content?: string;
    accept?: string;
    reject?: string;
    closeable?: boolean;
}
export declare class MatPromptData extends MatConfirmData {
    placeholder?: string;
    default?: string;
}
export declare class MatModal implements OnDestroy {
    private _dialog;
    constructor(_dialog: MatDialog);
    confirm(data: MatConfirmData, config?: MatDialogConfig<any>): MatDialogRef<any>;
    prompt(data: MatPromptData, config?: MatDialogConfig<any>): MatDialogRef<any>;
    dialog(componentOrTemplateRef: ComponentType<any> | TemplateRef<any>, config?: MatDialogConfig<any>): MatDialogRef<any>;
    full(componentOrTemplateRef: ComponentType<any> | TemplateRef<any>, config?: MatDialogConfig<any>): MatDialogRef<any>;
    open(componentOrTemplateRef: ComponentType<any> | TemplateRef<any>, config?: MatDialogConfig<any>): MatDialogRef<any>;
    closeAll(): void;
    afterAllClosed(): Observable<void>;
    getModalById(id: string): MatDialogRef<any>;
    ngOnDestroy(): void;
}
