import { TemplateRef, ChangeDetectorRef } from '@angular/core';
import { AnimationEvent } from '@angular/animations';
import { MatSnackBarRef } from '@angular/material/snack-bar';
import { MatSeverity } from '../core';
import { Observable } from 'rxjs';
export interface MatNotificationItem {
    notificationId?: string;
    template?: TemplateRef<any>;
    state?: 'show' | 'hidden';
    timerId?: any;
    startTime?: number;
    duration?: number;
    title?: string;
    message?: string;
    hiddenClose?: boolean;
    severity?: MatSeverity;
    class?: string;
    buttons?: any[];
    data?: any;
}
export declare const MAT_NOTIFICATION_MAX = 4;
export declare const MAT_NOTIFICATION_DURATION = 3000;
export declare const MAT_NOTIFICATION_PAUSE_ON_HOVER = true;
export declare const MAT_NOTIFICATION_MIN_DURATION = 800;
export declare class MatNotificationComponent {
    snackBarRef: MatSnackBarRef<MatNotificationComponent>;
    private cd;
    constructor(snackBarRef: MatSnackBarRef<MatNotificationComponent>, cd: ChangeDetectorRef);
    /** The length of time in milliseconds to wait before automatically dismissing the snack bar. */
    duration: number;
    /** Where pause dismissing on componednt hovered. */
    pauseOnHover: boolean;
    /** The minimum length of time in milliseconds to wait before automatically dismissing the snack bar. */
    minDuration: number;
    /** The max length of notification to show. */
    max: number;
    /** The notification items array. */
    list: MatNotificationItem[];
    /** The notification items array wait to show. */
    temList: MatNotificationItem[];
    /** Subject for notifying that the component has been hidden from the view */
    private readonly _afterDismissed;
    /** Subject for notifying that the component has been cleared from the view */
    private readonly _afterClear;
    setConfig(config?: any): void;
    mouseEnter(item: MatNotificationItem): void;
    mouseLeave(item: MatNotificationItem): void;
    startRemove(item: MatNotificationItem): void;
    clearTime(item: MatNotificationItem): void;
    removeItem(item: MatNotificationItem): void;
    clear(): void;
    add(item: MatNotificationItem): void;
    action(): void;
    afterDismissed(): Observable<MatNotificationItem>;
    afterClear(): Observable<void>;
    isFull(): boolean;
    onAnimationEnd(event: AnimationEvent): void;
    buttonClick(btn: any, item: any): void;
}
