import { TemplateRef, InjectionToken } from '@angular/core';
import { MatSnackBarHorizontalPosition, MatSnackBarVerticalPosition } from '@angular/material/snack-bar';
import { MatNotificationSnackBar } from './notification.service';
import { MatNotificationComponent, MatNotificationItem } from './notification.component';
export declare class MatNotificationConfig {
    duration?: number;
    pauseOnHover?: boolean;
    minDuration?: number;
    max?: number;
    horizontalPosition?: MatSnackBarHorizontalPosition;
    verticalPosition?: MatSnackBarVerticalPosition;
}
export declare const MAT_NOTIFICATION_DEFAULT_OPTIONS: InjectionToken<MatNotificationConfig>;
export declare function MAT_NOTIFICATION_DEFAULT_OPTIONS_FACTORY(): MatNotificationConfig;
export declare class MatNotification {
    private notice;
    private _defaultConfig;
    private _instance;
    private _count;
    private _idPrefix;
    constructor(notice: MatNotificationSnackBar, _defaultConfig: MatNotificationConfig);
    private _getConfig;
    private _creat;
    private _open;
    private _getId;
    success(message: string, title?: string, config?: MatNotificationItem): MatNotificationComponent;
    error(message: string, title?: string, config?: MatNotificationItem): MatNotificationComponent;
    info(message: string, title?: string, config?: MatNotificationItem): MatNotificationComponent;
    warn(message: string, title?: string, config?: MatNotificationItem): MatNotificationComponent;
    open(message: string, title?: string, config?: MatNotificationItem): MatNotificationComponent;
    openTemplate(template: TemplateRef<any>, config?: MatNotificationItem): MatNotificationComponent;
    create(config: MatNotificationItem): MatNotificationComponent;
}
