import { ChangeDetectorRef, OnInit } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { FormGroup, FormControl, FormArray } from '@angular/forms';
import { MatReactiveControlField } from './reactive-form-field';
export declare class MatReactiveFormControl implements OnInit {
    private _cd;
    _http: HttpClient;
    constructor(_cd: ChangeDetectorRef, _http: HttpClient);
    fields: MatReactiveControlField;
    /** DataSource change event emit */
    private _dataSourceChange;
    /** DataSource Emit subscription */
    private _dataSourceSubscription;
    formControl: FormControl | FormArray;
    rootFormGroup: FormGroup;
    get config(): any;
    set config(value: any);
    private _config;
    private _placeholder;
    get placeholder(): string;
    set placeholder(value: string);
    private _multiple;
    get multiple(): boolean;
    set multiple(value: boolean);
    private _dataSource;
    get dataSource(): any;
    set dataSource(value: any);
    /** String input proprty such as input、textare. */
    private _maxlength;
    get maxlength(): number;
    set maxlength(value: number);
    private _trim;
    get trim(): boolean;
    set trim(value: boolean);
    private _showTextTip;
    get showTextTip(): boolean;
    set showTextTip(value: boolean);
    private _before;
    get before(): string;
    set before(value: string);
    private _after;
    get after(): string;
    set after(value: string);
    private _srcField;
    get srcField(): string;
    set srcField(value: string);
    private _nameField;
    get nameField(): string;
    set nameField(value: string);
    private _thumbField;
    get thumbField(): string;
    set thumbField(value: string);
    private _triggerText;
    get triggerText(): string;
    set triggerText(value: string);
    private _limit;
    get limit(): number;
    set limit(value: number);
    private _maxSize;
    get maxSize(): number;
    set maxSize(value: number);
    private _accept;
    get accept(): string;
    set accept(value: string);
    private _url;
    get url(): string;
    set url(value: string);
    private _formData;
    get formData(): any;
    set formData(value: any);
    /** dropdown */
    private _disabledField;
    get disabledField(): string;
    set disabledField(value: string);
    private _viewField;
    get viewField(): string;
    set viewField(value: string);
    private _valueField;
    get valueField(): string;
    set valueField(value: string);
    _compareWith: (e1: any, e2: any) => boolean;
    get compareWith(): (e1: any, e2: any) => boolean;
    set compareWith(value: (e1: any, e2: any) => boolean);
    /** date */
    private _type;
    get type(): string;
    set type(value: string);
    private _maxDate;
    get maxDate(): string;
    set maxDate(value: string);
    private _minDate;
    get minDate(): string;
    set minDate(value: string);
    private _maxTime;
    get maxTime(): string;
    set maxTime(value: string);
    private _minTime;
    get minTime(): string;
    set minTime(value: string);
    private _showTime;
    get showTime(): boolean;
    set showTime(value: boolean);
    /** number */
    private _max;
    get max(): string;
    set max(value: string);
    private _min;
    get min(): string;
    set min(value: string);
    private _precision;
    get precision(): string;
    set precision(value: string);
    private _step;
    get step(): string;
    set step(value: string);
    /** checkbox */
    private _direction;
    get direction(): string;
    set direction(value: string);
    private _labelPosition;
    get labelPosition(): string;
    set labelPosition(value: string);
    /** select-button */
    private _iconField;
    get iconField(): string;
    set iconField(value: string);
    private _tick;
    get tick(): boolean;
    set tick(value: boolean);
    /** slider */
    private _rule;
    get rule(): boolean;
    set rule(value: boolean);
    private _thumbLabel;
    get thumbLabel(): boolean;
    set thumbLabel(value: boolean);
    private _textInterval;
    get textInterval(): string;
    set textInterval(value: string);
    private _tickInterval;
    get tickInterval(): string;
    set tickInterval(value: string);
    /** tree */
    private _childrenField;
    get childrenField(): string;
    set childrenField(value: string);
    private _selectableField;
    get selectableField(): string;
    set selectableField(value: string);
    private _lazy;
    get lazy(): boolean;
    set lazy(value: boolean);
    private _checkbox;
    get checkbox(): boolean;
    set checkbox(value: boolean);
    private _propagateUp;
    get propagateUp(): boolean;
    set propagateUp(value: boolean);
    private _propagateDown;
    get propagateDown(): boolean;
    set propagateDown(value: boolean);
    _loadChildren: (e: any) => void;
    get loadChildren(): (e: any) => void;
    set loadChildren(value: (e: any) => void);
    markForCheck(): void;
    /** Component init hook. */
    ngOnInit(): void;
    setControlConfig(e: any): void;
    /** Execute function or value to boolean. */
    executeBooleanValue(value: any, params: any): boolean;
    /** Execute function or value to string. */
    executeStringValue(value: any, params: any): any;
    /** Execute function or value to object. */
    executeObjectValue(value: any, params: any): any;
    /** Execute function or value to function. */
    executeFunctionValue(value: any): any;
    /** Execute function or value to function. */
    executeValidatorsValue(validatorsConfig: any, formValue: any, key: string): any;
}
