import { OnInit, AfterViewInit, OnDestroy, ViewContainerRef, ComponentFactoryResolver, ChangeDetectorRef } from '@angular/core';
import { FormGroup, FormBuilder, FormControl, AbstractControl, FormArray, FormGroupDirective } from '@angular/forms';
import { MatReactiveDesignerField } from './reactive-form-field';
import { MatReactiveFormMessageConfig, MatReactiveFormErrorMessageStrategy } from './reactive-form-message';
export declare class MatReactiveFormDesigner implements OnInit, AfterViewInit, OnDestroy {
    _fb: FormBuilder;
    private _resolver;
    private _cd;
    _rootForm: FormGroupDirective;
    _defaultMessageConfig: MatReactiveFormMessageConfig;
    _defaultErrorMessageStrategy: MatReactiveFormErrorMessageStrategy;
    container: ViewContainerRef;
    constructor(_fb: FormBuilder, _resolver: ComponentFactoryResolver, _cd: ChangeDetectorRef, _rootForm: FormGroupDirective, _defaultMessageConfig: MatReactiveFormMessageConfig, _defaultErrorMessageStrategy: MatReactiveFormErrorMessageStrategy);
    comnponentInstance: any;
    fields: MatReactiveDesignerField;
    private _initialize;
    get config(): any;
    set config(value: any);
    private _config;
    rootFormGroup: FormGroup;
    parentFormGroup: FormGroup;
    formControl: FormControl | FormArray;
    private _defaultValue;
    get defaultValue(): any;
    set defaultValue(value: any);
    /** The component label. */
    private _label;
    get label(): string;
    set label(value: string);
    /** The disabled status of formcontrol an component. */
    private _disabled;
    get disabled(): boolean;
    set disabled(value: boolean);
    /** Where is required. */
    private _required;
    get required(): boolean;
    set required(value: boolean);
    /** The form item class in global. */
    private _class;
    get class(): string;
    set class(value: string);
    /** The form item style inline. */
    private _style;
    get style(): {
        [key: string]: any;
    };
    set style(value: {
        [key: string]: any;
    });
    /** The form item describe. */
    private _describe;
    get describe(): string;
    set describe(value: string);
    /** Where is show the component. */
    private _hidden;
    get hidden(): boolean;
    set hidden(value: boolean);
    private _validators;
    set validators(value: any);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    markForCheck(): void;
    setDesignerConfig(e: any): void;
    setRequired(formValue: {
        [key: string]: any;
    }): void;
    /** Where the item config is gruopform. */
    isGroup(): boolean;
    /** Where the item config is arrayForm. */
    isArrayControl(): boolean;
    /** Add a new control on init when config is form item. */
    addControl(): void;
    removeControlFromArray(parent: FormArray, control: any): void;
    removeControlFromGroup(parent: FormGroup, control: FormControl | FormArray | FormGroup): void;
    removeControl(): void;
    getFormControlName(control: AbstractControl): string;
    getFormGroup(name?: string, parent?: FormGroup): FormGroup;
    /** Add component. */
    addComponent(): void;
    /** Remove component. */
    removeComponent(): void;
    /** Execute function or value to boolean. */
    executeBooleanValue(value: any, params: any): boolean;
    /** Execute function or value to string. */
    executeStringValue(value: any, params: any): any;
    /** Execute function or value to object. */
    executeObjectValue(value: any, params: any): any;
}
