import { ChangeDetectorRef, AfterViewInit, AfterContentInit, EventEmitter, OnDestroy, ElementRef } from '@angular/core';
import { FormBuilder, NgForm, FormGroup } from '@angular/forms';
import { MatReactiveFormService } from './reactive-form-service';
import { MatReactiveFormErrorMessageStrategy } from './reactive-form-message';
export declare type MatReactiveFormLayout = 'horizontal' | 'vertical' | 'inline';
export declare type MatReactiveFormLabelPosition = 'left' | 'right' | 'top';
export declare class MatReactiveForm implements AfterViewInit, AfterContentInit, OnDestroy {
    private _fb;
    private _ele;
    _defaultErrorMessageStrategy: MatReactiveFormErrorMessageStrategy;
    private _reactiveService;
    private _cd;
    constructor(_fb: FormBuilder, _ele: ElementRef, _defaultErrorMessageStrategy: MatReactiveFormErrorMessageStrategy, _reactiveService: MatReactiveFormService, _cd: ChangeDetectorRef);
    formRoot: FormGroup;
    onSubmitted: EventEmitter<any>;
    ngForm: NgForm;
    submitBtn: any;
    config: any;
    get layout(): MatReactiveFormLayout;
    set layout(value: MatReactiveFormLayout);
    private _layout;
    get labelPosition(): MatReactiveFormLabelPosition;
    set labelPosition(value: MatReactiveFormLabelPosition);
    private _labelPosition;
    set value(value: any);
    private _value;
    private _messageStrategy;
    get messageStrategy(): string;
    set messageStrategy(value: string);
    private _submitted;
    get submitted(): boolean;
    set submitted(value: boolean);
    get formValue(): any;
    onKeyDown(event: KeyboardEvent): boolean;
    onSubmit(e: any): void;
    log(e: any): void;
    /******** Patch the form value. ********/
    patchValue(value?: any): void;
    /******** Where the form is invalid. ********/
    invalid(): boolean;
    /******** Go to error element on submitted. ********/
    goToError(): void;
    /******** Reset the form value and status. ********/
    reset(value?: any): void;
    ngAfterViewInit(): void;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
}
