import { OnDestroy, ElementRef, OnInit, ViewContainerRef, ChangeDetectorRef, EventEmitter } from '@angular/core';
import { HttpClient } from '@angular//common/http';
import { OverlayService } from '../core';
import { MatReactiveTableHeaderConfig } from './reactive-table-config';
import { Observable } from 'rxjs';
export declare class MatReactiveSortComponent implements OnInit {
    private _cd;
    _http: HttpClient;
    constructor(_cd: ChangeDetectorRef, _http: HttpClient);
    private readonly _onSort;
    /** The title of columns. */
    title: string;
    /** The placeholder of the filter input. */
    searcPlaceholder: string;
    /** The text of reset button. */
    resetText: string;
    /** The options of the enmu. */
    config: MatReactiveTableHeaderConfig;
    /** The search text for input. */
    searchText: string;
    /** Options of the filter. */
    optionsDisplay: any;
    search: any;
    mutipleSearch: any;
    sort: {
        sortName: string;
        sortValue: 'asc' | 'desc' | '';
    };
    get multiple(): boolean;
    ngOnInit(): void;
    /** Reset the conditions. */
    resetHeader(): void;
    sortClick(): void;
    optionClick(option: any): void;
    multipleOptionClick(e: any, option: any): void;
    sureClick(): void;
    cancelClick(): void;
    formatOption(item: any, column: MatReactiveTableHeaderConfig): any;
    setOptions(column: MatReactiveTableHeaderConfig): void;
    headerSearch(event: any): void;
    /** Filter option by search text. */
    filterHeaderOption(): void;
    /** Returns an observable that notifies when the popover has been hidden from view. */
    onSort(): Observable<boolean>;
    /** Where the panel is selecet. */
    isSelect(): boolean;
    /** Where current column sort is active. */
    isSortActive(value: 'asc' | 'desc'): boolean;
    isOptionActive(value: any): any;
    selectAll(event: any): void;
}
export declare class MatReactiveSortDirective implements OnDestroy, OnInit {
    private _overlay;
    private _viewContainerRef;
    _ele: ElementRef<HTMLElement>;
    constructor(_overlay: OverlayService, _viewContainerRef: ViewContainerRef, _ele: ElementRef<HTMLElement>);
    private _instance;
    private _portal;
    private _scrollStrategy;
    /** The timeout ID of any current timer set to hide the popover */
    _hideTimeoutId: any;
    connectedTo: any;
    config: MatReactiveTableHeaderConfig;
    search: any;
    matReactiveSort: {
        sortName: string;
        sortValue: 'asc' | 'desc' | '';
    };
    onSort: EventEmitter<any>;
    show(): MatReactiveSortComponent;
    canShow(): boolean;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
