import { EventEmitter, OnInit, TemplateRef, OnDestroy, ChangeDetectorRef, ElementRef } from '@angular/core';
import { Platform } from '@angular/cdk/platform';
import { MatDomHandler } from '../core';
export declare class MatScrollposition implements OnInit, OnDestroy {
    private cd;
    private domHandler;
    private platform;
    private el;
    constructor(cd: ChangeDetectorRef, domHandler: MatDomHandler, platform: Platform, el: ElementRef);
    /** Event emitted when the scroll triggered. */
    matClick: EventEmitter<string>;
    /** Show scrolltop element. */
    private _top;
    set top(value: boolean | TemplateRef<void>);
    get top(): boolean | TemplateRef<void>;
    /** Show scrollbottom element. */
    private _bottom;
    set bottom(value: boolean | TemplateRef<void>);
    get bottom(): boolean | TemplateRef<void>;
    /** Top button is visible */
    _topVisible: boolean;
    /** Bottom button is visible */
    _bottomVisible: boolean;
    /** Scroll subscription. */
    private _subscription;
    /** Distance number to show scroll button. */
    private _distance;
    set distance(value: number);
    get distance(): number;
    /** Scroll host. */
    private _target;
    set target(value: string | HTMLElement);
    /** Display or hide button. */
    private _handleScroll;
    /** Remove scroll event listener. */
    private _deregisterScroll;
    /** Register scroll event listener. */
    private _registerScroll;
    /** Button on click. */
    clickPosition(type: 'Top' | 'Bottom'): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
