import { EventEmitter, ChangeDetectorRef, OnInit, OnDestroy } from '@angular/core';
export declare class MatSearch implements OnInit, OnDestroy {
    private _cd;
    constructor(_cd: ChangeDetectorRef);
    readonly matChange: EventEmitter<any>;
    readonly matIconClick: EventEmitter<any>;
    readonly valueChange: EventEmitter<any>;
    readonly matFocus: EventEmitter<any>;
    readonly matBlur: EventEmitter<any>;
    /** The input's placeholder text. */
    placeholder: string;
    /** The input's input change debounceTime. */
    debounceTime: number;
    iconPosition: 'before' | 'after';
    /** Whether the input is disabled. */
    private _disabled;
    get disabled(): boolean;
    set disabled(value: boolean);
    /** Whether the input value is trim. */
    private _trim;
    get trim(): boolean;
    set trim(value: boolean);
    /** Value of the input. */
    private _value;
    get value(): any;
    set value(value: any);
    onFocus(): void;
    onBlur(): void;
    onValueChange(event: string): void;
    onChange(event: string): void;
    onIconClick(event: MouseEvent): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
