import { MatPosition } from '../core';
import { ScrollStrategy } from '@angular/cdk/overlay';
import { ViewContainerRef, ComponentFactoryResolver } from '@angular/core';
import { Direction } from '@angular/cdk/bidi';
export declare class MatSideConfig {
    viewContainerRef?: ViewContainerRef;
    /** ID for the side. If omitted, a unique one will be generated. */
    id?: string;
    /** Custom class for the overlay pane. */
    panelClass?: string | string[];
    /** Whether the dialog has a backdrop. */
    hasBackdrop?: boolean;
    /** Custom class for the backdrop. */
    backdropClass?: string;
    /** Width of the dialog. */
    width?: string;
    /** Height of the dialog. */
    height?: string;
    /** Max-width of the dialog. If a number is provided, assumes pixel units. Defaults to 80vw. */
    maxWidth?: number | string;
    /** Max-height of the dialog. If a number is provided, assumes pixel units. */
    maxHeight?: number | string;
    position?: MatPosition;
    /** Layout direction for the dialog's content. */
    direction?: Direction;
    /** Data being injected into the child component. */
    data?: any;
    closeOnNavigation?: boolean;
    /** Min-width of the dialog. If a number is provided, assumes pixel units. */
    minWidth?: number | string;
    /** Min-height of the dialog. If a number is provided, assumes pixel units. */
    minHeight?: number | string;
    /** Scroll strategy to be used for the dialog. */
    scrollStrategy?: ScrollStrategy;
    /** Whether the user can use escape or clicking on the backdrop to close the modal. */
    disableClose?: boolean;
    /** Alternate `ComponentFactoryResolver` to use when resolving the associated component. */
    componentFactoryResolver?: ComponentFactoryResolver;
}
