import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { MatSeverity } from '../core';
export declare const DEFAULT_TAG_SIZE = "md";
export declare type MatTagSize = 'lg' | 'md' | 'sm';
export declare class MatTag {
    private _cd;
    constructor(_cd: ChangeDetectorRef);
    /** Unique ID to be used by button's property. */
    id: string;
    /** The text of button to display. */
    label: string;
    /** Event emitted when the button clicked by the user. */
    matClose: EventEmitter<any>;
    /** Size of the button. Can be 'lg' , 'md' , or 'sm'. */
    private _size;
    set size(value: MatTagSize);
    get size(): MatTagSize;
    /** Whether tag is disabled. */
    private _disabled;
    get disabled(): boolean;
    set disabled(value: boolean);
    /** Whether tag is fill. */
    private _fill;
    get fill(): boolean;
    set fill(value: boolean);
    /** Whether tag is closable. */
    private _closable;
    get closable(): boolean;
    set closable(value: boolean);
    /** Styles used to describe the button. */
    private _type;
    set type(value: MatSeverity);
    get type(): MatSeverity;
    /** Icon of button. */
    private _icon;
    set icon(value: string);
    get icon(): string;
    close(event: MouseEvent): void;
}
