import { EventEmitter, ChangeDetectorRef, OnInit, ElementRef, OnDestroy, NgZone } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { FocusMonitor } from '@angular/cdk/a11y';
import { Platform } from '@angular/cdk/platform';
export declare const MAT_TEXTAREA_VALUE_ACCESSOR: any;
export declare class MatTextareaTip {
}
export declare class MatTextarea implements ControlValueAccessor, OnInit, OnDestroy {
    private _cd;
    protected _platform: Platform;
    protected _elementRef: ElementRef;
    private _focusMonitor;
    constructor(_cd: ChangeDetectorRef, _platform: Platform, _elementRef: ElementRef, ngZone: NgZone, _focusMonitor: FocusMonitor);
    /** Emit event subject */
    private _valueChange$;
    /** Emit subscription */
    private _subscription;
    readonly matChange: EventEmitter<any>;
    readonly matFocus: EventEmitter<any>;
    readonly matBlur: EventEmitter<any>;
    readonly valueChange: EventEmitter<any>;
    customTip: MatTextareaTip;
    /** The native `<input type="checkbox">` element */
    _textareaElement: ElementRef<HTMLInputElement>;
    /** Name value will be applied to the input element if present */
    name: string | null;
    /** The input's placeholder text. */
    placeholder: string;
    maxlength: number;
    /** The input's input change debounceTime. */
    debounceTime: number;
    /** Unique id for the input. */
    id: string;
    set resize(value: 'horizontal' | 'vertical' | 'auto' | 'none');
    get resize(): 'horizontal' | 'vertical' | 'auto' | 'none';
    private _resize;
    /** Whether the input is disabled. */
    private _disabled;
    get disabled(): boolean;
    set disabled(value: boolean);
    private _style;
    set style(value: any);
    get style(): any;
    /** Whether the textarea show tip. */
    private _showTextTip;
    get showTextTip(): boolean;
    set showTextTip(value: boolean);
    /** Whether the input is required. */
    private _required;
    get required(): boolean;
    set required(value: boolean);
    /** Whether the input value is trim. */
    private _trim;
    get trim(): boolean;
    set trim(value: boolean);
    /** Whether the element is readonly. */
    private _readonly;
    get readonly(): boolean;
    set readonly(value: boolean);
    /** Value of the input. */
    private _value;
    get value(): any;
    set value(value: any);
    onFocus(): void;
    onBlur(): void;
    /** Focus the input element by function */
    focus(): void;
    /** Blur the input element by function */
    blur(): void;
    getInputValue(): string;
    onInput(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    registerChangeEvent(): void;
    /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
    _onTouched: () => any;
    /** The method to be called in order to update ngModel. */
    _controlValueAccessorChangeFn: (value: any) => void;
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value: any): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn: (value: any) => void): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn: any): void;
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled: boolean): void;
}
