import { TemplateRef } from '@angular/core';
import { AnimationTriggerMetadata } from '@angular/animations';
import { MatSnackBarRef } from '@angular/material/snack-bar';
import { MatSeverity } from '../core';
export interface MatToastData {
    content?: string | TemplateRef<any>;
    severity?: MatSeverity;
    class?: string;
    action?: string;
    duration?: number;
    minDuration?: number;
    showClose?: boolean;
    pauseOnHover?: boolean;
    [key: string]: any;
}
export declare const toastAnimation: AnimationTriggerMetadata;
export declare class MatToastComponent {
    snackBarRef: MatSnackBarRef<MatToastComponent>;
    data: MatToastData;
    constructor(snackBarRef: MatSnackBarRef<MatToastComponent>, data: MatToastData);
    private _duration;
    private _minDuration;
    private _pauseOnHover;
    private _startTime;
    private _durationTimeoutId;
    dismissAfter(duration?: number): void;
    dismiss(): void;
    action(): void;
    mouseEnter(): void;
    mouseLeave(): void;
}
