import { TemplateRef, InjectionToken } from '@angular/core';
import { MatSnackBar, MatSnackBarHorizontalPosition, MatSnackBarVerticalPosition, MatSnackBarRef } from '@angular/material/snack-bar';
import { MatToastComponent, MatToastData } from './toast.component';
export declare class MatToastConfig {
    duration: number;
    minDuration: number;
    showClose: boolean;
    pauseOnHover: boolean;
    horizontalPosition?: MatSnackBarHorizontalPosition;
    verticalPosition?: MatSnackBarVerticalPosition;
}
export declare const MAT_TOAST_DEFAULT_OPTIONS: InjectionToken<MatToastConfig>;
export declare function MAT_TOAST_DEFAULT_OPTIONS_FACTORY(): MatToastConfig;
export declare class MatToast {
    private snackBar;
    private _defaultConfig;
    constructor(snackBar: MatSnackBar, _defaultConfig: MatToastConfig);
    private _setConfig;
    private _getData;
    private _open;
    success(content: string | TemplateRef<any>, action?: string): MatSnackBarRef<MatToastComponent>;
    error(content: string | TemplateRef<any>, action?: string): MatSnackBarRef<MatToastComponent>;
    info(content: string | TemplateRef<any>, action?: string): MatSnackBarRef<MatToastComponent>;
    warn(content: string | TemplateRef<any>, action?: string): MatSnackBarRef<MatToastComponent>;
    open(config?: MatToastData): MatSnackBarRef<MatToastComponent>;
}
