import { ChangeDetectorRef, EventEmitter, ElementRef, ViewContainerRef, TemplateRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { OverlayService } from '../core';
import { MatFlatTree } from '../flat-tree';
export declare class MatTreeSelectTrigger {
}
export declare const MAT_TREE_SELECT_VALUE_ACCESSOR: any;
export declare class MatTreeSelect extends MatFlatTree implements ControlValueAccessor {
    _cd: ChangeDetectorRef;
    private _ele;
    private _viewContainerRef;
    private _overlay;
    constructor(_cd: ChangeDetectorRef, _ele: ElementRef, _viewContainerRef: ViewContainerRef, _overlay: OverlayService);
    /** User-supplied override of the trigger element. */
    customTrigger: MatTreeSelectTrigger;
    readonly matChange: EventEmitter<any>;
    readonly matFilter: EventEmitter<any>;
    readonly matOpened: EventEmitter<any>;
    treeSelectContentTemplate: TemplateRef<any>;
    tabIndex: number;
    /** Where show search input. */
    showFilter: boolean;
    /** Field name of view when datasource as objecet array. */
    placeholder: string;
    /** Field name of view when datasource as objecet array. */
    searcPlaceholder: string;
    /** `name` attribute for the underlying `input` element. */
    name: string;
    /** Whether the dropdown is required. */
    private _required;
    get required(): boolean;
    set required(value: boolean);
    /** Whether the dropdown options display with group. */
    private _reset;
    get reset(): boolean;
    set reset(value: boolean);
    /** Whether the calendar is open. */
    get opened(): boolean;
    set opened(value: boolean);
    private _opened;
    /** Whether the option is disabled. */
    private _disabled;
    get disabled(): any;
    set disabled(value: any);
    /** Reset value on button click */
    resetValue(): void;
    /** clear the select. */
    clear(event: MouseEvent): void;
    /** Whether data source is empty. */
    isDataSourceEmpty(): boolean;
    /** Event on value change */
    onValueChange(event: any): void;
    searchText: string;
    search(event: KeyboardEvent): void;
    private _openAsPopup;
    /** Observable on overlay close */
    private onOverlayClose;
    /** Open the tree options. */
    open(): void;
    /** Close the tree options. */
    close(): void;
    treeValueChange(): void;
    /** The value displayed in the trigger. */
    get triggerValue(): string;
    /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
    _onTouched: () => any;
    /** The method to be called in order to update ngModel. */
    _controlValueAccessorChangeFn: (value: any) => void;
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value: any): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn: (value: any) => void): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn: any): void;
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled: boolean): void;
}
