import { coerceBooleanProperty, coerceNumberProperty } from '@angular/cdk/coercion';
import { Component, ViewEncapsulation, ChangeDetectionStrategy, ChangeDetectorRef, Input, NgModule, EventEmitter, Output, forwardRef, isDevMode, Injectable, ElementRef, NgZone, ɵɵdefineInjectable, Directive, ViewContainerRef, ɵɵinject, ViewChild, Inject, ContentChild, Optional, InjectionToken, Renderer2, Injector, TemplateRef, ComponentFactoryResolver, HostListener, SkipSelf, INJECTOR, Pipe, ContentChildren } from '@angular/core';
import { CommonModule, DatePipe, LowerCasePipe, UpperCasePipe, DecimalPipe, PercentPipe } from '@angular/common';
import { Subject, merge, BehaviorSubject, defer, fromEvent } from 'rxjs';
import { debounceTime, throttleTime, distinctUntilChanged, takeUntil, filter, map, switchMap, startWith, take } from 'rxjs/operators';
import { MatButtonModule } from '@angular/material/button';
import { MatIconModule } from '@angular/material/icon';
export * from '@angular/material/icon';
import { NG_VALUE_ACCESSOR, FormsModule, FormBuilder, FormArray, NG_VALIDATORS, Validators, FormGroupDirective, ReactiveFormsModule, NgForm, NgControl } from '@angular/forms';
import { SelectionModel } from '@angular/cdk/collections';
import { MatCheckboxModule } from '@angular/material/checkbox';
export * from '@angular/material/checkbox';
export { DEFAULT_TAG_SIZE, HandleResponse, LocalFormats, MAT_DATE_VALUE_ACCESSOR, MAT_DEFAULT_POPOVER_ACTION, MAT_DEFAULT_POPOVER_POSITION, MAT_DEFAULT_POSITION, MAT_DROPDOWN_DEFAULT_CHILDREN_FIELD, MAT_DROPDOWN_DEFAULT_DISABLED_FIELD, MAT_DROPDOWN_DEFAULT_VIEW_FIELD, MAT_DROPDOWN_VALUE_ACCESSOR, MAT_FILE_UPLOAD_DEFAULT_REQUEST, MAT_FILE_UPLOAD_DEFAULT_REQUEST_FACTORY, MAT_FILE_UPLOAD_VALIDATORS_ACCESSOR, MAT_FILE_UPLOAD_VALUE_ACCESSOR, MAT_IMAGE_LIST_DEFAULT_GUTTER, MAT_IMAGE_UPLOAD_DEFAULT_REQUEST, MAT_IMAGE_UPLOAD_DEFAULT_REQUEST_FACTORY, MAT_IMAGE_UPLOAD_VALIDATORS_ACCESSOR, MAT_IMAGE_UPLOAD_VALUE_ACCESSOR, MAT_IMAGE_ZOOM_SCALE, MAT_INPUT_NUMBER_VALUE_ACCESSOR, MAT_INPUT_VALUE_ACCESSOR, MAT_LIGHTBOX_DATA, MAT_LIGHTBOX_DEFAULT_CONFIG, MAT_LIGHTBOX_DEFAULT_CONFIG_FACTORY, MAT_LIGHTBOX_DEFAULT_ROTATE_ANGLE, MAT_NOTIFICATION_DEFAULT_OPTIONS, MAT_NOTIFICATION_DEFAULT_OPTIONS_FACTORY, MAT_NOTIFICATION_DURATION, MAT_NOTIFICATION_MAX, MAT_NOTIFICATION_MIN_DURATION, MAT_NOTIFICATION_PAUSE_ON_HOVER, MAT_POPOVER_PANEL_CLASS, MAT_POSITIONS, MAT_RADIO_LIST_DEFAULT_COLOR, MAT_RADIO_LIST_DEFAULT_DIRECTION, MAT_RADIO_LIST_DEFAULT_DISABLED_FIELD, MAT_RADIO_LIST_DEFAULT_VIEW_FIELD, MAT_RADIO_LIST_VALUE_ACCESSOR, MAT_REACTIVE_FORM_ERROR_MESSAGE_STRATEGY, MAT_REACTIVE_FORM_ERROR_MESSAGE_STRATEGY_FACTORY, MAT_REACTIVE_FORM_MESSAGE_CONFIG, MAT_REACTIVE_FORM_MESSAGE_CONFIG_FACTORY, MAT_SELECT_BUTTON_VALUE_ACCESSOR, MAT_SIDE_DATA, MAT_SIDE_DEFAULT_OPTIONS, MAT_SIDE_DEFAULT_OPTIONS_FACTORY, MAT_SIDE_SCROLL_STRATEGY, MAT_SIDE_SCROLL_STRATEGY_FACTORY, MAT_SIDE_SCROLL_STRATEGY_PROVIDER, MAT_SIDE_SCROLL_STRATEGY_PROVIDER_FACTORY, MAT_TEXTAREA_VALUE_ACCESSOR, MAT_TEXT_LIGHT_DEFAULT_DEBOUNCETIME, MAT_TEXT_RETRACT, MAT_TIME_VALUE_ACCESSOR, MAT_TOAST_DEFAULT_OPTIONS, MAT_TOAST_DEFAULT_OPTIONS_FACTORY, MAT_TRANSFER_DISABLED_FIELD, MAT_TRANSFER_VALUE_ACCESSOR, MAT_TRANSFER_VIEW_FIELD, MAT_TREE_DEFAULT_CHILDREN_FIELD, MAT_TREE_DEFAULT_DISABLED_FIELD, MAT_TREE_DEFAULT_SELECTABLE_FIELD, MAT_TREE_DEFAULT_VIEW_FIELD, MAT_TREE_SELECT_VALUE_ACCESSOR, MAT_UPLOAD_DEFAULT_NAME_FIELD, MAT_UPLOAD_DEFAULT_SRC_FIELD, MAT_UPLOAD_DEFAULT_THUMB_FIELD, MAT_WATERFALL_DEFAULT_GUTTER, MatConfirmContainer, MatConfirmData, MatCopy, MatCopyComponent, MatCopyDirective, MatCopyModule, MatDate, MatDateHeader, MatDateModule, MatDialogComponent, MatDomHandler, MatDropdown, MatDropdownModule, MatField, MatFieldLabel, MatFieldModule, MatFieldWapper, MatFileUploadModule, MatFileUploadTrigger, MatFlatTree, MatFlatTreeModule, MatImage, MatImageList, MatImageModule, MatImageUploadModule, MatImageUploadTrigger, MatImageVirtualList, MatImageZoomDirective, MatImageZoomModule, MatInput, MatInputAfter, MatInputBefore, MatInputModule, MatInputNumber, MatInputNumberModule, MatLayer, MatLayerModule, MatLightBox, MatLightBoxService, MatLightboxConfig, MatLightboxModule, MatLightboxOverlayRef, MatModal, MatModalActions, MatModalClose, MatModalComponent, MatModalContent, MatModalModule, MatModalTitle, MatNotification, MatNotificationComponent, MatNotificationConfig, MatNotificationModule, MatPagination, MatPaginationModule, MatPopover, MatPopoverComponent, MatPopoverDirective, MatPopoverModule, MatPromptContainer, MatPromptData, MatRadioList, MatRadioListModule, MatReactiveForm, MatReactiveFormConfig, MatReactiveFormControlConfig, MatReactiveFormDesigner, MatReactiveFormErrorMessageStrategy, MatReactiveFormMessageConfig, MatReactiveFormModule, MatReactiveFormOperationConfig, MatReactiveFormUiConfig, MatReactiveLayout, MatReactiveTable, MatReactiveTableHeaderConfig, MatReactiveTableModule, MatReactiveTableOperationConfig, MatReactiveTableToolBarConfig, MatScrollposition, MatScrollpositionModule, MatSearch, MatSearchModule, MatSelectButton, MatSelectButtonModule, MatSide, MatSideConfig, MatSideContainer, MatSideModule, MatSliderRule, MatSliderRuleModule, MatStorage, MatTag, MatTagModule, MatTextLightDirective, MatTextLightModule, MatTextLightPipe, MatTextRetract, MatTextRetractModule, MatTextarea, MatTextareaModule, MatTextareaTip, MatTime, MatTimeline, MatTimelineItem, MatTimelineModule, MatToast, MatToastComponent, MatToastConfig, MatToastModule, MatTooltip, MatTooltipModule, MatTransfer, MatTransferModule, MatTreeSelect, MatTreeSelectModule, MatTreeSelectTrigger, MatUtils, MatWaterfall, MatWaterfallItem, MatWaterfallModule, MatZhnumberModule, MatZhnumberPipe, MtaFileUpload, MtaImageUpload, NewFrameConfig, OverlayService, PageEvent, SortOrder, dropdownScrollFactory, getConnectedPositionMap, getInvertPosition, getMatDropdownNonFunctionValueError, getMatRadioListNonFunctionValueError, getMatSelectButtonNonArrayValueError, getMatSelectButtonNonFunctionValueError, getMatTreeNonFunctionValueError, getPosition, getPositionName, getPositionNameByPosition, getWithPositions, throwMatSideContentAlreadyAttachedError, toastAnimation, verifyPosition } from '@angular/material/checkbox';
import { Clipboard, ClipboardModule } from '@angular/cdk/clipboard';
import { ComponentPortal, TemplatePortal, PortalInjector, DomPortal, BasePortalOutlet, CdkPortalOutlet, PortalModule } from '@angular/cdk/portal';
import { ESCAPE, ENTER, hasModifierKey } from '@angular/cdk/keycodes';
import { ScrollDispatcher, ScrollingModule } from '@angular/cdk/scrolling';
import { Overlay, OverlayModule, OverlayConfig, OverlayContainer } from '@angular/cdk/overlay';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { DateAdapter, MAT_DATE_LOCALE, MAT_DATE_FORMATS, MatCommonModule, MatRippleModule } from '@angular/material/core';
import { MatCalendar, MatCalendarHeader, MatDatepickerModule } from '@angular/material/datepicker';
import { MomentDateAdapter, MAT_MOMENT_DATE_ADAPTER_OPTIONS } from '@angular/material-moment-adapter';
import * as _rollupMoment from 'moment';
import _rollupMoment__default from 'moment';
import { MatDialogRef, MAT_DIALOG_DATA, MatDialog, MatDialogModule } from '@angular/material/dialog';
export * from '@angular/material/dialog';
import { MatSelect, MatSelectModule, MAT_SELECT_SCROLL_STRATEGY } from '@angular/material/select';
import { FocusMonitor, AriaDescriber, A11yModule } from '@angular/cdk/a11y';
import { Platform, normalizePassiveListenerOptions } from '@angular/cdk/platform';
import { TooltipComponent, TOOLTIP_PANEL_CLASS, MAT_TOOLTIP_SCROLL_STRATEGY, MAT_TOOLTIP_DEFAULT_OPTIONS, MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER, MatTooltipModule as MatTooltipModule$1, matTooltipAnimations } from '@angular/material/tooltip';
import { HttpParams, HttpHeaders, HttpClient, HttpEventType } from '@angular/common/http';
import { __awaiter } from 'tslib';
import { DomSanitizer } from '@angular/platform-browser';
import ImageViewer from 'iv-viewer';
import { MatSnackBarRef, MAT_SNACK_BAR_DATA, MatSnackBarModule, MatSnackBar } from '@angular/material/snack-bar';
import { MatRadioModule } from '@angular/material/radio';
export * from '@angular/material/radio';
import { MatSlider, MatSliderModule } from '@angular/material/slider';
export * from '@angular/material/slider';
import { MatTreeFlattener, MatTreeFlatDataSource, MatTreeModule } from '@angular/material/tree';
import { FlatTreeControl } from '@angular/cdk/tree';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
export * from '@angular/material/slide-toggle';
import { MatMenuModule } from '@angular/material/menu';
export * from '@angular/material/menu';
import { MatTable, MatTableModule } from '@angular/material/table';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import { HttpClient as HttpClient$1 } from '@angular//common/http';
export * from '@angular/material/tabs';
import * as Masonry from 'masonry-layout';
import imagesLoadedMethod from 'imagesloaded';

class MatBlock {
    constructor(_cd) {
        this._cd = _cd;
    }
    set lock(value) {
        if (value !== this._lock) {
            this._lock = coerceBooleanProperty(value);
        }
    }
    get lock() {
        return this._lock;
    }
    ngOnDestroy() {
    }
}
MatBlock.decorators = [
    { type: Component, args: [{
                selector: 'mat-block',
                exportAs: 'matBlock',
                template: "<div class=\"mat-block-container\" *ngIf=\"lock\">\r\n  <ng-template [ngTemplateOutlet]=\"default\"></ng-template>\r\n</div>\r\n<ng-content></ng-content>\r\n\r\n<ng-template #default>\r\n  <div class=\"mat-block-default\">\r\n    <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\"><path fill=\"currentColor\"  d=\"M298.666667 512v298.666667h469.333333v-298.666667H298.666667z m384-85.333333V320C682.666667 261.248 634.752 213.333333 575.744 213.333333h-84.821333A106.794667 106.794667 0 0 0 384 320V426.666667h298.666667z m-384 0V320C298.666667 213.973333 384.768 128 490.922667 128h84.821333A192.256 192.256 0 0 1 768 320V426.666667h85.333333v469.333333H213.333333V426.666667h85.333334z\"></path></svg>\r\n  </div>\r\n</ng-template>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-block]': 'true',
                    '[class.mat-block-active]': 'lock'
                }
            },] }
];
MatBlock.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatBlock.propDecorators = {
    lock: [{ type: Input }]
};

class MatBlockModule {
}
MatBlockModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [MatBlock],
                exports: [MatBlock]
            },] }
];

const DEFAULT_BUTTON_TYPE = 'default';
const DEFAULT_BUTTON_COLOR = 'primary';
const DEFAULT_BUTTON_SIZE = 'md';
const DEFAULT_TIME = 1000;
class MatButton {
    constructor() {
        /** Unique ID to be used by button's property. */
        this.id = null;
        /** This attribute indicates that this link should be used to download the file. */
        this.download = null;
        /** This attribute notifies the URLs indicated in it that the user clicked on the link. */
        this.ping = null;
        /** Where to display the contents of the link. Can be '_self', '_blank', '_parent', '_top', or some customer framename. */
        this.target = null;
        /** Url of link. */
        this.href = null;
        /** Event emitted when the button clicked by the user. */
        this.matClick = new EventEmitter();
        /** Click subject */
        this._click$ = new Subject();
        /** Size of the button. Can be 'lg' , 'md' , or 'sm'. */
        this._size = DEFAULT_BUTTON_SIZE;
        /** Millisecond of debounceTime. */
        this._debounceTime = 0;
        /** Millisecond of throttleTime. */
        this._throttleTime = 0;
        /** Whether button is disabled. */
        this._disabled = false;
        /** Used to mark whether or not it is loading */
        this._loading = false;
        /** Theme color palette for the button. */
        this._color = DEFAULT_BUTTON_COLOR;
        /** Styles used to describe the button. */
        this._displayType = DEFAULT_BUTTON_TYPE;
    }
    set size(value) {
        this._size = value || DEFAULT_BUTTON_SIZE;
    }
    get size() {
        return this._size;
    }
    set debounceTime(value) {
        this._debounceTime = value ? value : DEFAULT_TIME;
    }
    get debounceTime() {
        return this._debounceTime;
    }
    set throttleTime(value) {
        this._throttleTime = value ? value : DEFAULT_TIME;
    }
    get throttleTime() {
        return this._throttleTime;
    }
    get disabled() { return this._disabled; }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get loading() { return this._loading; }
    set loading(value) {
        this._loading = coerceBooleanProperty(value);
    }
    set color(value) {
        this._color = value || DEFAULT_BUTTON_COLOR;
    }
    get color() {
        return this._color;
    }
    set type(value) {
        this._type = value || DEFAULT_BUTTON_TYPE;
        this._setDisplayType();
    }
    get type() {
        return this._type;
    }
    _setDisplayType(on) {
        if (this.type && typeof this.type === 'object') {
            this._displayType = on ? (this.type.on || this.type.off) : (this.type.off || this.type.on);
        }
        else {
            this._displayType = this.type || DEFAULT_BUTTON_TYPE;
        }
    }
    set icon(value) {
        this._icon = value;
        this._setDisplayIcon();
    }
    get icon() {
        return this._icon;
    }
    _setDisplayIcon(on) {
        if (this.icon && typeof this.icon === 'object') {
            this._displayIcon = on ? (this.icon.on || this.icon.off) : (this.icon.off || this.icon.on);
        }
        else {
            this._displayIcon = this.icon;
        }
    }
    onMouseEnter() {
        if (!this.disabled) {
            this._setDisplayIcon(true);
            this._setDisplayType(true);
        }
    }
    onMouseLeave() {
        if (!this.disabled) {
            this._setDisplayIcon(false);
            this._setDisplayType(false);
        }
    }
    onClick(event) {
        if (this.disabled || this.loading) {
            return;
        }
        this._click$.next(event);
    }
    ngAfterViewInit() {
        this.registerClickEvent();
    }
    ngOnDestroy() {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
    }
    registerClickEvent() {
        this._subscription = this._click$.pipe(debounceTime(this.debounceTime || 0), throttleTime(this.throttleTime || 0), distinctUntilChanged()).subscribe(event => this.matClick.emit(event));
    }
}
MatButton.decorators = [
    { type: Component, args: [{
                selector: 'mat-buttons',
                template: "<a mat-button \r\n  [attr.id]=\"id\" \r\n  [attr.download]=\"download\" \r\n  [attr.ping]=\"ping\" \r\n  [attr.target]=\"target\" \r\n  [attr.href]=\"href\" \r\n  [color]=\"color\"\r\n  [disabled]=\"!!disabled\" \r\n  [disableRipple]=\"!!disableRipple\"\r\n  [class.mat-stroked-button]=\"_displayType === 'default' || _displayType === 'outline'\"\r\n  [class.mat-flat-button]=\"_displayType === 'fill'\"\r\n  [class.mat-icon-button]=\"_displayType === 'icon'\"\r\n>\r\n  <mat-icon [fontIcon]=\"_displayIcon\" *ngIf=\"_displayIcon\"></mat-icon>\r\n  <span *ngIf=\"label\" class=\"mat-buttons-text\">{{label}}</span>\r\n</a>",
                host: {
                    '[class.mat-buttons]': 'true',
                    '[class.mat-buttons-loading]': '!disabled && loading',
                    '[class.mat-buttons-default]': '_displayType === "default"',
                    '[class.mat-buttons-outline]': '_displayType === "outline"',
                    '[class.mat-buttons-fill]': '_displayType === "fill"',
                    '[class.mat-buttons-icon]': '_displayType === "icon"',
                    '[class.mat-buttons-text]': '_displayType === "text"',
                    '[class.mat-buttons-lg]': 'size === "lg"',
                    '[class.mat-buttons-md]': 'size === "md"',
                    '[class.mat-buttons-sm]': 'size === "sm"',
                    '(mouseenter)': 'onMouseEnter()',
                    '(mouseleave)': 'onMouseLeave()',
                    '(click)': 'onClick($event)',
                },
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            },] }
];
MatButton.propDecorators = {
    id: [{ type: Input }],
    label: [{ type: Input }],
    disableRipple: [{ type: Input }],
    download: [{ type: Input }],
    ping: [{ type: Input }],
    target: [{ type: Input }],
    href: [{ type: Input }],
    matClick: [{ type: Output }],
    size: [{ type: Input }],
    debounceTime: [{ type: Input }],
    throttleTime: [{ type: Input }],
    disabled: [{ type: Input }],
    loading: [{ type: Input }],
    color: [{ type: Input }],
    type: [{ type: Input }],
    icon: [{ type: Input }]
};

class MatButtonsModule {
}
MatButtonsModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatButtonModule, MatIconModule],
                exports: [MatButton],
                declarations: [MatButton],
                providers: [],
            },] }
];

function getMatCheckboxListNonFunctionValueError() {
    return Error('`compareWith` must be a function.');
}
const MAT_CHECKBOX_LIST_DEFAULT_VIEW_FIELD = 'label';
const MAT_CHECKBOX_LIST_DEFAULT_DISABLED_FIELD = 'disabled';
const MAT_CHECKBOX_LIST_DEFAULT_COLOR = 'primary';
const MAT_CHECKBOX_LIST_DEFAULT_DIRECTION = 'horizontal';
const MAT_CHECKBOX_LIST_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatCheckboxList),
    multi: true
};
class MatCheckboxList {
    constructor(_cd) {
        this._cd = _cd;
        /** Emit event subject */
        this._valueChange$ = new Subject();
        this.matChange = new EventEmitter();
        /** Whether the label should appear before or after the checkbox. Defaults to 'after' */
        this.labelPosition = 'after';
        /** Tabindex of the selection list. */
        this.tabIndex = 0;
        /** Field name of disabled when datasource as objecet array. */
        this.disabledField = MAT_CHECKBOX_LIST_DEFAULT_DISABLED_FIELD;
        /** Field name of view when datasource as objecet array. */
        this.viewField = MAT_CHECKBOX_LIST_DEFAULT_VIEW_FIELD;
        /** Whether multiple checkbox can be selected. */
        this._multiple = true;
        /** Whether the option is disabled. */
        this._disabled = false;
        /** Comparison function to specify which option is checked. Defaults to object equality. */
        this._compareWith = (o1, o2) => o1 === o2;
        /** Option of the checkbox. */
        this._dataSource = null;
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
    }
    get color() {
        return this._color || MAT_CHECKBOX_LIST_DEFAULT_COLOR;
    }
    set color(newValue) {
        this._color = newValue;
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get direction() {
        return this._direction || MAT_CHECKBOX_LIST_DEFAULT_DIRECTION;
    }
    set direction(newValue) {
        this._direction = newValue;
    }
    set multiple(value) {
        this._multiple = coerceBooleanProperty(value);
    }
    get multiple() {
        return this._multiple;
    }
    get disabled() { return this._disabled; }
    set disabled(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this._disabled) {
            this._disabled = newValue;
            this._cd.markForCheck();
        }
    }
    get compareWith() { return this._compareWith; }
    set compareWith(fn) {
        if (typeof fn !== 'function') {
            throw getMatCheckboxListNonFunctionValueError();
        }
        this._compareWith = fn;
        if (this._selectionModel) {
            // A different comparator means the selection could change.
            this._initializeSelection(this.value);
        }
    }
    /** Value of the checkbox list. */
    get value() {
        return this._value;
    }
    set value(newValue) {
        this._value = newValue;
        if (this.dataSource) {
            this._setSelectionByValue(newValue);
        }
    }
    set dataSource(dataValue) {
        this._dataSource = [];
        const data = Array.isArray(dataValue) ? dataValue : [];
        data.forEach(item => {
            const isItemString = typeof item === 'string';
            const disabled = isItemString ? false : !!item[this.disabledField || MAT_CHECKBOX_LIST_DEFAULT_DISABLED_FIELD];
            const value = (isItemString || !this.valueField) ? item : item[this.valueField];
            const view = isItemString ? item : item[this.viewField || MAT_CHECKBOX_LIST_DEFAULT_VIEW_FIELD];
            this._dataSource.push({ view, value, data: item, disabled });
        });
        if (this.value) {
            this._initializeSelection(this.value);
        }
    }
    get dataSource() {
        return this._dataSource;
    }
    /**
     * Sets the selected option based on a value. If no option can be
     * found with the designated value, the select trigger is cleared.
     */
    _setSelectionByValue(value) {
        if (this.multiple && value) {
            if (!Array.isArray(value)) {
                throw getMatCheckboxListNonFunctionValueError();
            }
            this._selectionModel.clear();
            value.forEach((currentValue) => this._selectValue(currentValue));
        }
        else {
            this._selectionModel.clear();
            this._selectValue(value);
        }
    }
    /** Invoked when an option is clicked. */
    _onCheckboxOptionChange(checkbox) {
        this._onTouched();
        this._selectionModel.toggle(checkbox.source.value);
        this._propagateChanges();
    }
    /** Whether the checkbox is all selected. */
    isAllSelected() {
        if (!this.dataSource || !this.dataSource.length || !this.multiple) {
            return false;
        }
        else {
            const result = this.dataSource.find((option) => {
                return !option.disabled && !this._selectionModel.isSelected(option.value);
            });
            return !result;
        }
    }
    /** Select all checkboxs */
    selectAll() {
        if (!this.multiple || this.disabled) {
            return;
        }
        if (this.dataSource && this.dataSource.length) {
            this.dataSource.forEach((option) => {
                if (!option.disabled && !this._selectionModel.isSelected(option.value)) {
                    this._selectionModel.select(option.value);
                }
            });
            this._propagateChanges();
        }
    }
    /** UnSelect all checkboxs */
    unSelectAll() {
        if (!this.multiple || this.disabled) {
            return;
        }
        this._selectionModel.clear();
        this._propagateChanges();
    }
    /**
     * Finds and selects and option based on its value.
     * @returns Option that has the corresponding value.
     */
    _selectValue(value) {
        const correspondingOption = this.dataSource.find((option) => {
            try {
                // Treat null as a special reset value.
                return option.value != null && this._compareWith(option.value, value);
            }
            catch (error) {
                if (isDevMode()) {
                    // Notify developers of errors in their comparator.
                    console.warn(error);
                }
                return false;
            }
        });
        if (correspondingOption) {
            this._selectionModel.select(correspondingOption.value);
        }
        return correspondingOption;
    }
    /** Whether data source is empty. */
    isDataSourceEmpty() {
        return !this.dataSource || !this.dataSource.length;
    }
    /** Checks whether a checkbox is selected. */
    _isSelected(data) {
        return this._selectionModel && this._selectionModel.isSelected(data.value);
    }
    _initializeSelection(value, emit = true) {
        // Defer setting the value in order to avoid the "Expression
        // has changed after it was checked" errors from Angular.
        Promise.resolve().then(() => {
            this._setSelectionByValue(value);
        });
    }
    /** Emits change event to set the model value. */
    _propagateChanges(emit = true) {
        let valueToEmit = null;
        const selected = this._selectionModel.selected;
        if (this.multiple) {
            valueToEmit = selected.length ? selected : undefined;
        }
        else {
            valueToEmit = selected[0] || undefined;
        }
        this._controlValueAccessorChangeFn(valueToEmit);
        this._value = valueToEmit;
        if (emit) {
            this._valueChange$.next(valueToEmit);
        }
        this._cd.markForCheck();
    }
    ngOnInit() {
        this._selectionModel = new SelectionModel(this.multiple, undefined, false);
        this.registerEmitEvent();
    }
    ngOnDestroy() {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
    }
    registerEmitEvent() {
        this._subscription = this._valueChange$.pipe(debounceTime(200), distinctUntilChanged()).subscribe(event => this.matChange.emit(event));
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.value = value;
        this._cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatCheckboxList.decorators = [
    { type: Component, args: [{
                selector: 'mat-checkbox-list',
                exportAs: 'matCheckboxList',
                template: "<mat-checkbox\r\n *ngFor=\"let option of dataSource\"\r\n [color]=\"color\"\r\n [disabled]=\"disabled || option.disabled\"\r\n [checked]=\"_isSelected(option)\"\r\n [value]=\"option.value\"\r\n [labelPosition]=\"labelPosition\"\r\n (change)=\"_onCheckboxOptionChange($event)\"\r\n >\r\n {{option.view}}\r\n</mat-checkbox>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                providers: [MAT_CHECKBOX_LIST_VALUE_ACCESSOR],
                host: {
                    '[attr.role]': 'option',
                    '[attr.tabindex]': 'tabIndex',
                    '[class.mat-checkbox-list]': 'true',
                    '[class.mat-checkbox-list-vertical]': 'direction === "vertical"',
                    '[class.mat-checkbox-list-horizontal]': 'direction === "horizontal"',
                }
            },] }
];
MatCheckboxList.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatCheckboxList.propDecorators = {
    matChange: [{ type: Output }],
    labelPosition: [{ type: Input }],
    tabIndex: [{ type: Input }],
    disabledField: [{ type: Input }],
    viewField: [{ type: Input }],
    valueField: [{ type: Input }],
    name: [{ type: Input }],
    color: [{ type: Input }],
    required: [{ type: Input }],
    direction: [{ type: Input }],
    multiple: [{ type: Input }],
    disabled: [{ type: Input }],
    compareWith: [{ type: Input }],
    value: [{ type: Input }],
    dataSource: [{ type: Input }]
};

class MatCheckboxListModule {
}
MatCheckboxListModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatCheckboxModule],
                exports: [MatCheckboxList, MatCheckboxModule],
                declarations: [MatCheckboxList],
                providers: [],
            },] }
];

class MatDomHandler {
    constructor() { }
    addClass(element, className) {
        const styles = className.split(' ');
        if (element.classList) {
            styles.forEach(name => {
                if (name) {
                    element.classList.add(name);
                }
            });
        }
        else {
            styles.forEach(name => element.className += ' ' + name);
        }
    }
    removeClass(element, className) {
        if (element.classList) {
            element.classList.remove(className.trim());
        }
        else {
            element.className = element.className.replace(new RegExp('(^|\\b)' + className.split(' ').join('|') + '(\\b|$)', 'gi'), ' ');
        }
    }
    getStyles(el, property) {
        if (window.getComputedStyle) {
            return window.getComputedStyle(el, null)[property];
        }
        else if (el.currentStyle) {
            return el.currentStyle[property];
        }
    }
    getScroll(el) {
        const element = el === window ? (document.documentElement || document.body) : el;
        const scrollHeight = element.scrollHeight, scrollWidth = element.scrollWidth, clientHeight = element.clientHeight, clientWidth = element.clientWidth, top = element.scrollTop, bottom = scrollHeight - clientHeight - top, left = element.scrollLeft, right = scrollWidth - clientWidth - left;
        return { scrollHeight, scrollWidth, top, bottom, left, right };
    }
    scrollTop(el, topValue = 0) {
        if (el === window) {
            document.body.scrollTop = topValue;
            if (document.documentElement) {
                document.documentElement.scrollTop = topValue;
            }
        }
        else {
            el.scrollTop = topValue;
        }
    }
    scrollBottom(el, bottomValue = 0) {
        const element = el === window ? (document.documentElement || document.body) : el;
        const scrollHeight = element.scrollHeight, clientHeight = element.clientHeight;
        if (scrollHeight - clientHeight > bottomValue) {
            element.scrollTop = scrollHeight - clientHeight - bottomValue;
        }
    }
}
MatDomHandler.decorators = [
    { type: Injectable }
];
MatDomHandler.ctorParameters = () => [];

const MAT_DEFAULT_POSITION = 'TC';
const MAT_POSITIONS = ['LT', 'LC', 'LB', 'TL', 'TC', 'TR', 'RT', 'RC', 'RB', 'BL', 'BC', 'BR'];
function verifyPosition(position) {
    const positionSet = new Set(MAT_POSITIONS);
    if (!positionSet.has(position)) {
        throw Error(`Position params "${position}" is invalid.`);
    }
}
function getPositionName(key) {
    return {
        LT: ['LT', 'RT', 'LB', 'RB'],
        LC: ['LC', 'RC', 'LT', 'LB', 'RT', 'RB'],
        LB: ['LB', 'RB', 'LT', 'RT'],
        TL: ['TL', 'BL', 'TR', 'BR'],
        TC: ['TC', 'BC', 'TL', 'BL', 'TR', 'BR'],
        TR: ['TR', 'BR', 'TL', 'BL'],
        RT: ['RT', 'LT', 'RB', 'LB'],
        RC: ['RC', 'LC', 'RT', 'RB', 'LT', 'LB'],
        RB: ['RB', 'LB', 'RT', 'LT'],
        BL: ['BL', 'TL', 'BR', 'TR'],
        BC: ['BC', 'TC', 'BL', 'BR', 'TL', 'TR'],
        BR: ['BR', 'TR', 'BL', 'TL'],
    }[key];
}
function getConnectedPositionMap(offsetX, offsetY) {
    const PositionMap = {
        LT: { originX: 'start', originY: 'top', overlayX: 'end', overlayY: 'top', offsetX: -offsetX, offsetY: 0 },
        LC: { originX: 'start', originY: 'center', overlayX: 'end', overlayY: 'center', offsetX: -offsetX, offsetY: 0 },
        LB: { originX: 'start', originY: 'bottom', overlayX: 'end', overlayY: 'bottom', offsetX: -offsetX, offsetY: 0 },
        TL: { originX: 'start', originY: 'top', overlayX: 'start', overlayY: 'bottom', offsetX: 0, offsetY: -offsetY },
        TC: { originX: 'center', originY: 'top', overlayX: 'center', overlayY: 'bottom', offsetX: 0, offsetY: -offsetY },
        TR: { originX: 'end', originY: 'top', overlayX: 'end', overlayY: 'bottom', offsetX: 0, offsetY: -offsetY },
        RT: { originX: 'end', originY: 'top', overlayX: 'start', overlayY: 'top', offsetX, offsetY: 0 },
        RC: { originX: 'end', originY: 'center', overlayX: 'start', overlayY: 'center', offsetX, offsetY: 0 },
        RB: { originX: 'end', originY: 'bottom', overlayX: 'start', overlayY: 'bottom', offsetX, offsetY: 0 },
        BL: { originX: 'start', originY: 'bottom', overlayX: 'start', overlayY: 'top', offsetX: 0, offsetY },
        BC: { originX: 'center', originY: 'bottom', overlayX: 'center', overlayY: 'top', offsetX: 0, offsetY },
        BR: { originX: 'end', originY: 'bottom', overlayX: 'end', overlayY: 'top', offsetX: 0, offsetY },
    };
    return PositionMap;
}
function getPosition(position, offsetX = 0, offsetY = 0) {
    verifyPosition(position.toUpperCase());
    const positionmap = getConnectedPositionMap(offsetX, offsetY);
    return positionmap[position];
}
function getInvertPosition(position, offsetX = 0, offsetY = 0) {
    const invertMap = {
        LT: 'RT', LC: 'RC', LB: 'RB',
        TL: 'BL', TC: 'BC', TR: 'BR',
        RT: 'LT', RC: 'LC', RB: 'LB',
        BL: 'TL', BC: 'TC', BR: 'TR',
    };
    return getPosition(invertMap[position], offsetX, offsetY);
}
function getWithPositions(position, offsetX = 0, offsetY = 0) {
    return getPositionName(position).map((name) => getPosition(name, offsetX, offsetY));
}
function getPositionNameByPosition(position) {
    const keyList = ['originX', 'originY', 'overlayX', 'overlayY'];
    const positionmap = getConnectedPositionMap();
    for (const positionName in positionmap) {
        if (keyList.every(key => position[key] === positionmap[positionName][key])) {
            return positionName;
        }
    }
}

class OverlayService {
    constructor(_overlay, _ngZone, _scrollDispatcher) {
        this._overlay = _overlay;
        this._ngZone = _ngZone;
        this._scrollDispatcher = _scrollDispatcher;
        this._destroyed = new Subject();
        this._onClose = new Subject();
    }
    createOverlay(connectedTo, config) {
        if (this._overlayRef && this._connectedTo === connectedTo) {
            return this._overlayRef;
        }
        this._connectedTo = connectedTo;
        const scrollableAncestors = connectedTo instanceof ElementRef ? this._scrollDispatcher.getAncestorScrollContainers(connectedTo) : [];
        const strategy = this._overlay.position()
            .flexibleConnectedTo(connectedTo)
            .withTransformOriginOn(config.withTransformOriginOn || 'body')
            .withFlexibleDimensions(config.withFlexibleDimensions || false)
            .withViewportMargin(config.withViewportMargin || 0)
            .withScrollableContainers(scrollableAncestors);
        strategy.positionChanges.pipe(takeUntil(this._destroyed)).subscribe(change => {
            if (this._overlayRef) {
                const prefix = 'mat-overlay-position-';
                const currentPosition = getPositionNameByPosition(change.connectionPair);
                this._overlayRef.overlayElement.classList.forEach(className => {
                    if (className.startsWith(prefix)) {
                        this._overlayRef.overlayElement.classList.remove(className);
                    }
                });
                this._overlayRef.overlayElement.classList.add(`mat-overlay-position-${currentPosition}`);
                if (this._overlayInstance && change.scrollableViewProperties.isOverlayClipped && this._overlayInstance.isVisible && this._overlayInstance.isVisible()) {
                    this._ngZone.run(() => this.close());
                }
            }
        });
        this._overlayRef = this._overlay.create({
            positionStrategy: strategy,
            panelClass: config.panelClass || 'mat-overlay-service-panel',
            backdropClass: config.backdropClass || 'mat-overlay-service-backdrop',
            hasBackdrop: config.hasBackdrop === false ? false : true,
            scrollStrategy: config.scrollStrategy || null,
            disposeOnNavigation: config.disposeOnNavigation === false ? false : true
        });
        this._overlayRef.backdropClick().subscribe(() => this.close());
        this._overlayRef.keydownEvents().pipe(filter((event) => event.keyCode === ESCAPE)).subscribe(() => this.close());
        this.updatePosition(config.position || MAT_DEFAULT_POSITION, config.offsetX, config.offsetY);
        this._overlayRef.detachments()
            .pipe(takeUntil(this._destroyed))
            .subscribe(() => this.close());
        return this._overlayRef;
    }
    updatePosition(positionStr, offsetX, offsetY) {
        const position = this._overlayRef.getConfig().positionStrategy;
        position.withPositions(getWithPositions(positionStr, offsetX, offsetY));
    }
    updateOverlayPosition() {
        this._overlayRef.updatePosition();
    }
    open(connectedTo, portal, config) {
        const overlayRef = this.createOverlay(connectedTo, config);
        this.close();
        const attachResult = overlayRef.attach(portal);
        this._overlayInstance = attachResult ? attachResult.instance : null;
        return this._overlayInstance;
    }
    hasOverlay() {
        return !!this._overlayRef;
    }
    afterClose() {
        return this._onClose.asObservable();
    }
    close() {
        if (this._overlayRef && this._overlayRef.hasAttached()) {
            this._overlayRef.detach();
            this._onClose.next();
        }
        this._overlayInstance = null;
    }
    ngOnDestroy() {
        if (this._overlayRef) {
            this._overlayRef.dispose();
            this._overlayInstance = null;
        }
        this._destroyed.next();
        this._destroyed.complete();
        this._onClose.complete();
    }
}
OverlayService.decorators = [
    { type: Injectable }
];
OverlayService.ctorParameters = () => [
    { type: Overlay },
    { type: NgZone },
    { type: ScrollDispatcher }
];

class MatStorage {
    constructor() {
        this._storage = window.localStorage;
        this._onChange = new Subject();
        this._registerEventListener();
    }
    /** utf8 to base64 */
    _UToB(value) {
        return window.btoa(unescape(encodeURIComponent(value)));
    }
    /** base64 to utf8 */
    _BToU(value) {
        return decodeURIComponent(escape(window.atob(value)));
    }
    /** where is expires */
    _isExpires(value) {
        const time = value._updateAt || value._createAt;
        const expires = value._expiresAt;
        if (!time || !expires) {
            return false;
        }
        else {
            return Date.now() > time + expires;
        }
    }
    /** format data to  StorageItem. */
    _getStringValue(value, expiresAt, createAt) {
        return this._UToB(JSON.stringify({
            _createAt: createAt || Date.now(),
            _updateAt: createAt ? Date.now() : '',
            _expiresAt: expiresAt || '',
            value
        }));
    }
    /** register event listener on storage change. */
    _registerEventListener() {
        console.log('_registerEventListener');
        window.addEventListener('storage', (e) => {
            this._onChange.next({ key: e.key, value: this.get(e.key) });
        });
    }
    /** get value by key. */
    get(key, fullProperty) {
        if (this.includes(key)) {
            const value = JSON.parse(this._BToU(this._storage.getItem(key)));
            if (this._isExpires(value)) {
                this.remove(key);
                return null;
            }
            else {
                return fullProperty ? value : value.value;
            }
        }
        else {
            return null;
        }
    }
    /**
     * @param expires Set the period of validity, unit seconds.
     * @description Add or update data.
     */
    set(key, value, expires = '') {
        if (this.includes(key)) {
            const item = this.get(key, true) || {};
            if (item.value !== value || expires != item._expiresAt) {
                this._storage.setItem(key, this._getStringValue(value, Number(expires) || item._expiresAt, item._createAt));
                this._onChange.next({ key, value });
            }
        }
        else {
            this._storage.setItem(key, this._getStringValue(value, Number(expires)));
            this._onChange.next({ key, value });
        }
    }
    /** remove item by key */
    remove(key) {
        this._storage.removeItem(key);
        this._onChange.next({ key, value: null });
    }
    /** clear all of the storage */
    clear() {
        this._storage.clear();
    }
    /** the count that storage has stored. */
    length() {
        return this._storage.length;
    }
    /** get all keys array. */
    keys() {
        return Array.from({
            length: this.length()
        }).map((_, index) => this._storage.key(index));
    }
    /** where the key is existed. */
    includes(key) {
        return this._storage.hasOwnProperty(key);
    }
    /** return a Observable to watch change by key */
    observable(key) {
        return this._onChange.asObservable().pipe(filter(value => value.key === key), map(({ value }) => value));
    }
}
MatStorage.ɵprov = ɵɵdefineInjectable({ factory: function MatStorage_Factory() { return new MatStorage(); }, token: MatStorage, providedIn: "platform" });
MatStorage.decorators = [
    { type: Injectable, args: [{ providedIn: 'platform' },] }
];
MatStorage.ctorParameters = () => [];

class MatUtils {
    static isObject(value) {
        return Object.prototype.toString.call(value) === '[object Object]';
    }
    static isArray(value) {
        return Object.prototype.toString.call(value) === '[object Array]';
    }
    static isNull(value) {
        return Object.prototype.toString.call(value) === '[object Null]';
    }
    static isEmpty(value, trim = false) {
        return value !== 0 && (value === undefined || value === null || value === '' || (trim && String(value).trim() === ''));
    }
    static isJson(value) {
        let result = false;
        try {
            const json = JSON.parse(value);
            result = !!json && typeof json === 'object';
        }
        catch (ex) {
            result = false;
        }
        return result;
    }
    // Get object value from path.
    static getObjectValue(key, object) {
        if (!key || !object) {
            return null;
        }
        let value;
        const keys = key.split('.');
        for (const k of keys) {
            value = value || object;
            value = value[k];
            if (!value) {
                break;
            }
        }
        return value;
    }
    // Set object value form path.
    static setObjectValue(key, newValue, object) {
        let value = object;
        const keys = key.split('.');
        for (let i = 0; i < keys.length - 1; i++) {
            value[keys[i]] = value[keys[i]] || {};
            value = value[keys[i]];
        }
        value[keys[keys.length - 1]] = newValue;
        return object;
    }
    static isStringFunction(expression) {
        const keys = ['=>', 'function', 'return'];
        return keys.some(key => expression.includes(key));
    }
    static functionCreator(expression) {
        const match = expression.match(/^\s*\(?\s*([^)]*)\s*\)?\s*=>(.*)/);
        const params = match[1];
        const body = !match[2].trim().startsWith('{') && !match[2].trim().endsWith('}') ? 'return ' + match[2] : match[2];
        return new Function(params, body);
    }
    static isFormData(formValue) {
        return typeof FormData !== 'undefined' && formValue instanceof FormData;
    }
    static isBlob(formValue) {
        return typeof Blob !== 'undefined' && formValue instanceof Blob;
    }
    static isArrayBuffer(formValue) {
        return typeof ArrayBuffer !== 'undefined' && formValue instanceof ArrayBuffer;
    }
    /** Execute function or value to boolean. */
    static executeBooleanValue(value, params) {
        if (typeof value === 'boolean') {
            return value;
        }
        else if (typeof value === 'function') {
            return value(params);
        }
        else if (typeof value === 'string') {
            if (MatUtils.isStringFunction(value)) {
                return MatUtils.functionCreator(value)(params);
            }
        }
    }
    /** Execute function or value to string. */
    static executeStringValue(value, params) {
        if (typeof value === 'string') {
            if (MatUtils.isStringFunction(value)) {
                return MatUtils.functionCreator(value)(params);
            }
            else {
                return value;
            }
        }
        else if (typeof value === 'function') {
            return value(params);
        }
        else {
            return value;
        }
    }
    /** Execute function or value to object. */
    static executeObjectValue(value, params) {
        if (typeof value === 'string' && MatUtils.isStringFunction(value)) {
            return MatUtils.functionCreator(value)(params);
        }
        else if (typeof value === 'function') {
            return value(params);
        }
        else {
            return value;
        }
    }
    /** Execute function or value to function. */
    static executeFunctionValue(value) {
        if (typeof value === 'string' && MatUtils.isStringFunction(value)) {
            return MatUtils.functionCreator(value);
        }
        else if (typeof value === 'function') {
            return value;
        }
    }
}
MatUtils.ɵprov = ɵɵdefineInjectable({ factory: function MatUtils_Factory() { return new MatUtils(); }, token: MatUtils, providedIn: "platform" });
MatUtils.decorators = [
    { type: Injectable, args: [{ providedIn: 'platform' },] }
];

class MatCopyComponent {
    constructor() {
        this._onClick = new Subject();
    }
    onClick() {
        this.hasClicked = true;
        this._onClick.next();
    }
    afterClick() {
        return this._onClick.asObservable().pipe(debounceTime(200));
    }
    ngOnDestroy() {
        this._onClick.complete();
    }
}
MatCopyComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-copy',
                template: "<div>{{hasClicked ? '\u590D\u5236\u6210\u529F' : '\u70B9\u51FB\u590D\u5236'}}</div>",
                animations: [
                    trigger('status', [
                        state('open', style({ transform: 'translateY(0)' })),
                        state('close', style({ transform: 'translateY(-100%)' })),
                        transition('void => open', [
                            animate('200ms ease-in'),
                        ]),
                        transition('open => close', [
                            animate('200ms ease-in'),
                        ])
                    ])
                ],
                host: {
                    '(click)': 'onClick()',
                    '[@status]': 'hasClicked ? "close" : "open"',
                    '[class.mat-copy-complete]': 'hasClicked'
                }
            },] }
];

class MatCopyDirective {
    constructor(_viewContainerRef, _copy, _elementRef, _overlay) {
        this._viewContainerRef = _viewContainerRef;
        this._copy = _copy;
        this._elementRef = _elementRef;
        this._overlay = _overlay;
        /** keyUp subject */
        this._keyUp$ = new Subject();
    }
    set disabled(value) {
        if (value !== this._disabled) {
            this._disabled = coerceBooleanProperty(value);
        }
    }
    get disabled() {
        return this._disabled;
    }
    getSelection() {
        if (!this.disabled && window.getSelection) {
            const selectText = window.getSelection().toString();
            const selectRange = window.getSelection().getRangeAt(0);
            const { x, y, width, height } = selectRange.getBoundingClientRect();
            if (selectText) {
                this.open({ x, y, width, height }, selectText);
            }
        }
    }
    open(connectedTo, selectText) {
        const portal = new ComponentPortal(MatCopyComponent, this._viewContainerRef);
        this._overlay.close();
        const instance = this._overlay.open(connectedTo, portal, {
            withViewportMargin: 0,
            hasBackdrop: true,
            backdropClass: 'mat-overlay-transparent-backdrop',
            position: 'BR',
            offsetY: 8
        });
        instance.afterClick().subscribe(e => {
            this.copy(selectText);
            this.close();
        });
    }
    /** Close the overlay. */
    close() {
        this._overlay.close();
    }
    copy(text) {
        if (text) {
            this._copy.copy(text);
        }
    }
    onKeyup() {
        this._keyUp$.next();
    }
    registerKeyUpEvent() {
        this._keyUp$.asObservable().pipe(debounceTime(200)).subscribe(event => {
            this.getSelection();
        });
    }
    ngOnInit() {
        this.registerKeyUpEvent();
    }
    ngOnDestroy() {
    }
}
MatCopyDirective.decorators = [
    { type: Directive, args: [{
                selector: '[matCopy]',
                exportAs: 'matCopy',
                providers: [OverlayService],
                host: {
                    '(click)': 'onKeyup()',
                }
            },] }
];
MatCopyDirective.ctorParameters = () => [
    { type: ViewContainerRef },
    { type: Clipboard },
    { type: ElementRef },
    { type: OverlayService }
];
MatCopyDirective.propDecorators = {
    disabled: [{ type: Input }]
};

class MatCopyModule {
}
MatCopyModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, ClipboardModule],
                declarations: [MatCopyDirective, MatCopyComponent],
                exports: [MatCopyDirective, MatCopyComponent],
                entryComponents: [MatCopyComponent]
            },] }
];

const MaxLength = Math.pow(2, 16);
const Attempts = 3;
class MatCopy {
    constructor(_copy) {
        this._copy = _copy;
    }
    copy(text, max = MaxLength) {
        if (text && text.length > max) {
            throw Error(`'Copy text must be less than the max ${max}, Please replace with copyMore.'`);
        }
        this._copy.copy(text);
    }
    copyMore(text, attempts = Attempts) {
        const copyPending = this._copy.beginCopy(text);
        const copyResult = new Subject();
        const attempt = () => {
            setTimeout(() => {
                const result = copyPending.copy();
                if (!result && --attempts) {
                    attempt();
                }
                else {
                    copyResult.next(!!result);
                    copyResult.complete();
                    copyPending.destroy();
                }
            }, 100);
        };
        attempt();
        return copyResult.asObservable();
    }
}
MatCopy.ɵprov = ɵɵdefineInjectable({ factory: function MatCopy_Factory() { return new MatCopy(ɵɵinject(Clipboard)); }, token: MatCopy, providedIn: MatCopyModule });
MatCopy.decorators = [
    { type: Injectable, args: [{ providedIn: MatCopyModule },] }
];
MatCopy.ctorParameters = () => [
    { type: Clipboard }
];

/**
 * TODO:Create Content Component For focusActiveCell;
 */
const moment = _rollupMoment__default || _rollupMoment;
const LocalFormats = {
    parse: {
        dateInput: 'YYYY-MM-DD HH:mm:ss',
    },
    display: {
        dateInput: 'YYYY-MM-DD HH:mm:ss',
        monthYearLabel: 'YYYY-MM',
        dateA11yLabel: 'LL',
        monthYearA11yLabel: 'YYYY-MM',
    },
};
const MAT_DATE_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatDate),
    multi: true
};
class MatDate {
    constructor(_cd, _ele, _viewContainerRef, _overlay) {
        this._cd = _cd;
        this._ele = _ele;
        this._viewContainerRef = _viewContainerRef;
        this._overlay = _overlay;
        this.matOpened = new EventEmitter();
        this.yearSelected = new EventEmitter();
        this.monthSelected = new EventEmitter();
        this.daySelected = new EventEmitter();
        this.placeholder = '';
        this.tabIndex = 0;
        /** Whether the value is required. */
        this._required = false;
        this._type = 'day';
        this._touchUi = false;
        this._showTime = false;
        /** Whether the option is disabled. */
        this._disabled = false;
        this._opened = false;
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
    }
    get formatDefault() {
        if (this.type === 'year') {
            return 'YYYY';
        }
        else if (this.type === 'month') {
            return 'YYYY-MM';
        }
        else {
            return 'YYYY-MM-DD' + (this.showTime ? ' HH:mm:ss' : '');
        }
    }
    set maxDate(value) {
        this._maxDate = value ? moment(value) : null;
        if (this._maxDate && this._selected && this._maxDate.isBefore(this._selected)) {
            this.clearValue();
        }
        this._cd.markForCheck();
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    set minDate(value) {
        this._minDate = value ? moment(value) : null;
        if (this._minDate && this._selected && this._minDate.isAfter(this._selected)) {
            this.clearValue();
        }
        this._cd.markForCheck();
    }
    /** The date to open the calendar to initially. */
    get startAt() {
        return this._startAt || this._validSelected || null;
    }
    set startAt(value) {
        if (value) {
            this._startAt = moment(value);
        }
        else {
            this._startAt = null;
        }
    }
    set dateFilter(value) {
        this._dateFilter = value;
        this._cd.markForCheck();
    }
    get dateFilter() {
        return this._dateFilter;
    }
    set type(value) {
        if (value !== this._type) {
            this._type = value || 'day';
            if (this.opened) {
                this.close();
            }
        }
    }
    get type() {
        return this._type;
    }
    get startView() {
        if (this.type === 'year') {
            return 'multi-year';
        }
        else if (this.type === 'month') {
            return 'year';
        }
        else {
            return 'month';
        }
    }
    get touchUi() { return this._touchUi; }
    set touchUi(value) {
        const newValue = coerceBooleanProperty(value);
        if (this._touchUi !== newValue) {
            this._touchUi = newValue;
            this._cd.markForCheck();
        }
    }
    get showTime() { return this._showTime; }
    set showTime(value) {
        const newValue = coerceBooleanProperty(value);
        if (this._showTime !== newValue) {
            this._showTime = newValue;
            this._cd.markForCheck();
        }
    }
    get disabled() { return this._disabled; }
    set disabled(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this._disabled) {
            this._disabled = newValue;
            this._cd.markForCheck();
        }
    }
    /** Whether the calendar is open. */
    get opened() { return this._opened; }
    set opened(value) { value ? this.open() : this.close(); }
    get selected() { return this._selected; }
    set selected(value) {
        if (value) {
            this._validSelected = moment(value);
            this._selected = this._validSelected.format(this.format || this.formatDefault);
            this._timeSelected = this._validSelected.format('HH:mm:ss');
        }
        else {
            this._validSelected = null;
            this._selected = '';
            this._timeSelected = this.getTimeDefault();
        }
        this._cd.markForCheck();
    }
    /** Get default time value. */
    getTimeDefault() {
        if (this._minDate && this.showTime) {
            return this._minDate.format('HH:mm:ss');
        }
        else {
            return '00:00:00';
        }
    }
    toggleTime() {
        this._timeOpened = !this._timeOpened;
    }
    /** Open the calendar. */
    open() {
        if (this._opened || this.disabled) {
            return;
        }
        this._validSelected = this._selected ? moment(this._selected) : moment(new Date());
        this._openAsPopup();
        this._opened = true;
        this.matOpened.emit(true);
        this.setMaxAndMinTime();
    }
    setMaxAndMinTime() {
        if (this.showTime) {
            if (this._minDate && this._minDate.isSame(this._validSelected, 'day')) {
                this._minTime = this._minDate.format('HH:mm:ss');
                if (this._timeSelected && moment(this._minTime, 'HH:mm:ss').diff(moment(this._timeSelected, 'HH:mm:ss')) > 0) {
                    this._timeSelected = this._minTime;
                }
            }
            else {
                this._minTime = null;
            }
            if (this._maxDate && this._maxDate.isSame(this._validSelected, 'day')) {
                this._maxTime = this._maxDate.format('HH:mm:ss');
                if (this._timeSelected && moment(this._maxTime, 'HH:mm:ss').diff(moment(this._timeSelected, 'HH:mm:ss')) < 0) {
                    this._timeSelected = this._maxTime;
                }
            }
            else {
                this._maxTime = null;
            }
        }
    }
    /** Close the calendar. */
    close() {
        if (!this._opened) {
            return;
        }
        this._overlay.close();
    }
    /** Where is show now button */
    isNow() {
        if (!this._minDate && !this._maxDate) {
            return true;
        }
        else {
            let result = true;
            if (this._minDate && this._minDate.isAfter(new Date(), this.showTime ? 'second' : 'day')) {
                result = false;
            }
            if (this._maxDate && this._maxDate.isBefore(new Date(), this.showTime ? 'second' : 'day')) {
                result = false;
            }
            return result;
        }
    }
    /** Observable on overlay close */
    onOverlayClose() {
        this._opened = false;
        this.matOpened.emit(false);
        this._onTouched();
        this._timeOpened = false;
    }
    /** Open the calendar as a popup. */
    _openAsPopup() {
        const portal = new TemplatePortal(this.datepickerContent, this._viewContainerRef);
        this._overlay.close();
        this._overlay.open(this._ele, portal, {
            withViewportMargin: 0,
            hasBackdrop: true,
            backdropClass: 'mat-overlay-transparent-backdrop',
            position: 'BL',
            panelClass: 'mat-datepicker-popup',
            offsetY: 2
        });
        this._overlay.afterClose().subscribe(() => this.onOverlayClose());
    }
    _selectYear(date) {
        this.yearSelected.emit(date);
        if (this.type === 'year') {
            this._selected = date.format(this.format || this.formatDefault);
            this._controlValueAccessorChangeFn(this._selected);
            this._cd.markForCheck();
            this.close();
        }
    }
    _selectMonth(date) {
        this.monthSelected.emit(date);
        if (this.type === 'month') {
            this._selected = date.format(this.format || this.formatDefault);
            this._controlValueAccessorChangeFn(this._selected);
            this._cd.markForCheck();
            this.close();
        }
    }
    _selectDay(date) {
        this.daySelected.emit(date);
        if (this.type === 'day') {
            if (!this.showTime) {
                this._selected = date.format(this.format || this.formatDefault);
                this._controlValueAccessorChangeFn(this._selected);
                this._cd.markForCheck();
                this.close();
            }
            else {
                this._validSelected = date;
                this._timeSelected = this._timeSelected || this.getTimeDefault();
            }
        }
        this.setMaxAndMinTime();
    }
    clearValue() {
        this._controlValueAccessorChangeFn('');
        this._validSelected = null;
        this._selected = '';
        this._timeSelected = this.getTimeDefault();
        this.close();
        this._cd.markForCheck();
    }
    setNowValue() {
        this._validSelected = moment(new Date());
        this._selected = this._validSelected.format(this.format || this.formatDefault);
        this._timeSelected = this._validSelected.format('HH:mm:ss');
        this._controlValueAccessorChangeFn(this._selected);
        this.close();
        this._cd.markForCheck();
    }
    setValue() {
        const timeArr = this._timeSelected.split(':');
        this._validSelected.set('hours', timeArr[0]);
        this._validSelected.set('minutes', timeArr[1]);
        this._validSelected.set('seconds', timeArr[2]);
        this._selected = this._validSelected.format(this.format || this.formatDefault);
        this._controlValueAccessorChangeFn(this._selected);
        this.close();
        this._cd.markForCheck();
    }
    _userSelection() {
        if (!this.showTime) {
            this.close();
        }
    }
    ngOnInit() {
    }
    ngOnDestroy() {
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.selected = value;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatDate.decorators = [
    { type: Component, args: [{
                selector: 'mat-date',
                exportAs: 'matDate',
                template: "<div class=\"mat-date-trigger\" (click)=\"open()\">\r\n    <span class=\"mat-date-value\">\r\n        <span class=\"mat-date-placeholder\" *ngIf=\"!selected\">{{placeholder}}</span>\r\n        <span class=\"mat-date-value-text\" *ngIf=\"selected\">{{selected}}</span>\r\n    </span>\r\n    <span class=\"mat-date-icon\">\r\n        <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n            <path fill=\"currentColor\" d=\"M862.0032 174.4896h-150.016v-49.9712a24.9856 24.9856 0 1 0-49.9712 0v49.9712H361.984v-49.9712a24.9856 24.9856 0 0 0-49.9712 0v49.9712h-150.016a100.096 100.096 0 0 0-99.9936 99.9936v549.9904a100.096 100.096 0 0 0 99.9936 100.0448h700.0064a100.096 100.096 0 0 0 99.9936-100.0448V274.4832a100.096 100.096 0 0 0-99.9936-99.9936z m-700.0064 50.0224h150.016v49.9712a24.9856 24.9856 0 0 0 49.9712 0v-49.9712h300.032v49.9712a24.9856 24.9856 0 1 0 49.9712 0v-49.9712h150.016c27.648 0 49.9712 22.3744 50.0224 49.9712v75.008H112.0256V274.4832c0-27.5968 22.3744-49.92 49.9712-49.9712zM862.0032 874.496H161.9968a50.0736 50.0736 0 0 1-50.0224-50.0224v-424.96h800v424.96a50.0736 50.0736 0 0 1-49.9712 50.0224z\"></path>\r\n            <path fill=\"currentColor\" d=\"M762.0096 536.9856H261.9904a24.9856 24.9856 0 1 0 0 50.0224h500.0192a24.9856 24.9856 0 0 0 0-50.0224z m0 150.016H261.9904a24.9856 24.9856 0 1 0 0 50.0224h500.0192a24.9856 24.9856 0 0 0 0-50.0224z\"></path>\r\n        </svg>\r\n    </span>\r\n</div>\r\n\r\n<ng-template #datepickerContentTemplate>\r\n    <div class=\"mat-datepicker-content\">\r\n        <mat-calendar \r\n          [attr.type]=\"type\" \r\n          [ngClass]=\"panelClass\" \r\n          [selected]=\"_validSelected\" \r\n          [startAt]=\"startAt\"\r\n          [startView]=\"startView\" \r\n          [minDate]=\"_minDate\" \r\n          [maxDate]=\"_maxDate\"\r\n          [dateFilter]=\"dateFilter\" \r\n          [dateClass]=\"dateClass\" \r\n          (selectedChange)=\"_selectDay($event)\" \r\n          (yearSelected)=\"_selectYear($event)\" \r\n          (monthSelected)=\"_selectMonth($event)\" \r\n          (_userSelection)=\"_userSelection()\"></mat-calendar>\r\n\r\n        <div class=\"mat-datepicker-footer\">\r\n            <div class=\"mat-datepicker-time-values\">\r\n                <mat-time [minTime]=\"_minTime\" [maxTime]=\"_maxTime\" #timePicker [opened]=\"_timeOpened\" *ngIf=\"showTime\" (matOptionClick)=\"_timeSelected = $event\" for=\"date\" [selected]=\"_timeSelected\" [showFooter]=\"false\"></mat-time>\r\n                <span class=\"mat-datepicker-time-trigger\" *ngIf=\"showTime\" (click)=\"toggleTime()\" title=\"\u4FEE\u6539\u65F6\u95F4\">\r\n                    {{_timeOpened ? '\u8FD4\u56DE\u65E5\u671F' : _timeSelected}}\r\n                    <svg *ngIf=\"!_timeOpened\" viewBox=\"0 0 1024 1024\" xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" style=\"vertical-align: bottom;margin-left: 4px;\"><path fill=\"currentColor\" d=\"M455.68 773.12c-3.413333 3.413333-8.533333 6.826667-15.36 8.533333l-204.8 40.96c-20.48 3.413333-37.546667-13.653333-34.133333-34.133333l40.96-204.8c1.706667-5.12 3.413333-10.24 8.533333-15.36l546.133333-547.84c13.653333-13.653333 32.426667-20.48 51.2-20.48s35.84 6.826667 49.493334 20.48l105.813333 105.813333c13.653333 13.653333 20.48 30.72 20.48 49.493334 0 18.773333-6.826667 35.84-20.48 49.493333L455.68 773.12z m413.013333-493.226667l-124.586666-124.586666-447.146667 447.146666-30.72 155.306667 155.306667-30.72 447.146666-447.146667z m40.96-40.96l52.906667-52.906666c3.413333-1.706667 3.413333-5.12 3.413333-8.533334s-1.706667-6.826667-3.413333-8.533333l-107.52-107.52c-1.706667-1.706667-5.12-3.413333-8.533333-3.413333s-6.826667 1.706667-8.533334 3.413333L785.066667 114.346667l124.586666 124.586666z\"></path><path fill=\"currentColor\" d=\"M844.8 1024H87.04C39.253333 1024 0 984.746667 0 936.96V179.2c0-47.786667 39.253333-87.04 87.04-87.04h385.706667c15.36 0 29.013333 13.653333 29.013333 29.013333s-13.653333 29.013333-29.013333 29.013334H87.04c-15.36 0-29.013333 13.653333-29.013333 29.013333v757.76c0 17.066667 13.653333 29.013333 29.013333 29.013333h757.76c17.066667 0 29.013333-13.653333 29.013333-29.013333V563.2c0-15.36 13.653333-29.013333 29.013334-29.013333s29.013333 13.653333 29.013333 29.013333v372.053333c1.706667 49.493333-37.546667 88.746667-87.04 88.746667z\" ></path></svg>\r\n                </span>\r\n            </div>\r\n            <div class=\"mat-datepicker-buttons\">\r\n                <div class=\"mat-datepicker-clear\" (click)=\"clearValue()\">\u6E05\u7A7A</div>\r\n                <div class=\"mat-datepicker-now\" (click)=\"setNowValue()\" *ngIf=\"isNow()\">\u73B0\u5728</div>\r\n                <div class=\"mat-datepicker-sure\" (click)=\"setValue()\" *ngIf=\"showTime\">\u786E\u5B9A</div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</ng-template>\r\n",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                providers: [
                    {
                        provide: DateAdapter,
                        useClass: MomentDateAdapter,
                        deps: [MAT_DATE_LOCALE, MAT_MOMENT_DATE_ADAPTER_OPTIONS]
                    },
                    { provide: MAT_DATE_FORMATS, useValue: LocalFormats },
                    MAT_DATE_VALUE_ACCESSOR,
                    OverlayService
                ],
                host: {
                    '[attr.tabindex]': 'tabIndex',
                    '[class.mat-date]': 'true',
                    '[class.mat-date-disabled]': 'disabled',
                    '[class.cdk-focused]': 'opened',
                }
            },] }
];
MatDate.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: ViewContainerRef },
    { type: OverlayService }
];
MatDate.propDecorators = {
    datepickerContent: [{ type: ViewChild, args: ['datepickerContentTemplate',] }],
    calendar: [{ type: ViewChild, args: [MatCalendar,] }],
    matOpened: [{ type: Output }],
    yearSelected: [{ type: Output }],
    monthSelected: [{ type: Output }],
    daySelected: [{ type: Output }],
    placeholder: [{ type: Input }],
    tabIndex: [{ type: Input }],
    format: [{ type: Input }],
    maxDate: [{ type: Input }],
    required: [{ type: Input }],
    minDate: [{ type: Input }],
    startAt: [{ type: Input }],
    dateFilter: [{ type: Input }],
    panelClass: [{ type: Input }],
    dateClass: [{ type: Input }],
    type: [{ type: Input }],
    touchUi: [{ type: Input }],
    showTime: [{ type: Input }],
    disabled: [{ type: Input }],
    opened: [{ type: Input }]
};

/**
 * TODO:接管键盘事件， 最大最小值限制
 */
const moment$1 = _rollupMoment__default || _rollupMoment;
const MAT_TIME_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatTime),
    multi: true
};
class MatTime {
    constructor(_cd, _ele, _viewContainerRef, _overlay) {
        this._cd = _cd;
        this._ele = _ele;
        this._viewContainerRef = _viewContainerRef;
        this._overlay = _overlay;
        this.matOpened = new EventEmitter();
        this.matChange = new EventEmitter();
        this.matOptionClick = new EventEmitter();
        this.placeholder = '';
        this.header = '选择时间';
        this.split = ':';
        this.showFooter = true;
        /** Whether the option is disabled. */
        this._disabled = false;
        /** Whether the option is disabled. */
        this._required = false;
        this._opened = false;
        this._validSelected = null;
        this._hourOptions = this.getTimePickerOptions(24);
        this._minuteAndSecondOptions = this.getTimePickerOptions(60);
        this.displayValue = {
            hour: '00',
            minute: '00',
            second: '00'
        };
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
    }
    set minTime(value) {
        this._minTime = value ? moment$1(value, 'HH:mm:ss') : null;
        if (this._minTime && this._validSelected && this._minTime.diff(moment$1(this._validSelected, 'HH:mm:ss')) > 0) {
            this.clearValue();
        }
        if (this._minTime && !this._validSelected) {
            this.displayValue = this.getDefaultValue();
        }
        this._cd.markForCheck();
    }
    set maxTime(value) {
        this._maxTime = value ? moment$1(value, 'HH:mm:ss') : null;
        if (this._maxTime && this._validSelected && this._maxTime.diff(moment$1(this._validSelected, 'HH:mm:ss')) < 0) {
            this.clearValue();
        }
        this._cd.markForCheck();
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this._disabled) {
            this._disabled = newValue;
            this._cd.markForCheck();
        }
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    /** Whether the calendar is open. */
    get opened() {
        return this._opened;
    }
    set opened(value) {
        value ? this.open() : this.close();
    }
    /** The currently selected date. */
    set selected(value) {
        if (value !== this._validSelected) {
            this._validSelected = value;
            this.setDisplayBySelected();
            this._cd.markForCheck();
        }
    }
    get selected() {
        return this._validSelected;
    }
    getDefaultValue() {
        if (this._minTime) {
            const hour = (this._minTime.hour() < 10 ? '0' : '') + this._minTime.hour();
            const minute = (this._minTime.minute() < 10 ? '0' : '') + this._minTime.minute();
            const second = (this._minTime.second() < 10 ? '0' : '') + this._minTime.second();
            return { hour, minute, second };
        }
        else {
            return { hour: '00', minute: '00', second: '00' };
        }
    }
    /** Open the calendar. */
    open() {
        if (this._opened || this.disabled) {
            return;
        }
        this.setDisplayBySelected();
        this._openAsPopup();
        this._opened = true;
        this.matOpened.emit(true);
    }
    /** Where the item is disabled. */
    isDisabledItem(value, type) {
        if (!this._minTime && !this._maxTime) {
            return false;
        }
        else {
            const maxValue = this._maxTime ? this._maxTime[type]() : 60;
            const minValue = this._minTime ? this._minTime[type]() : -1;
            return value < minValue || value > maxValue;
        }
    }
    /** Where the now button is show. */
    isNow() {
        if (!this._minTime && !this._maxTime) {
            return true;
        }
        else {
            let result = true;
            if (this._minTime && this._minTime.diff(moment$1(new Date(), 'HH:mm:ss')) > 0) {
                result = false;
            }
            if (this._maxTime && this._maxTime.diff(moment$1(new Date(), 'HH:mm:ss')) < 0) {
                result = false;
            }
            return result;
        }
    }
    /** Close the calendar. */
    close() {
        if (!this._opened) {
            return;
        }
        this._overlay.close();
    }
    /** Observable on overlay close */
    onOverlayClose() {
        this._opened = false;
        this.matOpened.emit(false);
        this._onTouched();
    }
    /** Open the calendar as a popup. */
    _openAsPopup() {
        const portal = new TemplatePortal(this.timeContent, this._viewContainerRef);
        this._overlay.close();
        this._overlay.open(this._ele, portal, {
            withViewportMargin: 0,
            hasBackdrop: this.for !== 'date',
            backdropClass: 'mat-overlay-transparent-backdrop',
            position: this.for === 'date' ? 'TL' : 'BL',
            panelClass: this.for === 'date' ? 'mat-time-popup-for-date' : 'mat-time-popup',
            offsetY: 2
        });
        this._overlay.afterClose().subscribe(() => this.onOverlayClose());
    }
    /** Get options by number */
    getTimePickerOptions(count) {
        return Array(count).fill('').map((_, i) => (i < 10 ? '0' : '') + i);
    }
    setDisplayNow() {
        const hour = (new Date().getHours() < 10 ? '0' : '') + new Date().getHours();
        const minute = (new Date().getMinutes() < 10 ? '0' : '') + new Date().getMinutes();
        const second = (new Date().getSeconds() < 10 ? '0' : '') + new Date().getSeconds();
        this.displayValue = { hour, minute, second };
    }
    ngOnInit() {
    }
    ngOnDestroy() {
    }
    /** Set time display by value */
    setDisplayBySelected() {
        const valueArrr = (this._validSelected || '').split(this.split);
        if (valueArrr.length === 3) {
            this.displayValue = {
                hour: valueArrr[0],
                minute: valueArrr[1],
                second: valueArrr[2]
            };
        }
        else {
            this.displayValue = this.getDefaultValue();
        }
    }
    /** Set value equal to now time */
    setNowValue() {
        this.setDisplayNow();
        const nowString = this.displayValue.hour + this.split + this.displayValue.minute + this.split + this.displayValue.second;
        this._controlValueAccessorChangeFn(nowString);
        this._validSelected = nowString;
        this.close();
    }
    /** Clear time value */
    clearValue() {
        this.displayValue = this.getDefaultValue();
        this._controlValueAccessorChangeFn('');
        this._validSelected = '';
        this.close();
    }
    /** Set value with display and close the overlay. */
    setValue() {
        const nowString = this.displayValue.hour + this.split + this.displayValue.minute + this.split + this.displayValue.second;
        this._controlValueAccessorChangeFn(nowString);
        this._validSelected = nowString;
        this.close();
    }
    /** Time option click */
    optionClick(item, type) {
        this.displayValue[type] = item;
        this.matOptionClick.emit(this.displayValue.hour + this.split + this.displayValue.minute + this.split + this.displayValue.second);
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.selected = value;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatTime.decorators = [
    { type: Component, args: [{
                selector: 'mat-time',
                exportAs: 'matTime',
                template: "<div class=\"mat-time-trigger\" (click)=\"open()\">\r\n  <span class=\"mat-time-value\">\r\n      <span class=\"mat-time-placeholder\" *ngIf=\"!selected\">{{placeholder}}</span>\r\n      <span class=\"mat-time-value-text\" *ngIf=\"selected\">{{selected}}</span>\r\n  </span>\r\n  <span class=\"mat-time-icon\">\r\n    <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\"><path fill=\"currentColor\" d=\"M512 115.2c217.6 0 396.8 179.2 396.8 396.8s-179.2 396.8-396.8 396.8S115.2 729.6 115.2 512 294.4 115.2 512 115.2M512 51.2C256 51.2 51.2 256 51.2 512S256 979.2 512 979.2s460.8-204.8 460.8-460.8S768 51.2 512 51.2L512 51.2z\"></path><path fill=\"currentColor\" d=\"M755.2 652.8c0 0-6.4 0-6.4 0L486.4 582.4C473.6 576 460.8 563.2 460.8 550.4L460.8 256c0-19.2 12.8-32 32-32S524.8 236.8 524.8 256l0 268.8 236.8 64c19.2 6.4 25.6 19.2 25.6 38.4C780.8 646.4 768 652.8 755.2 652.8z\"></path></svg>\r\n  </span>\r\n</div>\r\n\r\n<ng-template #timeContentTemplate>\r\n    <div class=\"mat-time-popup-content\">\r\n        <div class=\"mat-time-header\"> {{header}} </div>\r\n        <div class=\"mat-time-content\">\r\n            <div class=\"mat-time-hour\">\r\n                <div class=\"mat-time-option-header\">\u65F6</div>\r\n                <div class=\"mat-time-option-wapper\">\r\n                    <div class=\"mat-time-option-item\" [class.disabled]=\"isDisabledItem(index, 'hour')\"  *ngFor=\"let item of _hourOptions; index as index\" (click)=\"!isDisabledItem(index, 'hour') && optionClick(item, 'hour')\" [class.selected]=\"item == displayValue?.hour\">\r\n                        <span class=\"\">\r\n                            {{item}}\r\n                        </span>\r\n                    </div>\r\n                </div>\r\n \r\n            </div>\r\n            <div class=\"mat-time-minute\">\r\n                <div class=\"mat-time-option-header\">\u5206</div>\r\n                <div class=\"mat-time-option-wapper\">\r\n                    <div class=\"mat-time-option-item\" [class.disabled]=\"isDisabledItem(index, 'minute')\" *ngFor=\"let item of _minuteAndSecondOptions; index as index\" (click)=\"!isDisabledItem(index, 'minute') && optionClick(item, 'minute')\" [class.selected]=\"item == displayValue?.minute\">\r\n                        <span >\r\n                            {{item}}\r\n                        </span>\r\n                    </div>\r\n                </div>\r\n\r\n            </div>\r\n            <div class=\"mat-time-second\">\r\n                <div class=\"mat-time-option-header\">\u79D2</div>\r\n                <div class=\"mat-time-option-wapper\">\r\n                    <div class=\"mat-time-option-item\" [class.disabled]=\"isDisabledItem(index, 'second')\" *ngFor=\"let item of _minuteAndSecondOptions; index as index\" (click)=\"!isDisabledItem(index, 'second') && optionClick(item, 'second')\" [class.selected]=\"item == displayValue?.second\">\r\n                        <span>\r\n                            {{item}}\r\n                        </span>\r\n                    </div>\r\n                </div>\r\n\r\n            </div>\r\n        </div>\r\n        <div class=\"mat-time-footer\" *ngIf=\"showFooter\">\r\n            <div class=\"mat-time-values\">\r\n                {{displayValue?.hour}}:{{displayValue?.minute}}:{{displayValue?.second}}\r\n            </div>\r\n            <div class=\"mat-time-buttons\">\r\n                <div class=\"mat-time-clear\" (click)=\"clearValue()\">\u6E05\u7A7A</div>\r\n                <div class=\"mat-time-now\" (click)=\"setNowValue()\" *ngIf=\"isNow()\">\u73B0\u5728</div>\r\n                <div class=\"mat-time-sure\" (click)=\"setValue()\">\u786E\u5B9A</div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</ng-template>\r\n",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                providers: [MAT_TIME_VALUE_ACCESSOR, OverlayService],
                host: {
                    '[attr.tabindex]': 'tabIndex',
                    '[class.mat-time]': 'true',
                    '[class.mat-time-disabled]': 'disabled',
                    '[class.cdk-focused]': 'opened',
                }
            },] }
];
MatTime.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: ViewContainerRef },
    { type: OverlayService }
];
MatTime.propDecorators = {
    timeContent: [{ type: ViewChild, args: ['timeContentTemplate',] }],
    matOpened: [{ type: Output }],
    matChange: [{ type: Output }],
    matOptionClick: [{ type: Output }],
    tabIndex: [{ type: Input }],
    placeholder: [{ type: Input }],
    header: [{ type: Input }],
    for: [{ type: Input }],
    split: [{ type: Input }],
    showFooter: [{ type: Input }],
    minTime: [{ type: Input }],
    maxTime: [{ type: Input }],
    disabled: [{ type: Input }],
    required: [{ type: Input }],
    opened: [{ type: Input }],
    selected: [{ type: Input }]
};

class MatDateHeader extends MatCalendarHeader {
    constructor() {
        super(...arguments);
        this.text = '000';
    }
}
MatDateHeader.decorators = [
    { type: Component, args: [{
                selector: 'mat-calendar-header',
                template: "<div class=\"mat-calendar-header\">\r\n  <div class=\"mat-calendar-controls\">\r\n    <button mat-button type=\"button\" class=\"mat-calendar-period-button\"\r\n            (click)=\"currentPeriodClicked()\" [attr.aria-label]=\"periodButtonLabel\"\r\n            cdkAriaLive=\"polite\">\r\n      {{periodButtonText}}\r\n      <div class=\"mat-calendar-arrow\"\r\n           [class.mat-calendar-invert]=\"calendar.currentView != 'month'\"></div>\r\n    </button>\r\n\r\n    <div class=\"mat-calendar-spacer\"></div>\r\n\r\n    <ng-content></ng-content>\r\n\r\n    <button mat-icon-button type=\"button\" class=\"mat-calendar-previous-button\"\r\n            [disabled]=\"!previousEnabled()\" (click)=\"previousClicked()\"\r\n            [attr.aria-label]=\"prevButtonLabel\">\r\n    </button>\r\n\r\n    <button mat-icon-button type=\"button\" class=\"mat-calendar-next-button\"\r\n            [disabled]=\"!nextEnabled()\" (click)=\"nextClicked()\"\r\n            [attr.aria-label]=\"nextButtonLabel\">\r\n    </button>\r\n    <div>{{text}}</div>\r\n  </div>\r\n</div>\r\n",
                exportAs: 'matCalendarHeader',
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            },] }
];

class MatDateModule {
}
MatDateModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatDatepickerModule, FormsModule, MatButtonModule],
                exports: [MatDate, MatTime, MatDateHeader],
                declarations: [MatDate, MatTime, MatDateHeader],
                providers: [
                    { provide: MAT_DATE_LOCALE, useValue: 'zh-CN' },
                ],
                entryComponents: [MatDateHeader]
            },] }
];

class MatDialogComponent {
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
}
MatDialogComponent.decorators = [
    { type: Directive }
];
MatDialogComponent.ctorParameters = () => [
    { type: MatDialogRef },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
];

/**
 * TODO: 接管键盘事件， 因为搜索占位部分失效。
 */
function getMatDropdownNonFunctionValueError(key) {
    return Error(`"${key}" must be a function.'`);
}
const MAT_DROPDOWN_DEFAULT_VIEW_FIELD = 'label';
const MAT_DROPDOWN_DEFAULT_CHILDREN_FIELD = 'children';
const MAT_DROPDOWN_DEFAULT_DISABLED_FIELD = 'disabled';
const MAT_DROPDOWN_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatDropdown),
    multi: true
};
class MatDropdown {
    constructor(_cd) {
        this._cd = _cd;
        this.matChange = new EventEmitter();
        this.matFilter = new EventEmitter();
        this.matOpened = new EventEmitter();
        this.valueChange = new EventEmitter();
        this.tabIndex = 0;
        /** Field name of disabled when datasource as objecet array. */
        this.disabledField = MAT_DROPDOWN_DEFAULT_DISABLED_FIELD;
        /** Field name of view when datasource as objecet array. */
        this.viewField = MAT_DROPDOWN_DEFAULT_VIEW_FIELD;
        /** Field name of view when datasource as objecet array. */
        this.disableOptionCentering = true;
        /** Field name of view when datasource as objecet array. */
        this.disableRipple = false;
        /** Where show search input. */
        this.showFilter = true;
        /** Field name of view when datasource as objecet array. */
        this.placeholder = '';
        /** Field name of view when datasource as objecet array. */
        this.searcPlaceholder = '搜索';
        /** Field name of children when datasource as objecet array. */
        this.childrenField = MAT_DROPDOWN_DEFAULT_CHILDREN_FIELD;
        /** Whether the dropdown is required. */
        this._required = false;
        /** Whether the dropdown options display with group. */
        this._reset = true;
        /** Whether multiple options can be selected. */
        this._multiple = false;
        /** Whether the option is disabled. */
        this._disabled = false;
        /** Comparison function to specify which option is checked. Defaults to object equality. */
        this._compareWith = (o1, o2) => o1 === o2;
        /** Comparison function to specify which option is checked. Defaults to object equality. */
        this._filterWith = (option, key) => {
            if (key && key.trim() && option.view) {
                return option.view.includes(key);
            }
            else {
                return true;
            }
        };
        /** Value of the checkbox list. */
        this._value = null;
        /** Option of the checkbox. */
        this._dataSource = null;
        this._panelPosition = 'BL';
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get group() { return this._group; }
    set group(value) {
        this._group = coerceBooleanProperty(value);
    }
    get reset() { return this._reset; }
    set reset(value) {
        this._reset = coerceBooleanProperty(value);
    }
    set multiple(value) {
        this._multiple = coerceBooleanProperty(value);
    }
    get multiple() {
        return this._multiple;
    }
    get disabled() { return this._disabled; }
    set disabled(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this._disabled) {
            this._disabled = newValue;
            this._cd.markForCheck();
        }
    }
    get compareWith() { return this._compareWith; }
    set compareWith(fn) {
        if (typeof fn !== 'function') {
            throw getMatDropdownNonFunctionValueError('compareWith');
        }
        this._compareWith = fn;
    }
    get filterWith() { return this._filterWith; }
    set filterWith(fn) {
        if (typeof fn !== 'function') {
            throw getMatDropdownNonFunctionValueError('filterWith');
        }
        this._filterWith = fn;
    }
    get value() {
        return this._value;
    }
    set value(newValue) {
        if (this._value !== newValue) {
            this._value = newValue;
            this._cd.markForCheck();
        }
    }
    get direction() {
        return this._direction || 'horizontal';
    }
    set direction(newValue) {
        this._direction = newValue;
    }
    formatOption(item) {
        const isItemString = typeof item === 'string' || typeof item === 'number';
        const disabled = isItemString ? false : !!item[this.disabledField || MAT_DROPDOWN_DEFAULT_DISABLED_FIELD];
        const value = (isItemString || !this.valueField) ? item : item[this.valueField];
        const view = isItemString ? item : item[this.viewField || MAT_DROPDOWN_DEFAULT_VIEW_FIELD];
        return { view, value, data: item, disabled };
    }
    set dataSource(dataValue) {
        this._dataSource = [];
        const data = Array.isArray(dataValue) ? dataValue : [];
        data.forEach(item => {
            const value = this.formatOption(item);
            const subItems = item[this.childrenField || MAT_DROPDOWN_DEFAULT_CHILDREN_FIELD];
            let children = null;
            if (typeof item !== 'string' && this.group && subItems && subItems.length) {
                children = subItems.map((subvalue) => this.formatOption(subvalue));
            }
            this._dataSource.push(Object.assign(Object.assign({}, value), { children }));
        });
    }
    get dataSource() {
        return this._dataSource;
    }
    /** Filter option by search text. */
    filterOption() {
        const isVaildSearch = !!(this.searchText && this.searchText.trim());
        this.dataSource.forEach((options) => {
            if (this.group && options.children && options.children.length) {
                let parentHidden = true;
                options.children.forEach((option) => {
                    option.hidden = !this.filterWith(option, this.searchText) && isVaildSearch;
                    parentHidden = parentHidden && option.hidden;
                });
                options.hidden = parentHidden;
            }
            else {
                options.hidden = !this.filterWith(options, this.searchText) && isVaildSearch;
            }
        });
        this.matFilter.emit(this.searchText);
    }
    /** Reset value on button click */
    resetValue() {
        this.value = this.multiple ? [] : null;
        this.searchText = '';
        this._controlValueAccessorChangeFn(this.value);
        this.matChange.emit(this.value);
        this.matFilter.emit(this.searchText);
    }
    /** Whether data source is empty. */
    isDataSourceEmpty() {
        return !this.dataSource || !this.dataSource.length;
    }
    /** Whether empty on search */
    isEmpty() {
        return this.dataSource.findIndex(item => !item.hidden) === -1;
    }
    /** Event on value change */
    onValueChange(event) {
        this._controlValueAccessorChangeFn(event.value);
        this.matChange.emit(event.value);
        this.valueChange.emit(event.value);
    }
    onOpenedChange(event) {
        this._panelIsOpend = event;
        if (!event) {
            this.searchText = '';
            this.filterOption();
            this._onTouched();
        }
        this.matOpened.emit(event);
    }
    search(event) {
        const keyCode = event.keyCode;
        event.stopPropagation();
        if (keyCode === ENTER) {
            this.filterOption();
        }
    }
    ngOnInit() {
    }
    ngAfterViewInit() {
        // tslint:disable-next-line: deprecation
        const overlayDir = this.selectInstance.overlayDir;
        overlayDir.panelClass = this.multiple ? `mat-drop-down-overlay-panel-multiple-${this.direction}` : `mat-drop-down-overlay-panel-${this.direction}`;
        if (this.direction === 'horizontal') {
            overlayDir.minWidth = 0;
        }
        if (overlayDir) {
            overlayDir.positions = getWithPositions('BL', 0, 0);
            overlayDir.positionChange.subscribe(change => {
                const currentPosition = getPositionNameByPosition(change.connectionPair);
                overlayDir.overlayRef.removePanelClass(this._panelPosition);
                overlayDir.overlayRef.addPanelClass(currentPosition);
                this._panelPosition = currentPosition;
            });
        }
    }
    ngOnDestroy() {
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.value = value;
        this._cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatDropdown.decorators = [
    { type: Component, args: [{
                selector: 'mat-dropdown',
                exportAs: 'matDropdown',
                template: "<mat-select \r\n    [@.disabled]=\"true\"\r\n    [(value)]=\"value\"\r\n    [required]=\"required\"\r\n    [multiple]=\"multiple\"\r\n    [disabled]=\"disabled\"\r\n    [placeholder]=\"placeholder\"\r\n    [compareWith]=\"compareWith\"\r\n    [disableRipple]=\"direction === 'horizontal'\"\r\n    [panelClass]=\"direction\"\r\n    [disableOptionCentering]=\"false\"\r\n    (openedChange)=\"onOpenedChange($event)\"\r\n    (selectionChange)=\"onValueChange($event)\">\r\n    <div class=\"mat-dropdown-panel-header\" *ngIf=\"showFilter\" [style.width.px]=\"direction === 'vertical' && selectInstance?._triggerRect?.width\">\r\n        <span class=\"mat-dropdown-panel-header-title\" *ngIf=\"direction === 'horizontal'\">{{placeholder}}</span>\r\n        <span class=\"mat-dropdown-panel-header-condition\">\r\n            <mat-input [placeholder]=\"searcPlaceholder\" trim [(value)]=\"searchText\" (keydown)=\"search($event)\">\r\n                <mat-input-after (click)=\"filterOption()\">\r\n                    <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path path fill=\"currentColor\" d=\"M757.372928 734.871552l260.227072 218.35776a0.512 0.512 0 0 1 0.063488 0.720896l-38.887424 46.343168a0.512 0.512 0 0 1-0.720896 0.063488L713.900032 778.704896c-75.71456 66.17088-174.798848 106.26048-283.246592 106.26048C192.809984 884.9664 0 692.13184 0 454.259712 0 216.38656 192.809984 23.552 430.65344 23.552s430.65344 192.83456 430.65344 430.706688c0 107.191296-39.15264 205.236224-103.933952 280.612864z m-326.719488 88.56576c203.866112 0 369.13152-165.286912 369.13152-369.178624 0-203.890688-165.265408-369.1776-369.13152-369.1776-203.866112 0-369.13152 165.286912-369.13152 369.1776 0 203.891712 165.265408 369.1776 369.13152 369.1776z\"></path></svg>\r\n                </mat-input-after>\r\n            </mat-input>\r\n            <mat-buttons label=\"\u91CD\u7F6E\" type=\"outline\" (click)=\"resetValue()\" *ngIf=\"reset\"></mat-buttons>\r\n        </span>\r\n    </div>\r\n    <div class=\"mat-dropdown-panel-content\">\r\n        <ng-template [ngIf]=\"!group\">\r\n            <div *ngFor=\"let option of dataSource\" class=\"mat-option-item\" [class.hidden]=\"option.hidden\">\r\n                <mat-option [value]=\"option.value\" [disabled]=\"option.disabled\">\r\n                    <span class=\"mat-dropdown-option-view\">{{option.view}}</span>\r\n                </mat-option>\r\n            </div>\r\n        </ng-template>\r\n    \r\n        <ng-template [ngIf]=\"group\">\r\n            <mat-optgroup *ngFor=\"let group of dataSource\" [label]=\"group.view\" [disabled]=\"group.disabled\">\r\n                <mat-option *ngFor=\"let option of group.children\" [value]=\"option.value\" [disabled]=\"option.disabled\">\r\n                    <span class=\"mat-dropdown-option-view\">{{option.view}}</span>\r\n                </mat-option>\r\n            </mat-optgroup>\r\n        </ng-template>\r\n    </div>\r\n</mat-select>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                providers: [MAT_DROPDOWN_VALUE_ACCESSOR],
                host: {
                    '[attr.role]': 'option',
                    '[class.mat-dropdown]': 'true',
                    '[class.cdk-focused]': '_panelIsOpend',
                    '[class.mat-dropdown-disabled]': 'disabled',
                }
            },] }
];
MatDropdown.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatDropdown.propDecorators = {
    matChange: [{ type: Output }],
    matFilter: [{ type: Output }],
    matOpened: [{ type: Output }],
    valueChange: [{ type: Output }],
    selectInstance: [{ type: ViewChild, args: [MatSelect,] }],
    tabIndex: [{ type: Input }],
    disabledField: [{ type: Input }],
    viewField: [{ type: Input }],
    disableOptionCentering: [{ type: Input }],
    disableRipple: [{ type: Input }],
    showFilter: [{ type: Input }],
    placeholder: [{ type: Input }],
    searcPlaceholder: [{ type: Input }],
    childrenField: [{ type: Input }],
    valueField: [{ type: Input }],
    name: [{ type: Input }],
    required: [{ type: Input }],
    group: [{ type: Input }],
    reset: [{ type: Input }],
    multiple: [{ type: Input }],
    disabled: [{ type: Input }],
    compareWith: [{ type: Input }],
    filterWith: [{ type: Input }],
    value: [{ type: Input }],
    direction: [{ type: Input }],
    dataSource: [{ type: Input }]
};

const MAT_INPUT_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatInput),
    multi: true
};
class MatInputBefore {
}
MatInputBefore.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line: directive-selector
                selector: 'mat-input-before'
            },] }
];
class MatInputAfter {
}
MatInputAfter.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line: directive-selector
                selector: 'mat-input-after'
            },] }
];
// Increasing integer for generating unique ids.
let nextUniqueId = 0;
const MAT_INPUT_DEFAULT_TYPE = 'text';
class MatInput {
    constructor(_cd, _platform, _elementRef, ngZone, _focusMonitor) {
        this._cd = _cd;
        this._platform = _platform;
        this._elementRef = _elementRef;
        this._focusMonitor = _focusMonitor;
        /** Emit event subject */
        this._valueChange$ = new Subject();
        this.matChange = new EventEmitter();
        this.matFocus = new EventEmitter();
        this.matBlur = new EventEmitter();
        this.valueChange = new EventEmitter();
        /** Name value will be applied to the input element if present */
        this.name = null;
        /** The input's autocomplete text. */
        this.autocomplete = 'off';
        /** The input's placeholder text. */
        this.pattern = null;
        /** The input's before text. */
        this.before = '';
        this.maxlength = null;
        /** The input's after text. */
        this.after = '';
        /** The input's input change debounceTime. */
        this.debounceTime = 200;
        /** Unique id for the input. */
        this.id = `mat-input-${nextUniqueId++}`;
        /** Whether the element is readonly. */
        this._readonly = false;
        /** Input type of the element. */
        this._type = MAT_INPUT_DEFAULT_TYPE;
        /** Value of the input. */
        this._value = '';
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
        if (_platform.IOS) {
            ngZone.runOutsideAngular(() => {
                _elementRef.nativeElement.addEventListener('keyup', (event) => {
                    const el = event.target;
                    if (!el.value && !el.selectionStart && !el.selectionEnd) {
                        el.setSelectionRange(1, 1);
                        el.setSelectionRange(0, 0);
                    }
                });
            });
        }
        this._focusMonitor.monitor(this._elementRef, true).subscribe(focusOrigin => {
            if (!focusOrigin) {
                this.onBlur();
            }
            else {
                this.onFocus();
            }
        });
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
        this._cd.markForCheck();
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
        this._cd.markForCheck();
    }
    get trim() {
        return this._trim;
    }
    set trim(value) {
        this._trim = coerceBooleanProperty(value);
        this._cd.markForCheck();
    }
    get readonly() {
        return this._readonly;
    }
    set readonly(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this.readonly) {
            this._readonly = newValue;
            this._cd.markForCheck();
        }
    }
    get type() {
        return this._type;
    }
    set type(value) {
        this._type = value || MAT_INPUT_DEFAULT_TYPE;
        this._cd.markForCheck();
    }
    get value() {
        return this._value;
    }
    set value(value) {
        if (value !== this._value) {
            this._value = (value === null || value === undefined) ? '' : value;
            this._cd.markForCheck();
        }
    }
    onFocus() {
        if (!this.readonly) {
            this.matFocus.emit();
        }
    }
    onBlur() {
        this._onTouched();
        if (!this.readonly) {
            this.matBlur.emit();
        }
    }
    /** Focus the input element by function */
    focus() {
        this._focusMonitor.focusVia(this._inputElement, 'keyboard');
    }
    /** Blur the input element by function */
    blur() {
        this._inputElement.nativeElement.blur();
    }
    getInputValue() {
        return this._inputElement.nativeElement.value;
    }
    onInput() {
        const value = this.getInputValue();
        const newValue = this.trim ? value.trim() : value;
        this._value = newValue;
        this._controlValueAccessorChangeFn(newValue);
        this.valueChange.emit(newValue);
        this._valueChange$.next(newValue);
    }
    ngOnInit() {
        this.registerChangeEvent();
    }
    ngOnDestroy() {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
    }
    registerChangeEvent() {
        this._subscription = this._valueChange$.pipe(debounceTime(this.debounceTime), distinctUntilChanged()).subscribe(event => this.matChange.emit(event));
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.value = value;
        this._cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatInput.decorators = [
    { type: Component, args: [{
                selector: 'mat-input',
                template: "\r\n<div class=\"mat-input-before\" *ngIf=\"!!customBefore || before\">\r\n  <span *ngIf=\"before && !customBefore\">{{before}}</span>\r\n  <ng-content *ngIf=\"!before && customBefore\" select=\"mat-input-before\"></ng-content>\r\n</div>\r\n\r\n<input\r\n#input\r\n[id]=\"id\"\r\n[attr.name]=\"name\"\r\n[attr.pattern]=\"pattern || null\"\r\n[attr.maxLength]=\"maxlength\"\r\n[attr.type]=\"type\"\r\n[attr.autocomplete]=\"autocomplete\"\r\n[attr.placeholder]=\"placeholder\"\r\n[required]=\"required\"\r\n[value]=\"value\"\r\n[disabled]=\"disabled\"\r\n[readonly]=\"readonly\"\r\n(input)=\"onInput()\"\r\n>\r\n\r\n<div class=\"mat-input-after\" *ngIf=\"!!customAfter || after\">\r\n  <span *ngIf=\"after && !customAfter\">{{after}}</span>\r\n  <ng-content *ngIf=\"!after && customAfter\" select=\"mat-input-after\"></ng-content>\r\n</div>",
                providers: [MAT_INPUT_VALUE_ACCESSOR],
                host: {
                    '[class.mat-form-input]': 'true',
                    '[class.mat-form-input-has-after]': 'after || !!customAfter',
                    '[class.mat-form-input-has-before]': 'before || !!customBefore',
                    '[class.mat-form-input-has-after-text]': 'after && !customAfter',
                    '[class.mat-form-input-has-before-text]': 'before && !customBefore',
                    '[class.mat-form-input-has-after-el]': '!after && customAfter',
                    '[class.mat-form-input-has-before-el]': '!before && customBefore',
                    '[class.mat-form-input-disabled]': 'disabled',
                    '[class.mat-form-input-readonly]': 'readonly',
                },
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            },] }
];
MatInput.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: Platform },
    { type: ElementRef },
    { type: NgZone },
    { type: FocusMonitor }
];
MatInput.propDecorators = {
    matChange: [{ type: Output }],
    matFocus: [{ type: Output }],
    matBlur: [{ type: Output }],
    valueChange: [{ type: Output }],
    _inputElement: [{ type: ViewChild, args: ['input',] }],
    customBefore: [{ type: ContentChild, args: [MatInputBefore,] }],
    customAfter: [{ type: ContentChild, args: [MatInputAfter,] }],
    name: [{ type: Input }],
    placeholder: [{ type: Input }],
    autocomplete: [{ type: Input }],
    pattern: [{ type: Input }],
    before: [{ type: Input }],
    maxlength: [{ type: Input }],
    after: [{ type: Input }],
    debounceTime: [{ type: Input }],
    id: [{ type: Input }],
    disabled: [{ type: Input }],
    required: [{ type: Input }],
    trim: [{ type: Input }],
    readonly: [{ type: Input }],
    type: [{ type: Input }],
    value: [{ type: Input }]
};

class MatInputModule {
}
MatInputModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [MatInput, MatInputAfter, MatInputBefore],
                declarations: [MatInput, MatInputAfter, MatInputBefore],
                providers: [],
            },] }
];

// @dynamic
function dropdownScrollFactory(overlay) {
    const block = () => overlay.scrollStrategies.block();
    return block;
}
class MatDropdownModule {
}
MatDropdownModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatSelectModule, MatInputModule, MatButtonsModule],
                exports: [MatDropdown, MatInputModule, MatSelectModule, MatButtonsModule],
                declarations: [MatDropdown],
                providers: [
                    { provide: MAT_SELECT_SCROLL_STRATEGY, useFactory: dropdownScrollFactory, deps: [Overlay] }
                ],
            },] }
];

/** Options used to bind passive event listeners. */
const passiveListenerOptions = normalizePassiveListenerOptions({ passive: true });
class MatTooltip {
    constructor(_overlay, _ngZone, _platform, _viewContainerRef, _ariaDescriber, _elementRef, scrollStrategy, _defaultOptions) {
        this._overlay = _overlay;
        this._ngZone = _ngZone;
        this._platform = _platform;
        this._viewContainerRef = _viewContainerRef;
        this._ariaDescriber = _ariaDescriber;
        this._elementRef = _elementRef;
        this._defaultOptions = _defaultOptions;
        this._position = 'TC';
        this._disabled = false;
        /** The default delay in ms before showing the tooltip after show is called */
        this.showDelay = this._defaultOptions.showDelay;
        /** The default delay in ms before hiding the tooltip after hide is called */
        this.hideDelay = this._defaultOptions.hideDelay;
        /** The message to be displayed in the tooltip */
        this._message = '';
        /** Manually-bound passive event listeners. */
        this._passiveListeners = new Map();
        this._scrollStrategy = scrollStrategy;
        if (_defaultOptions && _defaultOptions.position) {
            this.position = _defaultOptions.position;
        }
    }
    /** Allows the user to define the position of the tooltip relative to the parent element */
    get position() { return this._position; }
    set position(value) {
        if (value !== this._position) {
            this._position = value;
            if (this._overlay.hasOverlay()) {
                this._overlay.updatePosition(this._position);
                if (this._tooltipInstance) {
                    this._tooltipInstance.show(0);
                }
                this._overlay.updateOverlayPosition();
            }
        }
    }
    /** Disables the display of the tooltip. */
    get disabled() { return this._disabled; }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
        // If tooltip is disabled, hide immediately.
        if (this._disabled) {
            this.hide(0);
        }
    }
    get message() { return this._message; }
    set message(value) {
        // If the message is not a string (e.g. number), convert it to a string and trim it.
        this._message = value != null ? `${value}`.trim() : '';
        if (!this._message && this._isTooltipVisible()) {
            this.hide(0);
        }
        else {
            this._updateTooltipMessage();
            this._ngZone.runOutsideAngular(() => {
                // The `AriaDescriber` has some functionality that avoids adding a description if it's the
                // same as the `aria-label` of an element, however we can't know whether the tooltip trigger
                // has a data-bound `aria-label` or when it'll be set for the first time. We can avoid the
                // issue by deferring the description by a tick so Angular has time to set the `aria-label`.
                Promise.resolve().then(() => {
                    this._ariaDescriber.describe(this._elementRef.nativeElement, this.message);
                });
            });
        }
    }
    /** Classes to be passed to the tooltip. Supports the same syntax as `ngClass`. */
    get tooltipClass() { return this._tooltipClass; }
    set tooltipClass(value) {
        this._tooltipClass = value;
        if (this._tooltipInstance) {
            this._setTooltipClass(this._tooltipClass);
        }
    }
    /** Updates the tooltip class */
    _setTooltipClass(tooltipClass) {
        if (this._tooltipInstance) {
            this._tooltipInstance.tooltipClass = tooltipClass;
            this._tooltipInstance._markForCheck();
        }
    }
    /** Shows/hides the tooltip */
    toggle() {
        this._isTooltipVisible() ? this.hide() : this.show();
    }
    /** Returns true if the tooltip is currently visible to the user */
    _isTooltipVisible() {
        return !!this._tooltipInstance && this._tooltipInstance.isVisible();
    }
    /** Hides the tooltip after the delay in ms, defaults to tooltip-delay-hide or 0ms if no input */
    hide(delay = this.hideDelay) {
        if (this._tooltipInstance) {
            this._tooltipInstance.hide(delay);
        }
    }
    /** Shows the tooltip after the delay in ms, defaults to tooltip-delay-show or 0ms if no input */
    show(delay = this.showDelay) {
        if (this.disabled || !this.message || (this._isTooltipVisible() &&
            !this._tooltipInstance._showTimeoutId && !this._tooltipInstance._hideTimeoutId)) {
            return;
        }
        this._portal = this._portal || new ComponentPortal(TooltipComponent, this._viewContainerRef);
        this._tooltipInstance = this._overlay.open(this._elementRef, this._portal, {
            withTransformOriginOn: '.mat-tooltip',
            withViewportMargin: 0,
            hasBackdrop: false,
            scrollStrategy: this._scrollStrategy(),
            position: this.position,
            panelClass: TOOLTIP_PANEL_CLASS
        });
        this._tooltipInstance.afterHidden().subscribe(() => this._overlay.close());
        this._setTooltipClass(this._tooltipClass);
        this._updateTooltipMessage();
        this._tooltipInstance.show(delay);
    }
    /** Updates the tooltip message and repositions the overlay according to the new message length */
    _updateTooltipMessage() {
        // Must wait for the message to be painted to the tooltip so that the overlay can properly
        // calculate the correct positioning based on the size of the text.
        if (this._tooltipInstance) {
            this._tooltipInstance.message = this.message;
            this._tooltipInstance._markForCheck();
        }
    }
    /**
     * Setup styling-specific things
     */
    ngOnInit() {
        // This needs to happen in `ngOnInit` so the initial values for all inputs have been set.
        this._setupPointerEvents();
    }
    /**
     * Dispose the tooltip when destroyed.
     */
    ngOnDestroy() {
        const nativeElement = this._elementRef.nativeElement;
        // Clean up the event listeners set in the constructor
        this._passiveListeners.forEach((listener, event) => {
            nativeElement.removeEventListener(event, listener, passiveListenerOptions);
        });
        this._passiveListeners.clear();
        this._ariaDescriber.removeDescription(nativeElement, this.message);
    }
    /** Binds the pointer events to the tooltip trigger. */
    _setupPointerEvents() {
        // The mouse events shouldn't be bound on mobile devices, because they can prevent the
        // first tap from firing its click event or can cause the tooltip to open for clicks.
        if (!this._platform.IOS && !this._platform.ANDROID) {
            this._passiveListeners
                .set('mouseenter', () => this.show())
                .set('mouseleave', () => this.hide());
        }
        this._passiveListeners.forEach((listener, event) => {
            this._elementRef.nativeElement.addEventListener(event, listener, passiveListenerOptions);
        });
    }
}
MatTooltip.decorators = [
    { type: Directive, args: [{
                selector: '[matTooltip]',
                exportAs: 'matTooltip',
                providers: [OverlayService]
            },] }
];
MatTooltip.ctorParameters = () => [
    { type: OverlayService },
    { type: NgZone },
    { type: Platform },
    { type: ViewContainerRef },
    { type: AriaDescriber },
    { type: ElementRef },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_TOOLTIP_SCROLL_STRATEGY,] }] },
    { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_TOOLTIP_DEFAULT_OPTIONS,] }] }
];
MatTooltip.propDecorators = {
    position: [{ type: Input, args: ['matTooltipPosition',] }],
    disabled: [{ type: Input, args: ['matTooltipDisabled',] }],
    showDelay: [{ type: Input, args: ['matTooltipShowDelay',] }],
    hideDelay: [{ type: Input, args: ['matTooltipHideDelay',] }],
    message: [{ type: Input, args: ['matTooltip',] }],
    tooltipClass: [{ type: Input, args: ['matTooltipClass',] }]
};

class MatTooltipModule {
}
MatTooltipModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    A11yModule,
                    OverlayModule,
                ],
                exports: [MatTooltip],
                declarations: [MatTooltip],
                entryComponents: [TooltipComponent],
                providers: [MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER],
            },] }
];

class MatReactiveFormService {
    constructor() {
        this._userValueChange = new Subject();
    }
    afterPatchValue() {
        return this._userValueChange.asObservable();
    }
    setFormValue(value) {
        this._userValueChange.next(value);
    }
    complete() {
        this._userValueChange.complete();
    }
}
MatReactiveFormService.decorators = [
    { type: Injectable }
];

class MatReactiveFormMessageConfig {
    constructor() {
        this.required = '必填项';
        this.notEmpty = '非空项';
        this.includes = '必须包含指定字符';
        this.maxlength = '超出最大限制';
        this.minlength = '未达到最小要求';
        this.startsWith = '必须以指定字符开始';
        this.endsWith = '必须以指定字符结束';
        this.json = '必须为JSON数据';
        this.pattern = '正则验证失败';
        this.lessThan = '必须小于指定值';
        this.greaterThan = '必须大于指定值';
        this.min = '必须小于等于指定值';
        this.max = '必须大于等于指定值';
        this.compare = '必须与比较值相同';
        this.different = '必须与比较值不同';
        this.unique = '此项唯一';
    }
}
const MAT_REACTIVE_FORM_MESSAGE_CONFIG = new InjectionToken('mat-reactive-form-message-config', {
    providedIn: 'root',
    factory: MAT_REACTIVE_FORM_MESSAGE_CONFIG_FACTORY
});
function MAT_REACTIVE_FORM_MESSAGE_CONFIG_FACTORY() {
    return new MatReactiveFormMessageConfig();
}
const MAT_REACTIVE_FORM_ERROR_MESSAGE_STRATEGY = new InjectionToken('mat-reactive-form-error-message-strategy', {
    providedIn: 'root',
    factory: MAT_REACTIVE_FORM_ERROR_MESSAGE_STRATEGY_FACTORY
});
function MAT_REACTIVE_FORM_ERROR_MESSAGE_STRATEGY_FACTORY() {
    return MatReactiveFormErrorMessageStrategy.OnTouchedOrSubmitted;
}
var MatReactiveFormErrorMessageStrategy;
(function (MatReactiveFormErrorMessageStrategy) {
    MatReactiveFormErrorMessageStrategy["OnDirty"] = "dirty";
    MatReactiveFormErrorMessageStrategy["OnTouched"] = "touched";
    MatReactiveFormErrorMessageStrategy["OnSubmitted"] = "submitted";
    MatReactiveFormErrorMessageStrategy["OnDirtyOrTouched"] = "dirty-or-touched";
    MatReactiveFormErrorMessageStrategy["OnDirtyOrSubmitted"] = "dirty-or-submitted";
    MatReactiveFormErrorMessageStrategy["OnTouchedOrSubmitted"] = "touched-or-submitted";
})(MatReactiveFormErrorMessageStrategy || (MatReactiveFormErrorMessageStrategy = {}));

class MatReactiveForm {
    constructor(_fb, _ele, _defaultErrorMessageStrategy, _reactiveService, _cd) {
        this._fb = _fb;
        this._ele = _ele;
        this._defaultErrorMessageStrategy = _defaultErrorMessageStrategy;
        this._reactiveService = _reactiveService;
        this._cd = _cd;
        this.onSubmitted = new EventEmitter();
        this.config = [];
        this._layout = 'horizontal';
        this._labelPosition = 'left';
        this._submitted = false;
        this.formRoot = this._fb.group({});
        this.messageStrategy = this._defaultErrorMessageStrategy || MatReactiveFormErrorMessageStrategy.OnTouchedOrSubmitted;
    }
    get layout() { return this._layout; }
    set layout(value) {
        if (value !== this._layout) {
            this._layout = value;
            this._cd.markForCheck();
        }
    }
    get labelPosition() { return this._labelPosition; }
    set labelPosition(value) {
        if (value !== this._labelPosition) {
            this._labelPosition = value;
            this._cd.markForCheck();
        }
    }
    set value(value) {
        if (value !== this._value) {
            this._value = value;
            this.patchValue();
        }
    }
    get messageStrategy() { return this._messageStrategy; }
    set messageStrategy(value) {
        if (value !== this._messageStrategy) {
            this._messageStrategy = 'mat-form-error-strategy-' + value;
            this._cd.markForCheck();
        }
    }
    get submitted() { return this._submitted; }
    set submitted(value) {
        if (value !== this._submitted) {
            this._submitted = value;
            this._cd.markForCheck();
        }
    }
    get formValue() {
        return this.formRoot.getRawValue();
    }
    onKeyDown(event) {
        if (event.key === 'Enter') {
            return false;
        }
    }
    onSubmit(e) {
        this.submitted = this.ngForm.submitted;
        if (this.invalid()) {
            this.goToError();
        }
        else {
            this.onSubmitted.emit(this.formValue);
        }
    }
    log(e) {
        console.log(this.ngForm);
        console.log(this.formRoot);
    }
    /******** Patch the form value. ********/
    patchValue(value = this._value) {
        setTimeout(() => this._reactiveService.setFormValue(value), 100);
        setTimeout(() => this.formRoot.patchValue(value), 200);
    }
    /******** Where the form is invalid. ********/
    invalid() {
        return this.formRoot.invalid;
    }
    /******** Go to error element on submitted. ********/
    goToError() {
        if (this.invalid()) {
            const errorElement = this._ele.nativeElement.getElementsByClassName('ng-invalid');
            if (errorElement && errorElement[0]) {
                try {
                    errorElement[0].scrollIntoView({ behavior: 'smooth', block: 'start', inline: 'nearest' });
                }
                catch (error) {
                    console.error('Form on submit go to error failed!');
                }
            }
        }
    }
    /******** Reset the form value and status. ********/
    reset(value) {
        this.ngForm.resetForm(value);
    }
    ngAfterViewInit() {
    }
    ngAfterContentInit() {
    }
    ngOnDestroy() {
        this._reactiveService.complete();
    }
}
MatReactiveForm.decorators = [
    { type: Component, args: [{
                selector: 'mat-reactive-form',
                template: "<form #ngForm=\"ngForm\" [formGroup]=\"formRoot\" (ngSubmit)=\"onSubmit($event)\" (keydown)=\"onKeyDown($event)\">\r\n    <mat-reactive-layout *ngFor=\"let item of config\" [config]=\"item\" [parentFormGroup]=\"formRoot\" [rootFormGroup]=\"formRoot\">\r\n\r\n    </mat-reactive-layout>\r\n    <button type=\"submit\">submit</button>\r\n    <div (click)=\"log(ngForm)\">log</div>\r\n    <div (click)=\"reset()\">reset</div>\r\n</form>",
                encapsulation: ViewEncapsulation.None,
                providers: [MatReactiveFormService],
                host: {
                    '[class]': 'messageStrategy',
                    '[class.mat-reactive-form]': 'true',
                    '[class.mat-form-submitted]': 'submitted',
                    '[class.mat-reactive-form-horizontal]': 'layout == "horizontal"',
                    '[class.mat-reactive-form-vertical]': 'layout == "vertical"',
                    '[class.mat-reactive-form-inline]': 'layout == "inline"',
                    '[class.mat-reactive-form-label-left]': 'labelPosition == "left"',
                    '[class.mat-reactive-form-label-top]': 'labelPosition == "top"',
                    '[class.mat-reactive-form-label-right]': 'labelPosition == "right"',
                }
            },] }
];
MatReactiveForm.ctorParameters = () => [
    { type: FormBuilder },
    { type: ElementRef },
    { type: MatReactiveFormErrorMessageStrategy, decorators: [{ type: Inject, args: [MAT_REACTIVE_FORM_ERROR_MESSAGE_STRATEGY,] }] },
    { type: MatReactiveFormService },
    { type: ChangeDetectorRef }
];
MatReactiveForm.propDecorators = {
    onSubmitted: [{ type: Output }],
    ngForm: [{ type: ViewChild, args: ['ngForm', { static: false },] }],
    submitBtn: [{ type: ViewChild, args: ['submitBtn', { static: false },] }],
    config: [{ type: Input }],
    layout: [{ type: Input }],
    labelPosition: [{ type: Input }],
    value: [{ type: Input }]
};

class MatReactiveFormValidators {
}
class MatReactiveFormValidatorFunctions {
}
// The validator of required.
MatReactiveFormValidatorFunctions.required = required;
// The validator of not empty.
MatReactiveFormValidatorFunctions.notEmpty = notEmpty;
// The validator of includes.
MatReactiveFormValidatorFunctions.includes = includes;
// The validator of includes.
MatReactiveFormValidatorFunctions.maxlength = maxlength;
// The validator of includes.
MatReactiveFormValidatorFunctions.minlength = minlength;
// The validator of startsWith.
MatReactiveFormValidatorFunctions.startsWith = startsWith;
// The validator of includes.
MatReactiveFormValidatorFunctions.endsWith = endsWith;
// The validator of json.
MatReactiveFormValidatorFunctions.json = json;
// The validator of pattern.
MatReactiveFormValidatorFunctions.pattern = pattern;
// The validator of lessThan.
MatReactiveFormValidatorFunctions.lessThan = lessThan;
// The validator of min.
MatReactiveFormValidatorFunctions.min = min;
// The validator of min.
MatReactiveFormValidatorFunctions.max = max;
// The validator of lessThan.
MatReactiveFormValidatorFunctions.greaterThan = greaterThan;
// The validator of compare.
MatReactiveFormValidatorFunctions.compare = compare;
// The validator of different.
MatReactiveFormValidatorFunctions.different = different;
// The validator of unique.
MatReactiveFormValidatorFunctions.unique = unique;
/******************* 常规 ********************/
function notEmpty(validatorConfig) {
    const k = notEmpty.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const result = MatUtils.isEmpty(control.value, true);
            return result ? { [k]: validatorConfig.message } : null;
        }
        return null;
    };
}
function required(validatorConfig) {
    const k = required.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const result = MatUtils.isEmpty(control.value);
            return result ? { [k]: validatorConfig.message } : null;
        }
        return null;
    };
}
/******************** 字符串验证 *******************/
function includes(validatorConfig) {
    const k = includes.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const value = getValidatorValue(control, validatorConfig.value);
            if (value && control.value && !control.value.includes(value)) {
                return { [k]: validatorConfig.message };
            }
        }
        return null;
    };
}
function startsWith(validatorConfig) {
    const k = startsWith.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const value = getValidatorValue(control, validatorConfig.value);
            if (value && control.value && !control.value.startsWith(value)) {
                return { [k]: validatorConfig.message };
            }
        }
        return null;
    };
}
function endsWith(validatorConfig) {
    const k = endsWith.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const value = getValidatorValue(control, validatorConfig.value);
            if (value && control.value && !control.value.endsWith(value)) {
                return { [k]: validatorConfig.message };
            }
        }
        return null;
    };
}
function json(validatorConfig) {
    const k = json.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            if (!MatUtils.isEmpty(control.value, true) && !MatUtils.isJson(control.value)) {
                return { [k]: validatorConfig.message };
            }
        }
        return null;
    };
}
function pattern(validatorConfig) {
    const k = pattern.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const reg = typeof validatorConfig.value === 'string' ? new RegExp(validatorConfig.value) : validatorConfig.value;
            if (!reg.test(control.value)) {
                return { [k]: validatorConfig.message };
            }
        }
        return null;
    };
}
function maxlength(validatorConfig) {
    const k = maxlength.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const value = getValidatorValue(control, validatorConfig.value);
            if (!MatUtils.isEmpty(control.value) && !MatUtils.isEmpty(value)) {
                if (control.value.length > Number(value)) {
                    return { [k]: validatorConfig.message };
                }
            }
        }
        return null;
    };
}
function minlength(validatorConfig) {
    const k = minlength.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const value = getValidatorValue(control, validatorConfig.value);
            if (!MatUtils.isEmpty(control.value) && !MatUtils.isEmpty(value)) {
                if (control.value.length < Number(value)) {
                    return { [k]: validatorConfig.message };
                }
            }
        }
        return null;
    };
}
/******************** Number ********************/
function lessThan(validatorConfig) {
    const k = lessThan.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const value = getValidatorValue(control, validatorConfig.value);
            if (!MatUtils.isEmpty(control.value, true) && !MatUtils.isEmpty(value) && parseFloat(control.value) >= parseFloat(value)) {
                return { [k]: validatorConfig.message };
            }
        }
        return null;
    };
}
function max(validatorConfig) {
    const k = max.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const value = getValidatorValue(control, validatorConfig.value);
            if (!MatUtils.isEmpty(control.value, true) && !MatUtils.isEmpty(value) && parseFloat(control.value) > parseFloat(value)) {
                return { [k]: validatorConfig.message };
            }
        }
        return null;
    };
}
function greaterThan(validatorConfig) {
    const k = greaterThan.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const value = getValidatorValue(control, validatorConfig.value);
            if (!MatUtils.isEmpty(control.value, true) && !MatUtils.isEmpty(value) && parseFloat(control.value) <= parseFloat(value)) {
                return { [k]: validatorConfig.message };
            }
        }
        return null;
    };
}
function min(validatorConfig) {
    const k = min.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const value = getValidatorValue(control, validatorConfig.value);
            if (!MatUtils.isEmpty(control.value, true) && !MatUtils.isEmpty(value) && parseFloat(control.value) < parseFloat(value)) {
                return { [k]: validatorConfig.message };
            }
        }
        return null;
    };
}
/******************** Relational ********************/
function compare(validatorConfig) {
    const k = compare.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const compareValue = getValidatorValue(control, validatorConfig.value);
            if (!MatUtils.isEmpty(compareValue) || !MatUtils.isEmpty(control.value)) {
                if (compareValue !== control.value) {
                    return { [k]: validatorConfig.message };
                }
            }
        }
        return null;
    };
}
function different(validatorConfig) {
    const k = different.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const compareValue = getValidatorValue(control, validatorConfig.value);
            if (!MatUtils.isEmpty(compareValue) || !MatUtils.isEmpty(control.value)) {
                if (compareValue === control.value) {
                    return { [k]: validatorConfig.message };
                }
            }
        }
        return null;
    };
}
function unique(validatorConfig) {
    const k = unique.name;
    return (control) => {
        if (executeValidatorExpression(validatorConfig, control)) {
            const { formArray, relativeRootControl } = getParentFormArray(control);
            const parent = control.parent;
            const path = getPathFromControl(control, relativeRootControl);
            if (parent && formArray && formArray instanceof FormArray) {
                const currentValue = control.value;
                for (const formGroup of formArray.controls) {
                    const controlItem = getControlFromPath(path, formGroup);
                    if (controlItem && controlItem != control && controlItem.value == currentValue) {
                        return { [k]: validatorConfig.message };
                    }
                }
            }
        }
        return null;
    };
}
/******************** 方法 ********************/
function getRootControl(control) {
    if (control.parent) {
        return getRootControl(control.parent);
    }
    return control;
}
function getParentFormArray(control) {
    if (control.parent && !(control.parent instanceof FormArray)) {
        const result = getParentFormArray(control.parent);
        return { formArray: result.formArray, relativeRootControl: result.relativeRootControl };
    }
    return { formArray: control.parent, relativeRootControl: control };
}
function getFormControlName(control) {
    let controlName = '';
    if (control.parent) {
        for (const formControlName in control.parent.controls) {
            if (control.parent.controls[formControlName] == control) {
                controlName = formControlName;
                break;
            }
        }
    }
    return controlName;
}
function executeValidatorExpression(validatorConfig, control) {
    const expression = validatorConfig.expression;
    if (!expression) {
        return true;
    }
    const formValue = getRootControl(control).value;
    if (typeof expression === 'function') {
        return expression(formValue);
    }
    else {
        return !!MatUtils.functionCreator(expression)(formValue);
    }
}
function getValidatorConfig(config, key) {
    return config.validators[key];
}
function getValueFromPath(control, path) {
    const value = getRootControl(control).value;
    return MatUtils.getObjectValue(path, value);
}
function getValidatorValue(control, validatorValue) {
    const formValue = getRootControl(control).value;
    if (typeof validatorValue === 'function') {
        return validatorValue(formValue);
    }
    else if (typeof validatorValue === 'string' && MatUtils.isStringFunction(validatorValue)) {
        return MatUtils.functionCreator(validatorValue)(formValue);
    }
    else {
        return validatorValue;
    }
}
function getPathFromControl(control, rootControl) {
    if (control === rootControl) {
        return '';
    }
    const controlName = getFormControlName(control);
    const paths = controlName ? [controlName] : [];
    let parent = control.parent;
    while (parent && parent !== rootControl) {
        paths.unshift(getFormControlName(parent));
        parent = parent.parent;
    }
    return paths.join('.');
}
function getControlFromPath(path, rootControl) {
    let control = rootControl;
    const paths = path ? path.trim().split('.') : [];
    for (const k of paths) {
        control = control.get(k);
        if (!control) {
            break;
        }
    }
    return control;
}

class MatReactiveDesignerField {
    constructor() {
        this.label = 'executeStringValue';
        this.disabled = 'executeBooleanValue';
        this.class = 'executeStringValue';
        this.style = 'executeObjectValue';
        this.describe = 'executeStringValue';
        this.hidden = 'executeBooleanValue';
    }
    keys() {
        return Object.keys(this);
    }
}
class MatReactiveControlField {
    constructor() {
        this.limit = 'executeStringValue';
        this.maxSize = 'executeStringValue';
        this.accept = 'executeStringValue';
        this.url = 'executeStringValue';
        this.formData = 'executeObjectValue';
        /** textare */
        this.showTextTip = 'executeBooleanValue';
        /** text */
        this.before = 'executeStringValue';
        this.after = 'executeStringValue';
        /** text、textare */
        this.trim = 'executeBooleanValue';
        this.maxlength = 'executeValidatorsValue';
        this.compareWith = 'executeFunctionValue';
        /** date */
        this.type = 'executeStringValue';
        this.maxDate = 'executeStringValue';
        this.minDate = 'executeStringValue';
        this.showTime = 'executeBooleanValue';
        /** time */
        this.minTime = 'executeStringValue';
        this.maxTime = 'executeStringValue';
        /** number */
        this.max = 'executeValidatorsValue';
        this.min = 'executeValidatorsValue';
        this.precision = 'executeStringValue';
        this.step = 'executeStringValue';
        /** checkbox */
        this.direction = 'executeStringValue';
        this.labelPosition = 'executeStringValue';
        /** select button */
        this.tick = 'executeBooleanValue';
        this.iconField = 'executeStringValue';
        /** silder */
        this.rule = 'executeBooleanValue';
        this.thumbLabel = 'executeBooleanValue';
        this.textInterval = 'executeStringValue';
        this.tickInterval = 'executeStringValue';
        /** tree */
        this.lazy = 'executeBooleanValue';
        this.checkbox = 'executeBooleanValue';
        this.propagateUp = 'executeBooleanValue';
        this.propagateDown = 'executeBooleanValue';
    }
    inputKeys() {
        return ['placeholder', 'trim', 'before', 'after', 'maxlength'];
    }
    numberKeys() {
        return ['placeholder', 'max', 'min', 'type', 'precision', 'step'];
    }
    checkboxKeys() {
        return ['direction', 'multiple', 'disabledField', 'viewField', 'valueField', 'compareWith', 'labelPosition'];
    }
    radioKeys() {
        return ['direction', 'disabledField', 'viewField', 'valueField', 'compareWith', 'labelPosition'];
    }
    dropdownKeys() {
        return ['placeholder', 'direction', 'multiple', 'disabledField', 'viewField', 'valueField', 'compareWith', 'labelPosition'];
    }
    dateKeys() {
        return ['placeholder', 'type', 'maxDate', 'minDate', 'showTime'];
    }
    timeKeys() {
        return ['placeholder', 'maxTime', 'minTime'];
    }
    imageKeys() {
        return ['multiple', 'triggerText', 'limit', 'accept', 'maxSize', 'url', 'formData', 'srcField', 'nameField', 'thumbField'];
    }
    keys(type) {
        if (this[type + 'Keys']) {
            return this[type + 'Keys']();
        }
        else {
            return null;
        }
    }
}

class MatReactiveHttpRequest {
    constructor(_http, _httpConfig) {
        this._http = _http;
        this._headers = { 'Content-Type': 'application/json' };
        this._config = _httpConfig;
    }
    _getHttpParams(formValue) {
        const params = {};
        if (this._config.queryParams) {
            const type = typeof this._config.queryParams;
            let queryParams;
            if (type === 'object') {
                queryParams = this._config.queryParams;
            }
            else if (type === 'function') {
                queryParams = this._config.queryParams(formValue);
            }
            else if (typeof type === 'string') {
                if (MatUtils.isStringFunction(this._config.queryParams)) {
                    queryParams = MatUtils.functionCreator(this._config.queryParams)(formValue);
                }
                else if (MatUtils.isJson(this._config.queryParams)) {
                    queryParams = JSON.parse(this._config.queryParams);
                }
            }
            for (const k in queryParams) {
                if (queryParams[k] || typeof queryParams[k] === 'number' || typeof queryParams[k] === 'boolean') {
                    params[k] = queryParams[k];
                }
            }
        }
        return Object.keys(params).length ? new HttpParams({ fromObject: params }) : null;
    }
    _getBody(formValue) {
        let body;
        if (this._config.body) {
            const type = typeof this._config.body;
            if (type === 'object') {
                body = this._config.body;
            }
            else if (type === 'function') {
                body = this._config.body(formValue);
            }
            else if (typeof type === 'string') {
                if (MatUtils.isStringFunction(this._config.body)) {
                    body = MatUtils.functionCreator(this._config.body)(formValue);
                }
                else if (MatUtils.isJson(this._config.body)) {
                    body = JSON.parse(this._config.body);
                }
            }
        }
        return body;
    }
    _getHttpHeaders() {
        return new HttpHeaders(this._config.headers || this._headers);
    }
    _getHttpWithCredentials() {
        if (typeof this._config.withCredentials === 'boolean') {
            return this._config.withCredentials;
        }
        else {
            return !!this._config.withCredentials || true;
        }
    }
    _getRequestOptions(formValue) {
        return { params: this._getHttpParams(formValue), headers: this._getHttpHeaders(), withCredentials: this._getHttpWithCredentials() };
    }
    _getRequest(formValue) {
        return this._http.get(this._config.url, this._getRequestOptions(formValue));
    }
    _postRequest(formValue) {
        return this._http.post(this._config.url, this._getBody(formValue), this._getRequestOptions(formValue));
    }
    _executeSetResult(event) {
        if (this._config.setResult) {
            if (typeof this._config.setResult === 'function') {
                return this._config.setResult(event);
            }
            else if (typeof this._config.setResult === 'string' && MatUtils.isStringFunction(this._config.setResult)) {
                return MatUtils.functionCreator(this._config.setResult)(event);
            }
            else {
                return event;
            }
        }
        return event;
    }
    Request(formValue) {
        const request = this._config.method === 'post' ? this._postRequest(formValue) : this._getRequest(formValue);
        return request.pipe(map(e => this._config.dataPath ? MatUtils.getObjectValue(this._config.dataPath, e) : e), map(e => this._executeSetResult(e)));
    }
}

class MatReactiveFormControl {
    constructor(_cd, _http) {
        this._cd = _cd;
        this._http = _http;
        this.fields = new MatReactiveControlField();
        /** DataSource change event emit */
        this._dataSourceChange = new Subject();
        this._dataSource = [];
        this._compareWith = (e1, e2) => e1 === e2;
    }
    get config() { return this._config; }
    set config(value) {
        this._config = value;
        this.dataSource = this._config.dataSource;
    }
    get placeholder() { return this._placeholder; }
    set placeholder(value) {
        if (value !== this._placeholder) {
            this._placeholder = value;
            this._cd.markForCheck();
        }
    }
    get multiple() { return this._multiple; }
    set multiple(value) {
        this._multiple = value;
    }
    get dataSource() { return this._dataSource; }
    set dataSource(value) {
        if (!value) {
            this._dataSource = [];
        }
        else if (typeof value === 'string' && MatUtils.isJson(value)) {
            this._dataSource = JSON.parse(value);
        }
        else if (typeof value === 'object' && value.url) {
            if (this._dataSourceSubscription) {
                this._dataSourceSubscription.unsubscribe();
            }
            this._dataSourceSubscription = this._dataSourceChange.pipe(switchMap(() => new MatReactiveHttpRequest(this._http, value).Request(this.rootFormGroup.value))).subscribe(event => {
                this._dataSource = event || [];
                this._cd.markForCheck();
            });
        }
        else {
            this._dataSource = Array.isArray(value) ? value : [];
        }
        this._cd.markForCheck();
    }
    get maxlength() { return this._maxlength; }
    set maxlength(value) {
        if (value !== this._maxlength) {
            this._maxlength = value;
            this._cd.markForCheck();
        }
    }
    get trim() { return this._trim; }
    set trim(value) {
        this._trim = value;
    }
    get showTextTip() { return this._showTextTip; }
    set showTextTip(value) {
        this._showTextTip = value;
    }
    get before() { return this._before; }
    set before(value) {
        if (value !== this._before) {
            this._before = value;
            this._cd.markForCheck();
        }
    }
    get after() { return this._after; }
    set after(value) {
        if (value !== this._after) {
            this._after = value;
            this._cd.markForCheck();
        }
    }
    get srcField() { return this._srcField; }
    set srcField(value) {
        if (value !== this._srcField) {
            this._srcField = value;
            this._cd.markForCheck();
        }
    }
    get nameField() { return this._nameField; }
    set nameField(value) {
        if (value !== this._nameField) {
            this._nameField = value;
            this._cd.markForCheck();
        }
    }
    get thumbField() { return this._thumbField; }
    set thumbField(value) {
        if (value !== this._thumbField) {
            this._thumbField = value;
            this._cd.markForCheck();
        }
    }
    get triggerText() { return this._triggerText; }
    set triggerText(value) {
        if (value !== this._triggerText) {
            this._triggerText = value;
            this._cd.markForCheck();
        }
    }
    get limit() { return this._limit; }
    set limit(value) {
        if (value !== this._limit) {
            this._limit = value;
            this._cd.markForCheck();
        }
    }
    get maxSize() { return this._maxSize; }
    set maxSize(value) {
        if (value !== this._maxSize) {
            this._maxSize = value;
            this._cd.markForCheck();
        }
    }
    get accept() { return this._accept; }
    set accept(value) {
        if (value !== this._accept) {
            this._accept = value;
            this._cd.markForCheck();
        }
    }
    get url() { return this._url; }
    set url(value) {
        if (value !== this._url) {
            this._url = value;
            this._cd.markForCheck();
        }
    }
    get formData() { return this._url; }
    set formData(value) {
        if (value !== this._formData) {
            this._formData = value;
            this._cd.markForCheck();
        }
    }
    get disabledField() { return this._disabledField; }
    set disabledField(value) {
        if (value !== this._disabledField) {
            this._disabledField = value;
            this._cd.markForCheck();
        }
    }
    get viewField() { return this._viewField; }
    set viewField(value) {
        if (value !== this._viewField) {
            this._viewField = value;
            this._cd.markForCheck();
        }
    }
    get valueField() { return this._valueField; }
    set valueField(value) {
        if (value !== this._valueField) {
            this._valueField = value;
            this._cd.markForCheck();
        }
    }
    get compareWith() { return this._compareWith; }
    set compareWith(value) {
        this._compareWith = value ? value : (e1, e2) => e1 === e2;
        this._cd.markForCheck();
    }
    get type() { return this._type; }
    set type(value) {
        if (value !== this._type) {
            this._type = value;
            this._cd.markForCheck();
        }
    }
    get maxDate() { return this._maxDate; }
    set maxDate(value) {
        if (value !== this._maxDate) {
            this._maxDate = value;
            this._cd.markForCheck();
        }
    }
    get minDate() { return this._minDate; }
    set minDate(value) {
        if (value !== this._minDate) {
            this._minDate = value;
            this._cd.markForCheck();
        }
    }
    get maxTime() { return this._maxTime; }
    set maxTime(value) {
        if (value !== this._maxTime) {
            this._maxTime = value;
            this._cd.markForCheck();
        }
    }
    get minTime() { return this._minTime; }
    set minTime(value) {
        if (value !== this._minTime) {
            this._minTime = value;
            this._cd.markForCheck();
        }
    }
    get showTime() { return this._showTime; }
    set showTime(value) {
        if (value !== this._showTime) {
            this._showTime = value;
            this._cd.markForCheck();
        }
    }
    get max() { return this._max; }
    set max(value) {
        if (value !== this._max) {
            this._max = value;
            this._cd.markForCheck();
        }
    }
    get min() { return this._min; }
    set min(value) {
        if (value !== this._min) {
            this._min = value;
            this._cd.markForCheck();
        }
    }
    get precision() { return this._precision; }
    set precision(value) {
        if (value !== this._precision) {
            this._precision = value;
            this._cd.markForCheck();
        }
    }
    get step() { return this._step; }
    set step(value) {
        if (value !== this._step) {
            this._step = value;
            this._cd.markForCheck();
        }
    }
    get direction() { return this._direction; }
    set direction(value) {
        if (value !== this._direction) {
            this._direction = value;
            this._cd.markForCheck();
        }
    }
    get labelPosition() { return this._labelPosition; }
    set labelPosition(value) {
        if (value !== this._labelPosition) {
            this._labelPosition = value;
            this._cd.markForCheck();
        }
    }
    get iconField() { return this._iconField; }
    set iconField(value) {
        if (value !== this._iconField) {
            this._iconField = value;
            this._cd.markForCheck();
        }
    }
    get tick() { return this._tick; }
    set tick(value) {
        if (value == this._tick) {
            this._tick = value;
            this._cd.markForCheck();
        }
    }
    get rule() { return this._rule; }
    set rule(value) {
        if (value == this._rule) {
            this._rule = value;
            this._cd.markForCheck();
        }
    }
    get thumbLabel() { return this._thumbLabel; }
    set thumbLabel(value) {
        if (value == this._thumbLabel) {
            this._thumbLabel = value;
            this._cd.markForCheck();
        }
    }
    get textInterval() { return this._textInterval; }
    set textInterval(value) {
        if (value !== this._textInterval) {
            this._textInterval = value;
            this._cd.markForCheck();
        }
    }
    get tickInterval() { return this._tickInterval; }
    set tickInterval(value) {
        if (value !== this._tickInterval) {
            this._tickInterval = value;
            this._cd.markForCheck();
        }
    }
    get childrenField() { return this._childrenField; }
    set childrenField(value) {
        if (value !== this._childrenField) {
            this._childrenField = value;
            this._cd.markForCheck();
        }
    }
    get selectableField() { return this._selectableField; }
    set selectableField(value) {
        if (value !== this._selectableField) {
            this._selectableField = value;
            this._cd.markForCheck();
        }
    }
    get lazy() { return this._lazy; }
    set lazy(value) {
        if (value == this._lazy) {
            this._lazy = value;
            this._cd.markForCheck();
        }
    }
    get checkbox() { return this._checkbox; }
    set checkbox(value) {
        if (value == this._checkbox) {
            this._checkbox = value;
            this._cd.markForCheck();
        }
    }
    get propagateUp() { return this._propagateUp; }
    set propagateUp(value) {
        if (value == this._propagateUp) {
            this._propagateUp = value;
            this._cd.markForCheck();
        }
    }
    get propagateDown() { return this._propagateDown; }
    set propagateDown(value) {
        if (value == this._propagateDown) {
            this._propagateDown = value;
            this._cd.markForCheck();
        }
    }
    get loadChildren() { return this._loadChildren; }
    set loadChildren(value) {
        this._loadChildren = value;
        this._cd.markForCheck();
    }
    markForCheck() {
        this._cd.markForCheck();
    }
    /** Component init hook. */
    ngOnInit() {
        this.setControlConfig(this.rootFormGroup.value);
        this.rootFormGroup.valueChanges.pipe(debounceTime(100)).subscribe(e => {
            this.setControlConfig(e);
            if (this.formControl) {
                this.formControl.updateValueAndValidity({ emitEvent: false });
            }
        });
        if (this._dataSourceSubscription) {
            setTimeout(() => {
                const subscribes = [];
                if (this.config.dataSource.relational) {
                    this.config.dataSource.relational.split(',').forEach(item => {
                        const path = item.trim();
                        if (path) {
                            subscribes.push(getControlFromPath(path, this.rootFormGroup).valueChanges);
                        }
                    });
                    if (subscribes.length) {
                        merge(...subscribes)
                            .pipe(startWith({}))
                            .subscribe(() => this._dataSourceChange.next(this.rootFormGroup.getRawValue()));
                    }
                }
                else {
                    this._dataSourceChange.next(this.rootFormGroup.getRawValue());
                }
            }, 100);
        }
    }
    setControlConfig(e) {
        const keys = this.fields.keys(this.config.component);
        if (keys) {
            keys.forEach(key => {
                if (this.fields[key] && this[this.fields[key]]) {
                    const config = this.fields[key].includes('Validators') ? this.config.validators : this.config[key];
                    this[key] = this[this.fields[key]](config, e, key);
                }
                else {
                    this[key] = this.config[key];
                }
            });
        }
    }
    /** Execute function or value to boolean. */
    executeBooleanValue(value, params) {
        if (typeof value === 'boolean') {
            return value;
        }
        else if (typeof value === 'function') {
            return value(params);
        }
        else if (typeof value === 'string') {
            if (MatUtils.isStringFunction(value)) {
                return MatUtils.functionCreator(value)(params);
            }
        }
    }
    /** Execute function or value to string. */
    executeStringValue(value, params) {
        if (typeof value === 'string') {
            if (MatUtils.isStringFunction(value)) {
                return MatUtils.functionCreator(value)(params);
            }
            else {
                return value;
            }
        }
        else if (typeof value === 'function') {
            return value(params);
        }
        else {
            return value;
        }
    }
    /** Execute function or value to object. */
    executeObjectValue(value, params) {
        if (typeof value === 'string' && MatUtils.isStringFunction(value)) {
            return MatUtils.functionCreator(value)(params);
        }
        else if (typeof value === 'function') {
            return value(params);
        }
        else {
            return value;
        }
    }
    /** Execute function or value to function. */
    executeFunctionValue(value) {
        if (typeof value === 'string' && MatUtils.isStringFunction(value)) {
            return MatUtils.functionCreator(value);
        }
        else if (typeof value === 'function') {
            return value;
        }
    }
    /** Execute function or value to function. */
    executeValidatorsValue(validatorsConfig, formValue, key) {
        const validatorConfig = (validatorsConfig || {})[key] || {};
        const expression = validatorConfig.expression;
        let value = null;
        let result = true;
        if (validatorConfig.value) {
            if (expression) {
                if (typeof expression === 'function') {
                    if (!expression(formValue)) {
                        result = false;
                    }
                }
                else {
                    result = !!MatUtils.functionCreator(expression)(formValue);
                }
            }
            if (result) {
                if (typeof validatorConfig.value === 'string' && MatUtils.isStringFunction(validatorConfig.value)) {
                    value = MatUtils.functionCreator(validatorConfig.value)(formValue);
                }
                else if (typeof validatorConfig.value === 'function') {
                    value = validatorConfig.value(formValue);
                }
                else {
                    value = validatorConfig.value;
                }
            }
        }
        return value;
    }
}
MatReactiveFormControl.decorators = [
    { type: Directive, args: [{},] }
];
MatReactiveFormControl.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: HttpClient }
];
MatReactiveFormControl.propDecorators = {
    formControl: [{ type: Input }],
    rootFormGroup: [{ type: Input }],
    config: [{ type: Input }]
};

class MatLightboxConfig extends OverlayConfig {
    constructor() {
        super(...arguments);
        this.loop = true;
        this.srcField = 'src';
        this.thumbField = 'thumb';
        this.describeField = 'describe';
        this.zoomValue = 100;
        this.maxZoom = 600;
        this.snapView = false;
        this.refreshOnResize = true;
        this.zoomOnMouseWheel = true;
        this.toolbar = true;
        this.zoom = true;
        this.rotate = true;
        this.reset = true;
        this.download = true;
        this.downloadPrefix = 'img_download';
    }
}
class MatLightboxOverlayRef {
    constructor(_overlayRef) {
        this._overlayRef = _overlayRef;
    }
    close() {
        this._overlayRef.dispose();
    }
}
function MAT_LIGHTBOX_DEFAULT_CONFIG_FACTORY() {
    return new MatLightboxConfig();
}
const MAT_LIGHTBOX_DEFAULT_CONFIG = new InjectionToken('mat-lightbox-default-config', {
    providedIn: 'root',
    factory: MAT_LIGHTBOX_DEFAULT_CONFIG_FACTORY
});
const MAT_LIGHTBOX_DATA = new InjectionToken('MAT_LIGHTBOX_DATA');
const MAT_LIGHTBOX_DEFAULT_ROTATE_ANGLE = 90;
class MatLightBox {
    constructor(_el, _renderer, imageRef, data, _defaultConfig) {
        this._el = _el;
        this._renderer = _renderer;
        this.imageRef = imageRef;
        this.data = data;
        this._defaultConfig = _defaultConfig;
        this.indexChange = new EventEmitter();
        this._dataSource = [];
        this._index = 0;
        this._showClose = true;
        /** Zoom in or out image functions. */
        this.zoomValue = 100;
        if (data) {
            this.dataSource = data.data || [];
            this.index = data.activeIndex || 0;
            this.setConfig(data.config);
        }
    }
    /** Image list. */
    set dataSource(value) {
        this._dataSource = value || [];
    }
    get dataSource() { return this._dataSource; }
    /** Image active index */
    set index(value) {
        this._index = value;
    }
    get index() { return this._index; }
    /** Whether to display in a loop.  */
    set loop(value) {
        this._loop = coerceBooleanProperty(value);
    }
    get loop() { return this._loop == undefined ? this._defaultConfig.loop : this._loop; }
    /** Whether to show toolbar.  */
    set toolbar(value) {
        this._toolbar = coerceBooleanProperty(value);
    }
    get toolbar() { return this._toolbar == undefined ? this._defaultConfig.toolbar : this._toolbar; }
    /** Whether to show zoom button.  */
    set zoom(value) {
        this._zoom = coerceBooleanProperty(value);
    }
    get zoom() { return this._zoom == undefined ? this._defaultConfig.zoom : this._zoom; }
    /** Whether to show rotate button.  */
    set rotate(value) {
        this._rotate = coerceBooleanProperty(value);
    }
    get rotate() { return this._rotate == undefined ? this._defaultConfig.rotate : this._rotate; }
    /** Whether to show reset button.  */
    set reset(value) {
        this._reset = coerceBooleanProperty(value);
    }
    get reset() { return this._reset == undefined ? this._defaultConfig.reset : this._reset; }
    /** Whether to show reset button.  */
    set download(value) {
        this._download = coerceBooleanProperty(value);
    }
    get download() { return this._download == undefined ? this._defaultConfig.download : this._download; }
    /** The prefix of download name.  */
    set downloadPrefix(value) {
        this._downloadPrefix = value;
    }
    get downloadPrefix() { return this._downloadPrefix || this._defaultConfig.downloadPrefix; }
    /** Whether show the close button element.  */
    set showClose(value) {
        this._showClose = coerceBooleanProperty(value);
    }
    get showClose() { return this._showClose; }
    set srcField(value) {
        this._srcField = value;
    }
    get srcField() {
        return this._srcField || this._defaultConfig.srcField;
    }
    set describeField(value) {
        this._describeField = value;
    }
    get describeField() {
        return this._describeField || this._defaultConfig.describeField;
    }
    set thumbField(value) {
        this._thumbField = value;
    }
    get thumbField() {
        return this._thumbField || this._defaultConfig.thumbField;
    }
    /** Init the view document. */
    ngAfterViewInit() {
        this.initImgViewer();
    }
    initImgViewer() {
        this.imageViewer = new ImageViewer(this._el.nativeElement.querySelector('.mat-lightbox-img'), this._defaultConfig);
        if (this.dataSource && this.dataSource.length > 0) {
            this.showImg();
        }
    }
    /** Show current index image. */
    showImg() {
        this.imageViewer.load(this.dataSource[this.index][this.srcField]);
    }
    zoomInImg() {
        this.zoomValue = this.imageViewer._state.zoomValue;
        this.zoomValue += 10;
        this.imageViewer.zoom(this.zoomValue);
    }
    zoomOutImg() {
        this.zoomValue = this.imageViewer._state.zoomValue;
        if (this.zoomValue == 100) {
            return;
        }
        this.zoomValue = Math.max(0, this.zoomValue - 10);
        this.imageViewer.zoom(this.zoomValue);
    }
    prevImg() {
        this.index = this.index <= 0 ? (this.loop ? this.dataSource.length - 1 : 0) : this.index - 1;
        this.showImg();
    }
    nextImg() {
        this.index = this.index >= this.dataSource.length - 1 ? (this.loop ? 0 : this.dataSource.length - 1) : this.index + 1;
        this.showImg();
    }
    resetImg() {
        this.imageViewer.resetZoom();
    }
    downloadImg() {
        const img = new Image();
        img.setAttribute('crossOrigin', 'anonymous');
        img.onload = () => {
            const canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            const context = canvas.getContext('2d');
            context.drawImage(img, 0, 0, img.width, img.height);
            const url = canvas.toDataURL('image/png');
            const download = this._renderer.createElement('a');
            this._renderer.setAttribute(download, 'download', `${this.downloadPrefix}_${this.index}`);
            this._renderer.setAttribute(download, 'display', 'none');
            this._renderer.setAttribute(download, 'href', url);
            this._renderer.setAttribute(download, 'target', '_blank');
            this._renderer.appendChild(this._el.nativeElement, download);
            download.click();
            this._renderer.removeChild(this._el.nativeElement, download);
        };
        img.src = this.dataSource[this.index][this.srcField];
    }
    setConfig(config) {
        if (!config) {
            return;
        }
        Object.keys(config).forEach(key => {
            if (Object.prototype.hasOwnProperty.call(this._defaultConfig, key)) {
                this._defaultConfig[key] = config[key];
            }
        });
    }
    close() {
        if (this.imageRef) {
            this.imageRef.close();
        }
    }
    imageError(event) {
        // event.target.src = '../../assets/images/imageerror.png';
    }
    imageLoad(event) {
    }
    showIcon(key) {
        if (key === 'left') {
            return this.loop ? this.index >= 0 : this.index > 0;
        }
        else {
            return this.loop ? this.index < this.dataSource.length : this.index < this.dataSource.length - 1;
        }
    }
}
MatLightBox.decorators = [
    { type: Component, args: [{
                selector: 'mat-lightbox',
                template: "<div class=\"mat-lightbox-wapper\">\r\n    <div class=\"mat-lightbox-close\" *ngIf=\"showClose\" (click)=\"close()\">\r\n        <div class=\"mat-close-icon\"></div>\r\n    </div>\r\n\r\n    <!-- <div class=\"mat-lightbox-left\" *ngIf=\"showIcon('left')\" (click)=\"changeToPrev()\"></div>\r\n\r\n    <div class=\"mat-lightbox-right\" *ngIf=\"showIcon('right')\" (click)=\"changeToNext()\"></div> -->\r\n\r\n    <div class=\"mat-lightbox-content\">\r\n        <div class=\"mat-lightbox-img\">\r\n\r\n        </div>\r\n        <!-- <img class=\"mat-lightbox-img\" [src]=\"dataSource[index]&& dataSource[index][srcField] || null\" (load)=\"imageLoad($event)\" (error)=\"imageError($event)\" alt=\"\"> -->\r\n        <div class=\"mat-lightbox-describe\" *ngIf=\"dataSource[index] && dataSource[index][describeField]\">\r\n        {{dataSource[index] ? dataSource[index][describeField] : ''}}\r\n        </div>\r\n\r\n        <div class=\"mat-lightbox-toolbar\">\r\n            <div class=\"mat-lightbox-toolbar-item\" title=\"\u5B9E\u9645\u5927\u5C0F\" (click)=\"resetImg()\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path fill=\"currentColor\" d=\"M511.38476562 938.88476563c-57.91992188 0-114.16992188-11.33789063-167.08007812-33.75000001C293.15234375 883.51367188 247.2734375 852.57617188 207.8984375 813.11328125c-39.375-39.375-70.40039063-85.34179688-92.02148438-136.40625-22.41210938-52.91015625-33.75-109.16015625-33.74999999-167.08007813 0-57.91992188 11.33789063-114.16992188 33.75-167.08007812C137.49804687 291.48242187 168.43554687 245.515625 207.8984375 206.140625c39.375-39.375 85.34179688-70.40039063 136.40625-92.02148438C397.30273437 91.79492187 453.46484375 80.45703125 511.38476562 80.45703125s114.16992188 11.33789063 167.08007813 33.75c51.15234375 21.62109375 97.03125 52.55859375 136.40625 92.02148438 39.375 39.375 70.40039063 85.34179688 92.02148438 136.40624999 22.41210938 52.91015625 33.75 109.16015625 33.74999999 167.08007813 0 57.91992188-11.33789063 114.16992188-33.75 167.08007813-21.62109375 51.15234375-52.55859375 97.03125-92.02148437 136.40624999-39.375 39.375-85.34179688 70.40039063-136.40625 92.02148438-52.91015625 22.32421875-109.16015625 33.66210938-167.08007813 33.66210938z m0-795.14648438c-49.39453125 0-97.3828125 9.66796875-142.47070312 28.74023438-43.59375 18.45703125-82.70507813 44.82421875-116.3671875 78.48632812s-60.02929688 72.7734375-78.48632813 116.3671875c-19.07226563 45.08789063-28.74023438 92.98828125-28.74023437 142.47070313 0 49.39453125 9.66796875 97.3828125 28.74023438 142.47070312 18.45703125 43.59375 44.82421875 82.70507813 78.48632812 116.3671875 33.66210938 33.66210938 72.7734375 60.02929688 116.3671875 78.48632813C414.00195312 866.19921875 461.90234375 875.8671875 511.38476562 875.8671875s97.3828125-9.66796875 142.47070313-28.74023438c43.59375-18.45703125 82.70507813-44.82421875 116.3671875-78.48632812C803.796875 734.80273438 830.1640625 695.69140625 848.62109375 652.09765625c19.07226563-45.08789063 28.74023438-92.98828125 28.74023438-142.47070313 0-49.39453125-9.66796875-97.3828125-28.74023438-142.47070312-18.45703125-43.59375-44.82421875-82.70507813-78.48632813-116.3671875s-72.7734375-60.02929688-116.36718749-78.48632813C608.76757813 153.40625 560.8671875 143.73828125 511.38476562 143.73828125z\"></path>\r\n                    <path fill=\"currentColor\" d=\"M511.47265625 441.86328125m-31.640625 0a31.640625 31.640625 0 1 0 63.28125 0 31.640625 31.640625 0 1 0-63.28125 0Z\"></path>\r\n                    <path fill=\"currentColor\" d=\"M511.47265625 580.90625m-31.640625 0a31.640625 31.640625 0 1 0 63.28125 0 31.640625 31.640625 0 1 0-63.28125 0Z\"></path>\r\n                    <path fill=\"currentColor\" d=\"M384.99804687 354.58789062h-34.01367187c-3.33984375 0-6.6796875 1.0546875-9.40429687 2.98828126-12.04101563 8.61328125-46.14257813 31.81640625-70.48828125 45.61523437-2.54882813 1.40625-4.04296875 4.13085938-4.04296875 7.03125v33.83789063h67.8515625v237.04101562c0 4.48242188 3.60351563 8.0859375 8.0859375 8.0859375h42.01171875c4.48242188 0 8.0859375-3.60351563 8.0859375-8.0859375V362.5859375c0-4.39453125-3.60351563-7.99804688-8.0859375-7.99804688zM701.75585938 354.58789062h-33.92578126c-3.33984375 0-6.6796875 1.0546875-9.40429687 2.98828126-12.04101563 8.61328125-46.14257813 31.81640625-70.48828125 45.61523437-2.54882813 1.40625-4.04296875 4.13085938-4.04296875 7.03125v25.83984375c0 4.48242188 3.60351563 8.0859375 8.0859375 8.0859375h59.765625v237.04101563c0 4.48242188 3.60351563 8.0859375 8.0859375 8.08593749H701.84375c4.48242188 0 8.0859375-3.60351563 8.0859375-8.0859375V362.67382812c0-4.48242188-3.69140625-8.0859375-8.17382813-8.08593749z\"></path>\r\n                </svg>\r\n            </div>\r\n            <div class=\"mat-lightbox-toolbar-item\" title=\"\u653E\u5927(+)\" (click)=\"zoomInImg()\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path fill=\"currentColor\" d=\"M796 751.008l124.992 124.992q8.992 10.016 8.992 22.496t-9.504 22.016-22.016 9.504-22.496-8.992l-124.992-124.992q-132.992 108.992-295.008 99.488t-280.992-132.512q-114.016-128.992-111.008-291.008t122.016-286.016q124-119.008 286.016-122.016t291.008 111.008q123.008 119.008 132.512 280.992t-99.488 295.008zM480 832q150.016-4 248.992-103.008T832 480q-4-150.016-103.008-248.992T480 128q-150.016 4-248.992 103.008T128 480q4 150.016 103.008 248.992T480 832z m-32-384v-96q0-14.016 8.992-23.008T480 320t23.008 8.992T512 352v96h96q14.016 0 23.008 8.992T640 480t-8.992 23.008T608 512h-96v96q0 14.016-8.992 23.008T480 640t-23.008-8.992T448 608v-96h-96q-14.016 0-23.008-8.992T320 480t8.992-23.008T352 448h96z\" ></path></svg>\r\n            </div>\r\n            <div class=\"mat-lightbox-toolbar-item\" title=\"\u7F29\u5C0F(-)\" (click)=\"zoomOutImg()\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path fill=\"currentColor\" d=\"M796 751.008l124.992 124.992q8.992 10.016 8.992 22.496t-9.504 22.016-22.016 9.504-22.496-8.992l-124.992-124.992q-132.992 108.992-295.008 99.488t-280.992-132.512q-114.016-128.992-111.008-291.008t122.016-286.016q124-119.008 286.016-122.016t291.008 111.008q123.008 119.008 132.512 280.992t-99.488 295.008zM480 832q150.016-4 248.992-103.008T832 480q-4-150.016-103.008-248.992T480 128q-150.016 4-248.992 103.008T128 480q4 150.016 103.008 248.992T480 832z m-128-384h256q14.016 0 23.008 8.992T640 480t-8.992 23.008T608 512h-256q-14.016 0-23.008-8.992T320 480t8.992-23.008T352 448z\"></path></svg>\r\n            </div>\r\n            <div class=\"mat-lightbox-toolbar-item\" title=\"\u4E0A\u4E00\u5F20(\u2190)\" (click)=\"prevImg()\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path fill=\"currentColor\" d=\"M362.58593777 512a29.53125001 29.53125001 0 0 0 9.4921875 21.79687473l194.0625 181.75781277a29.53125001 29.53125001 0 1 0 40.42968696-43.2421875L435.71093723 512l170.859375-160.3125a29.53125001 29.53125001 0 1 0-40.42968696-43.2421875L371.37499973 489.14843777a29.53125001 29.53125001 0 0 0-8.78906196 22.85156223zM512 90.125a421.875 421.875 0 1 0 421.875 421.875A421.875 421.875 0 0 0 512 90.125z m0 59.41406277a362.10937527 362.10937527 0 0 1 140.62500027 695.74218722A362.10937527 362.10937527 0 0 1 255.35937473 255.35937473a361.40624972 361.40624972 0 0 1 256.2890625-105.46875z\"></path></svg>\r\n            </div>\r\n            <div class=\"mat-lightbox-toolbar-item\" title=\"\u4E0B\u4E00\u5F20(\u2192)\" (click)=\"nextImg()\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path fill=\"currentColor\" d=\"M652.62500027 489.14843777l-195.46875026-181.75781277a29.53125001 29.53125001 0 1 0-40.78124974 43.2421875L587.58593723 512l-171.21093696 159.2578125a29.53125001 29.53125001 0 1 0 40.42968696 43.2421875L652.62500027 532.39062527a29.53125001 29.53125001 0 0 0 0-43.2421875zM512 90.125a421.875 421.875 0 1 0 421.875 421.875A421.875 421.875 0 0 0 512 90.125z m0 59.41406277a362.10937527 362.10937527 0 0 1 140.62500027 695.74218722A362.10937527 362.10937527 0 0 1 255.35937473 255.35937473a361.40624973 361.40624973 0 0 1 256.2890625-105.46875z\"></path></svg>\r\n            </div>\r\n            <!-- <div class=\"mat-lightbox-toolbar-item\" title=\"\u5DE6\u65CB\u8F6C(90\u00B0)\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path fill=\"currentColor\" d=\"M288.992 296.992h92.992q14.016 0 23.008 8.992t8.992 22.496-8.992 22.496-23.008 10.016H232.992q-14.016-0.992-23.008-10.016t-8.992-22.016V179.968q0-14.016 8.992-23.008t23.008-8.992 23.008 8.992 8.992 23.008v50.016q86.016-76.992 196.512-95.488t217.504 26.496q106.016 48 167.488 142.016t62.496 210.016q-4 163.008-112.512 271.488t-271.488 112.512q-163.008-4-271.488-112.512t-112.512-271.488h64q3.008 136 93.504 226.496t226.496 93.504q136-3.008 226.016-93.504t94.016-226.496q-0.992-100.992-56-180.512t-148-117.504q-94.016-35.008-188.512-13.504T289.024 296.992z\"></path></svg>\r\n            </div>\r\n            <div class=\"mat-lightbox-toolbar-item\" title=\"\u53F3\u65CB\u8F6C(90\u00B0)\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path fill=\"currentColor\" d=\"M784.992 230.016V180q0-14.016 8.992-23.008t22.496-8.992 22.496 8.992 10.016 23.008v148.992q-0.992 12.992-10.016 22.016t-22.016 10.016h-148.992q-14.016-0.992-23.008-10.016t-8.992-22.496 8.992-22.496 23.008-8.992h92.992q-78.016-82.016-183.488-99.488t-204.512 34.496q-98.016 54.016-140.992 152t-16.992 208q28.992 108 113.504 173.504t196.512 67.488q136-3.008 226.016-93.504t94.016-226.496h64q-4 163.008-112.512 271.488t-271.488 112.512q-163.008-4-271.488-112.512t-112.512-271.488q0.992-116 62.016-210.016t167.008-140.992q107.008-46.016 217.504-27.488t197.504 95.488z\"></path></svg>\r\n            </div> -->\r\n            <div class=\"mat-lightbox-toolbar-item\" title=\"\u4E0B\u8F7D\u56FE\u7247(\u2193)\" (click)=\"downloadImg()\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path fill=\"currentColor\" d=\"M512 90.125C279.0051875 90.125 90.125 279.0051875 90.125 512s188.8801875 421.875 421.875 421.875c232.993125 0 421.875-188.8801875 421.875-421.875S744.993125 90.125 512 90.125z m0 788.90625c-202.705875 0-367.03125-164.325375-367.03125-367.03125S309.294125 144.96875 512 144.96875c202.7041875 0 367.03125 164.325375 367.03125 367.03125S714.7041875 879.03125 512 879.03125z\"></path>\r\n                    <path fill=\"currentColor\" d=\"M661.5850625 516.7266875l-115.56 115.56c0-0.408375 0.131625-0.9433125 0.131625-1.3516875v-315.9c0-18.8983125-15.2533125-34.158375-34.151625-34.158375-18.9050625 0-34.158375 15.2600625-34.158375 34.158375v316.038375c0 0.401625 0.138375 0.9433125 0.138375 1.3449375l-115.56-115.56c-13.368375-13.361625-34.9633125-13.361625-48.3316875 0-13.368375 13.368375-13.368375 34.9700625 0 48.3316875l163.7533125 163.8916875c9.041625 9.0433125 21.2000625 14.04 34.02 14.04 12.828375 0 24.8450625-4.9966875 34.02-14.04l164.0233125-164.0233125c13.368375-13.368375 13.368375-34.9633125 0-48.3316875-13.3633125-13.368375-34.9633125-13.368375-48.3249375 0zM511.865 666.44l-1.353375-1.3449375c0.4100625 0 0.9500625 0.131625 1.353375 0.131625 0.4066875 0 0.9500625-0.131625 1.3516875-0.131625l-1.3516875 1.3449375z\"></path>\r\n                </svg>\r\n            </div>\r\n            <div class=\"mat-lightbox-page\">\r\n                {{index + 1}} / {{dataSource.length}}\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n</div>",
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class.mat-lightbox]': 'true'
                }
            },] }
];
MatLightBox.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 },
    { type: MatLightboxOverlayRef, decorators: [{ type: Optional }] },
    { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_LIGHTBOX_DATA,] }] },
    { type: MatLightboxConfig, decorators: [{ type: Inject, args: [MAT_LIGHTBOX_DEFAULT_CONFIG,] }] }
];
MatLightBox.propDecorators = {
    indexChange: [{ type: Output }],
    dataSource: [{ type: Input }],
    index: [{ type: Input }],
    loop: [{ type: Input }],
    toolbar: [{ type: Input }],
    zoom: [{ type: Input }],
    rotate: [{ type: Input }],
    reset: [{ type: Input }],
    download: [{ type: Input }],
    downloadPrefix: [{ type: Input }],
    showClose: [{ type: Input }],
    srcField: [{ type: Input }],
    describeField: [{ type: Input }],
    thumbField: [{ type: Input }]
};
class MatLightBoxService {
    constructor(overlay, injector) {
        this.overlay = overlay;
        this.injector = injector;
    }
    open(data) {
        const overlayRef = this.overlay.create(this.getOverlayConfig());
        const imagePreviewRef = new MatLightboxOverlayRef(overlayRef);
        const overlayComponent = this.attachContainer(overlayRef, data, imagePreviewRef);
        overlayRef.backdropClick().subscribe(_ => overlayComponent.close());
        return imagePreviewRef;
    }
    attachContainer(overlayRef, data, dialogRef) {
        const injector = this.createInjector(data, dialogRef);
        const containerPortal = new ComponentPortal(MatLightBox, null, injector);
        const containerRef = overlayRef.attach(containerPortal);
        return containerRef.instance;
    }
    createInjector(data, dialogRef) {
        const injectionTokens = new WeakMap();
        injectionTokens.set(MatLightboxOverlayRef, dialogRef);
        injectionTokens.set(MAT_LIGHTBOX_DATA, data);
        return new PortalInjector(this.injector, injectionTokens);
    }
    getOverlayConfig() {
        return new OverlayConfig({
            panelClass: 'mat-lightbox-overlay-panel',
            hasBackdrop: true,
            scrollStrategy: this.overlay.scrollStrategies.block(),
            positionStrategy: this.overlay.position().global().centerHorizontally().centerVertically()
        });
    }
}
MatLightBoxService.decorators = [
    { type: Injectable }
];
MatLightBoxService.ctorParameters = () => [
    { type: Overlay },
    { type: Injector }
];

/**
* Powered by ng-picture-viewer
*/
class MatLightboxModule {
}
MatLightboxModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    OverlayModule
                ],
                exports: [MatLightBox],
                declarations: [MatLightBox],
                providers: [MatLightBoxService],
                entryComponents: [MatLightBox],
            },] }
];

const toastAnimation = trigger('moveUpMotion', [
    transition(':enter', [
        style({
            transformOrigin: '0 0',
            transform: 'translateY(-100%)',
            opacity: 0
        }),
        animate('0.2s', style({
            transformOrigin: '0 0',
            transform: 'translateY(0%)',
            opacity: 1
        }))
    ]),
    transition(':leave', [
        style({
            transformOrigin: '0 0',
            transform: 'translateY(0%)',
            opacity: 1
        }),
        animate('0.2s', style({
            transformOrigin: '0 0',
            transform: 'translateY(-100%)',
            opacity: 0
        }))
    ])
]);
class MatToastComponent {
    constructor(snackBarRef, data) {
        this.snackBarRef = snackBarRef;
        this.data = data;
        this._duration = data.duration;
        this._minDuration = data.minDuration;
        this._pauseOnHover = data.pauseOnHover;
        this.snackBarRef.afterDismissed().subscribe(() => {
            if (this._durationTimeoutId) {
                clearTimeout(this._durationTimeoutId);
                this._durationTimeoutId = null;
            }
        });
        this.snackBarRef.afterOpened().subscribe(() => {
            this.dismissAfter();
        });
    }
    dismissAfter(duration = this._duration) {
        if (this._duration > 0) {
            this._startTime = Date.now();
            this._durationTimeoutId = setTimeout(() => this.dismiss(), duration);
        }
    }
    dismiss() {
        this.snackBarRef.dismiss();
    }
    action() {
        this.snackBarRef.dismissWithAction();
    }
    mouseEnter() {
        if (this._pauseOnHover) {
            clearTimeout(this._durationTimeoutId);
            this._durationTimeoutId = null;
        }
    }
    mouseLeave() {
        if (this._pauseOnHover) {
            const duration = Math.max(this._duration - (Date.now() - this._startTime), this._minDuration);
            this.dismissAfter(duration);
        }
    }
}
MatToastComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-toast-component',
                template: "<div @moveUpMotion class=\"mat-toast\" [ngClass]=\"data.class\" (mouseenter)=\"mouseEnter()\" (mouseleave)=\"mouseLeave()\">\r\n    <ng-template [ngTemplateOutlet]=\"data.isTemplate ? data.content : default\" [ngTemplateOutletContext]=\"{$implicit: data, data: data }\"></ng-template>\r\n    <ng-template #default>\r\n            <span *ngIf=\"data.severity\" class=\"mat-toast-severity {{data.severity}}\"></span>\r\n            <p class=\"mat-toast-content\"> {{data.content}} </p>\r\n            <span *ngIf=\"data.showClose\" (click)=\"action()\" class=\"mat-toast-close\"></span>\r\n    </ng-template>\r\n</div>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                animations: [toastAnimation]
            },] }
];
MatToastComponent.ctorParameters = () => [
    { type: MatSnackBarRef },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_SNACK_BAR_DATA,] }] }
];

class MatToastModule {
}
MatToastModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MatButtonsModule,
                    MatCommonModule,
                    MatSnackBarModule
                ],
                exports: [MatToastComponent],
                declarations: [MatToastComponent],
                entryComponents: [MatToastComponent],
            },] }
];

class MatToastConfig {
    constructor() {
        this.duration = 2000;
        this.minDuration = 800;
        this.showClose = false;
        this.pauseOnHover = true;
        this.horizontalPosition = 'center';
        this.verticalPosition = 'top';
    }
}
const MAT_TOAST_DEFAULT_OPTIONS = new InjectionToken('mat-toast-default-options', {
    providedIn: 'root',
    factory: MAT_TOAST_DEFAULT_OPTIONS_FACTORY
});
function MAT_TOAST_DEFAULT_OPTIONS_FACTORY() {
    return new MatToastConfig();
}
class MatToast {
    constructor(snackBar, _defaultConfig) {
        this.snackBar = snackBar;
        this._defaultConfig = _defaultConfig;
    }
    _setConfig(data = {}) {
        const matsnackconfig = {
            horizontalPosition: this._defaultConfig.horizontalPosition || 'center',
            verticalPosition: this._defaultConfig.verticalPosition || 'top',
            duration: 0,
            data,
            panelClass: 'mat-toast'
        };
        return matsnackconfig;
    }
    _getData(content, severity, action) {
        const data = {
            content,
            action,
            severity,
            minDuration: this._defaultConfig.minDuration || 0,
            duration: this._defaultConfig.duration || 0,
            hiddenClose: this._defaultConfig.showClose,
            pauseOnHover: this._defaultConfig.pauseOnHover
        };
        return data;
    }
    _open(data) {
        if (!data.content) {
            return;
        }
        data.isTemplate = data.content instanceof TemplateRef ? true : false;
        return this.snackBar.openFromComponent(MatToastComponent, this._setConfig(data));
    }
    success(content, action) {
        return this._open(this._getData(content, 'success', action));
    }
    error(content, action) {
        return this._open(this._getData(content, 'error', action));
    }
    info(content, action) {
        return this._open(this._getData(content, 'info', action));
    }
    warn(content, action) {
        return this._open(this._getData(content, 'warn', action));
    }
    open(config = {}) {
        return this._open(config);
    }
}
MatToast.ɵprov = ɵɵdefineInjectable({ factory: function MatToast_Factory() { return new MatToast(ɵɵinject(MatSnackBar), ɵɵinject(MAT_TOAST_DEFAULT_OPTIONS)); }, token: MatToast, providedIn: MatToastModule });
MatToast.decorators = [
    { type: Injectable, args: [{ providedIn: MatToastModule },] }
];
MatToast.ctorParameters = () => [
    { type: MatSnackBar },
    { type: MatToastConfig, decorators: [{ type: Inject, args: [MAT_TOAST_DEFAULT_OPTIONS,] }] }
];

class MatFileUploadTrigger {
}
MatFileUploadTrigger.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line: directive-selector
                selector: 'mat-file-upload-trigger',
                host: {
                    '[class.mat-file-upload-trigger]': 'true'
                }
            },] }
];
const MAT_FILE_UPLOAD_DEFAULT_REQUEST = new InjectionToken('mat-file-upload-default-request', {
    providedIn: 'root',
    factory: MAT_FILE_UPLOAD_DEFAULT_REQUEST_FACTORY
});
function MAT_FILE_UPLOAD_DEFAULT_REQUEST_FACTORY() {
    return {
        withCredentials: true,
        headers: new HttpHeaders(),
        url: ''
    };
}
const MAT_FILE_UPLOAD_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MtaFileUpload),
    multi: true
};
const MAT_FILE_UPLOAD_VALIDATORS_ACCESSOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => MtaFileUpload),
    multi: true
};
const MAT_UPLOAD_DEFAULT_SRC_FIELD = 'src';
const MAT_UPLOAD_DEFAULT_NAME_FIELD = 'name';
const HandleResponse = (response) => {
    return { data: response.data, result: response.result, msg: response.msg };
};
class MtaFileUpload {
    constructor(domSanitizer, cd, toast, _defaultRequest, http) {
        this.domSanitizer = domSanitizer;
        this.cd = cd;
        this.toast = toast;
        this._defaultRequest = _defaultRequest;
        this.http = http;
        this.matError = new EventEmitter();
        /** Whether upload can be multiple selected. */
        this._multiple = true;
        this._srcField = MAT_UPLOAD_DEFAULT_SRC_FIELD;
        this._nameField = MAT_UPLOAD_DEFAULT_NAME_FIELD;
        this.triggerText = '上传文件';
        this.name = 'files';
        this.handleResponse = '';
        this._fileList = [];
        this._vaule = [];
        this.requiredValidator = () => {
            return this.required && !this._vaule.length ? { 'required': 'file is required' } : null;
        };
        this.pendingValidator = () => {
            return this.pending ? { 'pending': 'file is uploading' } : null;
        };
        this.onChange = (_) => { };
        this.onTouched = () => { };
        this.validatorOnChange = () => { };
        this.validator = Validators.compose([this.requiredValidator, this.pendingValidator]);
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    set multiple(value) {
        this._multiple = coerceBooleanProperty(value);
    }
    get multiple() {
        return this._multiple;
    }
    set readonly(value) {
        this._readonly = coerceBooleanProperty(value);
    }
    get readonly() {
        return this._readonly;
    }
    set srcField(value) {
        this._srcField = value || MAT_UPLOAD_DEFAULT_SRC_FIELD;
    }
    get srcField() {
        return this._srcField;
    }
    set nameField(value) {
        this._nameField = value || MAT_UPLOAD_DEFAULT_NAME_FIELD;
    }
    get nameField() {
        return this._nameField;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
        this.validatorOnChange();
    }
    get required() {
        return this._required;
    }
    set pending(value) {
        this._pending = value;
        this.validatorOnChange();
    }
    get pending() {
        return this._pending;
    }
    ngAfterViewInit() {
    }
    /** Trigger Element Click Function. */
    triggerClick(event) {
        event.stopPropagation();
        if (!this.disabled && !this.readonly) {
            this.file.nativeElement.click();
        }
    }
    /** File Select Event */
    fileEleChange(event) {
        this.onTouched();
        const files = event.target['files'];
        if (files && files.length) {
            const existSize = this._fileList.length;
            for (let i = 0; i < files.length; i++) {
                if (this.isFileValid(files[i], i, existSize)) {
                    const index = this._fileList.push(this.formatFile(files[i]));
                    this.pending = true;
                    this.postFile(this._fileList[index - 1]);
                }
            }
        }
        event.target.value = '';
    }
    /** Get unique id */
    getUid() {
        return Math.random().toString(36).substring(2);
    }
    /** Format file size. */
    formatSize(size) {
        const unitMap = { 'B': 1, 'K': 1024, 'M': 1024 * 1024, 'G': 1024 * 1024 * 1024 };
        const index = Math.floor((String(size).length - 1) / 3);
        const unit = Object.keys(unitMap)[index];
        if (unit) {
            return Math.floor(size * 100 / unitMap[unit]) / 100 + unit;
        }
        else {
            return size + 'B';
        }
    }
    /** Format url by (window.URL.createObjectURL) or filereader  */
    formatUrl(file) {
        return this.domSanitizer.bypassSecurityTrustUrl(window.URL.createObjectURL(file));
    }
    /** Format file name */
    formatFile(file) {
        return {
            file,
            uid: file['uid'],
            [this.nameField]: file.name,
            size: this.formatSize(file.size),
            type: file.type,
            [this.srcField]: this.formatUrl(file),
            local: true
        };
    }
    // slice file
    isFileValid(file, index, existSize) {
        file['uid'] = file['uid'] || this.getUid();
        if (this.limit && (this.limit - existSize <= index)) {
            this.toast.error(this.limitText || `最多上传${this.limit}个文件！`);
            return false;
        }
        if (this.maxSize && file.size > this.maxSize * 1024 * 1024) {
            this.toast.error(this.maxSizeText || `单个文件最大${this.maxSize}M！`);
            return false;
        }
        if (this.accept) {
            const acceptedFilesArray = Array.isArray(this.accept) ? this.accept : this.accept.split(',');
            const mimeType = '' + file.type;
            const baseMimeType = mimeType.replace(/\/.*$/, '');
            const result = acceptedFilesArray.some(acceptType => {
                const validType = acceptType.trim();
                if (/\/\*$/.test(validType)) {
                    return baseMimeType === validType.replace(/\/.*$/, '');
                }
                return mimeType === validType;
            });
            if (!result) {
                this.toast.error(this.acceptText || `只能上传${this.acceptText}格式文件！`);
            }
            return result;
        }
        return true;
    }
    /** Remove item by index. */
    removeImage(index) {
        const removeFile = this._fileList[index];
        this._fileList.splice(index, 1);
        this._vaule = this._vaule.filter(item => item.uid !== removeFile.uid);
        this.changeValue();
        this.validatorOnChange();
        this.onTouched();
    }
    /** Where show the trigger element. */
    showFileTrigger() {
        if (this.readonly || this.disabled) {
            return false;
        }
        if (this.multiple) {
            return !this.limit || this.limit > this._fileList.length;
        }
        else {
            return !this._fileList || !this._fileList.length;
        }
    }
    getFromData() {
        const formData = new FormData();
        if (this.formData) {
            Object.keys(this.formData).map(key => formData.append(key, this.formData[key]));
        }
        return formData;
    }
    hasFileToUpload() {
        return !!this._fileList.find(item => !!item.file);
    }
    /** File upload fail */
    fileUploadFail(file, reason = '') {
        file.status = 'error';
        if (!this.handleError) {
            this._fileList = this._fileList.filter(item => item.uid !== file.uid);
            this.toast.error(reason);
            this.matError.emit({ file });
        }
        else {
            this.matError.emit({
                file,
                fileList: this._fileList,
            });
        }
    }
    // 上传文件
    postFile(file) {
        return __awaiter(this, void 0, void 0, function* () {
            const formData = this.getFromData();
            const url = this._defaultRequest.url || this.url;
            formData.append(this.name, file.file, file.name);
            file.progress = 0;
            yield this.http.post(url, formData, {
                reportProgress: true,
                observe: 'events',
                withCredentials: this._defaultRequest.withCredentials,
                headers: this._defaultRequest.headers
            }).subscribe(events => {
                if (events.type === HttpEventType.UploadProgress) {
                    file.status = 'uploading';
                    if (events.total > 0) {
                        file.progress = Math.ceil((events.loaded / events.total) * 100);
                    }
                }
                else if (events.type === HttpEventType.Response) {
                    const handleResponseFun = this.handleResponse || HandleResponse;
                    const response = handleResponseFun(events.body);
                    file.file = '';
                    if (response.result) {
                        file.status = 'success';
                        file.progress = 100;
                        this._vaule.push(Object.assign(Object.assign({}, response.data), { uid: file.uid }));
                        this.changeValue();
                    }
                    else {
                        this.fileUploadFail(file, response.msg);
                    }
                }
                return true;
            }, error => {
                this.fileUploadFail(file, `上传失败！文件名：${file.name}`);
            });
            if (!this.hasFileToUpload()) {
                this.pending = false;
            }
        });
    }
    /** @docs-private */
    registerOnValidatorChange(fn) {
        this.validatorOnChange = fn;
    }
    validate(c) {
        return this.validator ? this.validator(c) : null;
    }
    // valuechange
    changeValue() {
        this.onChange(this._vaule.length ? this._vaule : '');
    }
    /** Implemented as part of ControlValueAccessor. */
    writeValue(value) {
        this._fileList = [];
        this._vaule = [];
        if (value && value.length) {
            const fileValue = value.map(item => {
                item.uid = item.uid || this.getUid();
                return item;
            });
            this._vaule = [...fileValue];
            this._fileList = [...fileValue];
        }
        this.cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this.onChange = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /** Implemented as a part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
        this.cd.markForCheck();
    }
}
MtaFileUpload.decorators = [
    { type: Component, args: [{
                selector: 'mat-file-upload',
                template: "<input type=\"file\" #file (change)=\"fileEleChange($event)\" [disabled]=\"disabled\" [attr.accept]=\"accept\" [multiple]=\"multiple\" hidden>\r\n\r\n<div class=\"mat-file-upload-wapper\">\r\n    \r\n    <div class=\"mat-file-upload-trigger-wapper\" (click)=\"triggerClick($event)\" *ngIf=\"showFileTrigger()\">\r\n        <div class=\"mat-file-upload-trigger-default\" *ngIf=\"!customTrigger\">\r\n            <span class=\"mat-file-upload-trigger-default-icon\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path d=\"M544 201.6V672c0 19.2-12.8 32-32 32s-32-12.8-32-32V211.2L358.4 332.8c-12.8 12.8-32 12.8-44.8 0-12.8-12.8-12.8-32 0-44.8l156.8-156.8c25.6-25.6 64-25.6 89.6 0L716.8 288c12.8 12.8 12.8 32 0 44.8-12.8 12.8-32 12.8-44.8 0L544 201.6zM832 608c0-19.2 12.8-32 32-32s32 12.8 32 32v160c0 54.4-41.6 96-96 96H224c-54.4 0-96-41.6-96-96V608c0-19.2 12.8-32 32-32s32 12.8 32 32v160c0 19.2 12.8 32 32 32h576c19.2 0 32-12.8 32-32V608z\" fill=\"currentColor\"></path>\r\n                </svg>\r\n            </span>\r\n            <span class=\"mat-file-upload-trigger-default-label\">{{triggerText}}</span>\r\n        </div>\r\n        <ng-content *ngIf=\"customTrigger\" select=\"mat-file-upload-trigger\"></ng-content>\r\n    </div>\r\n\r\n    <a class=\"mat-file-upload-file-wapper\" target=\"_blank\" [attr.href]=\"!disabled && !readonly ? null : item[srcField]\" *ngFor=\"let item of _fileList; index as imgindex\">\r\n        <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n            <path fill=\"currentColor\" d=\"M358.4 893.155556c-102.4 0-204.8-51.2-261.688889-147.911112-39.822222-68.266667-51.2-147.911111-28.444444-227.555555s68.266667-142.222222 142.222222-182.044445l318.577778-182.044444c11.377778-5.688889 28.444444-5.688889 39.822222 11.377778 5.688889 11.377778 5.688889 28.444444-11.377778 39.822222L238.933333 381.155556c-56.888889 34.133333-96.711111 85.333333-113.777777 147.911111-17.066667 62.577778-5.688889 125.155556 22.755555 182.044444 68.266667 113.777778 216.177778 153.6 329.955556 91.022222l347.022222-199.111111c73.955556-45.511111 102.4-136.533333 56.888889-216.177778-45.511111-73.955556-136.533333-102.4-216.177778-56.888888l-341.333333 199.111111c-34.133333 17.066667-45.511111 62.577778-28.444445 96.711111 17.066667 34.133333 62.577778 45.511111 96.711111 28.444444l318.577778-182.044444c11.377778-5.688889 28.444444-5.688889 39.822222 11.377778 11.377778 11.377778 5.688889 28.444444-11.377777 39.822222l-318.577778 182.044444c-56.888889 34.133333-136.533333 11.377778-170.666667-45.511111-34.133333-62.577778-17.066667-142.222222 45.511111-176.355555L642.844444 284.444444c102.4-56.888889 233.244444-22.755556 290.133334 79.644445 56.888889 102.4 22.755556 233.244444-79.644445 290.133333L506.311111 853.333333c-45.511111 28.444444-96.711111 39.822222-147.911111 39.822223z\"></path>\r\n        </svg>\r\n        <div class=\"mat-file-upload-item\">\r\n            <div class=\"mat-file-upload-name\" [title]=\"item[nameField]\">{{item[nameField]}}</div>\r\n            <div class=\"mat-file-upload-close\" (click)=\"removeImage(imgindex)\" *ngIf=\"!disabled && !readonly\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path fill=\"currentColor\" d=\"M517.08411984 479.11475483L301.90637831 263.93753776a26.85237631 26.85237631 0 1 0-37.98667221 37.95153335l215.17669262 215.19504873L263.91970607 732.27864411a26.85237631 26.85237631 0 1 0 37.96936504 37.96884057l215.19504878-215.17669264 215.19504866 215.17669264a26.85237631 26.85237631 0 1 0 37.9688406-37.95100889l-215.17669262-215.2123559 215.17669262-215.1772171a26.85237631 26.85237631 0 1 0-37.9688406-37.96936505L517.10195147 479.11475483z\"></path>\r\n                </svg>\r\n            </div>\r\n            <div class=\"mat-file-upload-progress-wapper\" *ngIf=\"item.progress >= 0 && item.progress < 100\">\r\n                <div class=\"mat-file-upload-progress\" [style.width.%]=\"item.progress\"></div>\r\n            </div>\r\n        </div>\r\n    </a>\r\n\r\n</div>\r\n",
                providers: [MAT_FILE_UPLOAD_VALUE_ACCESSOR, MAT_FILE_UPLOAD_VALIDATORS_ACCESSOR],
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class.mat-file-upload]': 'true',
                    '[class.mat-file-upload-disabled]': 'disabled',
                }
            },] }
];
MtaFileUpload.ctorParameters = () => [
    { type: DomSanitizer },
    { type: ChangeDetectorRef },
    { type: MatToast },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_FILE_UPLOAD_DEFAULT_REQUEST,] }] },
    { type: HttpClient }
];
MtaFileUpload.propDecorators = {
    customTrigger: [{ type: ContentChild, args: [MatFileUploadTrigger,] }],
    file: [{ type: ViewChild, args: ['file', { static: false },] }],
    matError: [{ type: Output }],
    handleError: [{ type: Input }],
    disabled: [{ type: Input }],
    multiple: [{ type: Input }],
    readonly: [{ type: Input }],
    srcField: [{ type: Input }],
    nameField: [{ type: Input }],
    triggerText: [{ type: Input }],
    limit: [{ type: Input }],
    limitText: [{ type: Input }],
    url: [{ type: Input }],
    name: [{ type: Input }],
    formData: [{ type: Input }],
    maxSize: [{ type: Input }],
    maxSizeText: [{ type: Input }],
    handleResponse: [{ type: Input }],
    accept: [{ type: Input }],
    acceptText: [{ type: Input }],
    required: [{ type: Input }]
};

class MatFileUploadModule {
}
MatFileUploadModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, FormsModule, MatToastModule],
                declarations: [MtaFileUpload, MatFileUploadTrigger],
                exports: [MtaFileUpload, MatFileUploadTrigger]
            },] }
];

class MatImageUploadTrigger {
}
MatImageUploadTrigger.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line: directive-selector
                selector: 'mat-image-upload-trigger',
                host: {
                    '[class.mat-image-upload-trigger]': 'true'
                }
            },] }
];
const MAT_IMAGE_UPLOAD_DEFAULT_REQUEST = new InjectionToken('mat-image-upload-default-request', {
    providedIn: 'root',
    factory: MAT_IMAGE_UPLOAD_DEFAULT_REQUEST_FACTORY
});
function MAT_IMAGE_UPLOAD_DEFAULT_REQUEST_FACTORY() {
    return {
        withCredentials: true,
        headers: new HttpHeaders(),
        url: ''
    };
}
const MAT_IMAGE_UPLOAD_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MtaImageUpload),
    multi: true
};
const MAT_IMAGE_UPLOAD_VALIDATORS_ACCESSOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => MtaImageUpload),
    multi: true
};
const MAT_UPLOAD_DEFAULT_THUMB_FIELD = 'thumb';
class MtaImageUpload {
    constructor(domSanitizer, cd, lightBoxService, toast, _defaultRequest, http) {
        this.domSanitizer = domSanitizer;
        this.cd = cd;
        this.lightBoxService = lightBoxService;
        this.toast = toast;
        this._defaultRequest = _defaultRequest;
        this.http = http;
        this.matError = new EventEmitter();
        /** Whether upload can be multiple selected. */
        this._multiple = true;
        this._srcField = MAT_UPLOAD_DEFAULT_SRC_FIELD;
        this._nameField = MAT_UPLOAD_DEFAULT_NAME_FIELD;
        this._thumbField = MAT_UPLOAD_DEFAULT_THUMB_FIELD;
        this.color = 'primary';
        this.imageModel = 'cover';
        this.name = 'files';
        this.handleResponse = '';
        this._fileList = [];
        this._vaule = [];
        this.requiredValidator = () => {
            return this.required && !this._vaule.length ? { 'required': 'file is required' } : null;
        };
        this.pendingValidator = () => {
            return this.pending ? { 'pending': 'file is uploading' } : null;
        };
        this.onChange = (_) => { };
        this.onTouched = () => { };
        this.validatorOnChange = () => { };
        this.validator = Validators.compose([this.requiredValidator, this.pendingValidator]);
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    set multiple(value) {
        this._multiple = coerceBooleanProperty(value);
    }
    get multiple() {
        return this._multiple;
    }
    set readonly(value) {
        this._readonly = coerceBooleanProperty(value);
    }
    get readonly() {
        return this._readonly;
    }
    set srcField(value) {
        this._srcField = value || MAT_UPLOAD_DEFAULT_SRC_FIELD;
    }
    get srcField() {
        return this._srcField;
    }
    set nameField(value) {
        this._nameField = value || MAT_UPLOAD_DEFAULT_NAME_FIELD;
    }
    get nameField() {
        return this._nameField;
    }
    set thumbField(value) {
        this._thumbField = value || MAT_UPLOAD_DEFAULT_THUMB_FIELD;
    }
    get thumbField() {
        return this._thumbField;
    }
    get triggerText() { return this._triggerText || '上传照片'; }
    set triggerText(value) {
        if (this._triggerText !== value) {
            this._triggerText = value;
            this.cd.markForCheck();
        }
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
        this.validatorOnChange();
    }
    get required() {
        return this._required;
    }
    set pending(value) {
        this._pending = value;
        this.validatorOnChange();
    }
    get pending() {
        return this._pending;
    }
    ngAfterViewInit() {
    }
    /** Trigger Element Click Function. */
    triggerClick(event) {
        event.stopPropagation();
        if (!this.disabled && !this.readonly) {
            this.file.nativeElement.click();
        }
    }
    /** File Select Event */
    fileEleChange(event) {
        this.onTouched();
        const files = event.target['files'];
        if (files && files.length) {
            const existSize = this._fileList.length;
            for (let i = 0; i < files.length; i++) {
                if (this.isFileValid(files[i], i, existSize)) {
                    const index = this._fileList.push(this.formatFile(files[i]));
                    this.pending = true;
                    this.postFile(this._fileList[index - 1]);
                }
            }
        }
        event.target.value = '';
    }
    /** Get unique id */
    getUid() {
        return Math.random().toString(36).substring(2);
    }
    /** Format file size. */
    formatSize(size) {
        const unitMap = { 'B': 1, 'K': 1024, 'M': 1024 * 1024, 'G': 1024 * 1024 * 1024 };
        const index = Math.floor((String(size).length - 1) / 3);
        const unit = Object.keys(unitMap)[index];
        if (unit) {
            return Math.floor(size * 100 / unitMap[unit]) / 100 + unit;
        }
        else {
            return size + 'B';
        }
    }
    /** Format url by (window.URL.createObjectURL) or filereader  */
    formatUrl(file) {
        return this.domSanitizer.bypassSecurityTrustUrl(window.URL.createObjectURL(file));
    }
    /** Format file name */
    formatFile(file) {
        return {
            file,
            uid: file['uid'],
            [this.nameField]: file.name,
            size: this.formatSize(file.size),
            type: file.type,
            [this.thumbField]: this.formatUrl(file),
            [this.srcField]: this.formatUrl(file),
            local: true
        };
    }
    // slice file
    isFileValid(file, index, existSize) {
        file['uid'] = file['uid'] || this.getUid();
        if (this.limit && (this.limit - existSize <= index)) {
            this.toast.error(this.limitText || `最多上传${this.limit}张图片！`);
            return false;
        }
        if (this.maxSize && file.size > this.maxSize * 1024 * 1024) {
            this.toast.error(this.maxSizeText || `单个图片最大${this.maxSize}M！`);
            return false;
        }
        if (this.accept) {
            const acceptedFilesArray = Array.isArray(this.accept) ? this.accept : this.accept.split(',');
            const mimeType = '' + file.type;
            const baseMimeType = mimeType.replace(/\/.*$/, '');
            const result = acceptedFilesArray.some(acceptType => {
                const validType = acceptType.trim();
                if (/\/\*$/.test(validType)) {
                    return baseMimeType === validType.replace(/\/.*$/, '');
                }
                return mimeType === validType;
            });
            if (!result) {
                this.toast.error(this.acceptText || `只能上传${this.acceptText || this.accept}格式图片！`);
            }
            return result;
        }
        return true;
    }
    // 预览图片
    viewImage(activeIndex) {
        this.lightBoxService.open({
            data: this._vaule,
            config: {
                loop: this._vaule.length !== 1,
                srcField: this.srcField,
                thumbField: this.thumbField
            },
            activeIndex,
        });
    }
    /** Remove item by index. */
    removeImage(index) {
        const removeFile = this._fileList[index];
        this._fileList.splice(index, 1);
        this._vaule = this._vaule.filter(item => item.uid !== removeFile.uid);
        this.changeValue();
        this.validatorOnChange();
        this.onTouched();
    }
    /** Where show the trigger element. */
    showFileTrigger() {
        if (this.readonly || this.disabled) {
            return false;
        }
        if (this.multiple) {
            return !this.limit || this.limit > this._fileList.length;
        }
        else {
            return !this._fileList || !this._fileList.length;
        }
    }
    getFromData() {
        const formData = new FormData();
        if (this.formData) {
            Object.keys(this.formData).map(key => formData.append(key, this.formData[key]));
        }
        return formData;
    }
    hasFileToUpload() {
        return !!this._fileList.find(item => !!item.file);
    }
    /** File upload fail */
    fileUploadFail(file, reason = '') {
        file.status = 'error';
        if (!this.handleError) {
            this._fileList = this._fileList.filter(item => item.uid !== file.uid);
            this.toast.error(reason);
            this.matError.emit({ file });
        }
        else {
            this.matError.emit({
                file,
                fileList: this._fileList,
            });
        }
    }
    // 上传文件
    postFile(file) {
        return __awaiter(this, void 0, void 0, function* () {
            const formData = this.getFromData();
            const url = this._defaultRequest.url || this.url;
            formData.append(this.name, file.file, file.name);
            file.progress = 0;
            yield new Promise(resolve => {
                this.http.post(url, formData, {
                    reportProgress: true,
                    observe: 'events',
                    withCredentials: this._defaultRequest.withCredentials,
                    headers: this._defaultRequest.headers
                }).subscribe(events => {
                    if (events.type === HttpEventType.UploadProgress) {
                        file.status = 'uploading';
                        if (events.total > 0) {
                            file.progress = Math.ceil((events.loaded / events.total) * 100);
                        }
                    }
                    else if (events.type === HttpEventType.Response) {
                        const handleResponseFun = this.handleResponse || HandleResponse;
                        const response = handleResponseFun(events.body);
                        file.file = '';
                        if (response.result) {
                            file.status = 'success';
                            file.progress = 100;
                            this._vaule.push(Object.assign(Object.assign({}, response.data), { uid: file.uid }));
                            this.changeValue();
                        }
                        else {
                            this.fileUploadFail(file, response.msg);
                        }
                        resolve();
                    }
                    return true;
                }, error => {
                    file.file = '';
                    this.fileUploadFail(file, `上传失败！文件名：${file.name}`);
                    resolve();
                });
            });
            if (!this.hasFileToUpload()) {
                this.pending = false;
            }
        });
    }
    /** @docs-private */
    registerOnValidatorChange(fn) {
        this.validatorOnChange = fn;
    }
    validate(c) {
        return this.validator ? this.validator(c) : null;
    }
    // valuechange
    changeValue() {
        this.onChange(this._vaule.length ? this._vaule : '');
    }
    /** Implemented as part of ControlValueAccessor. */
    writeValue(value) {
        this._fileList = [];
        this._vaule = [];
        if (value && value.length) {
            const fileValue = value.map(item => {
                item.uid = item.uid || this.getUid();
                return item;
            });
            this._vaule = [...fileValue];
            this._fileList = [...fileValue];
        }
        this.cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this.onChange = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /** Implemented as a part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
        this.cd.markForCheck();
    }
}
MtaImageUpload.decorators = [
    { type: Component, args: [{
                selector: 'mat-image-upload',
                template: "<input type=\"file\" #file (change)=\"fileEleChange($event)\" [disabled]=\"disabled\" [attr.accept]=\"accept\" [multiple]=\"multiple\" hidden>\r\n\r\n<div class=\"mat-image-upload-wapper\">\r\n    \r\n    <div class=\"mat-image-upload-img-wapper\" *ngFor=\"let item of _fileList; index as imgindex\">\r\n        <mat-img [model]=\"imageModel\" [width]=\"80\" [height]=\"80\" outline [src]=\"item[srcField]\" [alt]=\"item[nameField]\"></mat-img>\r\n        <div class=\"mat-image-upload-progress\" *ngIf=\"item.progress >= 0 && item.progress < 100\">\r\n            {{item.progress}}%\r\n        </div>\r\n        <div class=\"mat-image-upload-action\" *ngIf=\"item.status === 'success' || !item.local\">\r\n            <span *ngIf=\"!disabled && !readonly\" (click)=\"removeImage(imgindex)\" title=\"\u5220\u9664\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path fill=\"currentColor\"  d=\"M382.320274 405.357714v384a20.626286 20.626286 0 0 1-21.577143 21.284572H317.44256a20.626286 20.626286 0 0 1-21.577143-21.357715v-384a20.626286 20.626286 0 0 1 21.577143-21.284571h43.154286a20.626286 20.626286 0 0 1 21.577143 21.357714h0.073142z m172.909715 0v384a20.626286 20.626286 0 0 1-21.650286 21.284572h-43.154286a20.626286 20.626286 0 0 1-21.577143-21.357715v-384a20.626286 20.626286 0 0 1 21.577143-21.284571h43.154286a20.626286 20.626286 0 0 1 21.577143 21.357714z m172.909714 0v384a20.626286 20.626286 0 0 1-21.650286 21.284572h-43.154286a20.626286 20.626286 0 0 1-21.577142-21.357715l-0.073143-384a20.626286 20.626286 0 0 1 21.577143-21.284571h43.227428a20.626286 20.626286 0 0 1 21.577143 21.357714z m86.381714 482.669715V256H209.483703v631.954286a74.825143 74.825143 0 0 0 14.482286 45.056c3.364571 3.803429 5.778286 5.632 7.094857 5.632h561.883428c1.316571 0 3.657143-1.828571 7.094857-5.632a74.825143 74.825143 0 0 0 14.555429-44.982857zM360.743131 170.642286h302.518858l-32.402286-77.970286a19.017143 19.017143 0 0 0-11.483429-7.314286H405.287131a19.017143 19.017143 0 0 0-11.483428 7.314286l-33.060572 77.970286zM987.431131 192v42.642286a20.626286 20.626286 0 0 1-21.577142 21.357714h-64.877715v631.954286c0 36.937143-10.532571 68.754286-31.744 95.744-21.211429 26.843429-46.592 40.301714-76.288 40.301714H231.060846c-29.696 0-55.149714-13.019429-76.288-38.985143-21.211429-26.038857-31.744-57.490286-31.744-94.354286V256H58.151131A20.626286 20.626286 0 0 1 36.573989 234.642286v-42.642286a20.626286 20.626286 0 0 1 21.577142-21.357714h208.676572L314.151131 59.318857c6.729143-16.457143 18.870857-30.427429 36.425143-41.984 17.554286-11.556571 35.401143-17.334857 53.394286-17.334857h216.064c17.993143 0 35.84 5.778286 53.394286 17.334857 17.554286 11.556571 29.696 25.6 36.425143 41.984l47.323428 111.323429h208.676572a20.626286 20.626286 0 0 1 21.577142 21.357714z\"></path>\r\n                </svg>\r\n            </span>\r\n            <span (click)=\"viewImage(imgindex)\" title=\"\u67E5\u770B\">\r\n                <svg viewBox=\"0 0 1592 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path fill=\"currentColor\" d=\"M1571.271111 438.613333C1400.604444 174.08 1117.297778 1.137778 796.444444 1.137778S192.284444 174.08 21.617778 438.613333c-28.444444 43.804444-28.444444 102.4 0 146.204445 170.666667 264.533333 453.973333 437.475556 774.826666 437.475555s604.16-172.942222 774.826667-437.475555c28.444444-43.235556 28.444444-102.4 0-146.204445zM796.444444 739.555556c-125.724444 0-227.555556-101.831111-227.555555-227.555556s101.831111-227.555556 227.555555-227.555556 227.555556 101.831111 227.555556 227.555556-101.831111 227.555556-227.555556 227.555556z\"></path>\r\n                </svg>\r\n            </span>\r\n        </div>\r\n    </div>\r\n\r\n    <div class=\"mat-image-upload-trigger-wapper\" (click)=\"triggerClick($event)\" *ngIf=\"showFileTrigger()\">\r\n        <div class=\"mat-image-upload-trigger-default\" *ngIf=\"!customTrigger\">\r\n            <span class=\"mat-image-upload-trigger-default-icon\"></span>\r\n            <span class=\"mat-image-upload-trigger-default-label\">{{triggerText}}</span>\r\n        </div>\r\n        <ng-content *ngIf=\"customTrigger\" select=\"mat-image-upload-trigger\"></ng-content>\r\n    </div>\r\n\r\n</div>\r\n",
                providers: [MAT_IMAGE_UPLOAD_VALUE_ACCESSOR, MAT_IMAGE_UPLOAD_VALIDATORS_ACCESSOR, MatLightBoxService],
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class.mat-image-upload]': 'true',
                    '[class.mat-image-upload-disabled]': 'disabled',
                }
            },] }
];
MtaImageUpload.ctorParameters = () => [
    { type: DomSanitizer },
    { type: ChangeDetectorRef },
    { type: MatLightBoxService },
    { type: MatToast },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_IMAGE_UPLOAD_DEFAULT_REQUEST,] }] },
    { type: HttpClient }
];
MtaImageUpload.propDecorators = {
    customTrigger: [{ type: ContentChild, args: [MatImageUploadTrigger,] }],
    file: [{ type: ViewChild, args: ['file', { static: false },] }],
    matError: [{ type: Output }],
    handleError: [{ type: Input }],
    disabled: [{ type: Input }],
    multiple: [{ type: Input }],
    readonly: [{ type: Input }],
    srcField: [{ type: Input }],
    nameField: [{ type: Input }],
    thumbField: [{ type: Input }],
    triggerText: [{ type: Input }],
    color: [{ type: Input }],
    limit: [{ type: Input }],
    limitText: [{ type: Input }],
    imageModel: [{ type: Input }],
    url: [{ type: Input }],
    name: [{ type: Input }],
    formData: [{ type: Input }],
    maxSize: [{ type: Input }],
    maxSizeText: [{ type: Input }],
    handleResponse: [{ type: Input }],
    accept: [{ type: Input }],
    acceptText: [{ type: Input }],
    required: [{ type: Input }]
};

class MatImageConfig {
    constructor() {
        this.model = 'cover';
        this.position = 'C';
        this.width = 80;
        this.height = 80;
        this.radius = 2;
        this.color = '#efefef';
        this.alt = '加载失败';
    }
}
function MAT_NOTIFICATION_DEFAULT_OPTIONS_FACTORY() {
    return new MatImageConfig();
}
const MAT_IMAGE_DEFAULT_CONFIG = new InjectionToken('mat-image-default-config', {
    providedIn: 'root',
    factory: MAT_NOTIFICATION_DEFAULT_OPTIONS_FACTORY
});
class MatImageBase {
    constructor(_ele, _cd, _defaultConfig) {
        this._ele = _ele;
        this._cd = _cd;
        this._defaultConfig = _defaultConfig;
    }
    set width(value) {
        if (this._width !== value) {
            this._width = value;
            this._cd.markForCheck();
        }
    }
    get width() {
        return this._width || this._defaultConfig.width;
    }
    set height(value) {
        if (this._height !== value) {
            this._height = value;
            this._cd.markForCheck();
        }
    }
    get height() {
        return this._height || this._defaultConfig.height;
    }
    set radius(value) {
        if (this._radius !== value) {
            this._radius = value;
            this._cd.markForCheck();
        }
    }
    get radius() {
        return this._radius || this._defaultConfig.radius;
    }
    set color(value) {
        if (value !== this._color) {
            this._color = value;
            this._setStyle();
            this._cd.markForCheck();
        }
    }
    get color() {
        return this._color || this._defaultConfig.color;
    }
    set model(mode) {
        if (mode !== this._model) {
            this._model = mode;
            this._setStyle();
            this._cd.markForCheck();
        }
    }
    set position(position) {
        if (position !== this._position) {
            this._position = position;
            this._setStyle();
            this._cd.markForCheck();
        }
    }
    set shadow(value) {
        if (value !== this._shadow) {
            this._shadow = coerceBooleanProperty(value);
            this._cd.markForCheck();
        }
    }
    get shadow() {
        return this._shadow === false ? false : (this._shadow || this._defaultConfig.shadow);
    }
    set outline(value) {
        if (value !== this._outline) {
            this._outline = coerceBooleanProperty(value);
            this._cd.markForCheck();
        }
    }
    get outline() {
        return this._outline === false ? false : (this._outline || this._defaultConfig.outline);
    }
    /** Set style when prams change */
    _setStyle() {
        this._imgStyle = {
            background: this.color || this._defaultConfig.color,
            objectFit: this._model || this._defaultConfig.model,
            objectPosition: this._getPosition()
        };
    }
    _getPosition() {
        const positionMap = {
            lt: 'left top',
            lc: 'left center',
            lb: 'left bottom',
            rt: 'right top',
            rc: 'right center',
            rb: 'right bottom',
            tc: 'center top',
            c: 'center center',
            cc: 'center center',
            bc: 'center bottom',
        };
        const position = this._position || this._defaultConfig.position;
        return positionMap[position.toLowerCase()] || position;
    }
}
MatImageBase.ctorParameters = () => [
    { type: ElementRef },
    { type: ChangeDetectorRef },
    { type: MatImageConfig, decorators: [{ type: Inject, args: [MAT_IMAGE_DEFAULT_CONFIG,] }] }
];
MatImageBase.propDecorators = {
    width: [{ type: Input }],
    height: [{ type: Input }],
    radius: [{ type: Input }],
    color: [{ type: Input }],
    model: [{ type: Input }],
    position: [{ type: Input }],
    shadow: [{ type: Input }],
    outline: [{ type: Input }]
};

class MatImage extends MatImageBase {
    constructor(_ele, _cd, _defaultConfig) {
        super(_ele, _cd, _defaultConfig);
        this._ele = _ele;
        this._cd = _cd;
        this._defaultConfig = _defaultConfig;
        /** Event emitted when the image has been loaded. */
        this.matLoad = new EventEmitter();
        /** Event emitted when the image has been load error. */
        this.matError = new EventEmitter();
        /** Title of img element */
        this.title = '';
        /** Alt of img element */
        this.alt = '';
        /** src of img element */
        this.src = '';
    }
    /** Mat image params with obje  */
    set config(value) {
        if (value && typeof value === 'object') {
            const configKeys = ['model', 'position', 'width', 'height', 'radius', 'color', 'outline', 'shadow', 'title', 'alt', 'src'];
            configKeys.forEach(key => this[key] = value[key]);
        }
    }
    /** Event on img load error */
    _imageError(event) {
        this.matLoad.emit(event);
    }
    /** Event on img load */
    _imageLoad(event) {
        this.matError.emit(event);
    }
    ngOnInit() {
        this._setStyle();
    }
}
MatImage.decorators = [
    { type: Component, args: [{
                selector: 'mat-img',
                exportAs: 'MatImage',
                template: "<img \r\n  [alt]=\"alt || ''\" \r\n  [title]=\"title || ''\"\r\n  (load)=\"_imageLoad($event)\"\r\n  (error)=\"_imageError($event)\"\r\n  [src]=\"src\"\r\n  [ngStyle]=\"_imgStyle\">",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-img]': 'true',
                    '[class.mat-img-shadow]': 'shadow',
                    '[class.mat-img-outline]': 'outline',
                    '[style.width.px]': 'width',
                    '[style.height.px]': 'height',
                    '[style.border-radius.px]': 'radius',
                }
            },] }
];
MatImage.ctorParameters = () => [
    { type: ElementRef },
    { type: ChangeDetectorRef },
    { type: MatImageConfig, decorators: [{ type: Inject, args: [MAT_IMAGE_DEFAULT_CONFIG,] }] }
];
MatImage.propDecorators = {
    matLoad: [{ type: Output }],
    matError: [{ type: Output }],
    title: [{ type: Input }],
    alt: [{ type: Input }],
    src: [{ type: Input }],
    config: [{ type: Input }]
};

const MAT_IMAGE_LIST_DEFAULT_GUTTER = 12;
class MatImageList extends MatImageBase {
    constructor(_ele, _cd, _defaultConfig) {
        super(_ele, _cd, _defaultConfig);
        this._ele = _ele;
        this._cd = _cd;
        this._defaultConfig = _defaultConfig;
        /** Spacing between pictures */
        this._gutter = MAT_IMAGE_LIST_DEFAULT_GUTTER;
        /** Data source of the images. */
        this._dataSource = [];
    }
    set gutter(value) {
        if (value !== this._gutter) {
            this._gutter = value;
            this.ngAfterViewInit();
        }
    }
    get gutter() {
        return this._gutter || MAT_IMAGE_LIST_DEFAULT_GUTTER;
    }
    set dataSource(dataValue) {
        const data = Array.isArray(dataValue) ? dataValue : [];
        this._dataSource = data;
    }
    get dataSource() {
        return this._dataSource;
    }
    ngAfterViewInit() {
        const imgEles = this._ele.nativeElement.getElementsByTagName('mat-img');
        if (imgEles && imgEles.length) {
            for (const item of imgEles) {
                item.style.margin = `0 ${this.gutter} ${this.gutter} 0`;
            }
        }
    }
}
MatImageList.decorators = [
    { type: Component, args: [{
                selector: 'mat-img-list',
                exportAs: 'MatImageList',
                template: "<mat-img \r\n    *ngFor=\"let item of dataSource\" \r\n    [alt]=\"item.alt\"\r\n    [title]=\"item.title\"\r\n    [src]=\"item.src\"\r\n    [outline]=\"outline\"\r\n    [model]=\"model\"\r\n    [position]=\"position\"\r\n    [width]=\"width\"\r\n    [height]=\"height\"\r\n    [radius]=\"radius\"\r\n    [color]=\"color\"\r\n    [outline]=\"outline\"\r\n    [shadow]=\"shadow\"\r\n    [style.margin-bottom.px]=\"gutter\"\r\n    [style.margin-right.px]=\"gutter\"\r\n></mat-img>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-img-list]': 'true',
                    '[class.mat-img-list-stack]': 'stack',
                    '[style.margin-right.px]': '"-" + gutter',
                    '[style.margin-bottom.px]': '"-" + gutter'
                }
            },] }
];
MatImageList.ctorParameters = () => [
    { type: ElementRef },
    { type: ChangeDetectorRef },
    { type: MatImageConfig, decorators: [{ type: Inject, args: [MAT_IMAGE_DEFAULT_CONFIG,] }] }
];
MatImageList.propDecorators = {
    gutter: [{ type: Input }],
    dataSource: [{ type: Input }]
};

class MatImageVirtualList extends MatImageList {
    ngAfterViewInit() {
        const containerWidth = this._ele.nativeElement.getBoundingClientRect().width;
        const rowNumber = Math.ceil(containerWidth / (this.width + this.gutter));
        this._itemSize = this.height / rowNumber;
    }
}
MatImageVirtualList.decorators = [
    { type: Component, args: [{
                selector: 'mat-img-scroll',
                exportAs: 'MatImageScroll',
                template: "<cdk-virtual-scroll-viewport #scrollViewport [itemSize]=\"_itemSize\" class=\"mat-virtual-scroll-image-list-viewpor\">\r\n  <mat-img \r\n    *cdkVirtualFor=\"let item of dataSource\" \r\n    [alt]=\"item.alt\"\r\n    [title]=\"item.title\"\r\n    [src]=\"item.src\"\r\n    [outline]=\"outline\"\r\n    [model]=\"model\"\r\n    [position]=\"position\"\r\n    [width]=\"width\"\r\n    [height]=\"height\"\r\n    [radius]=\"radius\"\r\n    [color]=\"color\"\r\n    [outline]=\"outline\"\r\n    [shadow]=\"shadow\"\r\n    [style.margin-bottom.px]=\"gutter\"\r\n    [style.margin-right.px]=\"gutter\"\r\n    ></mat-img>\r\n</cdk-virtual-scroll-viewport>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-img-list]': 'true',
                    '[style.margin-right.px]': '"-" + gutter',
                    '[style.margin-bottom.px]': '"-" + gutter'
                }
            },] }
];

class MatImageModule {
}
MatImageModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, ScrollingModule],
                declarations: [MatImage, MatImageList, MatImageVirtualList],
                exports: [MatImage, MatImageList, MatImageVirtualList]
            },] }
];

class MatImageUploadModule {
}
MatImageUploadModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, FormsModule, MatImageModule, MatToastModule, MatLightboxModule],
                declarations: [MtaImageUpload, MatImageUploadTrigger],
                exports: [MtaImageUpload, MatImageUploadTrigger]
            },] }
];

const MAT_TEXTAREA_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatTextarea),
    multi: true
};
class MatTextareaTip {
}
MatTextareaTip.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line: directive-selector
                selector: 'mat-textarea-tip'
            },] }
];
// Increasing integer for generating unique ids.
let nextUniqueId$1 = 0;
class MatTextarea {
    constructor(_cd, _platform, _elementRef, ngZone, _focusMonitor) {
        this._cd = _cd;
        this._platform = _platform;
        this._elementRef = _elementRef;
        this._focusMonitor = _focusMonitor;
        /** Emit event subject */
        this._valueChange$ = new Subject();
        this.matChange = new EventEmitter();
        this.matFocus = new EventEmitter();
        this.matBlur = new EventEmitter();
        this.valueChange = new EventEmitter();
        /** Name value will be applied to the input element if present */
        this.name = null;
        this.maxlength = null;
        /** The input's input change debounceTime. */
        this.debounceTime = 200;
        /** Unique id for the input. */
        this.id = `mat-textarea-${nextUniqueId$1++}`;
        this._resize = 'none';
        /** Whether the element is readonly. */
        this._readonly = false;
        /** Value of the input. */
        this._value = '';
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
        if (_platform.IOS) {
            ngZone.runOutsideAngular(() => {
                _elementRef.nativeElement.addEventListener('keyup', (event) => {
                    const el = event.target;
                    if (!el.value && !el.selectionStart && !el.selectionEnd) {
                        el.setSelectionRange(1, 1);
                        el.setSelectionRange(0, 0);
                    }
                });
            });
        }
        this._focusMonitor.monitor(this._elementRef, true).subscribe(focusOrigin => {
            if (!focusOrigin) {
                this.onBlur();
            }
            else {
                this.onFocus();
            }
        });
    }
    set resize(value) {
        this._resize = value;
    }
    get resize() {
        return this._resize;
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    set style(value) {
        this._style = value;
        if (this._elementRef && this._elementRef.nativeElement) {
            this._elementRef.nativeElement.style = value;
        }
    }
    get style() {
        return this._style;
    }
    get showTextTip() {
        return this._showTextTip;
    }
    set showTextTip(value) {
        this._showTextTip = coerceBooleanProperty(value);
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get trim() {
        return this._trim;
    }
    set trim(value) {
        this._trim = coerceBooleanProperty(value);
    }
    get readonly() {
        return this._readonly;
    }
    set readonly(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this.readonly) {
            this._readonly = newValue;
            this._cd.markForCheck();
        }
    }
    get value() {
        return this._value;
    }
    set value(value) {
        if (value !== this.value) {
            this._value = (value === null || value === undefined) ? '' : value;
            this._cd.markForCheck();
        }
    }
    onFocus() {
        if (!this.readonly) {
            this.matBlur.emit();
        }
    }
    onBlur() {
        this._onTouched();
        if (!this.readonly) {
            this.matBlur.emit();
        }
    }
    /** Focus the input element by function */
    focus() {
        this._focusMonitor.focusVia(this._textareaElement, 'keyboard');
    }
    /** Blur the input element by function */
    blur() {
        this._textareaElement.nativeElement.blur();
    }
    getInputValue() {
        return this._textareaElement.nativeElement.value;
    }
    onInput() {
        const value = this.getInputValue();
        const newValue = this.trim ? value.trim() : value;
        this._controlValueAccessorChangeFn(newValue);
        this.valueChange.emit(newValue);
        this._valueChange$.next(newValue);
    }
    ngOnInit() {
        this.registerChangeEvent();
    }
    ngOnDestroy() {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
    }
    registerChangeEvent() {
        this._subscription = this._valueChange$.pipe(debounceTime(this.debounceTime), distinctUntilChanged()).subscribe(event => this.matChange.emit(event));
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.value = value;
        this._cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatTextarea.decorators = [
    { type: Component, args: [{
                selector: 'mat-textarea',
                template: "<textarea \r\n  #textarea\r\n  [style.resize]=\"resize\"\r\n  [style]=\"style\"\r\n  [attr.name]=\"name\"\r\n  [id]=\"id\"\r\n  [attr.placeholder]=\"placeholder\"\r\n  [required]=\"required\"\r\n  [value]=\"value\"\r\n  [disabled]=\"disabled\"\r\n  [readonly]=\"readonly\"\r\n  [attr.maxLength]=\"maxlength\"\r\n  (input)=\"onInput()\"\r\n></textarea>\r\n\r\n<div class=\"mat-textarea-tip-wapper\" *ngIf=\"showTextTip && maxlength\">\r\n  <span *ngIf=\"!customTip\">{{textarea.value?.length || 0}}/{{maxlength}}</span>\r\n  <ng-content *ngIf=\"customTip\" select=\"mat-textarea-tip\"></ng-content>\r\n</div>",
                providers: [MAT_TEXTAREA_VALUE_ACCESSOR],
                host: {
                    '[class.mat-form-textarea]': 'true',
                    '[class.mat-form-textarea-disabled]': 'disabled',
                    '[class.mat-form-textarea-show-tip]': 'showTextTip && maxlength',
                    '[class.mat-form-textarea-readonly]': 'readonly',
                },
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            },] }
];
MatTextarea.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: Platform },
    { type: ElementRef },
    { type: NgZone },
    { type: FocusMonitor }
];
MatTextarea.propDecorators = {
    matChange: [{ type: Output }],
    matFocus: [{ type: Output }],
    matBlur: [{ type: Output }],
    valueChange: [{ type: Output }],
    customTip: [{ type: ContentChild, args: [MatTextareaTip,] }],
    _textareaElement: [{ type: ViewChild, args: ['textarea',] }],
    name: [{ type: Input }],
    placeholder: [{ type: Input }],
    maxlength: [{ type: Input }],
    debounceTime: [{ type: Input }],
    id: [{ type: Input }],
    resize: [{ type: Input }],
    disabled: [{ type: Input }],
    style: [{ type: Input }],
    showTextTip: [{ type: Input }],
    required: [{ type: Input }],
    trim: [{ type: Input }],
    readonly: [{ type: Input }],
    value: [{ type: Input }]
};

class MatTextareaModule {
}
MatTextareaModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [MatTextarea, MatTextareaTip],
                declarations: [MatTextarea, MatTextareaTip],
                providers: [],
            },] }
];

const MAT_INPUT_NUMBER_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatInputNumber),
    multi: true
};
// Increasing integer for generating unique ids.
let nextUniqueId$2 = 0;
class MatInputNumber {
    constructor(_cd, _platform, _elementRef, ngZone, _focusMonitor) {
        this._cd = _cd;
        this._platform = _platform;
        this._elementRef = _elementRef;
        this._focusMonitor = _focusMonitor;
        /** Emit event subject */
        this._valueChange$ = new Subject();
        this.matChange = new EventEmitter();
        this.matFocus = new EventEmitter();
        this.matBlur = new EventEmitter();
        this.valueChange = new EventEmitter();
        /** Name value will be applied to the input element if present */
        this.name = null;
        /** The input's input change debounceTime. */
        this.debounceTime = 200;
        /** Unique id for the input. */
        this.id = `mat-input-number-${nextUniqueId$2++}`;
        /** Whether the input is disabled. */
        this._handle = true;
        /** Whether the element is readonly. */
        this._readonly = false;
        /** Input type of the element. */
        this._type = 'integer';
        this._precision = 0;
        this._max = Infinity;
        this._min = -Infinity;
        this._step = 1;
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
        if (_platform.IOS) {
            ngZone.runOutsideAngular(() => {
                _elementRef.nativeElement.addEventListener('keyup', (event) => {
                    const el = event.target;
                    if (!el.value && !el.selectionStart && !el.selectionEnd) {
                        el.setSelectionRange(1, 1);
                        el.setSelectionRange(0, 0);
                    }
                });
            });
        }
        this._focusMonitor.monitor(this._elementRef, true).subscribe(focusOrigin => {
            if (!focusOrigin) {
                this.onBlur();
            }
            else {
                this.onFocus();
            }
        });
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get handle() { return this._handle; }
    set handle(value) {
        this._handle = coerceBooleanProperty(value);
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get readonly() {
        return this._readonly;
    }
    set readonly(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this.readonly) {
            this._readonly = newValue;
            this._cd.markForCheck();
        }
    }
    get type() {
        return this._type;
    }
    set type(value) {
        this._type = value || 'integer';
    }
    get value() {
        return (this._value || this._value === 0 || this._value === '0') ? this._value : '';
    }
    set value(value) {
        if (value !== this.value) {
            this._value = value;
            this._cd.markForCheck();
        }
    }
    get precision() {
        return Number(this._precision) || 0;
    }
    set precision(value) {
        this._precision = value;
    }
    get max() { return (this._max || this._max == 0) ? this._max : Infinity; }
    set max(value) {
        if (value !== this._max) {
            this._max = value;
        }
    }
    get min() { return (this._min || this._min == 0) ? this._min : -Infinity; }
    set min(value) {
        if (value !== this._min) {
            this._min = value;
        }
    }
    get step() { return this._step || 1; }
    set step(value) {
        if (value !== this._step) {
            this._step = value;
        }
    }
    onFocus() {
        if (!this.readonly) {
            this.matBlur.emit();
            this._isFocused = true;
        }
    }
    canMinus() {
        return Number(this.min) < 0;
    }
    onBlur() {
        this._onTouched();
        if (!this.readonly) {
            this.matBlur.emit();
            this._isFocused = false;
            if (this._inputElement.nativeElement.value === '-') {
                this._inputElement.nativeElement.value = '';
            }
            if (this._inputElement.nativeElement.value) {
                this._inputElement.nativeElement.value = parseFloat(this._inputElement.nativeElement.value) + '';
            }
        }
        this._cd.markForCheck();
    }
    /** Focus the input element by function */
    focus() {
        this._focusMonitor.focusVia(this._inputElement, 'keyboard');
    }
    /** Blur the input element by function */
    blur() {
        this._inputElement.nativeElement.blur();
    }
    getValuePowerNumber() {
        const value = this._inputElement.nativeElement.value || '';
        const valueArray = value.split('.');
        const valueLen = valueArray.length === 1 ? 0 : valueArray[1].length;
        const stepArray = this.step.toString().split('.');
        const stepLen = stepArray.length === 1 ? 0 : stepArray[1].length;
        return Math.max(valueLen, stepLen, this.precision);
    }
    calculateValue(event, isUp, fromHandle) {
        if (this.disabled) {
            return;
        }
        if (fromHandle && !this._isFocused) {
            this.focus();
        }
        event.stopPropagation();
        event.preventDefault();
        let value = Number(this._inputElement.nativeElement.value) || 0;
        const powerNumber = this.getValuePowerNumber();
        const power = Math.pow(10, powerNumber) * 10;
        if (isUp) {
            value = ((value * power + this.step * power) / power).toFixed(powerNumber);
            if (value > Number(this.max)) {
                return;
            }
        }
        else {
            value = ((value * power - this.step * power) / power).toFixed(powerNumber);
            if (value < Number(this.min)) {
                return;
            }
        }
        value = Number(value);
        this._inputElement.nativeElement.value = value + '';
        this.updataValue();
    }
    getFloatRegExp(num) {
        const reg = `^(\\-)*(\\d+)\\.(${'\\d'.repeat(num)}).*$`;
        return new RegExp(reg);
    }
    getNumberRegExp(params = '') {
        const reg = `[^\\d${params}${this.canMinus() ? '-' : ''}]`;
        return new RegExp(reg, 'g');
    }
    onInput() {
        switch (this.type) {
            case 'decimal':
                this.decimalInput(this.precision);
                break;
            case 'integer':
                this.integerInput();
                break;
        }
        this.updataValue();
    }
    updataValue() {
        let value = this._inputElement.nativeElement.value.trim();
        if (value) {
            value = value > Number(this.max) ? Number(this.max) : value;
            value = value < Number(this.min) ? Number(this.min) : value;
            this._inputElement.nativeElement.value = String(value);
        }
        const newValue = value && value !== '-' ? Number(value) : '';
        this._controlValueAccessorChangeFn(newValue);
        this._valueChange$.next(newValue);
        this.valueChange.emit(newValue);
    }
    integerInput() {
        let value = this._inputElement.nativeElement.value;
        value = value.replace(this.getNumberRegExp(), '');
        if (this.canMinus()) {
            if (value.indexOf('-') > 0) {
                value = value.replace(/\-/g, '');
            }
            value = value.replace('-', '$#$').replace(/\-/g, '').replace('$#$', '-');
            if (value && value !== '-') {
                value = parseFloat(value);
            }
        }
        else {
            if (value) {
                value = parseFloat(value);
            }
        }
        this._inputElement.nativeElement.value = value;
    }
    decimalInput(floatNum) {
        // clear whitout number and point、minus
        let value = this._inputElement.nativeElement.value
            .replace(this.getNumberRegExp('.'), '')
            .replace(/\.{2,}/g, '.');
        // the point can't be first
        if (value.indexOf('.') === 0) {
            value = '0' + value;
        }
        if (value.indexOf('-.') === 0) {
            value = value.replace(/\./g, '');
        }
        if (this.canMinus() && value.indexOf('-') > 0) {
            value = value.replace(/\-/g, '');
        }
        value = value.replace('-', '$#$').replace(/\-/g, '').replace('$#$', '-');
        value = value.replace('.', '$#$').replace(/\./g, '').replace('$#$', '.');
        // 只能输入floatNum个小数
        if (floatNum) {
            value = value.replace(this.getFloatRegExp(floatNum), '$1$2.$3');
        }
        // 以上已经过滤，此处控制的是如果没有小数点，首位不能为类似于 01、02的金额
        if (value.indexOf('.') < 0 && value !== '' && value !== '-' && value !== '-0') {
            value = parseFloat(value);
        }
        this._inputElement.nativeElement.value = value;
    }
    ngOnInit() {
        this.registerChangeEvent();
    }
    ngOnDestroy() {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
        this._focusMonitor.stopMonitoring(this._elementRef);
    }
    registerChangeEvent() {
        this._subscription = this._valueChange$.pipe(debounceTime(this.debounceTime), distinctUntilChanged()).subscribe(event => this.matChange.emit(event));
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.value = value;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatInputNumber.decorators = [
    { type: Component, args: [{
                selector: 'mat-number',
                template: "<input\r\n  #input\r\n  [id]=\"id\"\r\n  [attr.name]=\"name\"\r\n  [attr.placeholder]=\"placeholder\"\r\n  autocomplete=\"off\"\r\n  [value]=\"value\"\r\n  [required]=\"required\"\r\n  [disabled]=\"disabled\"\r\n  [readonly]=\"readonly\"\r\n  type=\"text\"\r\n  maxlength=\"16\"\r\n  (input)=\"onInput()\"\r\n  (keydown.ArrowUp)=\"calculateValue($event, true, false)\"\r\n  (keydown.ArrowDown)=\"calculateValue($event, false, true)\" \r\n>\r\n<div class=\"mat-input-number-handler\" *ngIf=\"handle\">\r\n  <span class=\"mat-input-number-handler-up\" (mousedown)=\"calculateValue($event, true, true)\" >\r\n    <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M853.333333 480H544V170.666667c0-17.066667-14.933333-32-32-32s-32 14.933333-32 32v309.333333H170.666667c-17.066667 0-32 14.933333-32 32s14.933333 32 32 32h309.333333V853.333333c0 17.066667 14.933333 32 32 32s32-14.933333 32-32V544H853.333333c17.066667 0 32-14.933333 32-32s-14.933333-32-32-32z\" fill=\"currentColor\"></path></svg>\r\n    <!-- <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" fill=\"currentColor\"><path d=\"M809.984 536.917333h-256v256h-83.968v-256h-256v-83.968h256v-256h83.968v256h256z\" fill=\"currentColor\"></path></svg> -->\r\n  </span>\r\n  <span class=\"mat-input-number-handler-down\" (mousedown)=\"calculateValue($event, false, true)\">\r\n    <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path d=\"M853.333333 544H170.666667c-17.066667 0-32-14.933333-32-32s14.933333-32 32-32h682.666666c17.066667 0 32 14.933333 32 32s-14.933333 32-32 32z\" fill=\"currentColor\"></path></svg>\r\n    <!-- <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path d=\"M186.368 456.704h626.688V573.44H186.368z\" fill=\"currentColor\"></path></svg> -->\r\n  </span>\r\n</div>\r\n<div class=\"mat-input-number-unit\" *ngIf=\"unit\">\r\n  {{unit}}\r\n</div>",
                providers: [MAT_INPUT_NUMBER_VALUE_ACCESSOR],
                host: {
                    '[class.mat-form-input-number]': 'true',
                    '[class.mat-form-input-number-disabled]': 'disabled',
                    '[class.mat-form-input-number-readonly]': 'readonly',
                },
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            },] }
];
MatInputNumber.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: Platform },
    { type: ElementRef },
    { type: NgZone },
    { type: FocusMonitor }
];
MatInputNumber.propDecorators = {
    matChange: [{ type: Output }],
    matFocus: [{ type: Output }],
    matBlur: [{ type: Output }],
    valueChange: [{ type: Output }],
    _inputElement: [{ type: ViewChild, args: ['input',] }],
    name: [{ type: Input }],
    placeholder: [{ type: Input }],
    unit: [{ type: Input }],
    debounceTime: [{ type: Input }],
    id: [{ type: Input }],
    disabled: [{ type: Input }],
    handle: [{ type: Input }],
    required: [{ type: Input }],
    readonly: [{ type: Input }],
    type: [{ type: Input }],
    value: [{ type: Input }],
    precision: [{ type: Input }],
    max: [{ type: Input }],
    min: [{ type: Input }],
    step: [{ type: Input }]
};

class MatInputNumberModule {
}
MatInputNumberModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [MatInputNumber],
                declarations: [MatInputNumber],
                providers: [],
            },] }
];

function getMatRadioListNonFunctionValueError() {
    return Error('`compareWith` must be a function.');
}
const MAT_RADIO_LIST_DEFAULT_VIEW_FIELD = 'label';
const MAT_RADIO_LIST_DEFAULT_DISABLED_FIELD = 'disabled';
const MAT_RADIO_LIST_DEFAULT_COLOR = 'primary';
const MAT_RADIO_LIST_DEFAULT_DIRECTION = 'horizontal';
const MAT_RADIO_LIST_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatRadioList),
    multi: true
};
class MatRadioList {
    constructor(_cd) {
        this._cd = _cd;
        this.matChange = new EventEmitter();
        /** Whether the label should appear before or after the radiobutton. Defaults to 'after' */
        this.labelPosition = 'after';
        /** Tabindex of the selection list. */
        this.tabIndex = 0;
        /** Field name of disabled when datasource as objecet array. */
        this.disabledField = MAT_RADIO_LIST_DEFAULT_DISABLED_FIELD;
        /** Field name of view when datasource as objecet array. */
        this.viewField = MAT_RADIO_LIST_DEFAULT_VIEW_FIELD;
        /** Whether the option is disabled. */
        this._disabled = false;
        /** Comparison function to specify which option is checked. Defaults to object equality. */
        this._compareWith = (o1, o2) => o1 === o2;
        /** Option of the radiobutton. */
        this._dataSource = null;
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
    }
    get color() {
        return this._color || MAT_RADIO_LIST_DEFAULT_COLOR;
    }
    set color(newValue) {
        this._color = newValue;
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get direction() {
        return this._direction || MAT_RADIO_LIST_DEFAULT_DIRECTION;
    }
    set direction(newValue) {
        this._direction = newValue;
    }
    get disabled() { return this._disabled; }
    set disabled(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this._disabled) {
            this._disabled = newValue;
            this._cd.markForCheck();
        }
    }
    get compareWith() { return this._compareWith; }
    set compareWith(fn) {
        if (typeof fn !== 'function') {
            throw getMatRadioListNonFunctionValueError();
        }
        this._compareWith = fn;
        if (this._selectionModel) {
            // A different comparator means the selection could change.
            this._initializeSelection(this.value);
        }
    }
    /** Value of the checkbox list. */
    get value() {
        const selected = this._selectionModel ? this._selectionModel.selected : [];
        return selected[0];
    }
    set value(newValue) {
        if (this.dataSource) {
            this._initializeSelection(newValue, false);
        }
    }
    /**
     * Finds and selects and option based on its value.
     * @returns Option that has the corresponding value.
     */
    _selectValue(value) {
        const correspondingOption = this.dataSource.find((option) => {
            try {
                // Treat null as a special reset value.
                return option.value != null && this._compareWith(option.value, value);
            }
            catch (error) {
                if (isDevMode()) {
                    // Notify developers of errors in their comparator.
                    console.warn(error);
                }
                return false;
            }
        });
        if (correspondingOption) {
            this._selectionModel.select(correspondingOption.value);
        }
        return correspondingOption;
    }
    set dataSource(dataValue) {
        this._dataSource = [];
        const data = Array.isArray(dataValue) ? dataValue : [];
        data.forEach(item => {
            const isItemString = typeof item === 'string' || typeof item === 'number';
            const disabled = isItemString ? false : !!item[this.disabledField || MAT_RADIO_LIST_DEFAULT_DISABLED_FIELD];
            const value = (isItemString || !this.valueField) ? item : item[this.valueField];
            const view = isItemString ? item : item[this.viewField || MAT_RADIO_LIST_DEFAULT_VIEW_FIELD];
            this._dataSource.push({ view, value, data: item, disabled });
        });
        if (this.value) {
            this._initializeSelection(this.value);
        }
    }
    get dataSource() {
        return this._dataSource;
    }
    /** Whether data source is empty. */
    isDataSourceEmpty() {
        return !this.dataSource || !this.dataSource.length;
    }
    /**
     * Sets the selected option based on a value. If no option can be
     * found with the designated value, the select trigger is cleared.
     */
    _setSelectionByValue(value) {
        this._selectionModel.clear();
        this._selectValue(value);
    }
    /** Invoked when an option is clicked. */
    _onRadioOptionChange(radio) {
        this._onTouched();
        this._selectionModel.toggle(radio.value);
        this._propagateChanges();
    }
    _initializeSelection(value, emit = true) {
        // Defer setting the value in order to avoid the "Expression
        // has changed after it was checked" errors from Angular.
        Promise.resolve().then(() => {
            this._setSelectionByValue(value);
            this._propagateChanges(emit);
        });
    }
    /** Emits change event to set the model value. */
    _propagateChanges(emit = true) {
        const selected = this._selectionModel.selected;
        const valueToEmit = selected[0] || undefined;
        this._controlValueAccessorChangeFn(valueToEmit);
        if (emit) {
            this.matChange.emit(valueToEmit);
        }
        this._cd.markForCheck();
    }
    ngOnInit() {
        this._selectionModel = new SelectionModel(false, undefined, false);
    }
    ngOnDestroy() {
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.value = value;
        this._cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatRadioList.decorators = [
    { type: Component, args: [{
                selector: 'mat-radio-list',
                exportAs: 'matRadioList',
                template: "<mat-radio-group [labelPosition]=\"labelPosition\" [color]=\"color\" [value]=\"value\" (change)=\"_onRadioOptionChange($event)\" class=\"mat-radio-list-wapper\">\r\n  <mat-radio-button\r\n   *ngFor=\"let option of dataSource\"\r\n   [disabled]=\"disabled || option.disabled\"\r\n   [value]=\"option.value\"\r\n   >\r\n   {{option.view}}\r\n  </mat-radio-button>\r\n</mat-radio-group>\r\n",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                providers: [MAT_RADIO_LIST_VALUE_ACCESSOR],
                host: {
                    '[attr.role]': 'option',
                    '[attr.tabindex]': 'tabIndex',
                    '[class.mat-radio-list]': 'true',
                    '[class.mat-radio-list-vertical]': 'direction === "vertical"',
                    '[class.mat-radio-list-horizontal]': 'direction === "horizontal"',
                }
            },] }
];
MatRadioList.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatRadioList.propDecorators = {
    matChange: [{ type: Output }],
    labelPosition: [{ type: Input }],
    tabIndex: [{ type: Input }],
    disabledField: [{ type: Input }],
    viewField: [{ type: Input }],
    valueField: [{ type: Input }],
    name: [{ type: Input }],
    color: [{ type: Input }],
    required: [{ type: Input }],
    direction: [{ type: Input }],
    disabled: [{ type: Input }],
    compareWith: [{ type: Input }],
    value: [{ type: Input }],
    dataSource: [{ type: Input }]
};

class MatRadioListModule {
}
MatRadioListModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatRadioModule],
                exports: [MatRadioList],
                declarations: [MatRadioList],
                providers: [],
            },] }
];

const MAT_SELECT_BUTTON_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatSelectButton),
    multi: true
};
function getMatSelectButtonNonFunctionValueError() {
    return Error('`compareWith` must be a function.');
}
function getMatSelectButtonNonArrayValueError() {
    return Error('Value must be an array in multiple-selectbutton mode.');
}
const MAT_SELECT_BUTTON_DEFAULT_VIEW_FIELD = 'label';
const MAT_SELECT_BUTTON_DEFAULT_ICON_FIELD = 'icon';
const MAT_SELECT_BUTTON_DEFAULT_DISABLED_FIELD = 'disabled';
class MatSelectButton {
    constructor(_cd) {
        this._cd = _cd;
        /** Emit event subject */
        this._valueChange$ = new Subject();
        this.valueChange = new EventEmitter();
        /** Field name of disabled when datasource as objecet array. */
        this.disabledField = MAT_SELECT_BUTTON_DEFAULT_DISABLED_FIELD;
        /** Field name of view when datasource as objecet array. */
        this.viewField = MAT_SELECT_BUTTON_DEFAULT_VIEW_FIELD;
        /** Field name of icon when datasource as objecet array. */
        this.iconField = MAT_SELECT_BUTTON_DEFAULT_ICON_FIELD;
        /** Comparison function to specify which option is checked. Defaults to object equality. */
        this._compareWith = (o1, o2) => o1 === o2;
        /** Option of the buttons. */
        this._dataSource = null;
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
    }
    set tick(value) {
        this._tick = coerceBooleanProperty(value);
    }
    get tick() {
        return this._tick;
    }
    get compareWith() { return this._compareWith; }
    set compareWith(fn) {
        if (typeof fn !== 'function') {
            throw getMatSelectButtonNonFunctionValueError();
        }
        this._compareWith = fn;
        if (this._selectionModel) {
            // A different comparator means the selection could change.
            this._initializeSelection(this.value);
        }
    }
    set multiple(value) {
        this._multiple = coerceBooleanProperty(value);
    }
    get multiple() {
        return this._multiple;
    }
    get disabled() { return this._disabled; }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get value() {
        const selected = this._selectionModel ? this._selectionModel.selected : [];
        return this.multiple ? selected : selected[0];
    }
    set value(newValue) {
        this._rawValue = newValue;
        if (this.dataSource) {
            this._initializeSelection(newValue, false);
        }
    }
    set dataSource(dataValue) {
        this._dataSource = [];
        const data = Array.isArray(dataValue) ? dataValue : [];
        data.forEach(item => {
            const isItemString = typeof item === 'string';
            const icon = isItemString ? '' : item[this.iconField || MAT_SELECT_BUTTON_DEFAULT_ICON_FIELD];
            const disabled = isItemString ? false : !!item[this.disabledField || MAT_SELECT_BUTTON_DEFAULT_DISABLED_FIELD];
            const value = (isItemString || !this.valueField) ? item : item[this.valueField];
            const view = isItemString ? item : item[this.viewField || MAT_SELECT_BUTTON_DEFAULT_VIEW_FIELD];
            this._dataSource.push({ view, value, icon, data: item, disabled });
        });
        if (this.value) {
            this._initializeSelection(this.value);
        }
    }
    get dataSource() {
        return this._dataSource;
    }
    /** Checks whether a button toggle is selected. */
    _isSelected(data) {
        return this._selectionModel && this._selectionModel.isSelected(data.value);
    }
    _initializeSelection(value, emit = true) {
        // Defer setting the value in order to avoid the "Expression
        // has changed after it was checked" errors from Angular.
        Promise.resolve().then(() => {
            this._setSelectionByValue(value);
            this._propagateChanges(emit);
        });
    }
    /**
     * Sets the selected option based on a value. If no option can be
     * found with the designated value, the select trigger is cleared.
     */
    _setSelectionByValue(value) {
        if (this.multiple && value) {
            if (!Array.isArray(value)) {
                throw getMatSelectButtonNonArrayValueError();
            }
            this._selectionModel.clear();
            value.forEach((currentValue) => this._selectValue(currentValue));
        }
        else {
            this._selectionModel.clear();
            this._selectValue(value);
        }
    }
    /** Whether data source is empty. */
    isDataSourceEmpty() {
        return !this.dataSource || !this.dataSource.length;
    }
    /**
     * Finds and selects and option based on its value.
     * @returns Option that has the corresponding value.
     */
    _selectValue(value) {
        const correspondingOption = this.dataSource.find((option) => {
            try {
                // Treat null as a special reset value.
                return option.value != null && this._compareWith(option.value, value);
            }
            catch (error) {
                if (isDevMode()) {
                    // Notify developers of errors in their comparator.
                    console.warn(error);
                }
                return false;
            }
        });
        if (correspondingOption) {
            this._selectionModel.select(correspondingOption.value);
        }
        return correspondingOption;
    }
    /** Invoked when an option is clicked. */
    _onButtonClick(button) {
        this._onTouched();
        this._selectionModel.toggle(button.value);
        this._propagateChanges();
    }
    /** Emits change event to set the model value. */
    _propagateChanges(emit = true) {
        let valueToEmit = null;
        const selected = this._selectionModel.selected;
        if (this.multiple) {
            valueToEmit = selected.length ? selected : undefined;
        }
        else {
            valueToEmit = selected[0] || undefined;
        }
        this._controlValueAccessorChangeFn(valueToEmit);
        if (emit) {
            this._valueChange$.next(valueToEmit);
        }
        this._cd.markForCheck();
    }
    ngOnInit() {
        this._selectionModel = new SelectionModel(this.multiple, undefined, false);
        this.registerEmitEvent();
    }
    ngOnDestroy() {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
    }
    registerEmitEvent() {
        this._subscription = this._valueChange$.pipe(debounceTime(200), distinctUntilChanged()).subscribe(event => this.valueChange.emit(event));
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.value = value;
        this._cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatSelectButton.decorators = [
    { type: Component, args: [{
                selector: 'mat-selectbutton',
                template: "<button \r\n  mat-stroked-button\r\n  color=\"primary\"\r\n  *ngFor=\"let button of dataSource\"\r\n  (click)=\"_onButtonClick(button)\"\r\n  [disabled]=\"disabled || button.disabled\"\r\n  [class.mat-selectbutton-checked]=\"_isSelected(button)\"\r\n  >\r\n  <mat-icon [fontIcon]=\"button.icon\" *ngIf=\"button.icon\"></mat-icon>\r\n  {{button.view}}\r\n  <span class=\"mat-selectbutton-tick\" *ngIf=\"tick && _isSelected(button)\"></span>\r\n</button>",
                providers: [MAT_SELECT_BUTTON_VALUE_ACCESSOR],
                host: {
                    '[attr.role]': '"group"',
                    '[class.mat-selectbutton]': 'true',
                    '[class.mat-selectbutton-showtick]': 'tick',
                    '[class.mat-selectbutton-empty]': 'isDataSourceEmpty()',
                },
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            },] }
];
MatSelectButton.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatSelectButton.propDecorators = {
    valueChange: [{ type: Output }],
    name: [{ type: Input }],
    disabledField: [{ type: Input }],
    viewField: [{ type: Input }],
    valueField: [{ type: Input }],
    tick: [{ type: Input }],
    iconField: [{ type: Input }],
    compareWith: [{ type: Input }],
    multiple: [{ type: Input }],
    disabled: [{ type: Input }],
    value: [{ type: Input }],
    dataSource: [{ type: Input }]
};

class MatSelectButtonModule {
}
MatSelectButtonModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatButtonModule, MatIconModule],
                exports: [MatSelectButton],
                declarations: [MatSelectButton],
                providers: [],
            },] }
];

class MatSliderRule {
    constructor(_view, _slider, _el, _cd) {
        this._view = _view;
        this._slider = _slider;
        this._el = _el;
        this._cd = _cd;
        this._rule = false;
        this._textInterval = 1;
    }
    set rule(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this._rule) {
            this._rule = newValue;
            this.toggleClass(this._rule);
            if (!this._rule) {
                this.clearElement();
            }
        }
    }
    get rule() {
        return this._rule;
    }
    set textInterval(value) {
        if (Number(value) !== this._textInterval) {
            this._textInterval = value;
            this.toggleClass(this.rule);
        }
    }
    get textInterval() {
        return this._textInterval || 1;
    }
    toggleClass(add) {
        const element = this._el.nativeElement;
        if (add) {
            element.classList.add('mat-slider-rule');
        }
        else {
            element.classList.remove('mat-slider-rule');
        }
    }
    set sliderValue(value) {
        if (value !== this._sliderValue) {
            this._sliderValue = value;
            this._slider.vertical = false;
            this._slider.thumbLabel = true;
            this.setRuleStyle();
        }
    }
    get sliderValue() {
        return this._sliderValue;
    }
    clearElement() {
        if (this._ruleWapperEle) {
            const element = this._el.nativeElement;
            element.removeChild(this._ruleWapperEle);
            console.log('remove');
        }
        this._ruleWapperEle = null;
        this._backgroundRuleEle = null;
        this._fillRuleEle = null;
        this._ruleTextEle = null;
    }
    getWapperRuleEle() {
        if (this._ruleWapperEle) {
            return this._ruleWapperEle;
        }
        else {
            const element = this._el.nativeElement;
            this._ruleWapperEle = document.createElement('div');
            this._ruleWapperEle.className = 'mat-slider-rule-wapper';
            element.appendChild(this._ruleWapperEle);
            return this._ruleWapperEle;
        }
    }
    getRuleTextEle() {
        if (this._ruleTextEle) {
            return this._ruleTextEle;
        }
        else {
            const wapper = this.getWapperRuleEle();
            this._ruleTextEle = document.createElement('div');
            this._ruleTextEle.className = 'mat-slider-rule-text';
            wapper.appendChild(this._ruleTextEle);
            return this._ruleTextEle;
        }
    }
    getFillRuleEle() {
        if (this._fillRuleEle) {
            return this._fillRuleEle;
        }
        else {
            const wapper = this.getWapperRuleEle();
            this._fillRuleEle = document.createElement('span');
            this._fillRuleEle.className = 'mat-slider-fill-rule';
            wapper.appendChild(this._fillRuleEle);
            return this._fillRuleEle;
        }
    }
    getBackgroundRuleEle() {
        if (this._backgroundRuleEle) {
            return this._backgroundRuleEle;
        }
        else {
            const wapper = this.getWapperRuleEle();
            this._backgroundRuleEle = document.createElement('div');
            this._backgroundRuleEle.className = 'mat-slider-backgropund-rule';
            wapper.appendChild(this._backgroundRuleEle);
            return this._backgroundRuleEle;
        }
    }
    setRuleStyle() {
        if (this.rule) {
            const slider = this._slider;
            slider._onFocus();
            const fillEle = this.getFillRuleEle();
            const bgEle = this.getBackgroundRuleEle();
            const textEle = this.getRuleTextEle();
            bgEle.style.width = (1 - slider.percent) * 100 + '%';
            bgEle.style.backgroundSize = this.getTickIntervalPercent(false);
            fillEle.style.width = slider.percent * 100 + '%';
            fillEle.style.display = slider._trackFillStyles.display;
            fillEle.style.backgroundSize = this.getTickIntervalPercent(true);
            textEle.innerHTML = this.getRuleText();
        }
    }
    getTickIntervalPercent(isFill) {
        const tickSize = this._slider['_tickIntervalPercent'] * 100;
        const percent = this._slider.percent;
        const size = isFill ? (tickSize / percent).toFixed(2) : (tickSize / (1 - percent)).toFixed(2);
        const backgroundSize = this._slider.vertical ? `2px ${size}%` : `${size}% 2px`;
        return backgroundSize;
    }
    getRuleText() {
        const slider = this._slider;
        const max = slider.max || 100;
        const min = slider.min || 0;
        const step = slider.step || 1;
        const tickInterval = Number(this.textInterval) || 1;
        const htmlStart = '<span>';
        const htmlEnd = '</span>';
        let htmlString = '';
        for (let i = min; i <= max; i = (i + step * tickInterval)) {
            htmlString = htmlString + (htmlStart + i + htmlEnd);
        }
        return htmlString;
    }
    ngDoCheck() {
        this.sliderValue = this._slider.value;
        if (this._slider._onFocus) {
            this._slider._onFocus();
            this.setRuleStyle();
        }
    }
}
MatSliderRule.decorators = [
    { type: Directive, args: [{
                selector: 'mat-slider[rule]',
            },] }
];
MatSliderRule.ctorParameters = () => [
    { type: ViewContainerRef },
    { type: MatSlider },
    { type: ElementRef },
    { type: ChangeDetectorRef }
];
MatSliderRule.propDecorators = {
    rule: [{ type: Input }],
    textInterval: [{ type: Input }]
};

class MatSliderRuleModule {
}
MatSliderRuleModule.decorators = [
    { type: NgModule, args: [{
                imports: [],
                exports: [MatSliderRule],
                declarations: [MatSliderRule]
            },] }
];

function getMatTreeNonFunctionValueError(key) {
    return Error(`"${key}" must be a function.'`);
}
const MAT_TREE_DEFAULT_VIEW_FIELD = 'label';
const MAT_TREE_DEFAULT_CHILDREN_FIELD = 'children';
const MAT_TREE_DEFAULT_DISABLED_FIELD = 'disabled';
const MAT_TREE_DEFAULT_SELECTABLE_FIELD = 'selectable';
class MatFlatTree {
    constructor(_cd) {
        this._cd = _cd;
        /** Event emitted when component is lazy load */
        this.matLoadChildren = new EventEmitter();
        /** Event emitted when selection has changeed. */
        this.selectionChange = new EventEmitter();
        /** Event emitted when selection has changeed. */
        this.checkAllChange = new EventEmitter();
        /** Event emitted when node expand. */
        this.matExpand = new EventEmitter();
        this._disabledField = MAT_TREE_DEFAULT_DISABLED_FIELD;
        this._selectableField = MAT_TREE_DEFAULT_SELECTABLE_FIELD;
        this._viewField = MAT_TREE_DEFAULT_VIEW_FIELD;
        this._childrenField = MAT_TREE_DEFAULT_CHILDREN_FIELD;
        this.propagateUp = true;
        this.propagateDown = true;
        /** Whether multiple nodes can be selected. */
        this._multiple = false;
        /** Whether show checkbox. */
        this._checkbox = false;
        this._compareWith = (o1, o2) => o1 === o2;
        this._dataSource = null;
        this._checkAll = false;
        this.dataSourceChange = new BehaviorSubject([]);
        this.flatNodeMap = new Map();
        this.nestedNodeMap = new Map();
        /** Flat tree control. */
        this.treeControl = new FlatTreeControl(node => node.level, node => node.expandable);
        /** Where the tree node has child. */
        this.hasChild = (_, node) => node.expandable || !node.leaf;
        this._destroy = new Subject();
    }
    /** Field name of disabled when datasource as objecet array. */
    set disabledField(value) {
        this._disabledField = value;
    }
    get disabledField() {
        return this._disabledField || MAT_TREE_DEFAULT_DISABLED_FIELD;
    }
    /** Field name of selectable when datasource as objecet array. */
    set selectableField(value) {
        this._selectableField = value;
    }
    get selectableField() {
        return this._selectableField || MAT_TREE_DEFAULT_SELECTABLE_FIELD;
    }
    /** Field name of view when datasource as objecet array. */
    set viewField(value) {
        this._viewField = value;
    }
    get viewField() {
        return this._viewField || MAT_TREE_DEFAULT_VIEW_FIELD;
    }
    /** Field name of children when datasource as objecet array. */
    set childrenField(value) {
        this._childrenField = value;
    }
    get childrenField() {
        return this._childrenField || MAT_TREE_DEFAULT_CHILDREN_FIELD;
    }
    set nodeDisabled(fn) {
        if (fn) {
            if (typeof fn !== 'function') {
                throw getMatTreeNonFunctionValueError('nodeDisabled');
            }
            this._nodeDisabled = fn;
        }
    }
    get nodeDisabled() { return this._nodeDisabled; }
    set nodeSelectable(fn) {
        if (fn) {
            if (typeof fn !== 'function') {
                throw getMatTreeNonFunctionValueError('nodeSelectable');
            }
            this._nodeSelectable = fn;
        }
    }
    get nodeSelectable() { return this._nodeSelectable; }
    set multiple(value) {
        const newValue = coerceBooleanProperty(value);
        if (this._multiple !== newValue) {
            if (this._selectionModel) {
                throw Error('Cannot change `multiple` mode of tree after initialization.');
            }
            this._multiple = newValue;
            this._cd.markForCheck();
        }
    }
    get multiple() {
        return this._multiple;
    }
    set checkbox(value) {
        const newValue = coerceBooleanProperty(value);
        if (this._checkbox !== newValue) {
            this._checkbox = newValue;
            this._cd.markForCheck();
        }
    }
    get checkbox() {
        return this._checkbox;
    }
    /** Compare treenode is different */
    get compareWith() { return this._compareWith; }
    set compareWith(fn) {
        if (typeof fn !== 'function') {
            throw Error('`compareWith` must be a function.');
        }
        this._compareWith = fn;
    }
    /** Option of the tree. */
    set dataSource(dataValue) {
        if (dataValue !== this._dataSource) {
            const data = Array.isArray(dataValue) ? dataValue : [];
            this._dataSource = data;
            this.dataSourceChange.next(data);
        }
    }
    get dataSource() { return this._dataSource; }
    set selection(value) {
        if (value != this._selection) {
            this._selection = value;
            if (this.treeControl.dataNodes && this.treeControl.dataNodes.length) {
                this.setSelectionByValue(value);
            }
        }
    }
    get selection() {
        return this._selection;
    }
    set checkAll(value) {
        const newValue = coerceBooleanProperty(value);
        if (this._checkAll !== newValue) {
            this._checkAll = newValue;
            if (this._selectionModel) {
                if (this._checkAll) {
                    this.selectAll();
                }
                else {
                    this.deselectAll();
                }
            }
            this._cd.markForCheck();
        }
    }
    get checkAll() {
        return this._checkAll;
    }
    /** Where the selection mode is empty */
    get empty() {
        return !this._selectionModel || this._selectionModel.isEmpty();
    }
    /** Get selected nodes. */
    get selectedNodes() {
        return !!this.multiple ? this._selectionModel.selected : this._selectionModel.selected[0];
    }
    setSelectionByValue(value) {
        this._selectionModel.clear();
        const selectValue = (nodeitem) => this.treeControl.dataNodes.find(item => {
            const compareResult = this.valueField ? item.value === nodeitem : this.compareWith(nodeitem, item.nodeData);
            if (compareResult) {
                this._selectionModel.select(item);
            }
            return compareResult;
        });
        if (!value) {
            return;
        }
        if (!!this.multiple) {
            value.forEach((currentValue) => selectValue(currentValue));
        }
        else {
            selectValue(value);
        }
        this._cd.markForCheck();
        this.emitCheckAll();
    }
    /** Toggle node select or not. */
    toggleNode(node) {
        this._selectionModel.toggle(node);
    }
    /** Select node. */
    selectNode(...nodes) {
        this._selectionModel.select(...nodes);
    }
    /** Select all nodes */
    selectAll(emit = false) {
        const canSelectedNodes = this.treeControl.dataNodes.filter(node => !node.disabled && node.selectable);
        this._selectionModel.clear();
        if (!!canSelectedNodes.length) {
            this.selectNode(...canSelectedNodes);
            if (emit) {
                this.checkAllChange.emit(true);
            }
        }
        this.setSelectionValue();
    }
    /** Check where is all selected. */
    emitCheckAll() {
        Promise.resolve().then(() => {
            this.checkAllChange.emit(this.isAllSelected());
        });
    }
    /** Cancel node seleted. */
    deselectNode(...nodes) {
        this._selectionModel.deselect(...nodes);
    }
    /** Cancel all node seleted. */
    deselectAll(emit = false) {
        this._selectionModel.clear();
        this.setSelectionValue();
        if (emit) {
            this.checkAllChange.emit(false);
        }
    }
    expand(node) {
        this.treeControl.expand(node);
    }
    expandAll() {
        this.treeControl.expandAll();
    }
    expandToLevel(level = 0) {
        this.treeControl.dataNodes.forEach((node) => {
            if (node.level <= level) {
                this.treeControl.expand(node);
            }
        });
    }
    collapse(node) {
        this.treeControl.collapse(node);
    }
    collapseAll() {
        this.treeControl.collapseAll();
    }
    collapseToLevel(level = 0) {
        this.treeControl.dataNodes.forEach((node) => {
            if (node.level <= level) {
                this.treeControl.collapse(node);
            }
        });
    }
    /** Remove node. */
    remove(node) {
        const parentNode = this.getParentNode(node);
        const parentNestNode = this.flatNodeMap.get(parentNode);
        const nestNode = this.flatNodeMap.get(node);
        if (parentNestNode) {
            parentNestNode[this.childrenField].splice(parentNestNode[this.childrenField].indexOf(nestNode), 1);
        }
        else {
            this.dataSourceChange.value.splice(this.dataSourceChange.value.indexOf(nestNode), 1);
        }
        this.dataSourceChange.next(this.dataSourceChange.value);
    }
    /** Update node. */
    update(node, nodeData = {}) {
        const nestNode = this.flatNodeMap.get(node);
        Object.keys(nodeData).forEach(key => nestNode[key] = nodeData[key]);
        this.dataSourceChange.next(this.dataSourceChange.value);
    }
    /** Insert node */
    insert(parentNode, nodes, startIndex) {
        const parentNestNode = this.flatNodeMap.get(parentNode);
        const insertNodes = Array.isArray(nodes) ? nodes : [nodes];
        parentNestNode[this.childrenField] = parentNestNode[this.childrenField] || [];
        const insertIndex = typeof startIndex === 'number' ? startIndex : parentNestNode[this.childrenField].length;
        parentNestNode[this.childrenField].splice(insertIndex, 0, ...insertNodes);
        this.dataSourceChange.next(this.dataSourceChange.value);
        this.treeControl.expand(parentNode);
    }
    /** Where all nodes has selected. */
    isAllSelected() {
        const canSelected = this.treeControl.dataNodes.filter(node => !node.disabled && !!node.selectable);
        return canSelected.length ? this._selectionModel.selected.length == canSelected.length : false;
    }
    /** Where the node is selected */
    isNodeSelected(node) {
        return this._selectionModel.isSelected(node);
    }
    /** Where all children selected. */
    isExpandableNodeSelected(node) {
        return true;
    }
    /** Set selection node on selected change. */
    setSelectionValue() {
        const selected = this._selectionModel.selected.map(item => item.value);
        if (selected && selected.length) {
            this._selection = this.multiple ? selected : selected[0];
        }
        else {
            this._selection = this.multiple ? [] : undefined;
        }
        this.selectionChange.emit(this._selection);
        this.emitCheckAll();
    }
    /** 初始化树结构 */
    initializeTree() {
        const transformer = (node, level) => {
            const isDisabled = (this.nodeDisabled && this.nodeDisabled(node)) || !!node[this.disabledField];
            const isSelectable = this.nodeSelectable ? !!this.nodeSelectable(node) : node[this.selectableField] != 'false';
            const childrenLength = node[this.childrenField] ? node[this.childrenField].length : 0;
            const isExpandable = childrenLength > 0;
            const isLeaf = node.leaf === undefined ? !isExpandable : !!node.leaf;
            const existingNode = this.nestedNodeMap.get(node);
            const isExpanded = this.treeControl.isExpanded(existingNode);
            const flatNode = existingNode ? existingNode : {};
            flatNode.leaf = isLeaf;
            flatNode.view = node[this.viewField];
            flatNode.value = this.valueField ? node[this.valueField] : node;
            flatNode.level = level;
            flatNode.childrenLength = childrenLength;
            flatNode.nodeData = node;
            flatNode.disabled = isDisabled;
            flatNode.expandable = isExpandable;
            flatNode.selectable = isSelectable;
            this.flatNodeMap.set(flatNode, node);
            this.nestedNodeMap.set(node, flatNode);
            return flatNode;
        };
        this.treeFlattener = new MatTreeFlattener(transformer, node => node.level, node => node.expandable, node => node[this.childrenField]);
        this.dataSourceDisplay = new MatTreeFlatDataSource(this.treeControl, this.treeFlattener);
        if (this._dataSource && this._dataSource.length) {
            this.dataSourceDisplay.data = this._dataSource;
        }
    }
    /** Watch data source change. */
    registerDataSourceChange() {
        this.dataSourceChange.subscribe(data => {
            this.dataSourceDisplay.data = data;
            if (this._selection) {
                this.setSelectionByValue(this._selection);
                this.setSelectionValue();
            }
        });
    }
    /** Get node by data. */
    getNode(data) {
        return this.treeControl.dataNodes.find(node => this.valueField ? node.value === data : this.compareWith(data, node.nodeData));
    }
    /** Get parent node by node. */
    getParentNode(node) {
        const currentLevel = node.level;
        if (currentLevel < 1) {
            return null;
        }
        const startIndex = this.treeControl.dataNodes.indexOf(node) - 1;
        for (let i = startIndex; i >= 0; i--) {
            const currentNode = this.treeControl.dataNodes[i];
            if (currentNode.level < currentLevel) {
                return currentNode;
            }
        }
        return null;
    }
    /** Propagate up to check. */
    propagateUpCheck(node) {
        if (this.propagateUp) {
            let parent = this.getParentNode(node);
            while (parent) {
                this.propagateUpSelected(parent);
                parent = this.getParentNode(parent);
            }
        }
    }
    propagateUpSelected(node) {
        // const currentNodeSelected = this.isNodeSelected(node);
        // const descEverySelected = descendants.every(child => this.isNodeSelected(child) || child.disabled || !child.selectable );
        const descendants = this.treeControl.getDescendants(node);
        const descSomeSelected = descendants.some(child => this.isNodeSelected(child));
        if (this.propagateUp) {
            if (!descSomeSelected) {
                this.deselectNode(node);
            }
            else {
                this.selectNode(node);
            }
        }
    }
    /** Propagate down to check. */
    propagateDownCheck(node) {
        if (this.propagateDown) {
            const descendants = this.treeControl.getDescendants(node).filter(item => !item.disabled && item.selectable);
            this.isNodeSelected(node) ? this.selectNode(...descendants) : this.deselectNode(...descendants);
        }
    }
    nodeClick(node) {
        if (node.disabled || !node.selectable) {
            return;
        }
        this.toggleNode(node);
        if (this.multiple) {
            if (node.expandable) {
                this.propagateDownCheck(node);
            }
            this.propagateUpCheck(node);
        }
        this.setSelectionValue();
    }
    /** Fileter node. */
    filter(keyword, mixMatch = false) {
        if (keyword && keyword.trim()) {
            this.filterNodeSet = new Set();
            const keywordArr = mixMatch ? Array.from(keyword.toLocaleLowerCase()) : [keyword];
            const filterNodes = this.treeControl.dataNodes.filter(node => {
                const nodeStr = mixMatch ? node.view.toLocaleLowerCase() : node.view;
                return keywordArr.every((str) => nodeStr.includes(str));
            });
            filterNodes.forEach(node => {
                if (!this.filterNodeSet.has(node)) {
                    this.filterNodeSet.add(node);
                }
                let parent = this.getParentNode(node);
                while (parent) {
                    if (!this.filterNodeSet.has(parent)) {
                        this.filterNodeSet.add(parent);
                    }
                    parent = this.getParentNode(parent);
                }
            });
            if (this.filterNodeSet.size) {
                this.treeControl.expandAll();
            }
        }
        else {
            this.filterNodeSet = null;
            this.treeControl.collapseAll();
        }
        this._cd.markForCheck();
    }
    hiddenNode(node) {
        return this.filterNodeSet && !this.filterNodeSet.has(node);
    }
    /** Event emitter on expand or colseand */
    onExpand(node) {
        const expanded = this.treeControl.isExpanded(node);
        this.matExpand.emit({ node, expanded });
        if (!node.expandable && this.lazy) {
            node._loading = true;
            this.matLoadChildren.emit({
                node,
                insert: (data) => {
                    this.insert(node, data);
                    node._loading = false;
                    this._cd.markForCheck();
                }
            });
        }
    }
    /** Get nested index. */
    getNestedIndex(node) {
        const parentNode = this.getParentNode(node);
        const parentNodeIndex = this.treeControl.dataNodes.indexOf(parentNode);
        const nodeIndex = this.treeControl.dataNodes.indexOf(node);
        let index = 0;
        for (let i = parentNodeIndex + 1; i < nodeIndex; i++) {
            const currentNode = this.treeControl.dataNodes[i];
            if (currentNode.level === node.level) {
                index = index + 1;
            }
        }
        return index;
    }
    /** Parent Length */
    getParentLength(node) {
        const parentNode = this.getParentNode(node);
        return parentNode ? parentNode.childrenLength : null;
    }
    /** Where the node is first in parent. */
    isNestedFirst(node) {
        return this.getNestedIndex(node) === 0;
    }
    /** Where the node is last in parent. */
    isNestedLast(node) {
        return this.getParentLength(node) === this.getNestedIndex(node) + 1;
    }
    move(node, relative, go) {
        const parentNode = this.getParentNode(node);
        const parentNestNode = this.flatNodeMap.get(parentNode);
        const children = parentNode ? parentNestNode[this.childrenField] : this.dataSourceChange.value;
        const parentLength = children.length;
        const nestNode = this.flatNodeMap.get(node);
        const index = children.indexOf(nestNode);
        if (!go || (go && go(index, parentLength))) {
            children[index] = children.splice(index + relative, 1, children[index])[0];
            this.dataSourceChange.next(this.dataSourceChange.value);
        }
    }
    moveUp(node) {
        this.move(node, -1, (index, len) => index !== 0);
    }
    moveDown(node) {
        this.move(node, 1, (index, len) => index < len - 1);
    }
    ngAfterViewInit() {
    }
    ngOnInit() {
        this._selectionModel = new SelectionModel(!!this.multiple);
        this.initializeTree();
        this.registerDataSourceChange();
    }
    ngOnDestroy() {
        this._destroy.next();
        this._destroy.complete();
    }
}
MatFlatTree.decorators = [
    { type: Component, args: [{
                selector: 'mat-flat-tree',
                template: "<!-- default node template -->\r\n<ng-template let-node #defaultTemplate>\r\n    <span [title]=\"node.view\">{{node.view}}</span>\r\n</ng-template>\r\n\r\n<div class=\"mat-flat-tree-wapper\">\r\n    <mat-tree [dataSource]=\"dataSourceDisplay\" [treeControl]=\"treeControl\">\r\n        <mat-tree-node [class.mat-tree-node-hidden]=\"hiddenNode(node)\" [class.mat-tree-node-hascheckbox]=\"checkbox\" [class.mat-tree-node-selected]=\"isNodeSelected(node)\" [class.mat-tree-node-disabled]=\"node.disabled || !node.selectable\" role=\"tree-node\" *matTreeNodeDef=\"let node\" matTreeNodePadding matTreeNodePaddingIndent=\"24\">\r\n            <span class=\"mat-tree-toggle-placeholder\" *ngIf=\"!(node.expandable || !node.leaf)\"></span>\r\n            <span matTreeNodeToggle class=\"mat-tree-toggle-button\" *ngIf=\"(node.expandable || !node.leaf) && !node._loading\" (click)=\"onExpand(node)\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path *ngIf=\"!treeControl.isExpanded(node)\" d=\"M93.0426665 9.2511995h837.914667a83.791467 83.791467 0 0 1 83.791467 83.791467v837.914667a83.791467 83.791467 0 0 1-83.791467 83.791467H93.0426665a83.791467 83.791467 0 0 1-83.791467-83.791467V93.0426665a83.791467 83.791467 0 0 1 83.791467-83.791467z m377.06160073 460.85306773h-167.58293398a41.89573277 41.89573277 0 0 0 0 83.79146554h167.58293398v167.58293398a41.89573277 41.89573277 0 1 0 83.79146554 0v-167.58293398h167.58293398a41.89573277 41.89573277 0 1 0 0-83.79146554h-167.58293398v-167.58293398a41.89573277 41.89573277 0 0 0-83.79146554 0v167.58293398z\" fill=\"currentColor\"></path>\r\n                    <path *ngIf=\"treeControl.isExpanded(node)\" d=\"M85.333333 0h853.333334a85.333333 85.333333 0 0 1 85.333333 85.333333v853.333334a85.333333 85.333333 0 0 1-85.333333 85.333333H85.333333a85.333333 85.333333 0 0 1-85.333333-85.333333V85.333333a85.333333 85.333333 0 0 1 85.333333-85.333333z m213.333334 469.333333a42.666667 42.666667 0 0 0 0 85.333334h426.666666a42.666667 42.666667 0 1 0 0-85.333334h-426.666666z\" fill=\"currentColor\"></path>\r\n                </svg>\r\n            </span>\r\n            <span class=\"mat-tree-loading\" *ngIf=\"node._loading\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path fill=\"currentColor\" d=\"M541.09070222 2.63964445a29.12711111 29.12711111 0 0 0 0 58.18140444c232.6528 0 421.90620445 189.28981333 421.90620445 421.90620444a29.12711111 29.12711111 0 0 0 58.18140444 0c0-264.72903111-215.39498667-480.12401778-480.12401778-480.12401778z\"></path>\r\n                </svg>\r\n            </span>\r\n\r\n            <mat-checkbox class=\"mat-tree-node-checkbox\" *ngIf=\"checkbox\" (change)=\"nodeClick(node)\" [checked]=\"isNodeSelected(node)\" [disabled]=\"node.disabled || !node.selectable\"></mat-checkbox>\r\n\r\n            <div class=\"mat-tree-node-label\" (click)=\"!checkbox && nodeClick(node)\">\r\n                <ng-template [ngTemplateOutlet]=\"nodeTemplate ? nodeTemplate : defaultTemplate\" [ngTemplateOutletContext]=\"{ $implicit: node }\"></ng-template>\r\n            </div>\r\n        </mat-tree-node>\r\n\r\n    </mat-tree>\r\n</div>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-flat-tree]': 'true'
                }
            },] }
];
MatFlatTree.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatFlatTree.propDecorators = {
    matLoadChildren: [{ type: Output }],
    selectionChange: [{ type: Output }],
    checkAllChange: [{ type: Output }],
    matExpand: [{ type: Output }],
    lazy: [{ type: Input }],
    disabledField: [{ type: Input }],
    selectableField: [{ type: Input }],
    viewField: [{ type: Input }],
    childrenField: [{ type: Input }],
    valueField: [{ type: Input }],
    disableRipple: [{ type: Input }],
    nodeTemplate: [{ type: Input }],
    propagateUp: [{ type: Input }],
    propagateDown: [{ type: Input }],
    nodeDisabled: [{ type: Input }],
    nodeSelectable: [{ type: Input }],
    multiple: [{ type: Input }],
    checkbox: [{ type: Input }],
    compareWith: [{ type: Input }],
    dataSource: [{ type: Input }],
    selection: [{ type: Input }],
    checkAll: [{ type: Input }]
};

class MatFlatTreeModule {
}
MatFlatTreeModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatTreeModule, MatCheckboxModule, MatRippleModule],
                declarations: [MatFlatTree],
                exports: [MatFlatTree]
            },] }
];

class MatTreeSelectTrigger {
}
MatTreeSelectTrigger.decorators = [
    { type: Directive, args: [{
                selector: 'mat-tree-select-trigger'
            },] }
];
const MAT_TREE_SELECT_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatTreeSelect),
    multi: true
};
class MatTreeSelect extends MatFlatTree {
    constructor(_cd, _ele, _viewContainerRef, _overlay) {
        super(_cd);
        this._cd = _cd;
        this._ele = _ele;
        this._viewContainerRef = _viewContainerRef;
        this._overlay = _overlay;
        this.matChange = new EventEmitter();
        this.matFilter = new EventEmitter();
        this.matOpened = new EventEmitter();
        this.tabIndex = 0;
        /** Where show search input. */
        this.showFilter = true;
        /** Field name of view when datasource as objecet array. */
        this.placeholder = '';
        /** Field name of view when datasource as objecet array. */
        this.searcPlaceholder = '';
        /** Whether the dropdown is required. */
        this._required = false;
        /** Whether the dropdown options display with group. */
        this._reset = true;
        this._opened = false;
        /** Whether the option is disabled. */
        this._disabled = false;
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
        this.selectionChange.subscribe(() => this.treeValueChange());
    }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    get reset() { return this._reset; }
    set reset(value) {
        this._reset = coerceBooleanProperty(value);
    }
    /** Whether the calendar is open. */
    get opened() { return this._opened; }
    set opened(value) { value ? this.open() : this.close(); }
    get disabled() { return this._disabled; }
    set disabled(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this._disabled) {
            this._disabled = newValue;
            this._cd.markForCheck();
        }
    }
    /** Reset value on button click */
    resetValue() {
        this.selection = this.multiple ? [] : null;
        this.searchText = '';
        this.filter('');
        this._controlValueAccessorChangeFn(this.selection);
        this.matChange.emit(this.selection);
        this.matFilter.emit(this.searchText);
    }
    /** clear the select. */
    clear(event) {
        if (event) {
            event.stopPropagation();
        }
        this.resetValue();
    }
    /** Whether data source is empty. */
    isDataSourceEmpty() {
        return !this.dataSource || !this.dataSource.length;
    }
    /** Event on value change */
    onValueChange(event) {
        this._controlValueAccessorChangeFn(event.value);
        this.matChange.emit(event.value);
    }
    search(event) {
        const keyCode = event.keyCode;
        event.stopPropagation();
        if (keyCode === ENTER) {
            this.filter(this.searchText);
        }
    }
    _openAsPopup() {
        const portal = new TemplatePortal(this.treeSelectContentTemplate, this._viewContainerRef);
        this._overlay.close();
        this._overlay.open(this._ele, portal, {
            withViewportMargin: 0,
            hasBackdrop: true,
            backdropClass: 'mat-overlay-transparent-backdrop',
            position: 'BL',
            panelClass: 'mat-tree-select-popup',
            offsetY: 2,
            scrollStrategy: this._overlay._overlay.scrollStrategies.block()
        });
        this._overlay.afterClose().subscribe(() => this.onOverlayClose());
    }
    /** Observable on overlay close */
    onOverlayClose() {
        this.searchText = '';
        this.filter('');
        this._opened = false;
        this.matOpened.emit(false);
        this._onTouched();
    }
    /** Open the tree options. */
    open() {
        if (this._opened || this.disabled) {
            return;
        }
        this._openAsPopup();
        this._opened = true;
        this.matOpened.emit(true);
    }
    /** Close the tree options. */
    close() {
        if (!this._opened) {
            return;
        }
        this._overlay.close();
    }
    treeValueChange() {
        this._controlValueAccessorChangeFn(this.selection);
        if (!this.multiple) {
            this.close();
        }
        this._cd.markForCheck();
    }
    /** The value displayed in the trigger. */
    get triggerValue() {
        if (this.empty) {
            return '';
        }
        if (this.multiple) {
            const selectedOptions = this._selectionModel.selected.map(option => option.view);
            return selectedOptions.join(', ');
        }
        return this._selectionModel.selected[0].view;
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.selection = value;
        this._cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatTreeSelect.decorators = [
    { type: Component, args: [{
                selector: 'mat-tree-select',
                exportAs: 'matTreeSelect',
                template: "<div class=\"mat-tree-select-trigger\" (click)=\"open()\" *ngIf=\"!customTrigger\">\r\n    <span class=\"mat-tree-select-value\" [ngSwitch]=\"empty\">\r\n        <span class=\"mat-tree-select-placeholder\" *ngSwitchCase=\"true\">{{placeholder || '\\u00A0'}}</span>\r\n        <span class=\"mat-tree-select-value-text\" [title]=\"triggerValue\" *ngSwitchCase=\"false\"> {{triggerValue || '\\u00A0'}}</span>\r\n    </span>\r\n    <span class=\"mat-tree-select-icon\" [class.mat-tree-select-can-clear]=\"triggerValue\">\r\n        <span class=\"mat-tree-select-toggle\"></span>\r\n        <span class=\"mat-tree-select-clear\" (click)=\"clear($event)\" *ngIf=\"triggerValue\"></span>\r\n    </span>\r\n</div>\r\n<ng-content select=\"mat-tree-select-trigger\" *ngIf=\"customTrigger\"></ng-content>\r\n\r\n<ng-template #treeSelectContentTemplate>\r\n    <div class=\"mat-tree-select-content\">\r\n        <div class=\"mat-tree-select-header\">\r\n            <mat-input [placeholder]=\"searcPlaceholder\" trim [(value)]=\"searchText\" (keydown)=\"search($event)\"></mat-input>\r\n        </div>\r\n\r\n            <div class=\"mat-flat-tree-wapper\">\r\n                <mat-tree [dataSource]=\"dataSourceDisplay\" [treeControl]=\"treeControl\">\r\n                    <mat-tree-node [class.mat-tree-node-hidden]=\"hiddenNode(node)\" [class.mat-tree-node-hascheckbox]=\"checkbox\" [class.mat-tree-node-selected]=\"isNodeSelected(node)\" [class.mat-tree-node-disabled]=\"node.disabled || !node.selectable\" role=\"tree-node\" *matTreeNodeDef=\"let node\" matTreeNodePadding matTreeNodePaddingIndent=\"24\">\r\n                        <span class=\"mat-tree-toggle-placeholder\" *ngIf=\"!(node.expandable || !node.leaf)\"></span>\r\n                        <span matTreeNodeToggle class=\"mat-tree-toggle-button\" *ngIf=\"(node.expandable || !node.leaf) && !node._loading\" (click)=\"onExpand(node)\">\r\n                            <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                                <path *ngIf=\"!treeControl.isExpanded(node)\" d=\"M93.0426665 9.2511995h837.914667a83.791467 83.791467 0 0 1 83.791467 83.791467v837.914667a83.791467 83.791467 0 0 1-83.791467 83.791467H93.0426665a83.791467 83.791467 0 0 1-83.791467-83.791467V93.0426665a83.791467 83.791467 0 0 1 83.791467-83.791467z m377.06160073 460.85306773h-167.58293398a41.89573277 41.89573277 0 0 0 0 83.79146554h167.58293398v167.58293398a41.89573277 41.89573277 0 1 0 83.79146554 0v-167.58293398h167.58293398a41.89573277 41.89573277 0 1 0 0-83.79146554h-167.58293398v-167.58293398a41.89573277 41.89573277 0 0 0-83.79146554 0v167.58293398z\" fill=\"currentColor\"></path>\r\n                                <path *ngIf=\"treeControl.isExpanded(node)\" d=\"M85.333333 0h853.333334a85.333333 85.333333 0 0 1 85.333333 85.333333v853.333334a85.333333 85.333333 0 0 1-85.333333 85.333333H85.333333a85.333333 85.333333 0 0 1-85.333333-85.333333V85.333333a85.333333 85.333333 0 0 1 85.333333-85.333333z m213.333334 469.333333a42.666667 42.666667 0 0 0 0 85.333334h426.666666a42.666667 42.666667 0 1 0 0-85.333334h-426.666666z\" fill=\"currentColor\"></path>\r\n                            </svg>\r\n                        </span>\r\n                        <span class=\"mat-tree-loading\" *ngIf=\"node._loading\">\r\n                            <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                                <path fill=\"currentColor\" d=\"M541.09070222 2.63964445a29.12711111 29.12711111 0 0 0 0 58.18140444c232.6528 0 421.90620445 189.28981333 421.90620445 421.90620444a29.12711111 29.12711111 0 0 0 58.18140444 0c0-264.72903111-215.39498667-480.12401778-480.12401778-480.12401778z\"></path>\r\n                            </svg>\r\n                        </span>\r\n\r\n                        <mat-checkbox class=\"mat-tree-node-checkbox\" *ngIf=\"checkbox\" (change)=\"nodeClick(node)\" [checked]=\"isNodeSelected(node)\" [disabled]=\"node.disabled || !node.selectable\"></mat-checkbox>\r\n\r\n                        <div class=\"mat-tree-node-label\" (click)=\"!checkbox && nodeClick(node)\">\r\n                            <ng-template [ngTemplateOutlet]=\"nodeTemplate ? nodeTemplate : defaultTemplate\" [ngTemplateOutletContext]=\"{ $implicit: node }\"></ng-template>\r\n                        </div>\r\n                    </mat-tree-node>\r\n\r\n                </mat-tree>\r\n            </div>\r\n    </div>\r\n</ng-template>\r\n\r\n<!-- default node template -->\r\n<ng-template let-node #defaultTemplate>\r\n    <span [title]=\"node.view\">{{node.view}}</span>\r\n</ng-template>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                providers: [MAT_TREE_SELECT_VALUE_ACCESSOR, OverlayService],
                host: {
                    '[attr.role]': 'option',
                    '[class.mat-tree-select]': 'true',
                    '[class.cdk-focused]': '_opened',
                    '[class.mat-tree-select-disabled]': 'disabled',
                }
            },] }
];
MatTreeSelect.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: ViewContainerRef },
    { type: OverlayService }
];
MatTreeSelect.propDecorators = {
    customTrigger: [{ type: ContentChild, args: [MatTreeSelectTrigger,] }],
    matChange: [{ type: Output }],
    matFilter: [{ type: Output }],
    matOpened: [{ type: Output }],
    treeSelectContentTemplate: [{ type: ViewChild, args: ['treeSelectContentTemplate',] }],
    tabIndex: [{ type: Input }],
    showFilter: [{ type: Input }],
    placeholder: [{ type: Input }],
    searcPlaceholder: [{ type: Input }],
    name: [{ type: Input }],
    required: [{ type: Input }],
    reset: [{ type: Input }],
    opened: [{ type: Input }],
    disabled: [{ type: Input }]
};

class MatTreeSelectModule {
}
MatTreeSelectModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatInputModule, MatTreeModule, MatCheckboxModule, MatRippleModule],
                exports: [MatTreeSelect, MatTreeSelectTrigger, MatInputModule],
                declarations: [MatTreeSelect, MatTreeSelectTrigger]
            },] }
];

class MatListReactive {
    constructor(_fb, _cd, _reactiveService) {
        this._fb = _fb;
        this._cd = _cd;
        this._reactiveService = _reactiveService;
        this.formArray = [];
        this._reactiveService.afterPatchValue().subscribe(e => this.onPathValue(e));
    }
    get config() { return this._config; }
    set config(value) {
        this._config = value;
        this.setFormArray(this.config.defaultValue);
        this.setOperation();
    }
    get canAdd() { return this._canAdd; }
    set canAdd(value) {
        if (this._canAdd !== value) {
            this._canAdd = value;
            this._cd.markForCheck();
        }
    }
    get canDelete() { return this._canDelete; }
    set canDelete(value) {
        if (value !== this._canDelete) {
            this._canDelete = value;
            this._cd.markForCheck();
        }
    }
    get addText() { return this._addText || '添加'; }
    set addText(value) {
        if (value !== this._addText) {
            this._addText = value;
            this._cd.markForCheck();
        }
    }
    get deleteText() { return this._deleteText || '删除'; }
    set deleteText(value) {
        if (value !== this._deleteText) {
            this._deleteText = value;
            this._cd.markForCheck();
        }
    }
    setFormArray(value) {
        const config = value || [];
        this.formArray = config.map(item => Object.assign({ defaultValue: item }, this._config.config));
    }
    onPathValue(value) {
        const name = this.config.name;
        const listValue = MatUtils.getObjectValue(name, value) || [];
        this.setFormArray(listValue);
    }
    setOperation() {
        const operation = this.config.operation || {};
        this.addText = operation.addText;
        this.canDelete = operation.canDelete;
        this.deleteText = operation.deleteText;
        if (operation.canAdd !== undefined) {
            this.registerChangeEvent();
        }
    }
    registerChangeEvent() {
        if (!this._subscription) {
            this._subscription = this.rootFormGroup.valueChanges.pipe(startWith({}), debounceTime(100)).subscribe(event => {
                this.canAdd = MatUtils.executeBooleanValue(this.config.operation.canAdd, this.rootFormGroup.getRawValue());
            });
        }
    }
    add() {
        this.formArray.push(Object.assign({}, this._config.config));
    }
    remove(index) {
        this.formArray.splice(index, 1);
    }
    ngOnInit() { }
}
MatListReactive.decorators = [
    { type: Component, args: [{
                template: "<ul>\r\n\r\n  <li *ngFor=\"let item of formArray; index as index\" @fly>\r\n    <mat-reactive-layout [hideLabel]=\"true\" [config]=\"item\" [rootFormGroup]=\"rootFormGroup\" [parentFormGroup]=\"formControl\"> </mat-reactive-layout>\r\n    <span class=\"mat-list-reactive-remove\" *ngIf=\"canDelete\" (click)=\"remove(index)\">{{deleteText}}</span>\r\n  </li>\r\n\r\n  <li class=\"mat-list-reactive-add\" (click)=\"add()\" *ngIf=\"canAdd\">\r\n    <span class=\"mat-list-reactive-add-icon\"></span>{{addText}}\r\n  </li>\r\n\r\n</ul>\r\n",
                animations: [
                    trigger('fly', [transition(':leave', [animate(100, style({ height: '0px' }))])])
                ],
                host: {
                    '[class.mat-list-reactive]': 'true'
                }
            },] }
];
MatListReactive.ctorParameters = () => [
    { type: FormBuilder },
    { type: ChangeDetectorRef },
    { type: MatReactiveFormService }
];

class MatTableReactive {
    constructor(_fb, _cd, _reactiveService) {
        this._fb = _fb;
        this._cd = _cd;
        this._reactiveService = _reactiveService;
        this.formArray = [];
        this.header = [];
        this._reactiveService.afterPatchValue().subscribe(e => this.onPathValue(e));
    }
    get config() { return this._config; }
    set config(value) {
        this._config = value;
        this.setHeader();
        this.setOperation();
        this.setFormArray(this.config.defaultValue || []);
    }
    get canAdd() { return this._canAdd; }
    set canAdd(value) {
        if (this._canAdd !== value) {
            this._canAdd = value;
            this._cd.markForCheck();
        }
    }
    get canDelete() { return this._canDelete; }
    set canDelete(value) {
        if (value !== this._canDelete) {
            this._canDelete = value;
            this._cd.markForCheck();
        }
    }
    get addText() { return this._addText || '添加'; }
    set addText(value) {
        if (value !== this._addText) {
            this._addText = value;
            this._cd.markForCheck();
        }
    }
    get deleteText() { return this._deleteText || '删除'; }
    set deleteText(value) {
        if (value !== this._deleteText) {
            this._deleteText = value;
            this._cd.markForCheck();
        }
    }
    setFormArray(value) {
        const config = this._config.config;
        this.formArray = value.map((item, index) => {
            return config.map(ele => Object.assign({ defaultValue: item[ele.name] }, ele));
        });
        this._cd.markForCheck();
    }
    onPathValue(value) {
        const name = this.config.name;
        const listValue = MatUtils.getObjectValue(name, value) || [];
        this.setFormArray(listValue);
    }
    setHeader() {
        this.header = (this._config.config || []).map(item => item.label);
    }
    setOperation() {
        const operation = this.config.operation || {};
        this.addText = operation.addText;
        this.canDelete = operation.canDelete;
        this.deleteText = operation.deleteText;
        if (operation.canAdd !== undefined) {
            this.registerChangeEvent();
        }
    }
    registerChangeEvent() {
        if (!this._subscription) {
            this._subscription = this.rootFormGroup.valueChanges.pipe(startWith({}), debounceTime(100)).subscribe(event => {
                this.canAdd = MatUtils.executeBooleanValue(this.config.operation.canAdd, this.rootFormGroup.getRawValue());
            });
        }
    }
    getRelativeRoot(index) {
        if (!this.formControl.at(index)) {
            this.formControl.push(this._fb.group({}));
        }
        return this.formControl.at(index);
    }
    add() {
        this.formControl.push(this._fb.group({}));
        const config = this._config.config;
        this.formArray.push(config.map(item => Object.assign({}, item)));
    }
    remove(index) {
        this.formArray.splice(index, 1);
    }
}
MatTableReactive.decorators = [
    { type: Component, args: [{
                template: "<div class=\"mat-table-reactive-wapper\">\r\n    <mat-buttons class=\"mat-table-reactive-add\" [label]=\"addText\" (matClick)=\"add()\" type=\"fill\"></mat-buttons>\r\n    <table cellspacing=\"0\" cellpadding=\"0\">\r\n        <thead>\r\n            <th *ngFor=\"let item of header\">{{item}}</th>\r\n            <th *ngIf=\"canDelete\">\u64CD\u4F5C</th>\r\n        </thead>\r\n        <tbody>\r\n            <tr *ngFor=\"let row of formArray; index as rowIndex\">\r\n                <td *ngFor=\"let col of row;\">\r\n                    <mat-reactive-layout [hideLabel]=\"true\" [config]=\"col\" [rootFormGroup]=\"rootFormGroup\" [parentFormGroup]=\"getRelativeRoot(rowIndex)\"> </mat-reactive-layout>\r\n                </td>\r\n                <td *ngIf=\"canDelete\">\r\n                  <mat-buttons class=\"mat-table-reactive-remove\" [label]=\"deleteText\" type=\"text\" (matClick)=\"remove(rowIndex)\"></mat-buttons>\r\n                </td>\r\n            </tr>\r\n        </tbody>\r\n    </table>\r\n</div>",
                host: {
                    '[class.mat-table-reactive]': 'true'
                }
            },] }
];
MatTableReactive.ctorParameters = () => [
    { type: FormBuilder },
    { type: ChangeDetectorRef },
    { type: MatReactiveFormService }
];

class MatInputReactive extends MatReactiveFormControl {
}
MatInputReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-input \r\n  [formControl]=\"formControl\" \r\n  [maxlength]=\"maxlength\" \r\n  [trim]=\"trim\" \r\n  [placeholder]=\"placeholder\" \r\n  [after]=\"after\" \r\n  [before]=\"before\" ></mat-input>\r\n"
            },] }
];
class MatTextareaReactive extends MatReactiveFormControl {
}
MatTextareaReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-textarea \r\n  [formControl]=\"formControl\" \r\n  [maxlength]=\"maxlength\" \r\n  [trim]=\"trim\" \r\n  [showTextTip]=\"showTextTip\" \r\n  [placeholder]=\"placeholder\" \r\n></mat-textarea>\r\n"
            },] }
];
class MatImageReactive extends MatReactiveFormControl {
}
MatImageReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-image-upload \r\n  [formControl]=\"formControl\" \r\n  [multiple]=\"multiple\"  \r\n  [triggerText]=\"triggerText\"\r\n  [limit]=\"limit\" \r\n  [accept]=\"accept\" \r\n  [maxSize]=\"maxSize\" \r\n  [url]=\"url\" \r\n  [formData]=\"formData\"\r\n\r\n></mat-image-upload>"
            },] }
];
class MatFileReactive extends MatReactiveFormControl {
}
MatFileReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-file-upload [formControl]=\"formControl\" [multiple]=\"multiple\"  [triggerText]=\"triggerText\"\r\n[limit]=\"limit\" [accept]=\"accept\" [maxSize]=\"maxSize\" [url]=\"url\" [formData]=\"formData\"></mat-file-upload>\r\n"
            },] }
];
class MatDropdownReactive extends MatReactiveFormControl {
}
MatDropdownReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-dropdown \r\n  [formControl]=\"formControl\" \r\n  [placeholder]=\"placeholder\" \r\n  [direction]=\"direction\" \r\n  [multiple]=\"multiple\" \r\n  [dataSource]=\"dataSource\" \r\n  [disabledField]=\"disabledField\" \r\n  [viewField]=\"viewField\" \r\n  [valueField]=\"valueField\"\r\n  [compareWith]=\"compareWith\"\r\n  >\r\n\r\n</mat-dropdown>"
            },] }
];
class MatTimeReactive extends MatReactiveFormControl {
}
MatTimeReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-time \r\n  [formControl]=\"formControl\" \r\n  [placeholder]=\"placeholder\"\r\n  [maxTime]=\"maxTime\" \r\n  [minTime]=\"minTime\" \r\n></mat-time>"
            },] }
];
class MatDateReactive extends MatReactiveFormControl {
}
MatDateReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-date \r\n  [placeholder]=\"placeholder\" \r\n  [type]=\"type\" \r\n  [maxDate]=\"maxDate\" \r\n  [minDate]=\"minDate\" \r\n  [showTime]=\"showTime\"\r\n  [formControl]=\"formControl\"\r\n  \r\n  ></mat-date>\r\n"
            },] }
];
class MatNumberReactive extends MatReactiveFormControl {
}
MatNumberReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-number \r\n  [formControl]=\"formControl\"\r\n  [max]=\"max\" \r\n  [min]=\"min\"  \r\n  [placeholder]=\"placeholder\" \r\n  [type]=\"type\" \r\n  [precision]=\"precision\" \r\n  [step]=\"step\"\r\n  \r\n  ></mat-number>"
            },] }
];
class MatCheckboxReactive extends MatReactiveFormControl {
}
MatCheckboxReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-checkbox-list \r\n  [direction]=\"direction\" \r\n  [multiple]=\"multiple\" \r\n  [dataSource]=\"dataSource\" \r\n  [disabledField]=\"disabledField\" \r\n  [viewField]=\"viewField\" \r\n  [valueField]=\"valueField\"\r\n  [compareWith]=\"compareWith\"\r\n  [labelPosition]=\"labelPosition\"\r\n  [formControl]=\"formControl\"\r\n  ></mat-checkbox-list>"
            },] }
];
class MatRadioReactive extends MatReactiveFormControl {
}
MatRadioReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-radio-list \r\n  [formControl]=\"formControl\"\r\n  [direction]=\"direction\" \r\n  [dataSource]=\"dataSource\" \r\n  [disabledField]=\"disabledField\" \r\n  [viewField]=\"viewField\" \r\n  [valueField]=\"valueField\"\r\n  [compareWith]=\"compareWith\"\r\n  [labelPosition]=\"labelPosition\"\r\n  ></mat-radio-list>"
            },] }
];
class MatSelectButtonReactive extends MatReactiveFormControl {
}
MatSelectButtonReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-selectbutton \r\n  [formControl]=\"formControl\"\r\n  [disabledField]=\"disabledField\" \r\n  [viewField]=\"viewField\" \r\n  [valueField]=\"valueField\"  \r\n  [dataSource]=\"dataSource\"\r\n  [compareWith]=\"compareWith\"\r\n  [multiple]=\"multiple\"\r\n  [tick]=\"tick\"\r\n  [iconField]=\"iconField\"\r\n\r\n  \r\n  ></mat-selectbutton>\r\n"
            },] }
];
class MatToggleReactive extends MatReactiveFormControl {
}
MatToggleReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-slide-toggle [formControl]=\"formControl\"> </mat-slide-toggle>"
            },] }
];
class MatSliderReactive extends MatReactiveFormControl {
}
MatSliderReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-slider \r\n  [rule]=\"rule\" \r\n  [max]=\"max\" \r\n  [min]=\"min\" \r\n  [step]=\"step\" \r\n  [thumbLabel]=\"thumbLabel\" \r\n  [textInterval]=\"textInterval\" \r\n  [formControl]=\"formControl\" \r\n  [tickInterval]=\"tickInterval\">\r\n</mat-slider>"
            },] }
];
class MatTreeReactive extends MatReactiveFormControl {
}
MatTreeReactive.decorators = [
    { type: Component, args: [{
                template: "<mat-tree-select\r\n    [formControl]=\"formControl\"\r\n    [placeholder]=\"placeholder\"\r\n    [lazy]=\"lazy\"\r\n    [multiple]=\"multiple\"\r\n    [checkbox]=\"checkbox\" \r\n    [disabledField]=\"disabledField\" \r\n    [selectableField]=\"selectableField\" \r\n    [viewField]=\"viewField\" \r\n    [childrenField]=\"childrenField\" \r\n    [compareWith]=\"compareWith\" \r\n    [valueField]=\"valueField\" \r\n    [propagateUp]=\"propagateUp\" \r\n    [propagateDown]=\"propagateDown\"\r\n    [dataSource]=\"dataSource\"\r\n    (matLoadChildren)=\"loadChildren($event)\"\r\n>\r\n\r\n</mat-tree-select>"
            },] }
];
class MatTextReactive extends MatReactiveFormControl {
    ngAfterViewInit() {
        Promise.resolve().then(_ => this.displayValue = this.formControl.value);
    }
    get displayValue() { return this._displayValue; }
    set displayValue(value) {
        if (value !== this._displayValue) {
            this._displayValue = value;
            this.markForCheck();
        }
    }
}
MatTextReactive.decorators = [
    { type: Component, args: [{
                template: "<div class=\"mat-reactive-text-wapper\">\r\n  {{displayValue}}\r\n</div>",
                host: {
                    '[class.mat-reactive-text]': 'true'
                }
            },] }
];
class MatTitleReactive extends MatReactiveFormControl {
    get displayValue() { return this.config.defaultValue; }
}
MatTitleReactive.decorators = [
    { type: Component, args: [{
                template: "<div class=\"mat-reactive-title-wapper\">\r\n  {{displayValue}}\r\n</div>",
                host: { '[class.mat-reactive-title]': 'true' }
            },] }
];
class MatLineReactive extends MatReactiveFormControl {
}
MatLineReactive.decorators = [
    { type: Component, args: [{
                template: '',
                host: { '[class.mat-reactive-line]': 'true' }
            },] }
];
const MatReactiveModule = [
    MatInputModule,
    MatImageUploadModule,
    MatFileUploadModule,
    MatTextareaModule,
    MatDropdownModule,
    MatDateModule,
    MatInputNumberModule,
    MatCheckboxListModule,
    MatRadioListModule,
    MatSelectButtonModule,
    MatSlideToggleModule,
    MatSliderModule,
    MatSliderRuleModule,
    MatTreeSelectModule
];
function isFormComponent(componentName) {
    const WhichIsNotForm = ['title', 'line'];
    return !WhichIsNotForm.includes(componentName);
}
const MatReactiveFormComponentsMap = {
    input: MatInputReactive,
    image: MatImageReactive,
    file: MatFileReactive,
    textarea: MatTextareaReactive,
    dropdown: MatDropdownReactive,
    time: MatTimeReactive,
    date: MatDateReactive,
    number: MatNumberReactive,
    checkbox: MatCheckboxReactive,
    radio: MatRadioReactive,
    selectButton: MatSelectButtonReactive,
    toggle: MatToggleReactive,
    slider: MatSliderReactive,
    tree: MatTreeReactive,
    list: MatListReactive,
    table: MatTableReactive,
    text: MatTextReactive,
    title: MatTitleReactive,
    line: MatLineReactive,
};
const MatReactiveFormComponents = [
    MatInputReactive,
    MatImageReactive,
    MatFileReactive,
    MatTextareaReactive,
    MatDropdownReactive,
    MatTimeReactive,
    MatDateReactive,
    MatNumberReactive,
    MatCheckboxReactive,
    MatRadioReactive,
    MatSelectButtonReactive,
    MatToggleReactive,
    MatSliderReactive,
    MatTreeReactive,
    MatListReactive,
    MatTableReactive,
    MatTextReactive,
    MatTitleReactive,
    MatLineReactive,
];

class MatReactiveFormDesigner {
    constructor(_fb, _resolver, _cd, _rootForm, _defaultMessageConfig, _defaultErrorMessageStrategy) {
        this._fb = _fb;
        this._resolver = _resolver;
        this._cd = _cd;
        this._rootForm = _rootForm;
        this._defaultMessageConfig = _defaultMessageConfig;
        this._defaultErrorMessageStrategy = _defaultErrorMessageStrategy;
        this.fields = new MatReactiveDesignerField();
        /** Where is required. */
        this._required = false;
        /** Where is show the component. */
        this._hidden = false;
    }
    get config() { return this._config; }
    set config(value) {
        this._config = value;
        this.validators = this._config.validators;
        this.defaultValue = this._config.defaultValue;
    }
    get defaultValue() { return this._defaultValue; }
    set defaultValue(value) {
        this._defaultValue = value;
    }
    get label() { return this._label; }
    set label(value) {
        if (value !== this._label) {
            this._label = value;
            this._cd.markForCheck();
        }
    }
    get disabled() { return this._disabled; }
    set disabled(value) {
        if (value !== this._disabled) {
            this._disabled = value;
            if (this.formControl) {
                if (this._disabled) {
                    this.formControl.disable({ onlySelf: true, emitEvent: false });
                }
                else {
                    this.formControl.enable({ onlySelf: true, emitEvent: false });
                }
            }
        }
    }
    get required() { return this._required; }
    set required(value) {
        if (value !== this._required) {
            this._required = value;
            this._cd.markForCheck();
        }
    }
    get class() { return this._class; }
    set class(value) {
        if (value !== this._class) {
            this._class = value;
            this._cd.markForCheck();
        }
    }
    get style() { return this._style; }
    set style(value) {
        this._style = value;
        this._cd.markForCheck();
    }
    get describe() { return this._describe; }
    set describe(value) {
        if (value !== this._describe) {
            this._describe = value;
            this._cd.markForCheck();
        }
    }
    get hidden() { return this._hidden; }
    set hidden(value) {
        const newValue = coerceBooleanProperty(value);
        if (this._hidden !== newValue) {
            this._hidden = newValue;
            if (newValue) {
                this.removeComponent();
                this.removeControl();
            }
            else {
                this.addControl();
                this.addComponent();
            }
            this._cd.markForCheck();
        }
    }
    set validators(value) {
        this._validators = [];
        if (value && Object.keys(value).length) {
            Object.keys(value).forEach(key => {
                if (MatReactiveFormValidatorFunctions[key]) {
                    this._validators.push(MatReactiveFormValidatorFunctions[key](value[key]));
                    if (this.formControl) {
                        this.formControl.setValidators(this._validators);
                    }
                }
            });
        }
    }
    ngOnInit() {
        if (isFormComponent(this._config.component)) {
            this.addControl();
            this.setDesignerConfig(this.rootFormGroup.value);
            this.rootFormGroup.valueChanges.pipe(debounceTime(100)).subscribe(e => {
                this.setDesignerConfig(e);
                this.formControl.updateValueAndValidity({ emitEvent: false });
            });
        }
    }
    ngOnDestroy() {
        this.removeComponent();
        this.removeControl();
    }
    ngAfterViewInit() {
        Promise.resolve().then(() => this.addComponent());
    }
    markForCheck() {
        this._cd.markForCheck();
    }
    setDesignerConfig(e) {
        this.fields.keys().forEach(key => {
            if (this.fields[key] && this[this.fields[key]]) {
                this[key] = this[this.fields[key]](this.config[key], e);
            }
        });
        this.setRequired(e);
    }
    setRequired(formValue) {
        const validators = this.config.validators;
        if (validators && validators.required) {
            const validator = validators.required;
            if (!validator.expression) {
                this.required = true;
            }
            else {
                if (typeof validator.expression === 'function') {
                    this.required = validator.expression(formValue);
                }
                else {
                    this.required = !!MatUtils.functionCreator(validator.expression)(formValue);
                }
            }
        }
        else {
            this.required = false;
        }
    }
    /** Where the item config is gruopform. */
    isGroup() {
        return this.config.name.split('.').length > 1;
    }
    /** Where the item config is arrayForm. */
    isArrayControl() {
        return this.config.component === 'list' || this.config.component === 'table';
    }
    /** Add a new control on init when config is form item. */
    addControl() {
        const names = (this.config.name || '').split('.');
        let name = this.config.name;
        let parent = this.parentFormGroup;
        if (names.length > 1) {
            for (let i = 0; i < names.length - 1; i++) {
                parent = this.getFormGroup(names[i], parent);
            }
            name = names[names.length - 1];
        }
        this.formControl = this.isArrayControl() ? this._fb.array([]) : this._fb.control({ value: this.defaultValue, disabled: this.disabled }, this._validators);
        if (parent instanceof FormArray) {
            parent.push(this.formControl);
        }
        else {
            parent.addControl(name, this.formControl);
        }
    }
    removeControlFromArray(parent, control) {
        const index = parent.controls.findIndex(item => item === control);
        parent.removeAt(index);
    }
    removeControlFromGroup(parent, control) {
        if (parent) {
            for (const formControlName in parent.controls) {
                if (parent.controls[formControlName] === control) {
                    parent.removeControl(formControlName);
                    if (!Object.keys(parent.controls).length) {
                        if (parent.parent instanceof FormArray) {
                            this.removeControlFromArray(parent.parent, parent);
                        }
                        else {
                            this.removeControlFromGroup(parent.parent, parent);
                        }
                    }
                    break;
                }
            }
        }
    }
    removeControl() {
        if (this.formControl) {
            const parent = this.formControl.parent;
            if (parent instanceof FormArray) {
                this.removeControlFromArray(parent, this.formControl);
            }
            else {
                this.removeControlFromGroup(parent, this.formControl);
            }
        }
    }
    getFormControlName(control) {
        let controlName = '';
        if (control.parent) {
            for (const formControlName in control.parent.controls) {
                if (control.parent.controls[formControlName] == control) {
                    controlName = formControlName;
                    break;
                }
            }
        }
        return controlName;
    }
    getFormGroup(name = this.config.name, parent = this.parentFormGroup) {
        if (!parent.get(name)) {
            parent.addControl(name, this._fb.group({}));
        }
        return parent.get(name);
    }
    /** Add component. */
    addComponent() {
        const component = MatReactiveFormComponentsMap[this.config.component];
        const factory = this._resolver.resolveComponentFactory(component);
        this.comnponentInstance = this.container.createComponent(factory).instance;
        this.comnponentInstance.rootFormGroup = this.rootFormGroup;
        this.comnponentInstance.formControl = this.formControl;
        this.comnponentInstance.config = this.config;
    }
    /** Remove component. */
    removeComponent() {
        if (this.container) {
            this.container.clear();
        }
        this.comnponentInstance = null;
    }
    /** Execute function or value to boolean. */
    executeBooleanValue(value, params) {
        if (typeof value === 'boolean') {
            return value;
        }
        else if (typeof value === 'function') {
            return value(params);
        }
        else if (typeof value === 'string') {
            if (MatUtils.isStringFunction(value)) {
                return MatUtils.functionCreator(value)(params);
            }
        }
    }
    /** Execute function or value to string. */
    executeStringValue(value, params) {
        if (typeof value === 'string') {
            if (MatUtils.isStringFunction(value)) {
                return MatUtils.functionCreator(value)(params);
            }
            else {
                return value;
            }
        }
        else if (typeof value === 'function') {
            return value(params);
        }
        else {
            return value;
        }
    }
    /** Execute function or value to object. */
    executeObjectValue(value, params) {
        if (typeof value === 'string' && MatUtils.isStringFunction(value)) {
            return MatUtils.functionCreator(value)(params);
        }
        else if (typeof value === 'function') {
            return value(params);
        }
        else {
            return value;
        }
    }
}
MatReactiveFormDesigner.ctorParameters = () => [
    { type: FormBuilder },
    { type: ComponentFactoryResolver },
    { type: ChangeDetectorRef },
    { type: FormGroupDirective, decorators: [{ type: Optional }] },
    { type: MatReactiveFormMessageConfig, decorators: [{ type: Inject, args: [MAT_REACTIVE_FORM_MESSAGE_CONFIG,] }] },
    { type: MatReactiveFormErrorMessageStrategy, decorators: [{ type: Inject, args: [MAT_REACTIVE_FORM_ERROR_MESSAGE_STRATEGY,] }] }
];
MatReactiveFormDesigner.propDecorators = {
    container: [{ type: ViewChild, args: ['container', { read: ViewContainerRef, static: false },] }],
    config: [{ type: Input }],
    rootFormGroup: [{ type: Input }],
    parentFormGroup: [{ type: Input }]
};

class MatReactiveLayout extends MatReactiveFormDesigner {
    constructor() {
        super(...arguments);
        this._hideLabel = false;
    }
    get hideLabel() { return this._hideLabel; }
    set hideLabel(value) {
        if (value !== this._hideLabel) {
            this._hideLabel = value;
            this.markForCheck();
        }
    }
    get errorMessage() {
        if (this.formControl && this.formControl.errors && this._checkErrorMessageStrategy()) {
            const keys = Object.keys(this.formControl.errors) || [];
            const key = keys[0];
            return this.formControl.errors[key] || this._defaultMessageConfig[key];
        }
    }
    log() {
        console.log(this._rootForm);
    }
    isSubmit() {
        return this._rootForm.submitted;
    }
    _checkErrorMessageStrategy() {
        let isBind = true;
        switch (this._defaultErrorMessageStrategy) {
            case MatReactiveFormErrorMessageStrategy.OnSubmitted:
                isBind = this.isSubmit();
                break;
            case MatReactiveFormErrorMessageStrategy.OnDirty:
                isBind = this.formControl.dirty;
                break;
            case MatReactiveFormErrorMessageStrategy.OnTouched:
                isBind = this.formControl.touched;
                break;
            case MatReactiveFormErrorMessageStrategy.OnDirtyOrTouched:
                isBind = this.formControl.dirty || this.formControl.touched;
                break;
            case MatReactiveFormErrorMessageStrategy.OnDirtyOrSubmitted:
                isBind = this.formControl.dirty || this.isSubmit();
                break;
            case MatReactiveFormErrorMessageStrategy.OnTouchedOrSubmitted:
                isBind = this.formControl.touched || this.isSubmit();
                break;
            default:
                isBind = true;
        }
        return isBind;
    }
}
MatReactiveLayout.decorators = [
    { type: Component, args: [{
                selector: 'mat-reactive-layout',
                template: "<div class=\"mat-reactive-layout-label\" *ngIf=\"!hideLabel\">\r\n  <span class=\"mat-reactive-layout-label-text\" (click)=\"log()\">\r\n    {{label || '\\u00A0'}}   \r\n    <span class=\"mat-reactive-layout-required\" *ngIf=\"required\">*</span>\r\n  </span>\r\n</div>\r\n\r\n<div class=\"mat-reactive-layout-component\">\r\n  <ng-template #container></ng-template>\r\n  <div class=\"mat-reactive-layout-error\" *ngIf=\"errorMessage\" [matTooltip]=\"errorMessage\"> ! </div>\r\n  <div class=\"mat-reactive-layout-describe\" *ngIf=\"describe\" [matTooltip]=\"describe\"> \uFF1F </div>\r\n</div>",
                host: {
                    '[class]': 'class + " " + config.component',
                    '[style]': 'style',
                    '[class.mat-reactive-layout]': 'true',
                    '[class.mat-reactive-layout-hidden]': 'hidden',
                }
            },] }
];
MatReactiveLayout.propDecorators = {
    hideLabel: [{ type: Input }]
};

class MatReactiveFormModule {
}
MatReactiveFormModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    ReactiveFormsModule,
                    MatTooltipModule,
                    MatButtonsModule,
                    ...MatReactiveModule
                ],
                declarations: [
                    MatReactiveForm,
                    MatReactiveLayout,
                    ...MatReactiveFormComponents
                ],
                exports: [
                    MatReactiveForm,
                    MatReactiveLayout
                ],
                entryComponents: MatReactiveFormComponents
            },] }
];

class MatReactiveFormOperationConfig {
}
class MatReactiveFormUiConfig {
}
class MatReactiveFormControlConfig extends MatReactiveFormUiConfig {
}
class MatReactiveFormConfig extends MatReactiveFormControlConfig {
}

class MatFieldLabel {
}
MatFieldLabel.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line: directive-selector
                selector: 'mat-field-label',
                host: {
                    '[class.mat-field-label-text]': 'true'
                }
            },] }
];
class MatFieldWapper {
    constructor(_ele, ngForm, _defaultErrorMessageStrategy) {
        this._ele = _ele;
        this.ngForm = ngForm;
        this._defaultErrorMessageStrategy = _defaultErrorMessageStrategy;
        this.onSubmitted = new EventEmitter();
        this.messageStrategy = this._defaultErrorMessageStrategy || MatReactiveFormErrorMessageStrategy.OnTouchedOrSubmitted;
        this.ngForm.ngSubmit.subscribe(e => console.log(e));
    }
    get messageStrategy() { return this._messageStrategy; }
    set messageStrategy(value) {
        if (value !== this._messageStrategy) {
            this._messageStrategy = 'mat-form-error-strategy-' + value;
        }
    }
    get submitted() {
        return this.ngForm && this.ngForm.submitted;
    }
    onKeyDown(event) {
        if (event.key === 'Enter') {
            return false;
        }
    }
    submit() {
    }
    onSubmit(e) {
        console.log(this.ngForm);
        if (this.invalid()) {
            this.goToError();
        }
        else {
            this.onSubmitted.emit(this.ngForm.value);
        }
    }
    /******** Where the form is invalid. ********/
    invalid() {
        return this.ngForm && this.ngForm.invalid;
    }
    /******** Go to error element on submitted. ********/
    goToError() {
        if (this.invalid()) {
            const errorElement = this._ele.nativeElement.getElementsByClassName('ng-invalid');
            if (errorElement && errorElement[0]) {
                try {
                    errorElement[0].scrollIntoView({ behavior: 'smooth', block: 'start', inline: 'nearest' });
                }
                catch (error) {
                    console.error('Form on submit go to error failed!');
                }
            }
        }
    }
    reset(value) {
        this.ngForm.resetForm(value);
    }
}
MatFieldWapper.decorators = [
    { type: Directive, args: [{
                selector: '[matFieldWapper]',
                host: {
                    '[class.mat-field-wapper]': 'true',
                    '[class]': 'messageStrategy',
                    '[class.mat-form-submitted]': 'submitted',
                    '(keydown)': 'onKeyDown($event)'
                }
            },] }
];
MatFieldWapper.ctorParameters = () => [
    { type: ElementRef },
    { type: NgForm, decorators: [{ type: Optional }] },
    { type: MatReactiveFormErrorMessageStrategy, decorators: [{ type: Inject, args: [MAT_REACTIVE_FORM_ERROR_MESSAGE_STRATEGY,] }] }
];
MatFieldWapper.propDecorators = {
    onSubmitted: [{ type: Output }]
};
class MatField {
    constructor(_cd, _parentForm, _defaultErrorMessageStrategy, _defaultMessageConfig) {
        this._cd = _cd;
        this._parentForm = _parentForm;
        this._defaultErrorMessageStrategy = _defaultErrorMessageStrategy;
        this._defaultMessageConfig = _defaultMessageConfig;
        this._hideLabel = false;
    }
    isRequired() {
        return this.ngControl && this.ngControl.validator && this.ngControl['_rawValidators'].some(item => item.required);
    }
    get label() { return this._label; }
    set label(value) {
        if (value !== this._label) {
            this._label = value;
            this._cd.markForCheck();
        }
    }
    get describe() { return this._describe; }
    set describe(value) {
        if (value !== this._describe) {
            this._describe = value;
            this._cd.markForCheck();
        }
    }
    get hideLabel() { return this._hideLabel; }
    set hideLabel(value) {
        if (value !== this._hideLabel) {
            this._hideLabel = value;
            this._cd.markForCheck();
        }
    }
    get errorMessage() {
        if (this.ngControl && this.ngControl.errors && this._checkErrorMessageStrategy()) {
            const keys = Object.keys(this.ngControl.errors) || [];
            const key = keys[0];
            return typeof this.ngControl.errors[key] === 'string' ? this.ngControl.errors[key] : this._defaultMessageConfig[key];
        }
    }
    isSubmit() {
        return this._parentForm && this._parentForm.submitted;
    }
    _checkErrorMessageStrategy() {
        let isBind = true;
        switch (this._defaultErrorMessageStrategy) {
            case MatReactiveFormErrorMessageStrategy.OnSubmitted:
                isBind = this.isSubmit();
                break;
            case MatReactiveFormErrorMessageStrategy.OnDirty:
                isBind = this.ngControl.dirty;
                break;
            case MatReactiveFormErrorMessageStrategy.OnTouched:
                isBind = this.ngControl.touched;
                break;
            case MatReactiveFormErrorMessageStrategy.OnDirtyOrTouched:
                isBind = this.ngControl.dirty || this.ngControl.touched;
                break;
            case MatReactiveFormErrorMessageStrategy.OnDirtyOrSubmitted:
                isBind = this.ngControl.dirty || this.isSubmit();
                break;
            case MatReactiveFormErrorMessageStrategy.OnTouchedOrSubmitted:
                isBind = this.ngControl.touched || this.isSubmit();
                break;
            default:
                isBind = true;
        }
        return isBind;
    }
    ngAfterViewInit() {
    }
    ngAfterContentInit() {
    }
    ngOnDestroy() {
    }
}
MatField.decorators = [
    { type: Component, args: [{
                selector: 'mat-field',
                template: "<div class=\"mat-field-label\">\r\n  <span class=\"mat-field-label-wapper\">\r\n    <ng-container *ngIf=\"!labelEle\"> {{label || '\\u00A0'}} </ng-container>\r\n    <ng-content *ngIf=\"labelEle\" select=\"mat-field-label\"></ng-content>\r\n    <span class=\"mat-field-required\">*</span>\r\n  </span>\r\n</div>\r\n<div class=\"mat-field-content\">\r\n  <div class=\"mat-field-content-wapper\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n  <div class=\"mat-field-error\" *ngIf=\"errorMessage\" [matTooltip]=\"errorMessage\"> ! </div>\r\n  <div class=\"mat-field-describe\" *ngIf=\"describe\" [matTooltip]=\"describe\" > \uFF1F </div>\r\n</div>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.Default,
                host: {
                    '[class.mat-field]': 'true'
                }
            },] }
];
MatField.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: NgForm, decorators: [{ type: Optional }] },
    { type: MatReactiveFormErrorMessageStrategy, decorators: [{ type: Inject, args: [MAT_REACTIVE_FORM_ERROR_MESSAGE_STRATEGY,] }] },
    { type: MatReactiveFormMessageConfig, decorators: [{ type: Inject, args: [MAT_REACTIVE_FORM_MESSAGE_CONFIG,] }] }
];
MatField.propDecorators = {
    ngControl: [{ type: ContentChild, args: [NgControl, { static: true },] }],
    labelEle: [{ type: ContentChild, args: [MatFieldLabel,] }],
    label: [{ type: Input }],
    describe: [{ type: Input }],
    hideLabel: [{ type: Input }]
};

class MatFieldModule {
}
MatFieldModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MatTooltipModule,
                    MatButtonsModule,
                    FormsModule
                ],
                declarations: [
                    MatField,
                    MatFieldLabel,
                    MatFieldWapper
                ],
                exports: [
                    MatField,
                    MatFieldWapper,
                    MatFieldLabel,
                ],
            },] }
];

const MAT_IMAGE_ZOOM_SCALE = 2.5;
class MatImageZoomDirective {
    constructor(_sanitizer, _el, _renderer, _overlay, _viewContainerRef) {
        this._sanitizer = _sanitizer;
        this._el = _el;
        this._renderer = _renderer;
        this._overlay = _overlay;
        this._viewContainerRef = _viewContainerRef;
        this._ele = this._el.nativeElement;
    }
    /** The number of scale. */
    set scale(value) {
        this._scale = coerceNumberProperty(value) || MAT_IMAGE_ZOOM_SCALE;
    }
    get scale() {
        return this._scale || MAT_IMAGE_ZOOM_SCALE;
    }
    set largeSrc(value) {
        if (this._largeSrc !== value) {
            this._largeSrc = value;
        }
    }
    get largeSrc() {
        return this._largeSrc;
    }
    /** Add event listener on mousemove */
    _onMouseMove(event) {
        if (!this._isLoaded) {
            return;
        }
        const bounds = this._ele.getBoundingClientRect();
        const leftMin = bounds.x;
        const moveWidth = this.zoomWindowWidth / this.scale;
        const moveHeight = this.zoomWindowHeight / this.scale;
        const leftMax = bounds.x + bounds.width - moveWidth;
        const topMin = bounds.y;
        const topMax = bounds.y + bounds.height - moveHeight;
        let left = event.clientX - moveWidth / 2;
        let top = event.clientY - moveHeight / 2;
        left = Math.min(Math.max(left, leftMin), leftMax);
        top = Math.min(Math.max(top, topMin), topMax);
        this._blockElement.style.left = left + 'px';
        this._blockElement.style.top = top + 'px';
        this._zoomImageElement.style.backgroundPosition = `-${(left - leftMin) * this.scale}px -${(top - topMin) * this.scale}px`;
    }
    /** Add event listener on mouseover. */
    _onMouseOver(event) {
        if (!this._isLoaded) {
            return;
        }
        this._blockElement.style.display = 'block';
        this._openZoomImage();
    }
    /** Add event listener on mouseout. */
    _onMouseOut(event) {
        if (!this._isLoaded) {
            return;
        }
        this._blockElement.style.display = 'none';
        this._hideZoomImage();
    }
    /** Add event listener on image load. */
    _onLoad(event) {
        this._isLoaded = true;
        const bounds = this._ele.getBoundingClientRect();
        this.zoomWindowWidth = this.zoomWindowWidth || bounds.width;
        this.zoomWindowHeight = this.zoomWindowHeight || bounds.height;
        this._resetScale(bounds);
        this._addMoveBlock();
        this._addZoomImage();
    }
    _addMoveBlock() {
        this._blockElement = this._renderer.createElement('div');
        this._blockElement.setAttribute('style', `display: none; width: ${this.zoomWindowWidth / this.scale}px; height: ${this.zoomWindowHeight / this.scale}px`);
        this._blockElement.setAttribute('class', 'mat-image-zoom-block');
        this._renderer.appendChild(document.body, this._blockElement);
    }
    _addZoomImage() {
        const zoomImgSrc = this.largeSrc || this._ele.getAttribute('src');
        const bounds = this._ele.getBoundingClientRect();
        this._zoomImageElement = this._renderer.createElement('div');
        this._zoomImageElement.setAttribute('style', `
        width: ${this.zoomWindowWidth}px;
        height: ${this.zoomWindowHeight}px;
        background-image: url(${zoomImgSrc});
        display: none;
        background-size: ${bounds.width * this.scale}px ${bounds.height * this.scale}px;
        `);
        this._zoomImageElement.setAttribute('class', 'mat-image-zoom-window');
        this._renderer.appendChild(document.body, this._zoomImageElement);
    }
    _resetScale(bounds) {
        const maxWidth = bounds.width;
        const maxHeight = bounds.height;
        const blockWidth = this.zoomWindowWidth / this.scale;
        const blockHeight = this.zoomWindowHeight / this.scale;
        const isTooWidth = blockWidth > maxWidth;
        const isTooHeight = blockHeight > maxHeight;
        if (isTooWidth || isTooHeight) {
            this._scale = (Math.max(blockWidth / maxWidth, blockHeight / maxHeight)) * this.scale;
        }
    }
    _setHostStyle() {
        this._ele.style.cursor = 'move';
        this._ele.style.userSelect = 'none';
        this._ele.style['-webkit-user-drag'] = 'none';
    }
    _openZoomImage() {
        const portal = new DomPortal(this._zoomImageElement);
        this._overlay.close();
        this._overlay.open(this._el, portal, {
            withViewportMargin: 0,
            hasBackdrop: false,
            position: 'RT',
            offsetY: 0,
            offsetX: 8
        });
        this._zoomImageElement.style.display = 'block';
    }
    _hideZoomImage() {
        this._overlay.close();
        this._zoomImageElement.style.display = 'none';
    }
    ngOnInit() {
        this._setHostStyle();
    }
    ngOnDestroy() {
    }
}
MatImageZoomDirective.decorators = [
    { type: Directive, args: [{
                selector: '[matImageZoom]',
                exportAs: 'matImageZoom',
                providers: [OverlayService]
            },] }
];
MatImageZoomDirective.ctorParameters = () => [
    { type: DomSanitizer },
    { type: ElementRef },
    { type: Renderer2 },
    { type: OverlayService },
    { type: ViewContainerRef }
];
MatImageZoomDirective.propDecorators = {
    zoomWindowWidth: [{ type: Input, args: ['matImageZoomWindowWidth',] }],
    zoomWindowHeight: [{ type: Input, args: ['matImageZoomWindowHeight',] }],
    scale: [{ type: Input, args: ['matImageZoomScale',] }],
    largeSrc: [{ type: Input, args: ['matImageZoom',] }],
    _onMouseMove: [{ type: HostListener, args: ['mousemove', ['$event'],] }],
    _onMouseOver: [{ type: HostListener, args: ['mouseover', ['$event'],] }],
    _onMouseOut: [{ type: HostListener, args: ['mouseout', ['$event'],] }],
    _onLoad: [{ type: HostListener, args: ['load', ['$event'],] }]
};

class MatImageZoomModule {
}
MatImageZoomModule.decorators = [
    { type: NgModule, args: [{
                imports: [],
                exports: [MatImageZoomDirective],
                declarations: [MatImageZoomDirective]
            },] }
];

class MatModalComponent {
    constructor(modalRef, data) {
        this.modalRef = modalRef;
        this.data = data;
    }
}
MatModalComponent.decorators = [
    { type: Directive }
];
MatModalComponent.ctorParameters = () => [
    { type: MatDialogRef },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
];
class MatConfirmContainer extends MatModalComponent {
    constructor() {
        super(...arguments);
        this.title = '提示';
        this.accept = '确定';
        this.reject = '取消';
        this.closeable = true;
    }
    ngOnInit() {
        this.title = this.data.title;
        this.content = this.data.content;
        this.accept = this.data.accept;
        this.reject = this.data.reject;
        this.closeable = this.data.closeable;
    }
    close(result) {
        this.modalRef.close(result);
    }
}
MatConfirmContainer.decorators = [
    { type: Component, args: [{
                selector: 'mat-confirm-container',
                template: "<mat-modal-title>\r\n  {{title}} &nbsp;\r\n  <mat-modal-close *ngIf=\"closeable\"></mat-modal-close>\r\n</mat-modal-title>\r\n<mat-modal-content> {{content}} </mat-modal-content>\r\n<mat-modal-actions *ngIf=\"accept || reject\" >\r\n  <mat-buttons (matClick)=\"close(false)\" *ngIf=\"reject\" type=\"default\" [label]=\"reject\"></mat-buttons>\r\n  <mat-buttons (matClick)=\"close(true)\" *ngIf=\"accept\" type=\"fill\" [label]=\"accept\"></mat-buttons>\r\n</mat-modal-actions>\r\n",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.Default,
                host: {
                    'class': 'mat-modal-container mat-confirm-container',
                }
            },] }
];
class MatPromptContainer extends MatModalComponent {
    constructor() {
        super(...arguments);
        this.title = '提示';
        this.accept = '确定';
        this.reject = '取消';
        this.closeable = true;
    }
    ngOnInit() {
        this.title = this.data.title;
        this.content = this.data.content;
        this.accept = this.data.accept;
        this.reject = this.data.reject;
        this.closeable = this.data.closeable;
        this.value = this.data.default || '';
        this.placeholder = this.data.placeholder;
    }
    close(result) {
        this.modalRef.close(result);
    }
}
MatPromptContainer.decorators = [
    { type: Component, args: [{
                selector: 'mat-prompt-container',
                template: "<mat-modal-title>\r\n  {{title}} &nbsp;\r\n  <mat-modal-close *ngIf=\"closeable\"></mat-modal-close>\r\n</mat-modal-title>\r\n<mat-modal-content> \r\n  <mat-input style=\"width: 100%;\" [(value)]=\"value\" [placeholder]=\"placeholder\"></mat-input>\r\n</mat-modal-content>\r\n<mat-modal-actions>\r\n  <mat-buttons (matClick)=\"close(false)\" *ngIf=\"reject\" type=\"default\" [label]=\"reject\"></mat-buttons>\r\n  <mat-buttons (matClick)=\"close(value)\" *ngIf=\"accept\" type=\"fill\" [label]=\"accept\"></mat-buttons>\r\n</mat-modal-actions>\r\n",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.Default,
                host: {
                    'class': 'mat-modal-container mat-prompt-container',
                }
            },] }
];

class MatModalClose {
    constructor(modalRef, _elementRef, _dialog) {
        this.modalRef = modalRef;
        this._elementRef = _elementRef;
        this._dialog = _dialog;
    }
    ngOnInit() {
        if (!this.modalRef) {
            this.modalRef = getClosestDialog(this._elementRef, this._dialog.openDialogs);
        }
    }
    onClick() {
        this.modalRef.close(this.modalResult);
    }
}
MatModalClose.decorators = [
    { type: Directive, args: [{
                selector: '[mat-modal-close], mat-modal-close, [matModalClose]',
                exportAs: 'matModalClose',
                host: {
                    '(click)': 'onClick()',
                    'class': 'mat-modal-close',
                }
            },] }
];
MatModalClose.ctorParameters = () => [
    { type: MatDialogRef, decorators: [{ type: Optional }] },
    { type: ElementRef },
    { type: MatDialog }
];
MatModalClose.propDecorators = {
    modalResult: [{ type: Input, args: ['mat-modal-close',] }],
    _matModalClose: [{ type: Input, args: ['matModalClose',] }]
};
class MatModalTitle {
}
MatModalTitle.decorators = [
    { type: Directive, args: [{
                selector: '[mat-modal-title], mat-modal-title, [matModalTitle]',
                exportAs: 'matModalTitle',
                host: {
                    'class': 'mat-modal-title',
                },
            },] }
];
class MatModalContent {
}
MatModalContent.decorators = [
    { type: Directive, args: [{
                selector: `[mat-modal-content], mat-modal-content, [matModalContent]`,
                host: { 'class': 'mat-modal-content' }
            },] }
];
class MatModalActions {
}
MatModalActions.decorators = [
    { type: Directive, args: [{
                selector: `[mat-modal-actions], mat-modal-actions, [matModalActions]`,
                host: { 'class': 'mat-modal-actions' }
            },] }
];
function getClosestDialog(element, openDialogs) {
    let parent = element.nativeElement.parentElement;
    while (parent && !parent.classList.contains('mat-dialog-container')) {
        parent = parent.parentElement;
    }
    return parent ? openDialogs.find(dialog => dialog.id === parent.id) : null;
}

class MatModalModule {
}
MatModalModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MatCommonModule,
                    MatDialogModule,
                    MatButtonsModule,
                    MatInputModule,
                ],
                exports: [MatConfirmContainer, MatPromptContainer, MatModalActions, MatModalClose, MatModalContent, MatModalTitle],
                declarations: [MatConfirmContainer, MatPromptContainer, MatModalActions, MatModalClose, MatModalContent, MatModalTitle],
                entryComponents: [MatConfirmContainer, MatPromptContainer],
            },] }
];

class MatConfirmData {
    constructor() {
        this.title = '提示';
        this.accept = '确定';
        this.reject = '取消';
        this.closeable = true;
    }
}
class MatPromptData extends MatConfirmData {
}
class MatModal {
    constructor(_dialog) {
        this._dialog = _dialog;
    }
    confirm(data, config = {}) {
        return this._dialog.open(MatConfirmContainer, Object.assign(Object.assign({}, config), { width: '430px', height: '230px', data: Object.assign(Object.assign({}, new MatConfirmData()), data), autoFocus: false }));
    }
    prompt(data, config = {}) {
        return this._dialog.open(MatPromptContainer, Object.assign(Object.assign({}, config), { width: '430px', height: '230px', data: Object.assign(Object.assign({}, new MatPromptData()), data), autoFocus: true }));
    }
    dialog(componentOrTemplateRef, config) {
        return this._dialog.open(componentOrTemplateRef, config);
    }
    full(componentOrTemplateRef, config = {}) {
        return this._dialog.open(componentOrTemplateRef, Object.assign(Object.assign({}, config), { maxWidth: '100vw', maxHeight: '100vh', height: '100vh', width: '100vw' }));
    }
    open(componentOrTemplateRef, config) {
        return this._dialog.open(componentOrTemplateRef, config);
    }
    closeAll() {
        this._dialog.closeAll();
    }
    afterAllClosed() {
        return this._dialog.afterAllClosed;
    }
    getModalById(id) {
        return this._dialog.getDialogById(id);
    }
    ngOnDestroy() {
    }
}
MatModal.ɵprov = ɵɵdefineInjectable({ factory: function MatModal_Factory() { return new MatModal(ɵɵinject(MatDialog)); }, token: MatModal, providedIn: MatModalModule });
MatModal.decorators = [
    { type: Injectable, args: [{ providedIn: MatModalModule },] }
];
MatModal.ctorParameters = () => [
    { type: MatDialog }
];

/*
 * @Author: your name
 * @Date: 2020-11-26 11:45:40
 * @LastEditTime: 2020-11-26 13:55:33
 * @LastEditors: your name
 * @Description: In User Settings Edit
 * @FilePath: \ng-document\projects\mat-ng\src\modal\public-api.ts
 */

class MatSideConfig {
    constructor() {
        /** Custom class for the overlay pane. */
        this.panelClass = '';
        /** Whether the dialog has a backdrop. */
        this.hasBackdrop = true;
        /** Custom class for the backdrop. */
        this.backdropClass = '';
        /** Width of the dialog. */
        this.width = '';
        /** Height of the dialog. */
        this.height = '';
        /** Max-width of the dialog. If a number is provided, assumes pixel units. Defaults to 80vw. */
        this.maxWidth = '100vw';
        /** Max-height of the dialog. If a number is provided, assumes pixel units. */
        this.maxHeight = '100vh';
        this.position = 'RT';
        /** Data being injected into the child component. */
        this.data = null;
        this.closeOnNavigation = true;
        /** Whether the user can use escape or clicking on the backdrop to close the modal. */
        this.disableClose = false;
    }
}

const matSideAnimations = {
    sideContainer: trigger('sideContainer', [
        state('void, exit', style({
            'box-shadow': 'none',
            'visibility': 'hidden',
        })),
        state('enter', style({
            'transform': 'none',
            'visibility': 'visible',
        })),
        transition('* => enter', animate('150ms cubic-bezier(0, 0, 0.2, 1)')),
        transition('* => void, * => exit', animate('75ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
    ])
};

function throwMatSideContentAlreadyAttachedError() {
    throw Error('Attempting to attach side content after content is already attached');
}
class MatSideContainer extends BasePortalOutlet {
    constructor(_elementRef, _cd, _config) {
        super();
        this._elementRef = _elementRef;
        this._cd = _cd;
        this._config = _config;
        /** State of the side animation. */
        this._state = 'enter';
        /** Emits when an animation state changes. */
        this._animationStateChanged = new EventEmitter();
        this._enableAnimations = false;
    }
    /**
     * Attach a ComponentPortal as content to this side container.
     * @param portal Portal to be attached as the side content.
     */
    attachComponentPortal(portal) {
        if (this._portalOutlet.hasAttached()) {
            throwMatSideContentAlreadyAttachedError();
        }
        return this._portalOutlet.attachComponentPortal(portal);
    }
    /**
     * Attach a TemplatePortal as content to this side container.
     * @param portal Portal to be attached as the side content.
     */
    attachTemplatePortal(portal) {
        if (this._portalOutlet.hasAttached()) {
            throwMatSideContentAlreadyAttachedError();
        }
        return this._portalOutlet.attachTemplatePortal(portal);
    }
    /** Callback, invoked whenever an animation on the host completes. */
    _onAnimationDone(event) {
        if (event.toState === 'enter') {
            // this._trapFocus();
        }
        else if (event.toState === 'exit') {
            // this._restoreFocus();
        }
        this._animationStateChanged.emit(event);
    }
    /** Callback, invoked when an animation on the host starts. */
    _onAnimationStart(event) {
        this._animationStateChanged.emit(event);
    }
    /** Starts the dialog exit animation. */
    _startExitAnimation() {
        this._state = 'exit';
        // Mark the container for check so it can react if the
        // view container is using OnPush change detection.
        this._cd.markForCheck();
    }
}
MatSideContainer.decorators = [
    { type: Component, args: [{
                selector: 'mat-side-container',
                template: "<ng-template cdkPortalOutlet></ng-template>\r\n",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.Default,
                animations: [matSideAnimations.sideContainer],
                host: {
                    '[class]': '_class',
                    '[class.mat-side-container]': 'true',
                    'tabindex': '-1',
                    'aria-modal': 'true',
                    '[attr.id]': '_id',
                    '[@sideContainer]': '_state',
                    '(@sideContainer.start)': '_onAnimationStart($event)',
                    '(@sideContainer.done)': '_onAnimationDone($event)',
                    '[attr.role]': '_config.role',
                }
            },] }
];
MatSideContainer.ctorParameters = () => [
    { type: ElementRef },
    { type: ChangeDetectorRef },
    { type: MatSideConfig }
];
MatSideContainer.propDecorators = {
    _portalOutlet: [{ type: ViewChild, args: [CdkPortalOutlet, { static: true },] }]
};

let uniqueId = 0;
class MatSideRef {
    constructor(_overlayRef, _containerInstance, id = `mat-dialog-${uniqueId++}`) {
        this._overlayRef = _overlayRef;
        this._containerInstance = _containerInstance;
        this.id = id;
        /** Whether the user is allowed to close the side. */
        this.disableClose = this._containerInstance._config.disableClose;
        /** Subject for notifying the user that the side has finished opening. */
        this._afterOpened = new Subject();
        /** Subject for notifying the user that the side has finished closing. */
        this._afterClosed = new Subject();
        /** Subject for notifying the user that the side has started closing. */
        this._beforeClosed = new Subject();
        /** Current state of the side. */
        this._state = 0 /* OPEN */;
        // Pass the id along to the container.
        _containerInstance._id = id;
        // Emit when opening animation completes
        _containerInstance._animationStateChanged.pipe(filter(event => event.phaseName === 'done' && event.toState === 'enter'), take(1))
            .subscribe(() => {
            this._afterOpened.next();
            this._afterOpened.complete();
        });
        // Dispose overlay when closing animation is complete
        _containerInstance._animationStateChanged.pipe(filter(event => event.phaseName === 'done' && event.toState === 'exit'), take(1)).subscribe(() => {
            clearTimeout(this._closeFallbackTimeout);
            this._overlayRef.dispose();
        });
        _overlayRef.detachments().subscribe(() => {
            this._beforeClosed.next(this._result);
            this._beforeClosed.complete();
            this._afterClosed.next(this._result);
            this._afterClosed.complete();
            this.componentInstance = null;
            this._overlayRef.dispose();
        });
        _overlayRef.keydownEvents()
            .pipe(filter(event => {
            return event.keyCode === ESCAPE && !this.disableClose && !hasModifierKey(event);
        }))
            .subscribe(event => {
            event.preventDefault();
            this.close();
        });
    }
    close(dialogResult) {
        this._result = dialogResult;
        this._containerInstance._animationStateChanged.pipe(filter(event => event.phaseName === 'start'), take(1))
            .subscribe(event => {
            this._beforeClosed.next(dialogResult);
            this._beforeClosed.complete();
            this._state = 2 /* CLOSED */;
            this._overlayRef.detachBackdrop();
            this._closeFallbackTimeout = setTimeout(() => {
                this._overlayRef.dispose();
            }, event.totalTime + 100);
        });
        this._containerInstance._startExitAnimation();
        this._state = 1 /* CLOSING */;
    }
    afterOpened() {
        return this._afterOpened.asObservable();
    }
    afterClosed() {
        return this._afterClosed.asObservable();
    }
    beforeClosed() {
        return this._beforeClosed.asObservable();
    }
    backdropClick() {
        return this._overlayRef.backdropClick();
    }
    keydownEvents() {
        return this._overlayRef.keydownEvents();
    }
    updatePosition(position) {
        const strategy = this._getPositionStrategy();
        if (position) {
            if (position.includes('L')) {
                strategy.left();
            }
            if (position.includes('R')) {
                strategy.right();
            }
            if (position.includes('T')) {
                strategy.top();
            }
            if (position.includes('B')) {
                strategy.bottom();
            }
            if (position.includes('RC') || position.includes('LC')) {
                strategy.centerVertically();
            }
            if (position.includes('TC') || position.includes('BC')) {
                strategy.centerHorizontally();
            }
        }
        this._containerInstance._class = position;
        this._overlayRef.updatePosition();
        return this;
    }
    updateSize(width = '', height = '') {
        this._getPositionStrategy().width(width).height(height);
        this._overlayRef.updatePosition();
        return this;
    }
    /** Add a CSS class or an array of classes to the overlay pane. */
    addPanelClass(classes) {
        this._overlayRef.addPanelClass(classes);
        return this;
    }
    /** Remove a CSS class or an array of classes from the overlay pane. */
    removePanelClass(classes) {
        this._overlayRef.removePanelClass(classes);
        return this;
    }
    /** Gets the current state of the dialog's lifecycle. */
    getState() {
        return this._state;
    }
    /** Fetches the position strategy object from the overlay ref. */
    _getPositionStrategy() {
        return this._overlayRef.getConfig().positionStrategy;
    }
}

const MAT_SIDE_DATA = new InjectionToken('MatSideData');
const MAT_SIDE_DEFAULT_OPTIONS = new InjectionToken('mat-side-default-options', {
    providedIn: 'root',
    factory: MAT_SIDE_DEFAULT_OPTIONS_FACTORY
});
function MAT_SIDE_DEFAULT_OPTIONS_FACTORY() {
    return new MatSideConfig();
}
const MAT_SIDE_SCROLL_STRATEGY = new InjectionToken('mat-side-scroll-strategy');
function MAT_SIDE_SCROLL_STRATEGY_FACTORY(overlay) {
    return () => overlay.scrollStrategies.noop();
}
/** @docs-private */
function MAT_SIDE_SCROLL_STRATEGY_PROVIDER_FACTORY(overlay) {
    return () => overlay.scrollStrategies.noop();
}
/** @docs-private */
const MAT_SIDE_SCROLL_STRATEGY_PROVIDER = {
    provide: MAT_SIDE_SCROLL_STRATEGY,
    deps: [Overlay],
    useFactory: MAT_SIDE_SCROLL_STRATEGY_PROVIDER_FACTORY,
};
class MatSide {
    constructor(_overlay, _injector, _defaultOptions, scrollStrategy, _parentDialog, _overlayContainer) {
        this._overlay = _overlay;
        this._injector = _injector;
        this._defaultOptions = _defaultOptions;
        this._parentDialog = _parentDialog;
        this._overlayContainer = _overlayContainer;
        this._openSidesAtThisLevel = [];
        this._afterAllClosedAtThisLevel = new Subject();
        this._afterOpenedAtThisLevel = new Subject();
        this.afterAllClosed = defer(() => this.openSides.length ? this._afterAllClosed : this._afterAllClosed.pipe(startWith(undefined)));
        this._scrollStrategy = scrollStrategy;
    }
    /** Keeps track of the currently-open dialogs. */
    get openSides() {
        return this._parentDialog ? this._parentDialog.openSides : this._openSidesAtThisLevel;
    }
    /** Stream that emits when a dialog has been opened. */
    get afterOpened() {
        return this._parentDialog ? this._parentDialog.afterOpened : this._afterOpenedAtThisLevel;
    }
    get _afterAllClosed() {
        const parent = this._parentDialog;
        return parent ? parent._afterAllClosed : this._afterAllClosedAtThisLevel;
    }
    open(componentOrTemplateRef, config) {
        config = _applyConfigDefaults(config, this._defaultOptions || new MatSideConfig());
        if (config.id && this.getDialogById(config.id)) {
            throw Error(`Dialog with id "${config.id}" exists already. The dialog id must be unique.`);
        }
        const overlayRef = this._createOverlay(config);
        const sideContainer = this._attachSideContainer(overlayRef, config);
        const sideRef = this._attachSideContent(componentOrTemplateRef, sideContainer, overlayRef, config);
        this.openSides.push(sideRef);
        sideRef.afterClosed().subscribe(() => this._removeOpenSide(sideRef));
        this.afterOpened.next(sideRef);
        return sideRef;
    }
    /**
     * Closes all of the currently-open dialogs.
     */
    closeAll() {
        this._closeSides(this.openSides);
    }
    /**
     * Finds an open dialog by its id.
     * @param id ID to use when looking up the dialog.
     */
    getDialogById(id) {
        return this.openSides.find(side => side.id === id);
    }
    ngOnDestroy() {
        this._closeSides(this._openSidesAtThisLevel);
        this._afterAllClosedAtThisLevel.complete();
        this._afterOpenedAtThisLevel.complete();
    }
    _createOverlay(config) {
        const overlayConfig = this._getOverlayConfig(config);
        return this._overlay.create(overlayConfig);
    }
    _getOverlayConfig(config) {
        const state = new OverlayConfig({
            positionStrategy: this._overlay.position().global(),
            scrollStrategy: config.scrollStrategy || this._scrollStrategy(),
            panelClass: config.panelClass,
            hasBackdrop: config.hasBackdrop,
            minWidth: config.minWidth,
            minHeight: config.minHeight,
            maxWidth: config.maxWidth,
            maxHeight: config.maxHeight,
            disposeOnNavigation: config.closeOnNavigation
        });
        if (config.backdropClass) {
            state.backdropClass = config.backdropClass;
        }
        return state;
    }
    _attachSideContainer(overlay, config) {
        const userInjector = config && config.viewContainerRef && config.viewContainerRef.injector;
        const injector = new PortalInjector(userInjector || this._injector, new WeakMap([[MatSideConfig, config]]));
        const containerPortal = new ComponentPortal(MatSideContainer, config.viewContainerRef, injector, config.componentFactoryResolver);
        const containerRef = overlay.attach(containerPortal);
        return containerRef.instance;
    }
    _attachSideContent(componentOrTemplateRef, sideContainer, overlayRef, config) {
        const sideRef = new MatSideRef(overlayRef, sideContainer, config.id);
        if (config.hasBackdrop) {
            overlayRef.backdropClick().subscribe(() => {
                if (!config.disableClose) {
                    sideRef.close();
                }
            });
        }
        if (componentOrTemplateRef instanceof TemplateRef) {
            sideContainer.attachTemplatePortal(new TemplatePortal(componentOrTemplateRef, null, {
                $implicit: config.data,
                sideRef
            }));
        }
        else {
            const injector = this._createInjector(config, sideRef, sideContainer);
            const contentRef = sideContainer.attachComponentPortal(new ComponentPortal(componentOrTemplateRef, undefined, injector));
            sideRef.componentInstance = contentRef.instance;
        }
        sideRef.updateSize(config.width, config.height).updatePosition(config.position);
        return sideRef;
    }
    _createInjector(config, sideRef, sideContainer) {
        const userInjector = config && config.viewContainerRef && config.viewContainerRef.injector;
        const injectionTokens = new WeakMap([
            [MatSideContainer, sideContainer], [MAT_SIDE_DATA, config.data], [MatSideRef, sideRef]
        ]);
        return new PortalInjector(userInjector || this._injector, injectionTokens);
    }
    /**
     * Removes a dialog from the array of open dialogs.
     * @param dialogRef Dialog to be removed.
     */
    _removeOpenSide(sideRef) {
        const index = this.openSides.indexOf(sideRef);
        if (index > -1) {
            this.openSides.splice(index, 1);
            if (!this.openSides.length) {
                this._afterAllClosed.next();
            }
        }
    }
    /** Closes all of the dialogs in an array. */
    _closeSides(sides) {
        let i = sides.length;
        while (i--) {
            sides[i].close();
        }
    }
}
MatSide.decorators = [
    { type: Injectable }
];
MatSide.ctorParameters = () => [
    { type: Overlay },
    { type: Injector },
    { type: MatSideConfig, decorators: [{ type: Optional }, { type: Inject, args: [MAT_SIDE_DEFAULT_OPTIONS,] }] },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_SIDE_SCROLL_STRATEGY,] }] },
    { type: MatSide, decorators: [{ type: Optional }, { type: SkipSelf }] },
    { type: OverlayContainer }
];
function _applyConfigDefaults(config, defaultOptions) {
    return Object.assign(Object.assign({}, defaultOptions), config);
}

class MatSideModule {
}
MatSideModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    OverlayModule,
                    PortalModule,
                    MatButtonsModule,
                    MatCommonModule,
                ],
                exports: [MatSideContainer],
                declarations: [MatSideContainer],
                entryComponents: [MatSideContainer],
                providers: [
                    MatSide,
                    MAT_SIDE_SCROLL_STRATEGY_PROVIDER,
                ],
            },] }
];

class MatLayerModule {
}
MatLayerModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatSideModule, MatModalModule],
                declarations: [],
                exports: [],
                providers: []
            },] }
];

class NewFrameConfig {
    constructor(config = {}) {
        this.keys = ['height', 'width', 'left', 'top', 'location', 'menubar', 'resizable', 'scrollbars', 'status', 'titlebar'];
        this.height = 600;
        this.width = 800;
        this.toolbar = 'no';
        this.location = 'no';
        this.menubar = '0';
        this.resizable = 'no';
        this.scrollbars = 'yes';
        this.status = 'no';
        this.titlebar = 'no';
        this.keys.forEach(key => {
            this[key] = config[key] === undefined ? this[key] : config[key];
        });
        this._setCenter();
    }
    _setCenter() {
        const left = (window.screen.availWidth - 10 - this.width) / 2;
        const top = (window.screen.availHeight - 30 - this.height) / 2;
        this.top = this.top || top;
        this.left = this.left || left;
    }
    toString() {
        return this.keys.map(key => `${key}=${this[key]}`).join(',');
    }
}
class MatLayer {
    constructor(_injector, _modal, _side) {
        this._injector = _injector;
        this._modal = _modal;
        this._side = _side;
    }
    openBlank(url, onSameUrlOpen = 'new') {
        const name = onSameUrlOpen == 'new' ? ('_blank_' + Date.now()) : '_blank';
        const win = window.open(url, name);
        return win;
    }
    openWindow(url, config = {}, onSameUrlOpen = 'new') {
        const specs = new NewFrameConfig(config);
        const name = onSameUrlOpen == 'new' ? ('_top_' + Date.now()) : '_blank';
        const win = window.open(url, name, specs.toString());
        return win;
    }
    openDialog(component, config) {
        this._modal.dialog(component, config);
    }
    openSide(component, config) {
        this._side.open(component, config);
    }
}
MatLayer.ɵprov = ɵɵdefineInjectable({ factory: function MatLayer_Factory() { return new MatLayer(ɵɵinject(INJECTOR), ɵɵinject(MatModal), ɵɵinject(MatSide)); }, token: MatLayer, providedIn: MatLayerModule });
MatLayer.decorators = [
    { type: Injectable, args: [{ providedIn: MatLayerModule },] }
];
MatLayer.ctorParameters = () => [
    { type: Injector },
    { type: MatModal },
    { type: MatSide }
];

const MAT_NOTIFICATION_MAX = 4;
const MAT_NOTIFICATION_DURATION = 3000;
const MAT_NOTIFICATION_PAUSE_ON_HOVER = true;
const MAT_NOTIFICATION_MIN_DURATION = 800;
class MatNotificationComponent {
    constructor(snackBarRef, cd) {
        this.snackBarRef = snackBarRef;
        this.cd = cd;
        /** The length of time in milliseconds to wait before automatically dismissing the snack bar. */
        this.duration = MAT_NOTIFICATION_DURATION;
        /** Where pause dismissing on componednt hovered. */
        this.pauseOnHover = MAT_NOTIFICATION_PAUSE_ON_HOVER;
        /** The minimum length of time in milliseconds to wait before automatically dismissing the snack bar. */
        this.minDuration = MAT_NOTIFICATION_MIN_DURATION;
        /** The max length of notification to show. */
        this.max = MAT_NOTIFICATION_MAX;
        /** The notification items array. */
        this.list = [];
        /** The notification items array wait to show. */
        this.temList = [];
        /** Subject for notifying that the component has been hidden from the view */
        this._afterDismissed = new Subject();
        /** Subject for notifying that the component has been cleared from the view */
        this._afterClear = new Subject();
    }
    setConfig(config = {}) {
        this.duration = config.duration || this.duration;
        this.pauseOnHover = typeof config.pauseOnHover === 'boolean' ? config.pauseOnHover : this.pauseOnHover;
        this.minDuration = config.minDuration || this.minDuration;
        this.max = config.max || this.max;
    }
    mouseEnter(item) {
        if (!this.pauseOnHover) {
            return;
        }
        this.clearTime(item);
        item.duration = Math.max(item.duration - (Date.now() - item.startTime), this.minDuration);
    }
    mouseLeave(item) {
        if (!this.pauseOnHover) {
            return;
        }
        this.startRemove(item);
    }
    startRemove(item) {
        this.clearTime(item);
        item.timerId = setTimeout(() => this.removeItem(item), item.duration);
        item.startTime = Date.now();
    }
    clearTime(item) {
        if (item.timerId) {
            clearTimeout(item.timerId);
            item.timerId = null;
        }
    }
    removeItem(item) {
        this.list = this.list.filter(value => item.notificationId !== value.notificationId);
        this._afterDismissed.next(item);
        if (item.timerId) {
            clearTimeout(item.timerId);
        }
        if (!this.list.length) {
            this._afterClear.next();
            this._afterClear.complete();
        }
        this.cd.markForCheck();
    }
    clear() {
        this.list.forEach((item) => {
            if (item.timerId) {
                clearTimeout(item.timerId);
            }
        });
        this.list = [];
        this.temList = [];
        this._afterClear.next();
        this._afterClear.complete();
        this.cd.markForCheck();
    }
    add(item) {
        if (this.isFull()) {
            this.temList.push(item);
            return;
        }
        item.duration = item.duration || this.duration;
        this.list.push(item);
        this.startRemove(item);
        this.cd.markForCheck();
        item.state = 'show';
    }
    action() {
        this.snackBarRef.dismissWithAction();
    }
    afterDismissed() {
        return this._afterDismissed.asObservable();
    }
    afterClear() {
        return this._afterClear.asObservable();
    }
    isFull() {
        return this.list.length >= this.max;
    }
    onAnimationEnd(event) {
        const { fromState, toState } = event;
        if (toState === 'void' && fromState === 'show' && this.temList.length && !this.isFull()) {
            this.add(this.temList.shift());
        }
    }
    buttonClick(btn, item) {
        if (btn.click) {
            btn.click(item);
        }
        this.removeItem(item);
    }
}
MatNotificationComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-notification-component',
                template: "<div (@state.done)=\"onAnimationEnd($event)\" [class.simple]=\"!item.title\" class=\"mat-notification-item {{item.severity}}\" [@state]=\"item.state\" id=\"{{item.notificationId}}\" (mouseenter)=\"mouseEnter(item)\" (mouseleave)=\"mouseLeave(item)\" *ngFor=\"let item of list\">\r\n    <ng-container *ngIf=\"!item.template\">\r\n        <span class=\"mat-notification-severity\"></span>\r\n        <div class=\"mat-notification-content\">\r\n            <h5 class=\"mat-notification-title\" *ngIf=\"item.title\">{{item.title}}</h5>\r\n            <p class=\"mat-notification-message\" *ngIf=\"item.message\">{{item.message}}</p>\r\n            <div class=\"mat-notification-button-group\" *ngIf=\"item.buttons?.length\">\r\n                <ng-container *ngFor=\"let btn of item.buttons\">\r\n                    <mat-buttons [label]=\"btn.label\" (click)=\"buttonClick(btn, item)\" [type]=\"btn.type\" [icon]=\"btn.icon\" [size]=\"btn.size\" [target]=\"btn.target\" [href]=\"btn.href\"></mat-buttons>\r\n                </ng-container>\r\n            </div>\r\n        </div>\r\n        <span *ngIf=\"!item.hiddenClose\" (click)=\"removeItem(item)\" class=\"mat-notification-close\">\u2573</span>\r\n    </ng-container>\r\n    <ng-template [ngIf]=\"item.template\" [ngTemplateOutlet]=\"item.template\" [ngTemplateOutletContext]=\"{ $implicit: item, data: item.data }\"></ng-template>\r\n</div>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                animations: [
                    trigger('state', [
                        state('void', style({
                            opacity: 0, transform: 'translateX(200%)'
                        })),
                        state('show', style({
                            opacity: 1
                        })),
                        transition('void => show', animate('200ms linear')),
                        transition('show => void', [
                            animate('250ms linear', style({ opacity: 0, height: 0, transform: 'translateY(-100%)', transformOrigin: '0% 0%' }))
                        ]),
                    ]),
                ]
            },] }
];
MatNotificationComponent.ctorParameters = () => [
    { type: MatSnackBarRef },
    { type: ChangeDetectorRef }
];

class MatNotificationModule {
}
MatNotificationModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    OverlayModule,
                    PortalModule,
                    CommonModule,
                    MatButtonsModule,
                    MatCommonModule,
                    MatSnackBarModule
                ],
                exports: [MatNotificationComponent],
                declarations: [MatNotificationComponent],
                entryComponents: [MatNotificationComponent],
            },] }
];

class MatNotificationSnackBar extends MatSnackBar {
}
MatNotificationSnackBar.ɵprov = ɵɵdefineInjectable({ factory: function MatNotificationSnackBar_Factory() { return new MatNotificationSnackBar(); }, token: MatNotificationSnackBar, providedIn: MatNotificationModule });
MatNotificationSnackBar.decorators = [
    { type: Injectable, args: [{ providedIn: MatNotificationModule },] }
];

class MatNotificationConfig {
    constructor() {
        this.horizontalPosition = 'right';
        this.verticalPosition = 'top';
    }
}
const MAT_NOTIFICATION_DEFAULT_OPTIONS = new InjectionToken('mat-notification-default-options', {
    providedIn: 'root',
    factory: MAT_NOTIFICATION_DEFAULT_OPTIONS_FACTORY$1
});
function MAT_NOTIFICATION_DEFAULT_OPTIONS_FACTORY$1() {
    return new MatNotificationConfig();
}
class MatNotification {
    constructor(notice, _defaultConfig) {
        this.notice = notice;
        this._defaultConfig = _defaultConfig;
        this._count = 0;
        this._idPrefix = 'notification-item-';
    }
    _getConfig() {
        const matsnackconfig = {
            horizontalPosition: this._defaultConfig.horizontalPosition || 'right',
            verticalPosition: this._defaultConfig.verticalPosition || 'top',
            duration: 0,
            panelClass: 'mat-notification'
        };
        return matsnackconfig;
    }
    _creat() {
        const snackBarRef = this.notice.openFromComponent(MatNotificationComponent, this._getConfig());
        this._instance = snackBarRef.instance;
        this._instance.setConfig(this._defaultConfig);
        this._instance.afterClear().subscribe(() => {
            this.notice.dismiss();
            this._instance = null;
        });
    }
    _open(config) {
        if (!this._instance) {
            this._creat();
        }
        this._instance.add(Object.assign(Object.assign({}, config), { notificationId: this._getId() }));
        return this._instance;
    }
    _getId() {
        this._count++;
        return this._idPrefix + this._count;
    }
    success(message, title = '', config = {}) {
        return this._open(Object.assign(Object.assign({}, config), { message, title, severity: 'success' }));
    }
    error(message, title = '', config = {}) {
        return this._open(Object.assign(Object.assign({}, config), { message, title, severity: 'error' }));
    }
    info(message, title = '', config = {}) {
        return this._open(Object.assign(Object.assign({}, config), { message, title, severity: 'info' }));
    }
    warn(message, title = '', config = {}) {
        return this._open(Object.assign(Object.assign({}, config), { message, title, severity: 'warn' }));
    }
    open(message, title = '', config = {}) {
        return this._open(Object.assign(Object.assign({}, config), { message, title }));
    }
    openTemplate(template, config = {}) {
        config.template = template;
        return this._open(config);
    }
    create(config) {
        return this._open(config);
    }
}
MatNotification.ɵprov = ɵɵdefineInjectable({ factory: function MatNotification_Factory() { return new MatNotification(ɵɵinject(MatNotificationSnackBar), ɵɵinject(MAT_NOTIFICATION_DEFAULT_OPTIONS)); }, token: MatNotification, providedIn: MatNotificationModule });
MatNotification.decorators = [
    { type: Injectable, args: [{ providedIn: MatNotificationModule },] }
];
MatNotification.ctorParameters = () => [
    { type: MatNotificationSnackBar },
    { type: MatNotificationConfig, decorators: [{ type: Inject, args: [MAT_NOTIFICATION_DEFAULT_OPTIONS,] }] }
];

/** The default page size if there is no page size and there are no provided page size options. */
const DEFAULT_PAGE_SIZE = 50;
/**
 * Change event object that is emitted when the user selects a
 * different page size or navigates to another page.
 */
class PageEvent {
}
class MatPagination {
    constructor(_cd) {
        this._cd = _cd;
        this._simple = false;
        this._position = 'after';
        this._pageIndex = 0;
        this._previousText = '上一页';
        this._nextText = '下一页';
        this._total = 0;
        /** The splice to shwo the pageIndex buttons. */
        this._pagePreArray = [];
        this._pageNextArray = [];
        this._previousSize = 2;
        this._nextSize = 2;
        this._pageSizeOptions = [];
        this._hidePageSize = false;
        this._showFirstLast = false;
        this._disabled = false;
        /** Event emitted when the paginator changes the page size or page index. */
        this.page = new EventEmitter();
        this._changes = new Subject();
        this._intlChanges = this._changes.subscribe(() => this._cd.markForCheck());
    }
    get simple() { return this._simple; }
    set simple(value) {
        this._simple = coerceBooleanProperty(value);
    }
    get position() { return this._position; }
    set position(value) {
        if (value !== this._position) {
            this._position = value;
            this._cd.markForCheck();
        }
    }
    /** The zero-based page index of the displayed list of items. Defaulted to 0. */
    get pageIndex() { return this._pageIndex; }
    set pageIndex(value) {
        this._pageIndex = Math.max(coerceNumberProperty(value), 0);
        this._cd.markForCheck();
    }
    /** The title text of previous button. */
    get previousText() { return this._previousText; }
    set previousText(value) {
        if (value !== this._previousText) {
            this._previousText = value;
            this._cd.markForCheck();
        }
    }
    /** The title text of next button. */
    get nextText() { return this._nextText; }
    set nextText(value) {
        if (value !== this._nextText) {
            this._nextText = value;
            this._cd.markForCheck();
        }
    }
    /** The total number of items that are being paginated. Defaulted to 0. */
    get total() { return this._total; }
    set total(value) {
        this._total = coerceNumberProperty(value);
        this._setPageArray();
        this._cd.markForCheck();
    }
    /** The total number of items that are searched. Defaulted null */
    get result() { return this._result; }
    set result(value) {
        if (this._result !== value) {
            this._result = value;
            this._cd.markForCheck();
        }
    }
    _setPageArray() {
        const all = new Array(this.getNumberOfPages()).fill('').map((_, i) => i + 1);
        const len = all.length;
        if (len <= this.previousSize) {
            this._pagePreArray = all;
            this._pageNextArray = [];
        }
        else if (len <= this.previousSize + this.nextSize + 1) {
            this._pagePreArray = all.splice(0, this.previousSize);
            this._pageNextArray = all;
        }
        else {
            this._pagePreArray = all.slice(0, this.previousSize);
            this._pageNextArray = all.slice(-this.nextSize);
        }
    }
    get previousSize() { return this._previousSize; }
    set previousSize(value) {
        if (value !== this._previousSize) {
            this._previousSize = coerceNumberProperty(value, 2);
            this._setPageArray();
            this._cd.markForCheck();
        }
    }
    get nextSize() { return this._nextSize; }
    set nextSize(value) {
        if (value !== this._nextSize) {
            this._nextSize = coerceNumberProperty(value, 2);
            this._setPageArray();
            this._cd.markForCheck();
        }
    }
    /** Number of items to display on a page. By default set to 50. */
    get pageSize() { return this._pageSize; }
    set pageSize(value) {
        this._pageSize = Math.max(coerceNumberProperty(value), 0);
        this._updateDisplayedPageSizeOptions();
        this._setPageArray();
    }
    /** The set of provided page size options to display to the user. */
    get pageSizeOptions() { return this._pageSizeOptions; }
    set pageSizeOptions(value) {
        this._pageSizeOptions = (value || []).map(p => coerceNumberProperty(p));
        this._updateDisplayedPageSizeOptions();
    }
    /** Whether to hide the page size selection UI from the user. */
    get hidePageSize() { return this._hidePageSize; }
    set hidePageSize(value) {
        this._hidePageSize = coerceBooleanProperty(value);
    }
    /** Whether to show the first/last buttons UI to the user. */
    get showFirstLast() { return this._showFirstLast; }
    set showFirstLast(value) {
        this._showFirstLast = coerceBooleanProperty(value);
    }
    /** Whether to disabled the buttons UI to the user. */
    get disabled() { return this._disabled; }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    ngOnInit() {
        this._initialized = true;
        this._updateDisplayedPageSizeOptions();
    }
    ngOnDestroy() {
        this._intlChanges.unsubscribe();
    }
    /** Clear the search result data. */
    reset() {
        this.result = null;
        const previousPageIndex = this.pageIndex;
        this.pageIndex = 0;
        this._emitPageEvent(previousPageIndex);
        this.clearJump();
    }
    /** Clear jump value on pageindex change. */
    clearJump() {
        this._jumpValue = null;
    }
    /** Advances to the next page if it exists. */
    nextPage() {
        if (!this.hasNextPage()) {
            return;
        }
        const previousPageIndex = this.pageIndex;
        this.pageIndex++;
        this._emitPageEvent(previousPageIndex);
        this.clearJump();
    }
    /** Advances to the customer page if it exists. */
    pageTo(index) {
        const previousPageIndex = this.pageIndex;
        if (index < 1) {
            this._pageIndex = 0;
        }
        else if (index > this.getNumberOfPages()) {
            this._pageIndex = this.getNumberOfPages();
        }
        else {
            this._pageIndex = index - 1;
        }
        this._emitPageEvent(previousPageIndex);
        this.clearJump();
    }
    /** Move back to the previous page if it exists. */
    previousPage() {
        if (!this.hasPreviousPage()) {
            return;
        }
        const previousPageIndex = this.pageIndex;
        this.pageIndex--;
        this._emitPageEvent(previousPageIndex);
        this.clearJump();
    }
    /** Move to the first page if not already there. */
    firstPage() {
        // hasPreviousPage being false implies at the start
        if (!this.hasPreviousPage()) {
            return;
        }
        const previousPageIndex = this.pageIndex;
        this.pageIndex = 0;
        this._emitPageEvent(previousPageIndex);
        this.clearJump();
    }
    /** Move to the last page if not already there. */
    lastPage() {
        // hasNextPage being false implies at the end
        if (!this.hasNextPage()) {
            return;
        }
        const previousPageIndex = this.pageIndex;
        this.pageIndex = this.getNumberOfPages() - 1;
        this._emitPageEvent(previousPageIndex);
        this.clearJump();
    }
    /** Where is active. */
    isActive(index) {
        return this.pageIndex === index - 1;
    }
    /** Where is active in ellipsis */
    isActiveInEllipsis() {
        return this.pageIndex >= this.previousSize && this.pageIndex < this.getNumberOfPages() - this.nextSize;
    }
    getTitleByIndex(index) {
        return `第${index}页`;
    }
    /** Whether there is a previous page. */
    hasPreviousPage() {
        return this.pageIndex >= 1 && this.pageSize != 0;
    }
    /** Whether there is a next page. */
    hasNextPage() {
        const maxPageIndex = this.getNumberOfPages() - 1;
        return this.pageIndex < maxPageIndex && this.pageSize != 0;
    }
    /** Whether has ellipsis */
    hasEllipsis() {
        return this.getNumberOfPages() > this.previousSize + this.nextSize + 1;
    }
    /** Calculate the number of pages */
    getNumberOfPages() {
        if (!this.pageSize) {
            return 0;
        }
        return Math.ceil(this.total / this.pageSize);
    }
    _changePageSize(pageSize) {
        const startIndex = this.pageIndex * this.pageSize;
        const previousPageIndex = this.pageIndex;
        this.pageIndex = Math.floor(startIndex / pageSize) || 0;
        this.pageSize = pageSize;
        this._emitPageEvent(previousPageIndex);
        this.clearJump();
    }
    /** Checks whether the buttons for going forwards should be disabled. */
    _nextButtonsDisabled() {
        return this.disabled || !this.hasNextPage();
    }
    /** Checks whether the buttons for going backwards should be disabled. */
    _previousButtonsDisabled() {
        return this.disabled || !this.hasPreviousPage();
    }
    /**
     * Updates the list of page size options to display to the user. Includes making sure that
     * the page size is an option and that the list is sorted.
     */
    _updateDisplayedPageSizeOptions() {
        if (!this._initialized) {
            return;
        }
        if (!this.pageSize) {
            this._pageSize = this.pageSizeOptions.length != 0 ?
                this.pageSizeOptions[0] :
                DEFAULT_PAGE_SIZE;
        }
        let displayOptions;
        displayOptions = this.pageSizeOptions.slice();
        if (displayOptions.indexOf(this.pageSize) === -1) {
            displayOptions.push(this.pageSize);
        }
        // Sort the numbers using a number-specific sort function.
        displayOptions.sort((a, b) => a - b);
        this._displayedPageSizeOptions = displayOptions.map(item => ({ label: item + '条/页', value: item }));
        this._cd.markForCheck();
    }
    /** Emits an event notifying that a change of the paginator's properties has been triggered. */
    _emitPageEvent(previousPageIndex) {
        this.page.emit({
            previousPageIndex,
            pageIndex: this.pageIndex,
            pageSize: this.pageSize,
            total: this.total
        });
    }
}
MatPagination.decorators = [
    { type: Component, args: [{
                selector: 'mat-pagination',
                exportAs: 'matPagination',
                template: "<div class=\"mat-pagination-container\">\r\n    <ng-template [ngTemplateOutlet]=\"simple ? default : advance\"></ng-template>\r\n</div>\r\n\r\n<ng-template #default>\r\n  <div class=\"mat-pagination-result-container\">\r\n    <!-- <ng-container *ngIf=\"result\">\r\n      \u67E5\u8BE2\u5230 <span class=\"mat-pagination-result\">{{result}}</span> \u6761\u7ED3\u679C\r\n    </ng-container> -->\r\n    <ng-container *ngIf=\"true\">\r\n      \u5171 <span>{{total}} \u6761</span>\r\n    </ng-container>\r\n  </div>\r\n  <!-- <div class=\"mat-pagination-clear\" (click)=\"clear()\" *ngIf=\"result\"> </div> -->\r\n  <ng-template [ngTemplateOutlet]=\"pageOptions\"></ng-template>\r\n  <ng-template [ngTemplateOutlet]=\"previous\"></ng-template>\r\n  <div>{{pageIndex + 1}} / {{getNumberOfPages() || 1}}</div>\r\n  <ng-template [ngTemplateOutlet]=\"next\"></ng-template>\r\n</ng-template>\r\n\r\n\r\n<ng-template #advance>\r\n    <!-- previous button -->\r\n    <ng-template [ngTemplateOutlet]=\"previous\"></ng-template>\r\n    <!-- page item before -->\r\n    <div class=\"mat-pagination-pageitem\" (click)=\"pageTo(item)\" [title]=\"getTitleByIndex(item)\" [class.mat-pagination-active]=\"isActive(item)\" *ngFor=\"let item of _pagePreArray\">{{item}}</div>\r\n\r\n    <!-- ellipsis -->\r\n    <div class=\"mat-pagination-ellipsis\" [class.active]=\"isActiveInEllipsis()\" *ngIf=\"hasEllipsis()\" [title]=\"isActiveInEllipsis() ? getTitleByIndex(pageIndex + 1) : ''\">\u2022\u2022\u2022</div>\r\n\r\n    <!-- page item after -->\r\n    <div class=\"mat-pagination-pageitem\" (click)=\"pageTo(item)\" [title]=\"getTitleByIndex(item)\" [class.mat-pagination-active]=\"isActive(item)\" *ngFor=\"let item of _pageNextArray\">{{item}}</div>\r\n\r\n    <!-- next button -->\r\n    <ng-template [ngTemplateOutlet]=\"next\"></ng-template>\r\n\r\n    <!-- page options -->\r\n    <ng-template [ngTemplateOutlet]=\"pageOptions\"></ng-template>\r\n\r\n    <!-- jump to page -->\r\n    <ng-template [ngTemplateOutlet]=\"pageJump\"></ng-template>\r\n\r\n</ng-template>\r\n\r\n<ng-template #previous>\r\n  <div class=\"mat-pagination-previous mat-pagination-arrow-left\" (click)=\"previousPage()\" [class.mat-pagination-unselectable]=\"!hasPreviousPage()\" [title]=\"previousText\"></div> \r\n</ng-template>\r\n\r\n<ng-template #next>\r\n  <div class=\"mat-pagination-next mat-pagination-arrow-right\" (click)=\"nextPage()\" [class.mat-pagination-unselectable]=\"!hasNextPage()\" [title]=\"nextText\"></div>\r\n</ng-template>\r\n\r\n<ng-template #pageOptions>\r\n  <div class=\"mat-pagination-options\">\r\n    <mat-dropdown \r\n      (matChange)=\"_changePageSize($event)\" \r\n      direction=\"vertical\" \r\n      [(value)]=\"pageSize\" \r\n      [dataSource]=\"_displayedPageSizeOptions\" \r\n      valueField=\"value\" \r\n      [showFilter]=\"false\">\r\n    </mat-dropdown>\r\n  </div>\r\n</ng-template>\r\n\r\n<ng-template #pageJump>\r\n  <div class=\"mat-pagination-jump\">\r\n    <span>\u8DF3\u81F3</span>\r\n    <mat-number \r\n      (keyup.enter)=\"pageTo(_jumpValue)\" \r\n      [(value)]=\"_jumpValue\" \r\n      [handle]=\"false\" \r\n      [max]=\"getNumberOfPages()\" \r\n      [min]=\"1\">\r\n    </mat-number>\r\n    <span>\u9875</span>\r\n  </div>\r\n</ng-template>\r\n",
                host: {
                    '[class.mat-pagination]': 'true',
                    '[class.mat-pagination-disabled]': 'disabled',
                    '[class.mat-pagination-before]': 'position === "before"',
                },
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            },] }
];
MatPagination.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatPagination.propDecorators = {
    simple: [{ type: Input }],
    position: [{ type: Input }],
    pageIndex: [{ type: Input }],
    previousText: [{ type: Input }],
    nextText: [{ type: Input }],
    total: [{ type: Input }],
    result: [{ type: Input }],
    previousSize: [{ type: Input }],
    nextSize: [{ type: Input }],
    pageSize: [{ type: Input }],
    pageSizeOptions: [{ type: Input }],
    hidePageSize: [{ type: Input }],
    showFirstLast: [{ type: Input }],
    disabled: [{ type: Input }],
    page: [{ type: Output }]
};

class MatPaginationModule {
}
MatPaginationModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MatSelectModule,
                    MatTooltipModule$1,
                    MatDropdownModule,
                    MatInputNumberModule
                ],
                exports: [MatPagination],
                declarations: [MatPagination],
                providers: [],
            },] }
];

const MAT_DEFAULT_POPOVER_POSITION = 'TL';
const MAT_DEFAULT_POPOVER_ACTION = 'click';
const MAT_POPOVER_PANEL_CLASS = 'mat-popover-panel';
/** Options used to bind passive event listeners. */
const passiveListenerOptions$1 = normalizePassiveListenerOptions({ passive: true });
class MatPopoverComponent {
    constructor(cd) {
        this.cd = cd;
        /** Property watched by the animation framework to show or hide the popover. */
        this.visibility = 'initial';
        /** Whether interactions on the page should close the popover. */
        this._closeOnInteraction = false;
        /** Subject for notifying that the popover has been hidden from the view */
        this._onHide = new Subject();
        /** Subject for notifying that the popover has been mouseenter from the view */
        this._onEnter = new Subject();
        /** Subject for notifying that the popover has been mouseleave from the view */
        this._onLeave = new Subject();
    }
    set content(value) {
        this._isTemplateContent = value instanceof TemplateRef;
        this._content = value;
    }
    get content() {
        return this._content;
    }
    set header(value) {
        this._isTemplateHeader = value instanceof TemplateRef;
        this._header = value;
    }
    get header() {
        return this._header;
    }
    set footer(value) {
        this._isTemplateFooter = value instanceof TemplateRef;
        this._footer = value;
    }
    get footer() {
        return this._footer;
    }
    /** Shows the popover with an animation originating from the provided origin. */
    show() {
        this._closeOnInteraction = true;
        this.visibility = 'visible';
        this.cd.markForCheck();
    }
    isVisible() {
        return this.visibility === 'visible';
    }
    animationStart() {
        this._closeOnInteraction = false;
    }
    animationDone(event) {
        const toState = event.toState;
        if (toState === 'hidden' && !this.isVisible()) {
            this._onHide.next();
        }
        if (toState === 'visible' || toState === 'hidden') {
            this._closeOnInteraction = true;
        }
    }
    hide() {
        this.visibility = 'hidden';
        this.cd.markForCheck();
    }
    /** Returns an observable that notifies when the popover has been hidden from view. */
    afterHidden() {
        return this._onHide.asObservable();
    }
    /** Returns an observable that notifies when the popover has been mouseenter from view. */
    onMouseEnter() {
        return this._onEnter.asObservable();
    }
    /** Returns an observable that notifies when the popover has been mouseleave from view. */
    onMouseLeave() {
        return this._onLeave.asObservable();
    }
    ngOnDestroy() {
        this._onHide.complete();
    }
}
MatPopoverComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-popover',
                exportAs: 'matPopoverComponent',
                animations: [matTooltipAnimations.tooltipState],
                template: "<div class=\"mat-popover\" [ngClass]=\"class\" [@state]=\"visibility\" (@state.start)=\"animationStart()\" (@state.done)=\"animationDone($event)\">\r\n    <div class=\"mat-popover-header\" *ngIf=\"header\">\r\n      <span class=\"mat-popover-header-content\">\r\n        <ng-template [ngTemplateOutlet]=\"_isTemplateHeader ? header : defaultHeader\" [ngTemplateOutletContext]=\"{$implicit: data, data: data }\"></ng-template>\r\n      </span>\r\n      <span *ngIf=\"showClose\" class=\"mat-popover-close\" (click)=\"hide()\">\u2573</span>\r\n    </div>\r\n    \r\n    <div class=\"mat-popover-content\" *ngIf=\"content\">\r\n      <ng-template [ngTemplateOutlet]=\"_isTemplateContent ? content : defaultContent\" [ngTemplateOutletContext]=\"{$implicit: data, data: data }\"></ng-template>\r\n    </div>\r\n\r\n    <div class=\"mat-popover-footer\" *ngIf=\"footer\">\r\n      <ng-template [ngTemplateOutlet]=\"_isTemplateFooter ? footer : defaultFooter\" [ngTemplateOutletContext]=\"{$implicit: data, data: data }\"></ng-template>\r\n    </div>\r\n    \r\n    <div class=\"mat-popover-arrow\"></div>\r\n</div>\r\n\r\n<ng-template #defaultHeader>\r\n  {{header}} \r\n</ng-template>\r\n\r\n<ng-template #defaultContent>\r\n  {{content}} \r\n</ng-template>\r\n\r\n<ng-template #defaultFooter>\r\n  {{footer}} \r\n</ng-template>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '(mouseenter)': '_onEnter.next()',
                    '(mouseleave)': '_onLeave.next()'
                }
            },] }
];
MatPopoverComponent.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
class MatPopoverDirective {
    constructor(_overlay, _viewContainerRef, _elementRef, _platform, scrollStrategy) {
        this._overlay = _overlay;
        this._viewContainerRef = _viewContainerRef;
        this._elementRef = _elementRef;
        this._platform = _platform;
        /** Manually-bound passive event listeners. */
        this._passiveListeners = new Map();
        this._position = MAT_DEFAULT_POPOVER_POSITION;
        this._disabled = false;
        this._showClose = false;
        this._action = MAT_DEFAULT_POPOVER_ACTION;
        this._scrollStrategy = scrollStrategy;
        this._connectedTo = this._elementRef;
    }
    set connectedTo(value) {
        this._clearEvent();
        this._connectedTo = value;
        this._updateEvent();
    }
    get connectedTo() {
        return this._connectedTo || this._elementRef;
    }
    get position() {
        return this._position || MAT_DEFAULT_POPOVER_POSITION;
    }
    set position(value) {
        if (value !== this._position) {
            this._position = value;
            if (this._overlay.hasOverlay()) {
                this._overlay.updatePosition(this._position);
                if (this._instance) {
                    this._instance.show();
                }
                this._overlay.updateOverlayPosition();
            }
        }
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
        if (this._disabled) {
            this.hide();
        }
    }
    get showClose() {
        return this._showClose;
    }
    set showClose(value) {
        if (this._showClose !== coerceBooleanProperty(value)) {
            this._showClose = coerceBooleanProperty(value);
            this._updateInstance();
        }
    }
    get class() {
        return this._class;
    }
    set class(value) {
        if (this._class !== value) {
            this._class = value;
            this._updateInstance();
        }
    }
    get content() {
        return this._content;
    }
    set content(value) {
        if (this._content !== value) {
            this._content = value;
            this._updateInstance();
        }
    }
    get header() {
        return this._header;
    }
    set header(value) {
        if (this._header !== value) {
            this._header = value;
            this._updateInstance();
        }
    }
    get footer() {
        return this._footer;
    }
    set footer(value) {
        if (this._footer !== value) {
            this._footer = value;
            this._updateInstance();
        }
    }
    get data() {
        return this._data;
    }
    set data(value) {
        if (this._data !== value) {
            this._data = value;
            this._updateInstance();
        }
    }
    get action() {
        return this._action;
    }
    set action(value) {
        if (this._action !== value) {
            this._action = value;
            this._updateEvent();
        }
    }
    set config(value) {
        if (value && typeof value === 'object') {
            const configKeys = ['position', 'disabled', 'showClose', 'class', 'content', 'header', 'footer', 'data', 'action'];
            configKeys.forEach(key => this[key] = value[key]);
        }
    }
    _updateInstance() {
        if (this._instance) {
            this._instance.class = this.class;
            this._instance.data = this.data;
            this._instance.footer = this.footer;
            this._instance.header = this.header;
            this._instance.content = this.content;
            this._instance.showClose = this.showClose;
            if (this._instance) {
                this._overlay.updateOverlayPosition();
            }
        }
    }
    show() {
        if (this.disabled || !this.content || this.isVisible()) {
            return;
        }
        this.clearHideTimeout();
        this._overlay.close();
        this._portal = this._portal || new ComponentPortal(MatPopoverComponent, this._viewContainerRef);
        this._instance = this._overlay.open(this.connectedTo, this._portal, {
            withTransformOriginOn: '.mat-popover',
            withViewportMargin: 0,
            hasBackdrop: this.action === 'click',
            scrollStrategy: this._scrollStrategy(),
            position: this.position,
            panelClass: MAT_POPOVER_PANEL_CLASS
        });
        if (this.action === 'mouse') {
            this._instance.onMouseEnter().subscribe(() => this.clearHideTimeout());
            this._instance.onMouseLeave().subscribe(() => this.hide());
        }
        else {
            this._overlay.afterClose().subscribe(() => this.hide());
        }
        this._instance.afterHidden().subscribe(() => this._overlay.close());
        this._updateInstance();
        this._instance.show();
        return this._instance;
    }
    hide() {
        if (this._instance) {
            this._hideTimeoutId = setTimeout(() => {
                this._hideTimeoutId = null;
                this._instance.hide();
            }, 10);
        }
    }
    clearHideTimeout() {
        if (this._hideTimeoutId) {
            clearTimeout(this._hideTimeoutId);
            this._hideTimeoutId = null;
        }
    }
    isVisible() {
        return !!this._instance && this._instance.isVisible();
    }
    toggle() {
        this.isVisible() ? this.hide() : this.show();
    }
    ngOnInit() {
        this._updateEvent();
    }
    ngOnDestroy() {
        this._clearEvent();
    }
    _updateEvent() {
        this._clearEvent();
        if (this.action === 'mouse') {
            this._setupPointerEvents();
        }
        else {
            this._setupClickEvent();
        }
    }
    _clearEvent() {
        const nativeElement = this.connectedTo instanceof ElementRef ? this.connectedTo.nativeElement : this.connectedTo;
        // Clean up the event listeners set in the constructor
        this._passiveListeners.forEach((listener, event) => {
            nativeElement.removeEventListener(event, listener, passiveListenerOptions$1);
        });
        this._passiveListeners.clear();
    }
    _setupClickEvent() {
        const nativeElement = this.connectedTo instanceof ElementRef ? this.connectedTo.nativeElement : this.connectedTo;
        this._passiveListeners.set('click', () => this.toggle());
        this._passiveListeners.forEach((listener, event) => {
            nativeElement.addEventListener(event, listener, passiveListenerOptions$1);
        });
    }
    /** Binds the pointer events to the popover trigger. */
    _setupPointerEvents() {
        // The mouse events shouldn't be bound on mobile devices, because they can prevent the
        // first tap from firing its click event or can cause the popover to open for clicks.
        if (!this._platform.IOS && !this._platform.ANDROID) {
            this._passiveListeners
                .set('mouseenter', () => this.show())
                .set('mouseleave', () => this.hide());
        }
        const nativeElement = this.connectedTo instanceof ElementRef ? this.connectedTo.nativeElement : this.connectedTo;
        this._passiveListeners.forEach((listener, event) => {
            nativeElement.addEventListener(event, listener, passiveListenerOptions$1);
        });
    }
}
MatPopoverDirective.decorators = [
    { type: Directive, args: [{
                selector: '[matPopover]',
                exportAs: 'matPopover',
                providers: [OverlayService]
            },] }
];
MatPopoverDirective.ctorParameters = () => [
    { type: OverlayService },
    { type: ViewContainerRef },
    { type: ElementRef },
    { type: Platform },
    { type: undefined, decorators: [{ type: Inject, args: [MAT_TOOLTIP_SCROLL_STRATEGY,] }] }
];
MatPopoverDirective.propDecorators = {
    position: [{ type: Input, args: ['matPopPosition',] }],
    disabled: [{ type: Input, args: ['matPopDisabled',] }],
    showClose: [{ type: Input, args: ['matPopShowClose',] }],
    class: [{ type: Input, args: ['matPopClass',] }],
    content: [{ type: Input, args: ['matPopContent',] }],
    header: [{ type: Input, args: ['matPopHeader',] }],
    footer: [{ type: Input, args: ['matPopFooter',] }],
    data: [{ type: Input, args: ['matPopData',] }],
    action: [{ type: Input, args: ['matPopAction',] }],
    config: [{ type: Input, args: ['matPopover',] }]
};

class MatPopoverModule {
}
MatPopoverModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                ],
                exports: [MatPopoverDirective, MatPopoverComponent],
                declarations: [MatPopoverDirective, MatPopoverComponent],
                entryComponents: [MatPopoverComponent],
                providers: [MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER, OverlayService],
            },] }
];

class MatPopover extends MatPopoverDirective {
    open(connectedTo, config) {
        this.config = config;
        this.connectedTo = connectedTo;
        return this.show();
    }
}
MatPopover.ɵprov = ɵɵdefineInjectable({ factory: function MatPopover_Factory() { return new MatPopover(ɵɵinject(OverlayService), ɵɵinject(ViewContainerRef), ɵɵinject(ElementRef), ɵɵinject(Platform), ɵɵinject(MAT_TOOLTIP_SCROLL_STRATEGY)); }, token: MatPopover, providedIn: MatPopoverModule });
MatPopover.decorators = [
    { type: Injectable, args: [{ providedIn: MatPopoverModule },] }
];

class MatReactiveTableField extends MatModalComponent {
    constructor() {
        super(...arguments);
        this.config = [];
        this.selected = [];
        this.configMap = {};
    }
    setConfigMap() {
        (this.config || []).forEach(item => {
            this.configMap[item.field] = { label: item.title, disabled: !!item.disabledToggle };
        });
    }
    removeItem(item) {
        this.selected = this.selected.filter(value => value !== item);
    }
    drop(event) {
        moveItemInArray(this.selected, event.previousIndex, event.currentIndex);
    }
    ngOnInit() {
        this.config = this.data.config || [];
        this.setConfigMap();
        this.selected = [...(this.data.selected || [])];
    }
}
MatReactiveTableField.decorators = [
    { type: Component, args: [{
                template: "<mat-modal-title>\r\n    \u8BBE\u7F6E\u5B57\u6BB5\u663E\u793A \r\n    <mat-modal-close></mat-modal-close>\r\n</mat-modal-title>\r\n<mat-modal-content>\r\n    <div class=\"mat-reactive-field-wapper\">\r\n        <div class=\"mat-reactive-field-left\">\r\n            <div class=\"mat-reactive-field-title\">\u663E\u793A\u5B57\u6BB5</div>\r\n            <mat-checkbox-list [dataSource]=\"config\" disabledField=\"disabledToggle\" valueField=\"field\" viewField=\"title\" [(ngModel)]=\"selected\"></mat-checkbox-list>\r\n        </div>\r\n        <div class=\"mat-reactive-field-right\">\r\n            <div class=\"mat-reactive-field-title\">\u5F53\u524D\u9009\u5B9A\u6392\u5E8F</div>\r\n            <div class=\"mat-reactive-field-selected\" cdkDropList (cdkDropListDropped)=\"drop($event)\">\r\n                <div class=\"mat-reactive-field-item\" *ngFor=\"let item of selected\" cdkDrag cdkDragLockAxis=\"y\">\r\n                  <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M634.311111 0c-34.133333 0-59.733333 25.6-59.733333 59.733333s28.444444 59.733333 59.733333 59.733334c34.133333 0 59.733333-25.6 59.733333-59.733334 2.844444-34.133333-25.6-59.733333-59.733333-59.733333z m0 301.511111c-34.133333 0-59.733333 25.6-59.733333 59.733333s28.444444 59.733333 59.733333 59.733334c34.133333 0 59.733333-25.6 59.733333-59.733334 2.844444-34.133333-25.6-59.733333-59.733333-59.733333z m0 301.511111c-34.133333 0-59.733333 25.6-59.733333 59.733334s28.444444 59.733333 59.733333 59.733333c34.133333 0 59.733333-25.6 59.733333-59.733333 2.844444-34.133333-25.6-59.733333-59.733333-59.733334-31.288889 0 0 0 0 0z m0 301.511111c-34.133333 0-59.733333 25.6-59.733333 59.733334 0 34.133333 28.444444 59.733333 59.733333 59.733333 34.133333 0 59.733333-25.6 59.733333-59.733333 2.844444-34.133333-25.6-59.733333-59.733333-59.733334-31.288889 0 0 0 0 0zM372.622222 0C341.333333 0 312.888889 25.6 312.888889 59.733333s28.444444 59.733333 59.733333 59.733334c34.133333 0 59.733333-25.6 59.733334-59.733334 2.844444-34.133333-25.6-59.733333-59.733334-59.733333z m0 301.511111c-34.133333 0-59.733333 25.6-59.733333 59.733333s28.444444 59.733333 59.733333 59.733334c34.133333 0 59.733333-25.6 59.733334-59.733334 2.844444-34.133333-25.6-59.733333-59.733334-59.733333z m0 301.511111c-34.133333 0-59.733333 25.6-59.733333 59.733334s28.444444 59.733333 59.733333 59.733333c34.133333 0 59.733333-25.6 59.733334-59.733333 2.844444-34.133333-25.6-59.733333-59.733334-59.733334z m0 301.511111c-34.133333 0-59.733333 25.6-59.733333 59.733334 0 34.133333 28.444444 59.733333 59.733333 59.733333 34.133333 0 59.733333-25.6 59.733334-59.733333 2.844444-34.133333-25.6-59.733333-59.733334-59.733334z\" fill=\"currentColor\"></path></svg>\r\n                  <span class=\"mat-reactive-field-item-text\">{{configMap[item].label}}</span>\r\n                  <span class=\"mat-close-icon\" (click)=\"removeItem(item)\" *ngIf=\"!configMap[item].disabled\"></span>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</mat-modal-content>\r\n<mat-modal-actions>\r\n    <mat-buttons [mat-modal-close]=\"false\" type=\"default\" label=\"\u53D6\u6D88\"></mat-buttons>\r\n    <mat-buttons [mat-modal-close]=\"selected\" type=\"fill\" label=\"\u4FDD\u5B58\"></mat-buttons>\r\n</mat-modal-actions>"
            },] }
];

const MAT_REACTIVE_TABLE_PLACEHOLDER = '--';
const MAT_REACTIVE_TABLE_DISABLED_FIELD = 'disabled';
const MAT_REACTIVE_TABLE_PAGE_OPTIONS = [20, 40, 60, 80, 100];
class MatReactiveTable {
    constructor(_cd, _renderer, _ele, _http, _viewContainerRef, _overlay, _date, _lower, _upper, _number, _percent, _modal) {
        this._cd = _cd;
        this._renderer = _renderer;
        this._ele = _ele;
        this._http = _http;
        this._viewContainerRef = _viewContainerRef;
        this._overlay = _overlay;
        this._date = _date;
        this._lower = _lower;
        this._upper = _upper;
        this._number = _number;
        this._percent = _percent;
        this._modal = _modal;
        this.displayDataSource = [];
        /** Field name of disabled when datasource as objecet array. */
        this.disabledField = MAT_REACTIVE_TABLE_DISABLED_FIELD;
        this.sort = { sortName: '', sortValue: '' };
        this.headerSearch = {};
        this.lazy = true;
        this.lazyLoad = new EventEmitter();
        this.keyvalueOrder = (a, b) => 1;
        /** Row placeholder when data is empty. */
        this.placeholder = MAT_REACTIVE_TABLE_PLACEHOLDER;
        this._displayedColumns = [];
        this._rowSelectable = (data) => !!data[this.disabledField || MAT_REACTIVE_TABLE_DISABLED_FIELD];
        this._columns = [];
        this._dataSource = [];
        this._operations = [];
        this.canSetField = true;
        this.canExport = true;
        this._toolbarButtons = [];
        this._total = 0;
        this.viewField = 'view';
        this._viewOptions = [];
        /** Fuzzy search placeholder. */
        this.fuzzyPlaceholder = '请输入您要查找的内容';
        this.fuzzyField = 'fuzzy';
        /**
         * Table Resize.
         */
        this.pressed = false;
        this.operateWidth = 1;
    }
    set displayedColumns(value) {
        this._displayedColumns = Array.isArray(value) ? value : [];
    }
    get displayedColumns() {
        if (this.selectable && this.operations.length > 0) {
            return ['system_select', ...this._displayedColumns, 'system_operate'];
        }
        else if (this.selectable) {
            return ['system_select', ...this._displayedColumns];
        }
        else if (this.operations.length > 0) {
            return [...this._displayedColumns, 'system_operate'];
        }
        else {
            return this._displayedColumns;
        }
    }
    get selectable() { return this._selectable; }
    set selectable(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this._selectable) {
            this._selectable = newValue;
            this._cd.markForCheck();
        }
    }
    /** Comparison function to specify which row is selectable. */
    get rowSelectable() { return this._rowSelectable; }
    set rowSelectable(fn) {
        if (typeof fn !== 'function') {
            throw Error(`"rowSelectable" must be a function.'`);
        }
        this._rowSelectable = fn;
    }
    /** Columns change. */
    get columns() { return this._columns; }
    set columns(value) {
        this._columns = (value || []).filter(item => {
            if (item.field) {
                item.title = MatUtils.executeStringValue(item.title, this);
            }
            return !!item.field;
        });
        this.transformDataSource();
    }
    /** The dataSource. */
    get dataSource() { return this._dataSource || []; }
    set dataSource(value) {
        this._dataSource = value;
        this.transformDataSource();
    }
    renderTable() {
        this.transformDataSource();
        this.matTable.renderRows();
    }
    /** All of operation in table. */
    get operations() { return this._operations || []; }
    set operations(value) {
        this._operations = value || [];
    }
    openOperations(rowData, event) {
        this._operations.forEach(item => {
            if (item.disabled) {
                const disabled = MatUtils.executeBooleanValue(item.disabled, rowData._metadata);
                item._disabled = !!disabled;
                item._disabledTitle = disabled || '';
            }
            else {
                item._disabled = false;
                item._disabledTitle = '';
            }
        });
        this.openOperationsOverlay(rowData, event.target);
    }
    openOperationsOverlay(rowData, connectedTo) {
        this._overlay.close();
        this._operationPortal = this._operationPortal || new TemplatePortal(this.operationsTemplate, this._viewContainerRef, { $implicit: rowData._metadata });
        this._overlay.open(connectedTo, this._operationPortal, {
            withViewportMargin: 0,
            hasBackdrop: true,
            scrollStrategy: this._overlay._overlay.scrollStrategies.reposition(),
            position: 'RT',
            offsetX: 4,
            panelClass: 'mat-menu-panel',
        });
    }
    closeOperationsOverlay(rowData) {
        this._overlay.close();
    }
    /** The operate and select cell width. */
    get systemSelectWidth() {
        return this.selectable ? 16 : 0;
    }
    get toolbarButtons() { return this._toolbarButtons || []; }
    set toolbarButtons(value) {
        this._toolbarButtons = value || [];
        this.outsideButtons = [];
        this.insideButtons = [];
        this._toolbarButtons.forEach(item => {
            if (item.outside) {
                this.outsideButtons.push(item);
            }
            else {
                this.insideButtons.push(item);
            }
        });
    }
    get total() { return this._total || 0; }
    set total(value) {
        if (value !== this._total) {
            this._total = value;
            this._cd.markForCheck();
        }
    }
    get pageSizeOptions() { return this._pageSizeOptions || MAT_REACTIVE_TABLE_PAGE_OPTIONS; }
    set pageSizeOptions(value) {
        this._pageSizeOptions = value;
        if (value) {
            this._cd.markForCheck();
        }
    }
    get pageSize() { return this._pageSize || this.pageSizeOptions[0]; }
    set pageSize(value) {
        if (value !== this._pageSize) {
            this._pageSize = value;
        }
    }
    onPage(event) {
        const search = Object.assign(Object.assign(Object.assign(Object.assign({}, event), { [this.fuzzyField]: this.fuzzyText }), this.sort), { [this.viewField]: this.viewActive });
        Object.keys(this.headerSearch).forEach(key => search[key] = this.headerSearch[key].value);
        this._previousSearch = Object.assign({}, search);
        if (this.lazy) {
            this.lazyLoad.emit(search);
        }
        else {
        }
    }
    openToolbarMenu(menuTrigger) {
        const hostMenuElement = this._ele.nativeElement.querySelector('.mat-reactive-table-menu-host');
        const width = getComputedStyle(hostMenuElement).width;
        this.toolbarMenuMinWidth = width;
        menuTrigger.openMenu();
    }
    // Reset all of the table condition.
    resetTable() {
        this.removeSearch();
        this.fuzzyText = '';
        this.matPagination.reset();
    }
    refreshTable() {
        this.lazyLoad.emit(this._previousSearch);
    }
    set viewOptions(value) {
        this._viewOptions = value || [];
        if (this._viewOptions.length && !this.viewActive) {
            const defaultIndex = this._viewOptions.findIndex(view => !!view.default);
            this.viewActive = this._viewOptions[Math.max(0, defaultIndex)].value;
        }
    }
    get viewOptions() {
        return this._viewOptions;
    }
    toggleView(view) {
        this.viewActive = view.value;
        this.matPagination.reset();
    }
    /** Fuzzy searc trigger by key enter. */
    fuzzyEnterSearch(event) {
        const keyCode = event.keyCode;
        event.stopPropagation();
        if (keyCode === ENTER) {
            this.fuzzyIconSearch();
        }
    }
    /** Fuzzy searc trigger by icon. */
    fuzzyIconSearch() {
        this.fuzzyText = this.fuzzyInput.value;
        this.matPagination.reset();
    }
    /** Reorder and hidden fields. */
    openFieldModel() {
        const modelRef = this._modal.dialog(MatReactiveTableField, {
            width: '800px',
            height: '565px',
            autoFocus: false,
            restoreFocus: false,
            disableClose: true,
            data: {
                config: this.columns,
                selected: this._displayedColumns
            }
        });
        modelRef.afterClosed().subscribe(e => this.afterFieldModelClose(e));
    }
    afterFieldModelClose(e) {
        if (e) {
            this.displayedColumns = e;
            if (this.matTableRef.nativeElement.style.width) {
                const wapperWidth = parseFloat(this.getWapperStyle('width'));
                let afterWapperWidth = 0;
                const newCol = this.columns.filter(item => {
                    let result = false;
                    if (e.includes(item.field)) {
                        result = !item.width;
                        item.width = item.width || (Math.max(50, item.field.length * 16));
                        afterWapperWidth = afterWapperWidth + item.width;
                    }
                    return result;
                });
                if (afterWapperWidth < wapperWidth) {
                    if (newCol.length) {
                        newCol[newCol.length - 1].width = wapperWidth - afterWapperWidth - newCol[newCol.length - 1].width;
                    }
                    else {
                        console.log(afterWapperWidth + '--' + wapperWidth);
                        this.columns.forEach(item => {
                            if (e.includes(item.field)) {
                                item.width = item.width + (wapperWidth - afterWapperWidth) / e.length;
                            }
                        });
                    }
                }
            }
        }
    }
    /**
     * Select or UnSelect.
     */
    /** Toogle all. */
    toggleAll(event) {
        if (event.checked) {
            this.selectAll();
        }
        else {
            this.unSelectAll();
        }
    }
    /** Select all. */
    selectAll() {
        this.unSelectAll();
        this.displayDataSource.forEach(item => {
            if (!item.disabled) {
                this._selectionModel.select(item._metadata);
            }
        });
    }
    /** Unselect all. */
    unSelectAll() {
        this._selectionModel.clear();
    }
    /** Where the selectModel has value. */
    hasSelected() {
        return this._selectionModel.hasValue();
    }
    /** Where the row is selected. */
    isSelected(rowData) {
        return this._selectionModel.isSelected(rowData._metadata);
    }
    /** Toggle the row data. */
    toggleRow(event, rowData) {
        this._selectionModel.toggle(rowData._metadata);
    }
    /** Where all data is sekected. */
    isAllSelected() {
        const numSelected = this._selectionModel.selected.length;
        const numRows = this.displayDataSource.filter(item => !item.disabled).length;
        return numSelected && numSelected === numRows;
    }
    ngOnInit() {
        this._selectionModel = new SelectionModel(true, undefined, false);
    }
    ngAfterViewInit() {
        // this.setTableWidth();
    }
    ngAfterContentInit() {
    }
    ngOnChanges(simple) {
    }
    ngOnDestroy() {
    }
    /**
     * column sort and filter.
     */
    // Where this header can open a panel for sort or filter
    isHeaderPanel(column) {
        return !!column.panel;
    }
    getColumnByKey(key) {
        return this.columns.find(item => item.field === key);
    }
    isHeaderActive(column) {
        if (this.sort.sortName === column.field && this.sort.sortValue) {
            return true;
        }
        else if (this.headerSearch[column.field]) {
            return true;
        }
        return false;
    }
    removeSearch(field) {
        if (field) {
            delete this.headerSearch[field];
        }
        else {
            this.headerSearch = {};
        }
        this.matPagination.reset();
    }
    hasSearch() {
        return this.headerSearch && Object.keys(this.headerSearch).length > 0;
    }
    /**
     *  Table Data source transform.
     */
    dateFormat(data, value) {
        return this._date.transform(data, value || 'YYYY-MM-DD');
    }
    numberFormat(data, value) {
        return this._number.transform(data, value || '1.0-2');
    }
    percentFormat(data, value) {
        return this._percent.transform(data, value);
    }
    lowercaseFormat(data, value) {
        return this._lower.transform(data);
    }
    uppercaseFormat(data, value) {
        return this._upper.transform(data);
    }
    dictFormat(data, value) {
        return value;
    }
    functionFormat(data, value) {
        const fun = MatUtils.executeFunctionValue(value);
        return fun ? fun(data) : data;
    }
    transformDataSource() {
        this.displayDataSource = this.dataSource.map((data) => this.formatRowData(data));
    }
    formatRowOperations(row) {
        row.system_operate = this.operations.map(item => {
            if (item.disabled) {
                const disabled = MatUtils.executeBooleanValue(item.disabled, row._metadata);
                return Object.assign({}, item, { _disabled: !!disabled, _disabledTitle: disabled || '' });
            }
            else {
                return Object.assign({}, item, { _disabled: false, _disabledTitle: '' });
            }
        });
    }
    formatRowData(data) {
        const row = {};
        this.columns.forEach(item => {
            const name = item.field;
            row._metadata = data;
            row.disabled = this.rowSelectable(data);
            if (name) {
                row[name] = MatUtils.getObjectValue(name, data);
                if (item.format && item.format.type && this[item.format.type + 'Format']) {
                    row[name] = this[item.format.type + 'Format'](data, item.format.value);
                }
                row[name] = MatUtils.isEmpty(row[name]) ? this.placeholder : row[name];
            }
        });
        this.formatRowOperations(row);
        return row;
    }
    /** Wherer the config has resize colmun. */
    isResizeable() {
        return this.columns.some(item => item.resizeable);
    }
    /** Set the table width after viewinit or columns change. */
    setTableWidth() {
        let tableWidth = 0;
        this._displayedColumns.forEach(col => {
            const colWidth = this.getColumnWidth(col);
            tableWidth = tableWidth + colWidth + 25;
            this.getColumnByKey(col).width = colWidth;
        });
        this.operateWidth = this.getColumnWidth('system_operate');
        this.matTableRef.nativeElement.style.width = tableWidth + this.systemSelectWidth + 24 + 'px';
    }
    /** Add resize event. */
    onResizeColumn(event, currentIndex) {
        this.setTableWidth();
        const wapperWidth = parseFloat(this.getWapperStyle('width'));
        const field = this.columns[currentIndex].field;
        const displayIndex = this.displayedColumns.indexOf(field);
        const nextIndex = this.columns.findIndex(item => item.field == this.displayedColumns[displayIndex + 1]);
        const startWidth = this.columns[currentIndex].width;
        const nextWidth = this.columns[nextIndex].width;
        const startTableWidth = parseFloat(this.matTableRef.nativeElement.style.width);
        this.pressed = true;
        this.startX = event.pageX;
        event.preventDefault();
        this.mouseMove(currentIndex, nextIndex, wapperWidth, startWidth, nextWidth, startTableWidth);
    }
    getWapperStyle(key) {
        const style = getComputedStyle(this._ele.nativeElement.querySelector('.mat-reactive-table-wapper'));
        return style[key];
    }
    mouseMove(index, nextIndex, wapperWidth, startWidth, nextWidth, startTableWidth) {
        this.resizableMousemove = this._renderer.listen('document', 'mousemove', (event) => {
            if (this.pressed && event.buttons) {
                const dx = event.pageX - this.startX;
                const colWidth = startWidth + dx;
                if (colWidth > 50) {
                    this.columns[index].width = colWidth;
                    const maxTableWidth = startTableWidth + (this.operateWidth ? this.operateWidth + 25 : 0) + dx;
                    if (maxTableWidth < wapperWidth) {
                        this.columns[nextIndex].width = nextWidth + (wapperWidth - maxTableWidth);
                        this.matTableRef.nativeElement.style.width = wapperWidth + 'px';
                    }
                    else {
                        this.matTableRef.nativeElement.style.width = maxTableWidth + 'px';
                    }
                }
            }
        });
        this.resizableMouseup = this._renderer.listen('document', 'mouseup', (event) => {
            if (this.pressed) {
                this.pressed = false;
                this.resizableMousemove();
                this.resizableMouseup();
            }
        });
    }
    setColumnWidth(width, field) {
        this.getColumnByKey(field).width = width;
    }
    getColumnWidth(field) {
        const thElement = this.matTableRef.nativeElement.querySelector('th.' + 'mat-column-' + field);
        return thElement ? parseFloat(getComputedStyle(thElement).width) : 0;
    }
}
MatReactiveTable.decorators = [
    { type: Component, args: [{
                selector: 'mat-reactive-table',
                template: "<div class=\"mat-reactive-table-result\" *ngIf=\"hasSearch()\">\r\n    <div class=\"mat-reactive-table-result-text\">\r\n        \u67E5\u8BE2\u5230<span class=\"mat-reactive-table-result-number\">{{total}}</span>\u6761\u7ED3\u679C <span class=\"mat-close-icon\" (click)=\"removeSearch()\"></span>\r\n    </div>\r\n    <div class=\"mat-reactive-table-result-option\" [search]=\"headerSearch\" (onSort)=\"matPagination.reset()\" [matReactiveSort]=\"sort\" [config]=\"getColumnByKey(option.key)\" *ngFor=\"let option of headerSearch | keyvalue: keyvalueOrder\">\r\n        <span class=\"mat-reactive-table-result-option-text\">{{option.value.view}}</span>\r\n        <span class=\"mat-close-icon\" (click)=\"removeSearch(option.key)\"></span>\r\n    </div>\r\n</div>\r\n\r\n<!-- Table toolbar -->\r\n<div class=\"mat-reactive-table-toolbar\">\r\n    <div class=\"mat-reactive-table-toolbar-left\">\r\n        <div class=\"mat-reactive-table-toolbar-fuzzy\">\r\n            <mat-input [placeholder]=\"fuzzyPlaceholder\" #fuzzyInput trim (keydown)=\"fuzzyEnterSearch($event)\">\r\n                <mat-input-after (click)=\"fuzzyIconSearch()\">\r\n                    <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                        <path path fill=\"currentColor\" d=\"M757.372928 734.871552l260.227072 218.35776a0.512 0.512 0 0 1 0.063488 0.720896l-38.887424 46.343168a0.512 0.512 0 0 1-0.720896 0.063488L713.900032 778.704896c-75.71456 66.17088-174.798848 106.26048-283.246592 106.26048C192.809984 884.9664 0 692.13184 0 454.259712 0 216.38656 192.809984 23.552 430.65344 23.552s430.65344 192.83456 430.65344 430.706688c0 107.191296-39.15264 205.236224-103.933952 280.612864z m-326.719488 88.56576c203.866112 0 369.13152-165.286912 369.13152-369.178624 0-203.890688-165.265408-369.1776-369.13152-369.1776-203.866112 0-369.13152 165.286912-369.13152 369.1776 0 203.891712 165.265408 369.1776 369.13152 369.1776z\"></path>\r\n                    </svg>\r\n                </mat-input-after>\r\n            </mat-input>\r\n        </div>\r\n        <div class=\"mat-buttons mat-buttons-default mat-buttons-md\" *ngIf=\"canExport\">\r\n            <button mat-button class=\"mat-stroked-button\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path d=\"M499.6 724.1c6.8 6.8 17.7 6.8 24.4 0l281.4-276.7c4.9-5 6.4-12.4 3.8-18.9-2.7-6.4-9-10.6-16-10.6l-169.8 0.1V137.3c0-9.6-7.8-17.3-17.3-17.3H418.2c-4.6 0-9 1.8-12.2 5-3.2 3.2-5.1 7.7-5.1 12.2V418l-170.2 0.1c-4.7 0-9 1.9-12.2 5.1-1.6 1.6-2.9 3.5-3.8 5.6-2.7 6.5-1.2 13.9 3.8 18.8l281.1 276.5z\" fill=\"currentColor\"></path>\r\n                    <path d=\"M875.1 630.6h-50.5c-11.4 0-20.6 9.2-20.6 20.6v161H222.4v-161c0-11.4-9.2-20.6-20.6-20.6h-52.9c-11.4 0-20.6 9.2-20.6 20.6v191.6c0 33.8 27.4 61.2 61.2 61.2h645.1c33.8 0 61.2-27.4 61.2-61.2V651.2c-0.1-11.3-9.3-20.6-20.7-20.6z\" fill=\"currentColor\"></path>\r\n                </svg>\r\n                \u5BFC\u51FA\r\n            </button>\r\n        </div>\r\n        <div class=\"mat-buttons mat-buttons-default mat-buttons-md\" *ngIf=\"canSetField\">\r\n            <button mat-button class=\"mat-stroked-button\" (click)=\"openFieldModel()\">\r\n                <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                    <path d=\"M881 512c0-52.4 32.9-96.8 79-114.5-11-43.2-28-83.9-50.2-121.3C864.6 296.3 810 288.1 773 251c-37-37-45.2-91.7-25.1-136.8C710.4 92 669.7 75 626.5 64c-17.8 46.1-62.2 79-114.5 79-52.4 0-96.8-32.9-114.5-79-43.2 11-83.9 28-121.3 50.2 20.1 45.2 11.9 99.8-25.1 136.8-37 37-91.7 45.2-136.8 25.2C92 313.6 75 354.3 64 397.5c46.1 17.8 79 62.2 79 114.5 0 52.4-32.9 96.8-79 114.5 11 43.2 28 83.9 50.2 121.3C159.4 727.7 214 735.9 251 773c37 37 45.2 91.7 25.1 136.8C313.6 932 354.3 949 397.5 960c17.8-46.1 62.2-79 114.5-79 52.4 0 96.8 32.9 114.5 79 43.2-11 83.9-28 121.3-50.2-20.1-45.2-11.9-99.8 25.1-136.8 37-37 91.7-45.2 136.8-25.2C932 710.4 949 669.7 960 626.5c-46.1-17.7-79-62.1-79-114.5zM512 635c-67.9 0-123-55.1-123-123s55.1-123 123-123 123 55.1 123 123-55.1 123-123 123z\" fill=\"currentColor\"></path>\r\n                </svg>\r\n                \u663E\u793A\u5B57\u6BB5\r\n            </button>\r\n        </div>\r\n        <!-- TODO:  \u7B2C\u4E09\u7248 \u89C6\u56FE\u4E0B\u62C9\u7EC4\u4EF6 \u3010\u52FF\u52A8\u3011 --start -->\r\n        <!-- <div class=\"mat-buttons mat-buttons-text mat-buttons-md mat-reactive-table-viewbtn\">\r\n            <button mat-button [matMenuTriggerFor]=\"viewMenu\">\r\n                <svg class=\"view\" viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path fill=\"currentColor\" d=\"M512 128q69.674667 0 135.509333 21.162667t115.498667 54.997333 93.482667 74.837333 73.685333 82.005333 51.669333 74.837333 32.170667 54.826667l9.984 21.333333q-2.346667 4.992-6.314667 13.482667t-18.816 34.688-31.658667 51.669333-44.330667 59.989333-56.832 64.341333-69.504 60.16-82.346667 51.498667-94.848 34.688-107.349333 13.482667q-69.674667 0-135.509333-21.162667t-115.498667-54.826667-93.482667-74.325333-73.685333-81.493333-51.669333-74.496-32.170667-54.997333l-9.984-20.992q2.346667-4.992 6.314667-13.482667t18.816-34.816 31.658667-51.84 44.330667-60.330667 56.832-64.682667 69.504-60.330667 82.346667-51.84 94.848-34.816 107.349333-13.482667zM512 213.333333q-46.677333 0-91.648 12.330667t-81.152 31.829333-70.656 47.146667-59.648 54.485333-48.853333 57.685333-37.674667 52.821333-26.325333 43.989333q12.330667 21.674667 26.325333 43.52t37.674667 52.352 48.853333 57.002667 59.648 53.845333 70.656 46.677333 81.152 31.488 91.648 12.16 91.648-12.330667 81.152-31.658667 70.656-46.848 59.648-54.186667 48.853333-57.344 37.674667-52.650667 26.325333-43.648q-12.330667-21.674667-26.325333-43.648t-37.674667-52.650667-48.853333-57.344-59.648-54.186667-70.656-46.848-81.152-31.658667-91.648-12.330667zM512 341.333333q70.656 0 120.661333 50.005333t50.005333 120.661333-50.005333 120.661333-120.661333 50.005333-120.661333-50.005333-50.005333-120.661333 50.005333-120.661333 120.661333-50.005333zM512 426.666667q-35.328 0-60.330667 25.002667t-25.002667 60.330667 25.002667 60.330667 60.330667 25.002667 60.330667-25.002667 25.002667-60.330667-25.002667-60.330667-60.330667-25.002667z\"></path></svg>\r\n                \u5168\u90E8\r\n                <svg class=\"arrow\" viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path d=\"M511.936 704.032a31.584 31.584 0 0 1-22.4-9.28L127.2 332.48a31.808 31.808 0 0 1 0.128-45.12 31.904 31.904 0 0 1 45.12-0.128L512 626.72l339.552-339.52a31.808 31.808 0 0 1 45.12 0.128 31.904 31.904 0 0 1 0.128 45.12L534.464 694.784a31.616 31.616 0 0 1-22.4 9.28h-0.128z\" fill=\"currentColor\"></path></svg>\r\n            </button>\r\n            <mat-menu #viewMenu=\"matMenu\">\r\n                <button *ngFor=\"let item of viewOptions\"  mat-menu-item (click)=\"toggleView($event)\">{{item.label}}</button>\r\n            </mat-menu>\r\n        </div> -->\r\n        <!-- \u7B2C\u4E09\u7248 \u89C6\u56FE\u4E0B\u62C9\u7EC4\u4EF6 --end -->\r\n    </div>\r\n    <div class=\"mat-reactive-table-toolbar-right\">\r\n\r\n        <ng-container *ngFor=\"let item of outsideButtons; index as index\" >\r\n            <mat-buttons *ngIf=\"!!item.outside\" class=\"mat-reactive-table-toolbar-right-button\" type=\"fill\" [label]=\"item.label\" [target]=\"item.target\" [href]=\"item.href\" (matClick)=\"item.click && item.click($event)\"></mat-buttons>\r\n        </ng-container>\r\n\r\n        <ng-container *ngIf=\"insideButtons.length\">\r\n            <div class=\"mat-buttons mat-buttons-outline mat-buttons-md\" >\r\n                <button [matMenuTriggerFor]=\"menu\" mat-button class=\"mat-stroked-button mat-primary mat-reactive-table-toolbar-more-button\" >\r\n                    \u529F\u80FD\u64CD\u4F5C\r\n                    <div class=\"mat-reactive-table-toolbar-arrow\"></div>\r\n                </button>\r\n            </div>\r\n\r\n            <mat-menu #menu=\"matMenu\" class=\"mat-reactive-table-toolbar-menu\">\r\n                <a *ngFor=\"let item of insideButtons\" mat-menu-item [target]=\"item.target || null\" [attr.href]=\"item.href || null\" (click)=\"item.click && item.click($event)\">{{item.label}}</a>\r\n            </mat-menu>\r\n        </ng-container>\r\n\r\n        <!-- TODO: \u4E0D\u80FD\u5220\u9664\u4E00\u4E0B\u4EE3\u7801\u3010\u52FF\u52A8\u3011 -->\r\n        <!-- <span class=\"mat-reactive-table-toolbar-button-wapper\" *ngIf=\"toolbarButtons.length\" >\r\n            <mat-buttons class=\"mat-reactive-table-toolbar-right-button\" [class.with-arrow]=\"toolbarButtons.length > 1\" type=\"fill\" [label]=\"toolbarButtons[0].label\" [target]=\"toolbarButtons[0].target\" [href]=\"toolbarButtons[0].href\" (matClick)=\"toolbarButtons[0].click && toolbarButtons[0].click($event)\"></mat-buttons>\r\n            <ng-container *ngIf=\"toolbarButtons.length > 1\" >\r\n                <div class=\"mat-reactive-table-menu-host\" #matMenuTriggerHost=\"matMenuTrigger\" [matMenuTriggerFor]=\"menu\"></div>\r\n                <mat-buttons (matClick)=\"openToolbarMenu(matMenuTriggerHost)\" class=\"mat-reactive-table-toolbar-arrow-button\" icon=\"icon-bottom\"  type=\"icon\"></mat-buttons>\r\n                <mat-menu #menu=\"matMenu\" class=\"mat-reactive-table-toolbar-menu\">\r\n                    <div [style.minWidth]=\"toolbarMenuMinWidth\" >\r\n                        <ng-container *ngFor=\"let item of toolbarButtons | slice:1\" >\r\n                            <a mat-menu-item *ngIf=\"item.href\" [target]=\"item.target || null\" [attr.href]=\"item.href || null\" (click)=\"item.click && item.click($event)\">{{item.label}}</a>\r\n                            <button mat-menu-item *ngIf=\"!item.href\" (click)=\"item.click && item.click($event)\">{{item.label}}</button>\r\n                        </ng-container>\r\n                    </div>\r\n                </mat-menu>\r\n            </ng-container>\r\n        </span> -->\r\n        <mat-pagination (page)=\"onPage($event)\" [simple]=\"true\" [total]=\"total\" [pageSize]=\"pageSize\" [pageSizeOptions]=\"pageSizeOptions\"> </mat-pagination>\r\n    </div>\r\n</div>\r\n\r\n<!-- Table view -->\r\n<div class=\"mat-reactive-table-tabs\" *ngIf=\"viewOptions.length\">\r\n    <div class=\"mat-reactive-table-tabs-item\" (click)=\"toggleView(item)\" [class.active]=\"item.value == viewActive\" *ngFor=\"let item of viewOptions\">{{item.label}}</div>\r\n</div>\r\n\r\n<div class=\"mat-reactive-table-wapper\">\r\n    <table mat-table [dataSource]=\"displayDataSource\" cdkDropListGroup>\r\n\r\n        <ng-container matColumnDef=\"system_select\" sticky>\r\n            <th mat-header-cell *matHeaderCellDef [style.width.px]=\"systemSelectWidth\" class=\"mat-sticky-start\">\r\n                <mat-checkbox *ngIf=\"selectable\" (change)=\"toggleAll($event)\" [checked]=\"hasSelected() && isAllSelected()\"></mat-checkbox>\r\n            </th>\r\n            <td mat-cell *matCellDef=\"let rowData\" class=\"mat-sticky-start\" (click)=\"$event.stopPropagation()\" [style.width.px]=\"systemSelectWidth\">\r\n                <div class=\"mat-table-system_select-wapper\" [style.width.px]=\"systemSelectWidth\">\r\n                    <mat-checkbox *ngIf=\"selectable\" [disabled]=\"rowData.disabled\" (change)=\"toggleRow($event, rowData)\" [checked]=\"isSelected(rowData)\"></mat-checkbox>\r\n                    <!-- <div class=\"mat-table-operate-icon\" (click)=\"openOperations(rowData, $event)\">\r\n                        <span class=\"mat-table-operate-dot\"></span>\r\n                        <span class=\"mat-table-operate-dot\"></span>\r\n                        <span class=\"mat-table-operate-dot\"></span>\r\n                    </div> -->\r\n                </div>\r\n            </td>\r\n        </ng-container>\r\n\r\n        <ng-container matColumnDef=\"system_operate\" [stickyEnd]=\"true\">\r\n            <th mat-header-cell *matHeaderCellDef class=\"mat-sticky-end\" [style.width.px]=\"operateWidth\">\u64CD\u4F5C</th>\r\n            <td mat-cell *matCellDef=\"let rowData\"  class=\"mat-sticky-end\" (click)=\"$event.stopPropagation()\" [style.width.px]=\"operateWidth\">\r\n                <div class=\"mat-table-system_operate-wapper\">\r\n                    <span class=\"mat-table-system_operate-item\" *ngFor=\"let item of rowData.system_operate\" >\r\n                        <mat-buttons [disabled]=\"item._disabled\" [title]=\"item._disabledTitle\" [label]=\"item.label\" type=\"text\"></mat-buttons>\r\n                    </span>\r\n                </div>\r\n            </td>\r\n        </ng-container>\r\n\r\n        <!-- Dynamic Column -->\r\n        <ng-container [matColumnDef]=\"col.field\" *ngFor=\"let col of columns; index as index; first as first; last as last\" [stickyEnd]=\"col.sticky === 'end'\">\r\n            <th mat-header-cell *matHeaderCellDef #reactiveHeader [ngClass]=\"['mat-sticky-' + col.sticky]\" [style.width.px]=\"col.width\">\r\n                <!-- <div class=\"mat-header-resizer left \" *ngIf=\"!first && col.resizeable\" (mousedown)=\"onResizeColumn($event, col.field)\"></div> -->\r\n                <span class=\"mat-reactive-table-label\" [class.mat-reactive-table-label-active]=\"isHeaderActive(col)\" [class.mat-reactive-table-label-hover]=\"isHeaderPanel(col)\" [search]=\"headerSearch\" [matReactiveSort]=\"sort\" (onSort)=\"matPagination.reset()\" [config]=\"col\" [connectedTo]=\"reactiveHeader\">\r\n                    {{col.title}}\r\n                    <span class=\"mat-reactive-table-sort\" *ngIf=\"isHeaderPanel(col)\"></span>\r\n                </span>\r\n                <div class=\"mat-header-resizer right\" *ngIf=\"!last && col.resizeable != false\" (mousedown)=\"onResizeColumn($event, index)\"></div>\r\n            </th>\r\n            <td mat-cell *matCellDef=\"let rowData;  let index = index;\" [ngClass]=\"['mat-sticky-' + col.sticky]\" [style.width.px]=\"col.width\">\r\n                <div class=\"mat-cell-content\">{{rowData[col.field] || placeholder}}</div>\r\n            </td>\r\n        </ng-container>\r\n\r\n        <tr mat-header-row *matHeaderRowDef=\"displayedColumns;sticky: true\"></tr>\r\n        <tr mat-row *matRowDef=\"let rowData; columns: displayedColumns;\"></tr>\r\n    </table>\r\n</div>\r\n\r\n<ng-template #operationsTemplate let-data >\r\n    <div class=\"mat-menu-content\" style=\"width: 100%;\"> \r\n        <button *ngFor=\"let item of operations\" [disabled]=\"item._disabled\" [title]=\"item._disabledTitle\" mat-menu-item (click)=\"closeOperationsOverlay(data)\">{{item.label}}</button>\r\n    </div>\r\n</ng-template>\r\n",
                encapsulation: ViewEncapsulation.None,
                providers: [DatePipe, LowerCasePipe, UpperCasePipe, DecimalPipe, PercentPipe, OverlayService],
                host: {
                    '[class.mat-reactive-table]': 'true',
                    '[class.mat-reactive-table-]': 'true',
                }
            },] }
];
MatReactiveTable.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: Renderer2 },
    { type: ElementRef },
    { type: HttpClient },
    { type: ViewContainerRef },
    { type: OverlayService },
    { type: DatePipe },
    { type: LowerCasePipe },
    { type: UpperCasePipe },
    { type: DecimalPipe },
    { type: PercentPipe },
    { type: MatModal }
];
MatReactiveTable.propDecorators = {
    matTableRef: [{ type: ViewChild, args: [MatTable, { read: ElementRef },] }],
    matTable: [{ type: ViewChild, args: [MatTable, { static: false },] }],
    matPagination: [{ type: ViewChild, args: [MatPagination, { static: false },] }],
    fuzzyInput: [{ type: ViewChild, args: ['fuzzyInput',] }],
    operationsTemplate: [{ type: ViewChild, args: ['operationsTemplate',] }],
    disabledField: [{ type: Input }],
    sort: [{ type: Input }],
    headerSearch: [{ type: Input }],
    lazy: [{ type: Input }],
    lazyLoad: [{ type: Output }],
    placeholder: [{ type: Input }],
    displayedColumns: [{ type: Input }],
    selectable: [{ type: Input }],
    rowSelectable: [{ type: Input }],
    columns: [{ type: Input }],
    dataSource: [{ type: Input }],
    operations: [{ type: Input }],
    canSetField: [{ type: Input }],
    canExport: [{ type: Input }],
    toolbarButtons: [{ type: Input }],
    total: [{ type: Input }],
    pageSizeOptions: [{ type: Input }],
    pageSize: [{ type: Input }],
    viewField: [{ type: Input }],
    viewOptions: [{ type: Input }],
    fuzzyPlaceholder: [{ type: Input }],
    fuzzyField: [{ type: Input }]
};

/** 排序顺序 */
const SortOrder = ['', 'asc', 'desc'];
class MatReactiveTableOperationConfig {
}
class MatReactiveTableHeaderConfig {
}
class MatReactiveTableToolBarConfig {
    constructor() {
        this.fuzzyField = 'fuzzy';
        this.fuzzyPlaceholder = '请输入关键词';
        this.advanceSearch = true;
        this.advanceSearchText = '筛选';
        this.exportText = '导出';
        this.fieldSetting = true;
        this.fieldSettingText = '字段';
        this.viewField = 'view';
    }
}

class MatReactiveSortComponent {
    constructor(_cd, _http) {
        this._cd = _cd;
        this._http = _http;
        this._onSort = new Subject();
        /** The placeholder of the filter input. */
        this.searcPlaceholder = '搜索';
        /** The text of reset button. */
        this.resetText = '重置';
        /** Options of the filter. */
        this.optionsDisplay = [];
    }
    get multiple() {
        return this.config.panel.multiple;
    }
    ngOnInit() {
        this.title = this.config.title;
        this.setOptions(this.config);
        this.optionsDisplay = this.config.panel.options;
        this._cd.markForCheck();
        if (!this.isSelect() && this.search[this.config.field]) {
            this.searchText = this.search[this.config.field].value;
        }
        if (this.multiple) {
            this.mutipleSearch = this.search[this.config.field] || {};
        }
    }
    /** Reset the conditions. */
    resetHeader() {
        if (this.sort.sortName === this.config.field) {
            this.sort.sortName = '';
            this.sort.sortValue = '';
        }
        delete this.search[this.config.field];
        this._onSort.next();
    }
    sortClick() {
        const sortValue = this.sort.sortName == this.config.field ? (this.sort.sortValue || '') : '';
        this.sort.sortName = this.config.field;
        switch (sortValue) {
            case '':
                this.sort.sortValue = 'asc';
                break;
            case 'asc':
                this.sort.sortValue = 'desc';
                break;
            case 'desc':
                this.sort.sortValue = '';
                this.sort.sortName = '';
                break;
            default:
                this.sort.sortValue = '';
                this.sort.sortName = '';
        }
        this._onSort.next();
    }
    optionClick(option) {
        if (!this.multiple) {
            this.search[this.config.field] = { view: option.view, value: option.value };
            this._onSort.next();
        }
    }
    multipleOptionClick(e, option) {
        const value = this.mutipleSearch.value || [];
        const view = this.mutipleSearch.view || [];
        const index = value.findIndex(item => item == option.value);
        if (index >= 0) {
            value.splice(index, 1);
            view.splice(index, 1);
        }
        else {
            value.push(option.value);
            view.push(option.view);
        }
        this.mutipleSearch = { view, value };
    }
    sureClick() {
        if (!this.mutipleSearch.value || !this.mutipleSearch.value.length) {
            delete this.search[this.config.field];
        }
        else {
            this.search[this.config.field] = this.mutipleSearch;
        }
        this._onSort.next();
    }
    cancelClick() {
        this._onSort.next(true);
    }
    formatOption(item, column) {
        const isItemString = typeof item === 'string' || typeof item === 'number';
        const value = (isItemString || !column.panel.valueField) ? item : item[column.panel.valueField];
        const view = isItemString ? item : item[column.panel.viewField || MAT_DROPDOWN_DEFAULT_VIEW_FIELD];
        return { view, value, data: item };
    }
    setOptions(column) {
        const value = column.panel.dataSource;
        if (!column.panel.options) {
            if (!value) {
                column.panel.options = [];
            }
            else if (typeof value === 'string' && MatUtils.isJson(value)) {
                column.panel.options = JSON.parse(value);
            }
            else if (typeof value === 'object' && value.url) {
                new MatReactiveHttpRequest(this._http, value).Request({}).subscribe(event => column.panel.options = event || []);
            }
            else {
                column.panel.options = Array.isArray(value) ? value : [];
            }
            column.panel.options = column.panel.options.map(item => this.formatOption(item, column));
        }
        else {
            column.panel.options.forEach(option => option.hidden = false);
        }
    }
    headerSearch(event) {
        const keyCode = event.keyCode;
        event.stopPropagation();
        if (keyCode === ENTER) {
            this.filterHeaderOption();
        }
    }
    /** Filter option by search text. */
    filterHeaderOption() {
        if (this.isSelect()) {
            this.optionsDisplay.forEach((options) => {
                options.hidden = options.view && this.searchText && !options.view.includes(this.searchText);
            });
        }
        else {
            if (this.searchText) {
                this.search[this.config.field] = { view: this.searchText, value: this.searchText };
            }
            else {
                delete this.search[this.config.field];
            }
            this._onSort.next();
        }
    }
    /** Returns an observable that notifies when the popover has been hidden from view. */
    onSort() {
        return this._onSort.asObservable();
    }
    /** Where the panel is selecet. */
    isSelect() {
        return !!this.config.panel.dataSource;
    }
    /** Where current column sort is active. */
    isSortActive(value) {
        return this.sort && this.config && this.sort.sortName == this.config.field && this.sort.sortValue === value;
    }
    isOptionActive(value) {
        if (this.config && (this.multiple && this.mutipleSearch && this.mutipleSearch.value) || (!this.multiple && this.search && this.search[this.config.field])) {
            const select = this.multiple ? this.mutipleSearch.value : [this.search[this.config.field].value];
            return select.includes(value);
        }
        else {
            return false;
        }
    }
    selectAll(event) {
        if (event.checked) {
            this.mutipleSearch = {
                value: [],
                view: []
            };
            this.optionsDisplay.forEach(option => {
                if (!option.hidden) {
                    this.mutipleSearch.value.push(option.value);
                    this.mutipleSearch.view.push(option.view);
                }
            });
        }
        else {
            this.mutipleSearch = {};
        }
    }
}
MatReactiveSortComponent.decorators = [
    { type: Component, args: [{
                selector: 'mat-reactive-sort',
                exportAs: 'matReactiveSortComponent',
                template: "<div class=\"mat-select-panel-wrap mat-reactive-table-header-panel\" style=\"width: 100%;\">\r\n  <div class=\"mat-select-panel horizontal \">\r\n      <div class=\"mat-dropdown-panel-header\">\r\n          <span class=\"mat-dropdown-panel-header-title\">\r\n              <span class=\"mat-reactive-sort\" (click)=\"config?.panel.sortable && sortClick()\">\r\n                {{title}}\r\n                  <svg *ngIf=\"!!config?.panel.sortable\" viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n                      <path class=\"mat-reactive-asc\" [class.mat-reactive-sort-active]=\"isSortActive('asc')\" d=\"M389.929292 88.142479c-1.929955-4.513804-4.725628-8.747221-8.40953-12.431124-11.17348-11.17348-27.357068-14.271028-41.313941-9.312086-3.345188 1.187035-6.551206 2.837628-9.540284 4.956895-1.821485 1.282203-3.557012 2.727111-5.185093 4.355191-1.626034 1.627057-183.705975 184.528714-183.705975 184.528714-15.46932 15.476483-15.47546 40.563858 0 56.039317 15.474436 15.474436 40.564881 15.474436 56.039317 0l116.057249-116.057249 0 720.05043c0 21.88238 17.744129 39.626509 39.626509 39.619346 21.887496 0 39.625486-17.736966 39.625486-39.619346L393.123031 103.732549l-0.019443 0C393.103588 98.420567 392.052652 93.108584 389.929292 88.142479L389.929292 88.142479zM389.929292 88.142479\" fill=\"currentColor\"></path>\r\n                      <path class=\"mat-reactive-desc\" [class.mat-reactive-sort-active]=\"isSortActive('desc')\" d=\"M882.227578 707.726753c-15.47546-15.47546-40.565904-15.47546-56.040341 0l-116.063389 116.051109 0.00614-720.045313c0-21.887496-17.744129-39.625486-39.631626-39.625486-21.88238 0-39.620369 17.73799-39.620369 39.625486l0 800.948925 0 15.59007 0.01228 0c0.005117 5.305843 1.057075 10.622942 3.180436 15.59007 1.929955 4.51278 4.724605 8.741082 8.410554 12.426007 11.174504 11.174504 27.355021 14.277168 41.313941 9.31618 3.346211-1.184989 6.550183-2.842745 9.540284-4.954849 1.820462-1.288343 3.557012-2.734274 5.184069-4.362354 1.626034-1.627057 183.705975-184.52155 183.705975-184.52155C897.694851 748.289588 897.694851 723.202213 882.227578 707.726753L882.227578 707.726753zM882.227578 707.726753\" fill=\"currentColor\"></path>\r\n                  </svg>\r\n              </span>\r\n          </span>\r\n          <span class=\"mat-dropdown-panel-header-condition\">\r\n              <mat-input [placeholder]=\"searcPlaceholder\" trim [(value)]=\"searchText\" (keydown)=\"headerSearch($event)\" >\r\n                  <mat-input-after (click)=\"filterHeaderOption()\">\r\n                      <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" ><path path fill=\"currentColor\" d=\"M757.372928 734.871552l260.227072 218.35776a0.512 0.512 0 0 1 0.063488 0.720896l-38.887424 46.343168a0.512 0.512 0 0 1-0.720896 0.063488L713.900032 778.704896c-75.71456 66.17088-174.798848 106.26048-283.246592 106.26048C192.809984 884.9664 0 692.13184 0 454.259712 0 216.38656 192.809984 23.552 430.65344 23.552s430.65344 192.83456 430.65344 430.706688c0 107.191296-39.15264 205.236224-103.933952 280.612864z m-326.719488 88.56576c203.866112 0 369.13152-165.286912 369.13152-369.178624 0-203.890688-165.265408-369.1776-369.13152-369.1776-203.866112 0-369.13152 165.286912-369.13152 369.1776 0 203.891712 165.265408 369.1776 369.13152 369.1776z\"></path></svg>\r\n                  </mat-input-after>\r\n              </mat-input>\r\n              <mat-buttons [label]=\"resetText\" type=\"outline\" (matClick)=\"resetHeader()\"></mat-buttons>\r\n          </span>\r\n      </div>\r\n      <div class=\"mat-dropdown-panel-content\">\r\n\r\n          <div *ngFor=\"let option of optionsDisplay\" [class.hidden]=\"option.hidden\" class=\"mat-option-item\" [class.mat-option-item-multiple]=\"multiple\">\r\n              <div class=\"mat-option\" [class.mat-selected]=\"!multiple && isOptionActive(option.value)\" (click)=\"optionClick(option)\">\r\n                    <span class=\"mat-dropdown-option-view\">\r\n                        <mat-checkbox *ngIf=\"multiple\" (change)=\"multipleOptionClick($event, option)\" [checked]=\"isOptionActive(option.value)\">\r\n                            {{option.view}}\r\n                        </mat-checkbox>\r\n                       \r\n                        <ng-container *ngIf=\"!multiple\">{{option.view}}</ng-container>\r\n                    </span>\r\n              </div>\r\n          </div>\r\n      </div>\r\n      <div class=\"mat-dropdown-panel-footer\" *ngIf=\"multiple\">\r\n        <div class=\"left\">\r\n            <mat-checkbox (change)=\"selectAll($event)\">\u5168\u9009</mat-checkbox>\r\n        </div>\r\n        <div class=\"right\">\r\n            <mat-buttons label=\"\u53D6\u6D88\" (matClick)=\"cancelClick()\"></mat-buttons>\r\n            <mat-buttons type=\"fill\" label=\"\u786E\u5B9A\" (matClick)=\"sureClick()\"></mat-buttons>\r\n        </div>\r\n\r\n      </div>\r\n  </div>\r\n</div>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[style.width]': '"100%"',
                    'class': 'mat-reactive-sort'
                }
            },] }
];
MatReactiveSortComponent.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: HttpClient$1 }
];
MatReactiveSortComponent.propDecorators = {
    title: [{ type: Input }],
    searcPlaceholder: [{ type: Input }],
    resetText: [{ type: Input }],
    config: [{ type: Input }],
    sort: [{ type: Input }]
};
class MatReactiveSortDirective {
    constructor(_overlay, _viewContainerRef, _ele) {
        this._overlay = _overlay;
        this._viewContainerRef = _viewContainerRef;
        this._ele = _ele;
        this.onSort = new EventEmitter();
        this._scrollStrategy = _overlay._overlay.scrollStrategies.reposition();
    }
    show() {
        if (this.canShow()) {
            this._overlay.close();
            this._portal = this._portal || new ComponentPortal(MatReactiveSortComponent, this._viewContainerRef);
            this._instance = this._overlay.open(this.connectedTo || this._ele.nativeElement, this._portal, {
                withViewportMargin: 0,
                hasBackdrop: true,
                scrollStrategy: this._scrollStrategy,
                position: 'BL',
                panelClass: 'mat-drop-down-overlay-panel-horizontal',
            });
            this._ele.nativeElement.classList.add('mat-reactive-table-sort-panel-opened');
            this._instance.config = this.config;
            this._instance.sort = this.matReactiveSort;
            this._instance.search = this.search;
            this._instance.onSort().subscribe((e) => {
                this._overlay.close();
                if (!e) {
                    this.onSort.emit();
                }
            });
            this._overlay.afterClose().subscribe(e => this._ele.nativeElement.classList.remove('mat-reactive-table-sort-panel-opened'));
            return this._instance;
        }
    }
    canShow() {
        return this.config && this.config.panel && this.config.panel.sortable;
    }
    ngOnInit() {
    }
    ngOnDestroy() {
    }
}
MatReactiveSortDirective.decorators = [
    { type: Directive, args: [{
                selector: '[matReactiveSort]',
                exportAs: 'matReactiveSort',
                providers: [OverlayService],
                host: {
                    '(click)': 'show()'
                }
            },] }
];
MatReactiveSortDirective.ctorParameters = () => [
    { type: OverlayService },
    { type: ViewContainerRef },
    { type: ElementRef }
];
MatReactiveSortDirective.propDecorators = {
    connectedTo: [{ type: Input }],
    config: [{ type: Input }],
    search: [{ type: Input }],
    matReactiveSort: [{ type: Input }],
    onSort: [{ type: Output }]
};

class MatReactiveTableModule {
}
MatReactiveTableModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    FormsModule,
                    ReactiveFormsModule,
                    MatTooltipModule,
                    MatTableModule,
                    MatButtonModule,
                    MatMenuModule,
                    MatIconModule,
                    DragDropModule,
                    MatModalModule,
                    MatCheckboxModule,
                    MatRippleModule,
                    MatButtonsModule,
                    MatInputModule,
                    MatDropdownModule,
                    MatCheckboxListModule,
                    MatPaginationModule,
                ],
                declarations: [
                    MatReactiveTable,
                    MatReactiveTableField,
                    MatReactiveSortDirective,
                    MatReactiveSortComponent
                ],
                exports: [
                    MatReactiveTable
                ],
                entryComponents: [MatReactiveSortComponent, MatReactiveTableField]
            },] }
];

const DEFAULT_SCROLL_DISTANCE = 400;
const DEFAULT_SCROLL_TIME = 100;
class MatScrollposition {
    constructor(cd, domHandler, platform, el) {
        this.cd = cd;
        this.domHandler = domHandler;
        this.platform = platform;
        this.el = el;
        /** Event emitted when the scroll triggered. */
        this.matClick = new EventEmitter();
        /** Scroll host. */
        this._target = null;
    }
    set top(value) {
        if (value instanceof TemplateRef) {
            this._top = value;
        }
        else {
            this._top = coerceBooleanProperty(value);
        }
    }
    get top() {
        return this._top;
    }
    set bottom(value) {
        if (value instanceof TemplateRef) {
            this._bottom = value;
        }
        else {
            this._bottom = coerceBooleanProperty(value);
        }
    }
    get bottom() {
        return this._bottom;
    }
    set distance(value) {
        this._distance = Number(value);
    }
    get distance() {
        return this._distance || DEFAULT_SCROLL_DISTANCE;
    }
    set target(value) {
        if (typeof value === 'string') {
            const winEles = ['body', 'html', 'window'];
            this._target = winEles.includes(value) ? window : document.querySelector(value);
            this.domHandler.removeClass(this.el.nativeElement, 'mat-scrollposition-sticky');
            this.domHandler.addClass(this.el.nativeElement, 'mat-scrollposition-fixed');
        }
        else {
            this._target = value;
            this.domHandler.removeClass(this.el.nativeElement, 'mat-scrollposition-fixed');
            this.domHandler.addClass(this.el.nativeElement, 'mat-scrollposition-sticky');
        }
        this._registerScroll();
    }
    /** Display or hide button. */
    _handleScroll() {
        const scroll = this.domHandler.getScroll(this._target);
        const isTop = scroll.top > this.distance;
        const isBottom = scroll.bottom > this.distance;
        if (this._topVisible === isTop && this._bottomVisible === isBottom) {
            return;
        }
        this._topVisible = isTop;
        this._bottomVisible = isBottom;
        this.cd.markForCheck();
    }
    /** Remove scroll event listener. */
    _deregisterScroll() {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
    }
    /** Register scroll event listener. */
    _registerScroll() {
        if (!this.platform.isBrowser) {
            return;
        }
        this._deregisterScroll();
        this._handleScroll();
        this._subscription = fromEvent(this._target, 'scroll').pipe(throttleTime(DEFAULT_SCROLL_TIME), distinctUntilChanged()).subscribe(() => this._handleScroll());
    }
    /** Button on click. */
    clickPosition(type) {
        this.domHandler[`scroll${type}`](this._target, 0);
        this.matClick.emit(type);
    }
    ngOnInit() {
        if (!this._subscription) {
            this._target = this._target || window;
            this._registerScroll();
        }
    }
    ngOnDestroy() {
        this._deregisterScroll();
    }
}
MatScrollposition.decorators = [
    { type: Component, args: [{
                selector: 'mat-scrollposition',
                template: "<div class=\"mat-scrollposition-top\" (click)=\"clickPosition('Top')\" [class.default]=\"top == true\" *ngIf=\"top && _topVisible\">\r\n    <ng-template [ngTemplateOutlet]=\"top == true ? topContent : top\"></ng-template>\r\n</div>\r\n<div class=\"mat-scrollposition-bottom\" (click)=\"clickPosition('Bottom')\" [class.default]=\"bottom == true\" *ngIf=\"bottom && _bottomVisible\">\r\n    <ng-template [ngTemplateOutlet]=\"bottom == true ? bottomContent : bottom\"></ng-template>\r\n</div>\r\n<ng-template #topContent>\r\n    <span class=\"mat-scrollposition-icon top\"></span>\r\n</ng-template>\r\n<ng-template #bottomContent>\r\n    <span class=\"mat-scrollposition-icon bottom\"></span>\r\n</ng-template>",
                host: {
                    '[class.mat-scrollposition]': 'true'
                },
                providers: [MatDomHandler],
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            },] }
];
MatScrollposition.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: MatDomHandler },
    { type: Platform },
    { type: ElementRef }
];
MatScrollposition.propDecorators = {
    matClick: [{ type: Output }],
    top: [{ type: Input }],
    bottom: [{ type: Input }],
    distance: [{ type: Input }],
    target: [{ type: Input }]
};

class MatScrollpositionModule {
}
MatScrollpositionModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [MatScrollposition],
                exports: [MatScrollposition]
            },] }
];

class MatSearch {
    constructor(_cd) {
        this._cd = _cd;
        this.matChange = new EventEmitter();
        this.matIconClick = new EventEmitter();
        this.valueChange = new EventEmitter();
        this.matFocus = new EventEmitter();
        this.matBlur = new EventEmitter();
        /** The input's input change debounceTime. */
        this.debounceTime = 500;
        /** Value of the input. */
        this._value = '';
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get trim() {
        return this._trim;
    }
    set trim(value) {
        this._trim = coerceBooleanProperty(value);
    }
    get value() {
        return this._value;
    }
    set value(value) {
        if (value !== this._value) {
            this._value = (value === null || value === undefined) ? '' : value;
            this._cd.markForCheck();
        }
    }
    onFocus() {
        this.matFocus.emit();
    }
    onBlur() {
        this.matBlur.emit();
    }
    onValueChange(event) {
        this._value = event;
        this.valueChange.emit(event);
    }
    onChange(event) {
        this.matChange.emit(event);
    }
    onIconClick(event) {
        if (this.disabled) {
            return;
        }
        this.matIconClick.emit(event);
    }
    ngOnInit() {
    }
    ngOnDestroy() {
    }
}
MatSearch.decorators = [
    { type: Component, args: [{
                selector: 'mat-search',
                template: "<mat-input \r\n  [placeholder]=\"placeholder\" \r\n  [trim]=\"trim\" \r\n  [value]=\"value\"\r\n  [disabled]=\"disabled\" \r\n  [debounceTime]=\"debounceTime\" \r\n  (valueChange)=\"onValueChange($event)\"\r\n  (matChange)=\"onChange($event)\"\r\n  (matFocus)=\"onFocus()\"\r\n  (matBlur)=\"onBlur()\">\r\n\r\n  <mat-input-before (click)=\"onIconClick($event)\" *ngIf=\"iconPosition=='before'\"></mat-input-before>\r\n  <mat-input-after  (click)=\"onIconClick($event)\" *ngIf=\"iconPosition=='after'\"></mat-input-after>\r\n</mat-input>",
                host: {
                    '[class.mat-search]': 'true',
                    '[class.mat-search-disabled]': 'disabled',
                },
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            },] }
];
MatSearch.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatSearch.propDecorators = {
    matChange: [{ type: Output }],
    matIconClick: [{ type: Output }],
    valueChange: [{ type: Output }],
    matFocus: [{ type: Output }],
    matBlur: [{ type: Output }],
    placeholder: [{ type: Input }],
    debounceTime: [{ type: Input }],
    iconPosition: [{ type: Input }],
    disabled: [{ type: Input }],
    trim: [{ type: Input }],
    value: [{ type: Input }]
};

class MatSearchModule {
}
MatSearchModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatInputModule],
                exports: [MatSearch],
                declarations: [MatSearch],
                providers: [],
            },] }
];

const DEFAULT_TAG_SIZE = 'md';
class MatTag {
    constructor(_cd) {
        this._cd = _cd;
        /** Unique ID to be used by button's property. */
        this.id = null;
        /** Event emitted when the button clicked by the user. */
        this.matClose = new EventEmitter();
        /** Size of the button. Can be 'lg' , 'md' , or 'sm'. */
        this._size = DEFAULT_TAG_SIZE;
        /** Whether tag is disabled. */
        this._disabled = false;
        /** Whether tag is fill. */
        this._fill = false;
        /** Whether tag is closable. */
        this._closable = false;
    }
    set size(value) {
        this._size = value || DEFAULT_TAG_SIZE;
        this._cd.markForCheck();
    }
    get size() {
        return this._size;
    }
    get disabled() { return this._disabled; }
    set disabled(value) {
        if (value !== this._disabled) {
            this._disabled = coerceBooleanProperty(value);
            this._cd.markForCheck();
        }
    }
    get fill() { return this._fill; }
    set fill(value) {
        if (this._fill !== value) {
            this._fill = coerceBooleanProperty(value);
            this._cd.markForCheck();
        }
    }
    get closable() { return this._closable; }
    set closable(value) {
        if (value !== this._closable) {
            this._closable = coerceBooleanProperty(value);
            this._cd.markForCheck();
        }
    }
    set type(value) {
        if (value !== this._type) {
            this._type = value;
            this._cd.markForCheck();
        }
    }
    get type() {
        return this._type;
    }
    set icon(value) {
        if (this._icon !== value) {
            this._icon = value;
            this._cd.markForCheck();
        }
    }
    get icon() {
        return this._icon;
    }
    close(event) {
        if (!this.disabled) {
            this.matClose.emit(event);
        }
    }
}
MatTag.decorators = [
    { type: Component, args: [{
                selector: 'mat-tag',
                template: "<mat-icon [fontIcon]=\"icon\" *ngIf=\"icon\"></mat-icon>\r\n<span class=\"mat-tag-label\">{{label}}</span>\r\n<span class=\"mat-tag-close\" *ngIf=\"closable && !disabled\" (click)=\"close($event)\">\r\n  <svg viewBox=\"0 0 1024 1024\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M130.45942158 859.21892238C121.1423835 868.85723591 121.40282994 884.22358585 131.04114461 893.54062279 140.67945927 902.85766087 156.04580807 902.5972133 165.36284501 892.95889863L869.26803058 164.78112085C878.58506752 155.14280733 878.32461995 139.77645853 868.68630642 130.45942158 859.04799289 121.1423835 843.68164295 121.40282994 834.36460601 131.04114461L130.45942158 859.21892238Z\" fill=\"currentColor\" p-id=\"6166\"></path><path d=\"M834.36460601 892.95889863C843.68164295 902.5972133 859.04799289 902.85766087 868.68630642 893.54062279 878.32461995 884.22358585 878.58506752 868.85723591 869.26803058 859.21892238L165.36284501 131.04114461C156.04580807 121.40282994 140.67945927 121.1423835 131.04114461 130.45942158 121.40282994 139.77645853 121.1423835 155.14280733 130.45942158 164.78112085L834.36460601 892.95889863Z\" fill=\"currentColor\"></path></svg>\r\n</span>",
                host: {
                    '[class.mat-tag]': 'true',
                    '[class.mat-tag-default]': '!type',
                    '[class.mat-tag-error]': 'type === "error"',
                    '[class.mat-tag-warn]': 'type === "warn"',
                    '[class.mat-tag-info]': 'type === "info"',
                    '[class.mat-tag-success]': 'type === "success"',
                    '[class.mat-tag-fill]': '!!fill',
                    '[class.mat-tag-disabled]': '!!disabled',
                    '[class.mat-tag-lg]': 'size === "lg"',
                    '[class.mat-tag-md]': 'size === "md"',
                    '[class.mat-tag-sm]': 'size === "sm"',
                },
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            },] }
];
MatTag.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatTag.propDecorators = {
    id: [{ type: Input }],
    label: [{ type: Input }],
    matClose: [{ type: Output }],
    size: [{ type: Input }],
    disabled: [{ type: Input }],
    fill: [{ type: Input }],
    closable: [{ type: Input }],
    type: [{ type: Input }],
    icon: [{ type: Input }]
};

class MatTagModule {
}
MatTagModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatIconModule],
                exports: [MatTag],
                declarations: [MatTag],
                providers: [],
            },] }
];

const MAT_TEXT_RETRACT = Math.pow(2, 8);
class MatTextRetract {
    constructor(_cd) {
        this._cd = _cd;
        this.expandText = '...展开';
        this.collapseText = '收起';
        /** Where the elemet is locked */
        this._text = '';
        this._max = MAT_TEXT_RETRACT;
    }
    set text(value) {
        if (value !== this._text) {
            this._text = value;
            this._setDisplay();
            this._cd.markForCheck();
        }
    }
    get text() {
        return this._text;
    }
    set max(value) {
        if (this._max != value) {
            this._max = Number(value) || MAT_TEXT_RETRACT;
            this._setDisplay();
            this._cd.markForCheck();
        }
    }
    get max() {
        return this._max;
    }
    get showText() {
        return this._showText;
    }
    _setDisplay() {
        if (this.isExpand) {
            this._showText = this._text.substr(0, this.max);
        }
        else {
            this._showText = this._text;
        }
    }
    get showToggle() {
        return this._text.length > this.max;
    }
    toggle() {
        this.isExpand = !this.isExpand;
        this._setDisplay();
    }
    ngOnDestroy() {
    }
}
MatTextRetract.decorators = [
    { type: Component, args: [{
                selector: 'mat-text-retract',
                exportAs: 'matTextRetract',
                template: "<span class=\"mat-text-retract-display\">{{showText}}</span>\r\n<span class=\"mat-text-retract-toggle\" *ngIf=\"showToggle\" (click)=\"toggle()\">\r\n  {{isExpand ? expandText : collapseText}}\r\n</span>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-text-retract]': 'true',
                }
            },] }
];
MatTextRetract.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatTextRetract.propDecorators = {
    expandText: [{ type: Input }],
    collapseText: [{ type: Input }],
    isExpand: [{ type: Input }],
    text: [{ type: Input }],
    max: [{ type: Input }]
};

class MatTextRetractModule {
}
MatTextRetractModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [MatTextRetract],
                exports: [MatTextRetract]
            },] }
];

class MatTextLightPipe {
    constructor(_sanitizer) {
        this._sanitizer = _sanitizer;
    }
    _stringToHtml(val, regStr, color, bgcolor) {
        if (!val || !regStr) {
            return val;
        }
        return val.split(regStr.trim()).join(`<mark class="mat-text-light" style="color: ${color || ''};background-color: ${bgcolor || ''}">${regStr}</mark>`);
    }
    transform(val, regStr, color, bgcolor) {
        return this._sanitizer.bypassSecurityTrustHtml(this._stringToHtml(val, regStr, color, bgcolor));
    }
}
MatTextLightPipe.decorators = [
    { type: Pipe, args: [{
                name: 'matTextlight'
            },] }
];
MatTextLightPipe.ctorParameters = () => [
    { type: DomSanitizer }
];

const MAT_TEXT_LIGHT_DEFAULT_DEBOUNCETIME = 300;
class MatTextLightDirective extends MatTextLightPipe {
    constructor(_sanitizer, _el) {
        super(_sanitizer);
        this._sanitizer = _sanitizer;
        this._el = _el;
        /** Search change subject */
        this._search$ = new Subject();
    }
    set color(value) {
        this._color = value;
    }
    get color() {
        return this._color;
    }
    set bgcolor(value) {
        this._bgcolor = value;
    }
    get bgcolor() {
        return this._bgcolor;
    }
    set content(value) {
        this._content = value;
    }
    get content() {
        return this._content;
    }
    set search(value) {
        this._search = value;
        this._search$.next(this._search);
    }
    get search() {
        return this._search;
    }
    _highlight(value) {
        this._el.nativeElement.innerHTML = this._stringToHtml(this.content, value, this.color, this.bgcolor);
    }
    ngOnInit() {
        this._subscription = this._search$.pipe(debounceTime(MAT_TEXT_LIGHT_DEFAULT_DEBOUNCETIME), distinctUntilChanged()).subscribe((value) => this._highlight(value));
        this._search$.next('');
    }
    ngOnDestroy() {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
    }
}
MatTextLightDirective.decorators = [
    { type: Directive, args: [{
                selector: '[matTextlight]',
                exportAs: 'matTextlight',
            },] }
];
MatTextLightDirective.ctorParameters = () => [
    { type: DomSanitizer },
    { type: ElementRef }
];
MatTextLightDirective.propDecorators = {
    color: [{ type: Input, args: ['matTextlightColor',] }],
    bgcolor: [{ type: Input, args: ['matTextlightBgcolor',] }],
    content: [{ type: Input, args: ['matTextlight',] }],
    search: [{ type: Input, args: ['matTextlightSearch',] }]
};

class MatTextLightModule {
}
MatTextLightModule.decorators = [
    { type: NgModule, args: [{
                imports: [],
                exports: [MatTextLightPipe, MatTextLightDirective],
                declarations: [MatTextLightPipe, MatTextLightDirective]
            },] }
];

class MatTimeline {
    constructor() {
        this.type = 'vertical';
    }
}
MatTimeline.decorators = [
    { type: Component, args: [{
                selector: 'mat-timeline',
                exportAs: 'MatTimeline',
                template: "<ng-content></ng-content>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-timeline]': 'true'
                }
            },] }
];
MatTimeline.propDecorators = {
    type: [{ type: Input }]
};

class MatTimelineItem {
    constructor(_cd) {
        this._cd = _cd;
    }
}
MatTimelineItem.decorators = [
    { type: Component, args: [{
                selector: 'mat-timeline-item',
                exportAs: 'MatTimelineItem',
                template: "<div class=\"mat-timeline-left-content\">\r\n    <ng-content select=\".mat-timeline-left\"></ng-content>\r\n</div>\r\n\r\n<div class=\"mat-timeline-icon-content\">\r\n    <div class=\"mat-timeline-line\" [style.borderStyle]=\"lineStyle\" [style.color]=\"lineColor\"></div>\r\n    <ng-content select=\".mat-timeline-icon\"></ng-content>\r\n    <div class=\"mat-timeline-dot\" [style.color]=\"iconColor\"></div>\r\n</div>\r\n\r\n<div class=\"mat-timeline-right-content\">\r\n    <ng-content select=\".mat-timeline-right\"></ng-content>\r\n</div>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-timeline-item]': 'true'
                }
            },] }
];
MatTimelineItem.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatTimelineItem.propDecorators = {
    iconColor: [{ type: Input }],
    lineColor: [{ type: Input }],
    lineStyle: [{ type: Input }]
};

class MatTimelineModule {
}
MatTimelineModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [MatTimelineItem, MatTimeline],
                exports: [MatTimelineItem, MatTimeline]
            },] }
];

const MAT_TRANSFER_VIEW_FIELD = 'label';
const MAT_TRANSFER_DISABLED_FIELD = 'disabled';
const MAT_TRANSFER_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatTransfer),
    multi: true
};
class MatTransfer {
    constructor(_cd) {
        this._cd = _cd;
        this.matChange = new EventEmitter();
        this.matFilter = new EventEmitter();
        this.tabIndex = 0;
        /** Field name of disabled when datasource as objecet array. */
        this.disabledField = MAT_TRANSFER_DISABLED_FIELD;
        /** Field name of view when datasource as objecet array. */
        this.viewField = MAT_TRANSFER_VIEW_FIELD;
        this._dataSource = null;
        this.dataSourceDisplay = [];
        /** Whether the dropdown is required. */
        this._required = false;
        /** Whether multiple options can be selected. */
        this._multiple = true;
        /** Comparison function to specify which option is checked. Defaults to object equality. */
        this._compareWith = (o1, o2) => o1 === o2;
        /** onTouch function registered via registerOnTouch (ControlValueAccessor). */
        this._onTouched = () => { };
        /** The method to be called in order to update ngModel. */
        this._controlValueAccessorChangeFn = () => { };
    }
    /** Option of the tree. */
    set dataSource(dataValue) {
        this._dataSource = [];
        const data = Array.isArray(dataValue) ? dataValue : [];
        data.forEach(item => {
            const isItemString = typeof item === 'string';
            const disabled = isItemString ? false : !!item[this.disabledField];
            const value = (isItemString || !this.valueField) ? item : item[this.valueField];
            const view = isItemString ? item : item[this.viewField || MAT_TRANSFER_VIEW_FIELD];
            const icon = isItemString ? '' : item[this.iconField];
            const secondary = isItemString ? '' : item[this.secondaryField];
            this._dataSource.push({ view, value, data: item, disabled, icon, secondary });
        });
        this.dataSourceDisplay = this._dataSource;
        if (this.value) {
            this._initializeSelection(this.value);
        }
    }
    get dataSource() { return this._dataSource; }
    get required() {
        return this._required;
    }
    set required(value) {
        this._required = coerceBooleanProperty(value);
    }
    set multiple(value) {
        const newValue = coerceBooleanProperty(value);
        if (this._multiple !== newValue) {
            if (this._selectionModel) {
                throw Error('Cannot change `multiple` mode of transfer after initialization.');
            }
            this._multiple = newValue;
            this._cd.markForCheck();
        }
    }
    get multiple() {
        return this._multiple;
    }
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
    }
    get compareWith() { return this._compareWith; }
    set compareWith(fn) {
        if (typeof fn !== 'function') {
            throw Error('`compareWith` must be a function in mat-transfer.');
        }
        this._compareWith = fn;
        if (this._selectionModel) {
            // A different comparator means the selection could change.
            this._initializeSelection(this.value);
        }
    }
    /** Value of the transfer. */
    get value() {
        return this._value;
    }
    set value(newValue) {
        this._value = newValue;
        if (this.dataSource) {
            this._setSelectionByValue(newValue);
        }
    }
    /** Whether data source is empty. */
    isDataSourceEmpty() {
        return !this.dataSource || !this.dataSource.length;
    }
    search() {
        if (!this.searchText) {
            this.dataSourceDisplay = this.dataSource;
        }
        else {
            this.dataSourceDisplay = this.dataSource.filter((item) => item.view.includes(this.searchText));
        }
    }
    resetFilter() {
        this.searchText = '';
        this.search();
        this._cd.markForCheck();
    }
    reset() {
        this.searchText = '';
        this.search();
        this._selectionModel.clear();
        this._propagateChanges(true);
    }
    get empty() {
        return !this.value || this.multiple && this.value.length;
    }
    /** 切换选中状态 */
    toggleItem(item) {
        if (item.disabled) {
            return;
        }
        const isSelected = this._selectionModel.isSelected(item.value);
        if (!isSelected && this.limit && this.limit <= this._selectionModel.selected.length) {
            this._selectionModel.deselect(this._selectionModel.selected[0]);
        }
        this._selectionModel.toggle(item.value);
        this._propagateChanges();
        this._onTouched();
    }
    /** 删除选中的 */
    removeItem(item) {
        this._selectionModel.deselect(item.value);
    }
    /** 选中所有选项 */
    selectAll() {
        this.dataSourceDisplay.forEach((item) => {
            if (!item.disabled) {
                this._selectionModel.select(item.value);
            }
        });
        this._propagateChanges(true);
    }
    unSelectAll() {
        this._selectionModel.clear();
        this._propagateChanges(true);
    }
    toggleAll() {
        if (this.isAllSelected) {
            this.unSelectAll();
        }
        else {
            this.selectAll();
        }
    }
    get isAllSelected() {
        const hasUnselected = this.dataSourceDisplay.find(item => !item.disabled && !this._selectionModel.isSelected(item.value));
        return this.dataSourceDisplay.length ? !hasUnselected : false;
    }
    /** Checks whether a checkbox is selected. */
    _isSelected(data) {
        return this._selectionModel && this._selectionModel.isSelected(data.value);
    }
    /** Emits change event to set the model value. */
    _propagateChanges(emit = true) {
        let valueToEmit = null;
        const selected = this._selectionModel.selected;
        if (this.multiple) {
            valueToEmit = selected.length ? selected : undefined;
        }
        else {
            valueToEmit = selected[0] || undefined;
        }
        this._controlValueAccessorChangeFn(valueToEmit);
        this._value = valueToEmit;
        if (emit) {
            this.matChange.emit(valueToEmit);
        }
        this._cd.markForCheck();
    }
    /**
     * Finds and selects and option based on its value.
     * @returns Option that has the corresponding value.
     */
    _selectValue(value) {
        const correspondingOption = this.dataSource.find((option) => {
            try {
                // Treat null as a special reset value.
                return option.value != null && this._compareWith(option.value, value);
            }
            catch (error) {
                if (isDevMode()) {
                    // Notify developers of errors in their comparator.
                    console.warn(error);
                }
                return false;
            }
        });
        if (correspondingOption) {
            this._selectionModel.select(correspondingOption.value);
        }
        return correspondingOption;
    }
    /** 获取选中的选项 */
    get dataSourceSelected() {
        return this.dataSource.filter((item) => this._selectionModel.isSelected(item.value));
    }
    /**
     * Sets the selected option based on a value. If no option can be
     * found with the designated value, the select trigger is cleared.
     */
    _setSelectionByValue(value) {
        if (this.multiple && value) {
            if (!Array.isArray(value)) {
                throw Error('`value` must be a array.');
            }
            this._selectionModel.clear();
            value.forEach((currentValue) => this._selectValue(currentValue));
        }
        else {
            this._selectionModel.clear();
            this._selectValue(value);
        }
    }
    _initializeSelection(value, emit = true) {
        // Defer setting the value in order to avoid the "Expression
        // has changed after it was checked" errors from Angular.
        Promise.resolve().then(() => {
            this._setSelectionByValue(value);
        });
    }
    ngOnInit() {
        this._selectionModel = new SelectionModel(!!this.multiple);
    }
    ngAfterViewInit() {
    }
    ngOnDestroy() {
    }
    /**
     * Sets the model value. Implemented as part of ControlValueAccessor.
     * @param value Value to be set to the model.
     */
    writeValue(value) {
        this.value = value;
        this._cd.markForCheck();
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._controlValueAccessorChangeFn = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
MatTransfer.decorators = [
    { type: Component, args: [{
                selector: 'mat-transfer',
                exportAs: 'MatTransfer',
                template: "<div class=\"mat-transfer-wapper\">\r\n    <div class=\"mat-transfer-search\">\r\n        <mat-input [(value)]=\"searchText\" (matChange)=\"search()\">\r\n            <mat-input-before></mat-input-before>\r\n        </mat-input>\r\n    </div>\r\n    <div class=\"mat-transfer-content\">\r\n        <div class=\"mat-transfer-source\">\r\n            <div class=\"mat-transfer-header\">\r\n                <span class=\"mat-transfer-title\">\u5F85\u9009\u62E9</span>\r\n                <mat-checkbox (change)=\"toggleAll()\" [checked]=\"isAllSelected\" *ngIf=\"multiple && !limit\">\u5168\u9009</mat-checkbox>\r\n            </div>\r\n            <cdk-virtual-scroll-viewport [itemSize]=\"40\" class=\"mat-transfer-item-wapper\">\r\n                <div class=\"mat-transfer-item\" [class.disabled]=\"item.disabled\" *cdkVirtualFor=\"let item of dataSourceDisplay\" (click)=\"toggleItem(item)\">\r\n                    <div class=\"mat-transfer-label\">\r\n                        <mat-img width=\"40\" height=\"40\" *ngIf=\"iconField\" [src]=\"item.icon\" radius=\"20\"></mat-img>\r\n                        <span class=\"mat-transfer-text\">\r\n                            <span class=\"mat-transfer-text-primary\">{{item.view}}</span>\r\n                            <span class=\"mat-transfer-text-secondary\" *ngIf=\"secondaryField\">{{item.secondary}}</span>\r\n                        </span>\r\n                    </div>\r\n                    <div class=\"mat-transfer-icon\" [class.mat-transfer-icon-selected]=\"_isSelected(item)\"></div>\r\n                </div>\r\n            </cdk-virtual-scroll-viewport>\r\n        </div>\r\n        <div class=\"mat-transfer-target\">\r\n            <div class=\"mat-transfer-header\">\r\n                <span class=\"mat-transfer-title\">\r\n                    \u5DF2\u9009\u62E9\r\n                    <span class=\"mat-transfer-selected\">({{dataSourceSelected.length}}/{{limit || dataSource.length}})</span>\r\n                </span>\r\n            </div>\r\n            <cdk-virtual-scroll-viewport [itemSize]=\"40\" class=\"mat-transfer-item-wapper\">\r\n                <div class=\"mat-transfer-item\" *cdkVirtualFor=\"let item of dataSourceSelected\">\r\n                    <div class=\"mat-transfer-label\">\r\n                        <mat-img width=\"40\" height=\"40\" *ngIf=\"iconField\" [src]=\"item.icon\" radius=\"20\"></mat-img>\r\n                        <span class=\"mat-transfer-text\">\r\n                            <span class=\"mat-transfer-text-primary\">{{item.view}}</span>\r\n                            <span class=\"mat-transfer-text-secondary\" *ngIf=\"secondaryField\">{{item.secondary}}</span>\r\n                        </span>\r\n                    </div>\r\n                    <div class=\"mat-transfer-icon mat-transfer-icon-remove\" (click)=\"removeItem(item)\"></div>\r\n                </div>\r\n            </cdk-virtual-scroll-viewport>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                providers: [MAT_TRANSFER_VALUE_ACCESSOR],
                host: {
                    '[attr.role]': 'option',
                    '[class.mat-transfer]': 'true'
                }
            },] }
];
MatTransfer.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
MatTransfer.propDecorators = {
    matChange: [{ type: Output }],
    matFilter: [{ type: Output }],
    tabIndex: [{ type: Input }],
    disabledField: [{ type: Input }],
    limit: [{ type: Input }],
    viewField: [{ type: Input }],
    valueField: [{ type: Input }],
    iconField: [{ type: Input }],
    secondaryField: [{ type: Input }],
    itemTemplate: [{ type: Input }],
    name: [{ type: Input }],
    dataSource: [{ type: Input }],
    required: [{ type: Input }],
    multiple: [{ type: Input }],
    disabled: [{ type: Input }],
    compareWith: [{ type: Input }],
    value: [{ type: Input }]
};

class MatTransferModule {
}
MatTransferModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, MatInputModule, MatTreeModule, MatCheckboxModule, MatRippleModule, ScrollingModule, MatImageModule],
                exports: [MatTransfer, MatInputModule],
                declarations: [MatTransfer]
            },] }
];

class MatWaterfallItem {
    constructor(_cd, _el) {
        this._cd = _cd;
        this._el = _el;
    }
    get element() {
        return this._el.nativeElement;
    }
}
MatWaterfallItem.decorators = [
    { type: Component, args: [{
                selector: 'mat-waterfall-item',
                exportAs: 'MatWaterfallItem',
                template: "<ng-content></ng-content>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-waterfall-item]': 'true'
                }
            },] }
];
MatWaterfallItem.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef }
];

const MAT_WATERFALL_DEFAULT_GUTTER = '0';
class MatWaterfall {
    constructor(_el) {
        this._el = _el;
        this.gutter = MAT_WATERFALL_DEFAULT_GUTTER;
    }
    ngOnInit() {
    }
    ngAfterContentInit() {
        this.setChildrenGutter();
        this.items.changes.pipe(debounceTime(1)).subscribe((e) => {
            if (this.msnry) {
                this.setChildrenGutter();
                this.msnry.reloadItems();
                this.msnry.layout();
            }
        });
    }
    ngAfterViewInit() {
        this.initMasonry();
    }
    ngOnDestroy() {
        if (this.msnry) {
            this.msnry.destroy();
        }
    }
    setChildrenGutter() {
        this.items.forEach(item => {
            item.element.style.padding = `calc(${this.gutter}/2)`;
        });
    }
    initMasonry() {
        const container = this._el.nativeElement;
        this.msnry = new Masonry(container, {
            itemSelector: '.mat-waterfall-item',
            horizontalOrder: this.horizontalOrder,
            stamp: this.stamp
        });
        imagesLoadedMethod(this._el.nativeElement).on('progress', (instance, image) => {
            if (image.isLoaded) {
                this.msnry.reloadItems();
                this.msnry.layout();
            }
        });
    }
}
MatWaterfall.decorators = [
    { type: Component, args: [{
                selector: 'mat-waterfall',
                exportAs: 'MatWaterfall',
                template: "<ng-content></ng-content>",
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.mat-waterfall]': 'true',
                    '[style.margin]': '"calc(-" + gutter + "/2)"'
                }
            },] }
];
MatWaterfall.ctorParameters = () => [
    { type: ElementRef }
];
MatWaterfall.propDecorators = {
    gutter: [{ type: Input }],
    horizontalOrder: [{ type: Input }],
    stamp: [{ type: Input }],
    items: [{ type: ContentChildren, args: [MatWaterfallItem, { descendants: true },] }]
};

class MatWaterfallModule {
}
MatWaterfallModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [MatWaterfallItem, MatWaterfall],
                exports: [MatWaterfallItem, MatWaterfall]
            },] }
];

const MAT_ZH_NUMBER_FRACTION = ['角', '分'];
const MAT_ZH_NUMBER_DIGIT = ['零', '壹', '贰', '叁', '肆', '伍', '陆', '柒', '捌', '玖'];
const MAT_ZH_NUMBER_UNIT = [['元', '万', '亿'], ['', '拾', '佰', '仟']];
class MatZhnumberPipe {
    _upperNumber(no, headString = '负') {
        let num = Number(no), str = '';
        if (!num && num !== 0) {
            return '';
        }
        const head = num < 0 ? headString : '';
        num = Math.abs(num);
        MAT_ZH_NUMBER_FRACTION.forEach((item, index) => {
            str += (MAT_ZH_NUMBER_DIGIT[Math.floor(num * 10 * Math.pow(10, index)) % 10] + MAT_ZH_NUMBER_FRACTION[index]).replace(/零./, '');
        });
        str = str || '整';
        num = Math.floor(num);
        for (let i = 0; i < MAT_ZH_NUMBER_UNIT[0].length && num > 0; i++) {
            let p = '';
            for (let j = 0; j < MAT_ZH_NUMBER_UNIT[1].length && num > 0; j++) {
                p = MAT_ZH_NUMBER_DIGIT[num % 10] + MAT_ZH_NUMBER_UNIT[1][j] + p;
                num = Math.floor(num / 10);
            }
            str = p.replace(/(零.)*零$/, '').replace(/^$/, '零') + MAT_ZH_NUMBER_UNIT[0][i] + str;
        }
        return head + str.replace(/(零.)*零元/, '元').replace(/(零.)+/g, '零').replace(/^整$/, '零元整');
    }
    transform(value, minusStr) {
        return this._upperNumber(value, minusStr);
    }
}
MatZhnumberPipe.decorators = [
    { type: Pipe, args: [{
                name: 'matZhnumber'
            },] }
];

class MatZhnumberModule {
}
MatZhnumberModule.decorators = [
    { type: NgModule, args: [{
                imports: [],
                exports: [MatZhnumberPipe],
                declarations: [MatZhnumberPipe]
            },] }
];

/*
 * Public API Surface of mat-ng
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MAT_CHECKBOX_LIST_DEFAULT_COLOR, MAT_CHECKBOX_LIST_DEFAULT_DIRECTION, MAT_CHECKBOX_LIST_DEFAULT_DISABLED_FIELD, MAT_CHECKBOX_LIST_DEFAULT_VIEW_FIELD, MAT_CHECKBOX_LIST_VALUE_ACCESSOR, MatBlock, MatBlockModule, MatButton, MatButtonsModule, MatCheckboxList, MatCheckboxListModule, getMatCheckboxListNonFunctionValueError, MatImageConfig as ɵa, MAT_NOTIFICATION_DEFAULT_OPTIONS_FACTORY as ɵb, MatReactiveFormControl as ɵba, MatListReactive as ɵbb, MatTableReactive as ɵbc, MatReactiveTableField as ɵbd, MatReactiveSortComponent as ɵbe, MatReactiveSortDirective as ɵbf, MAT_IMAGE_DEFAULT_CONFIG as ɵc, MatImageBase as ɵd, matSideAnimations as ɵe, MatNotificationSnackBar as ɵf, MatInputReactive as ɵg, MatTextareaReactive as ɵh, MatImageReactive as ɵi, MatFileReactive as ɵj, MatDropdownReactive as ɵk, MatTimeReactive as ɵl, MatDateReactive as ɵm, MatNumberReactive as ɵn, MatCheckboxReactive as ɵo, MatRadioReactive as ɵp, MatSelectButtonReactive as ɵq, MatToggleReactive as ɵr, MatSliderReactive as ɵs, MatTreeReactive as ɵt, MatTextReactive as ɵu, MatTitleReactive as ɵv, MatLineReactive as ɵw, MatReactiveModule as ɵx, MatReactiveFormComponents as ɵy, MatReactiveFormService as ɵz };
//# sourceMappingURL=mat-ng.js.map
